<?php
/**
* @package RokNewsRotator
* @copyright Copyright (C) 2007 RocketWerx. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

global $mosConfig_offset, $mosConfig_live_site, $mainframe;

$type 		= intval( $params->get( 'type', 1 ) );
$count 		= intval( $params->get( 'count', 5 ) );
$catid 		= trim( $params->get( 'catid' ) );
$secid 		= trim( $params->get( 'secid' ) );
$show_front	= trim( $params->get( 'show_front', 1 ) );
$length = intval($params->get( 'preview_count', 300) );
$jslib 				= $params->get( 'jslib', 0);
$duration   = trim( $params->get( 'duration', 600));
$delay      = trim( $params->get( 'delay', 2500));
$readmore    = trim( $params->get( 'readmore', "Read More"));
$linktitle  = trim( $params->get( 'linktitle', 0));
$corners  = trim( $params->get( 'corners', 1));
$autoplay  = trim( $params->get( 'autoplay', 1));
$controls  = trim( $params->get( 'controls', 1));
$autohide  = trim( $params->get( 'autohide', 1));
$linkimage  = trim( $params->get( 'linkimage', 1));

$now 		= date( 'Y-m-d H:i:s', time() );
$access 	= !$mainframe->getCfg( 'shownoauth' );
$nullDate 	= $database->getNullDate();


function getRotatorImage(&$row) {
    $regex = "#<!--IMAGE\s(.*?)IMAGE-->#s";
    preg_match( $regex, $row->introtext, $matches );
    if (sizeof($matches)==2) return trim($matches[1]);
    else return false;
}

if (!function_exists('prepareContent')) {

	function prepareContent( $text, $length=300 ) {
		// strips tags won't remove the actual jscript
		$text = preg_replace( "'<script[^>]*>.*?</script>'si", "", $text );
		$text = preg_replace( '/{.+?}/', '', $text);
		// replace line breaking tags with whitespace
		$text = preg_replace( "'<(br[^/>]*?/|hr[^/>]*?/|/(div|h[1-6]|li|p|td))>'si", ' ', $text );
		$text = strip_tags( $text );
		if (strlen($text) > $length) $text = substr($text, 0, $length) . "...";
		return $text;
	}
}

// select between Content Items, Static Content or both
switch ( $type ) {
    case 4:
    //Frontpage Items only 
    	$query = "SELECT a.id, a.title, a.introtext, a.sectionid, a.catid"
    	. "\n FROM #__content AS a"
    	. "\n INNER JOIN #__content_frontpage AS f ON f.content_id = a.id"
		. "\n INNER JOIN #__categories AS cc ON cc.id = a.catid"
		. "\n INNER JOIN #__sections AS s ON s.id = a.sectionid"
    	. "\n WHERE ( a.state = 1 AND a.sectionid > 0 )"
    	. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
    	. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
    	. ( $access ? "\n AND a.access <= " . (int) $my->gid : '' )
    	. "\n ORDER BY a.created DESC"
    	;
    	$database->setQuery( $query, 0, $count );
    	$rows = $database->loadObjectList();
    	break;
	    
	case 2: 
	//Static Content only
		$query = "SELECT a.id, a.title, a.introtext"
		. "\n FROM #__content AS a"
		. "\n WHERE ( a.state = 1 AND a.sectionid = 0 )"
		. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
		. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
		. ( $access ? "\n AND a.access <= " . (int) $my->gid : '' )
		. "\n ORDER BY a.created DESC"
		;
		$database->setQuery( $query, 0, $count );
		$rows = $database->loadObjectList();
		break;

	case 3: 
	//Both
		$whereCatid = '';
		if ($catid) {
			$catids = explode( ',', $catid );
			mosArrayToInts( $catids );
			$whereCatid = "\n AND ( a.catid=" . implode( " OR a.catid=", $catids ) . " )";
		}
		$whereSecid = '';
		if ($secid) {
			$secids = explode( ',', $secid );
			mosArrayToInts( $secids );
			$whereSecid = "\n AND ( a.sectionid=" . implode( " OR a.sectionid=", $secids ) . " )";
		}
		$query = "SELECT a.id, a.introtext, a.title, a.sectionid, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state, s.published AS sec_state"
		. "\n FROM #__content AS a"
		. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
		. "\n LEFT JOIN #__categories AS cc ON cc.id = a.catid"
		. "\n LEFT JOIN #__sections AS s ON s.id = a.sectionid"
		. "\n WHERE a.state = 1"
		. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
		. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
		. ( $access ? "\n AND a.access <= " . (int) $my->gid : '' )
		. $whereCatid
		. $whereSecid
		. ( $show_front == '0' ? "\n AND f.content_id IS NULL" : '' )
		. "\n ORDER BY a.created DESC"
		;
		$database->setQuery( $query, 0, $count );
		$temp = $database->loadObjectList();
		
		$rows = array();
		if (count($temp)) {
			foreach ($temp as $row ) {
				if (($row->cat_state == 1 || $row->cat_state == '') &&  ($row->sec_state == 1 || $row->sec_state == '') &&  ($row->cat_access <= $my->gid || $row->cat_access == '' || !$access) &&  ($row->sec_access <= $my->gid || $row->sec_access == '' || !$access)) {
					$rows[] = $row;
				}
			}
		}
		unset($temp);
		break;

	case 1:  
	default:
	//Content Items only
		$whereCatid = '';
		if ($catid) {
			$catids = explode( ',', $catid );
			mosArrayToInts( $catids );
			$whereCatid = "\n AND ( a.catid=" . implode( " OR a.catid=", $catids ) . " )";
		}
		$whereSecid = '';
		if ($secid) {
			$secids = explode( ',', $secid );
			mosArrayToInts( $secids );
			$whereSecid = "\n AND ( a.sectionid=" . implode( " OR a.sectionid=", $secids ) . " )";
		}
		$query = "SELECT a.id, a.title, a.sectionid, a.catid, a.introtext"
		. "\n FROM #__content AS a"
		. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
		. "\n INNER JOIN #__categories AS cc ON cc.id = a.catid"
		. "\n INNER JOIN #__sections AS s ON s.id = a.sectionid"
		. "\n WHERE ( a.state = 1 AND a.sectionid > 0 )"
		. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
		. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
		. ( $access ? "\n AND a.access <= " . (int) $my->gid . " AND cc.access <= " . (int) $my->gid . " AND s.access <= " . (int) $my->gid : '' )
		. $whereCatid
		. $whereSecid
		. ( $show_front == '0' ? "\n AND f.content_id IS NULL" : '' )
		. "\n AND s.published = 1"
		. "\n AND cc.published = 1"
		. "\n ORDER BY a.created DESC"
		;
		$database->setQuery( $query, 0, $count );
		$rows = $database->loadObjectList();
		break;
}



// needed to reduce queries used by getItemid for Content Items
if ( ( $type == 1 ) || ( $type == 3 ) || ( $type == 4) ) {
	$bs 	= $mainframe->getBlogSectionCount();
	$bc 	= $mainframe->getBlogCategoryCount();
	$gbs 	= $mainframe->getGlobalBlogSectionCount();
}

// Output
if ($jslib == 1) {
	echo "<script src=\"modules/roknewsrotator/mootools.js\" type=\"text/javascript\"></script>\n";
}
?>
<script type="text/javascript" src="modules/roknewsrotator/roknewsrotator-packed.js"></script>
<script type="text/javascript">
	window.addEvent('domready', function() {
		var rotator = new RokNewsRotator('news-rotator', {
			delay: <?php echo $delay; ?>,
			duration: <?php echo $duration; ?>,
            corners: <?php echo $corners==1?"true":"false"; ?>,
			autoplay: <?php echo $autoplay==1?"true":"false"; ?>
		});
	});
</script>
<div id="news-rotator">
<?php
$counter = 0;
foreach ( $rows as $row ) {
	
	// get Itemid
	switch ( $type ) {
	    
		case 2:
			$query = "SELECT id"
			. "\n FROM #__menu"
			. "\n WHERE type = 'content_typed'"
			. "\n AND componentid = $row->id"
			;
			$database->setQuery( $query );
			$Itemid = $database->loadResult();
			break;
		case 4:
		case 3:
			if ( $row->sectionid ) {
				$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
			} else {
				$query = "SELECT id"
				. "\n FROM #__menu"
				. "\n WHERE type = 'content_typed'"
				. "\n AND componentid = $row->id"
				;
				$database->setQuery( $query );
				$Itemid = $database->loadResult();
			}
			break;
		case 1:
		default:
			$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
			break;
	}

	// Blank itemid checker for SEF
	if ($Itemid == NULL) {
		$Itemid = '';
	} else {
		$Itemid = '&amp;Itemid='. $Itemid;
	}
    
	$link = sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='. $row->id . $Itemid );
	$mainimage = getRotatorImage($row);
	
	?>
        <div class="story-block">
            <div class="image">
                <?php if ($mainimage) { ?>
                    <?php if ($linkimage==1) { ?>
                        <a href="<?php echo $link; ?>" title="<?php echo $row->title; ?>"><img src="<?php echo $mainimage ?>" alt="<?php echo $row->title; ?>" /></a>
                    <?php } else { ?>
                        <img src="<?php echo $mainimage ?>" alt="<?php echo $row->title; ?>" />
                    <? } ?>
                <? } ?>
            </div>
            <div class="story">
                <div class="padding">
                    <?php if ($linktitle==1) { ?>
                    <h1><a href="<?php echo $link; ?>"><?php echo $row->title; ?></a></h1>
                    <?php } else { ?>
                    <h1><?php echo $row->title; ?></h1>
                    <?php } ?>
                    <p>
                       <?php echo prepareContent($row->introtext, $length); ?> 
                       <?php if ($linktitle!=1) { ?>
                       <a href="<?php echo $link; ?>" class="readon"><?php echo $readmore; ?></a>    
                       <?php } ?>
                    </p>
                </div>
            </div>
        </div>
	<?php
}
?>
</div>
