<?php
/**
* @version		$Id: helper.php 9764 2007-12-30 07:48:11Z rhuk $
* @package		RocketTheme
* @copyright	Copyright (C) 2005 - 2008 RocketTheme, LLC. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );


class modRokMiniNewsHelper
{
	
	function getSection(&$params) {
		global $mosConfig_offset,$mainframe,$database,$my;

		/// no direct access
		defined( '_VALID_MOS' ) or die( 'Restricted access' );

		$secid		= trim( $params->get('secid') );
		$count 		= intval( $params->get( 'count', 20 ) );
		$access 	= !$mainframe->getCfg( 'shownoauth' );
		$now 		= _CURRENT_SERVER_TIME;
		$nullDate 	= $database->getNullDate();
		
		$query = 'SELECT s.id, s.title, s.name' .
			' FROM #__sections AS s' .
			' WHERE s.id > 0 ' .
			($access ? ' AND s.access <= ' .(int) $my->gid : '').
			' AND s.published = 1 AND s.id = ' . $secid;

		$database->setQuery( $query);
		$database->loadObject($row);
		
		return $row;
	}
	
	function getCategories(&$params) {
		
		global $mosConfig_offset,$mainframe,$database,$my;
		
		$secid		= trim( $params->get('secid') );
		$count 		= intval( $params->get( 'count', 20 ) );
		$access 	= !$mainframe->getCfg( 'shownoauth' );
		$now 		= _CURRENT_SERVER_TIME;
		$nullDate 	= $database->getNullDate();

		$query = 'SELECT c.id, c.title, c.name' .
			' FROM #__categories AS c' .
			' WHERE c.id > 0 ' .
			($access ? ' AND c.access <= ' .(int) $my->gid : '').
			' AND c.published = 1 AND c.section = ' . $secid;

		$database->setQuery( $query, 0, 15 );
		$rows = $database->loadObjectList();

		if ( $rows ) {
			// list of sectionids, used to find corresponding Itemids
			for( $i=0, $n=count( $rows ); $i<$n; $i++ ) {
				$cids[] = (int) $rows[$i]->id;
			}
			// add 0 to the list, to get the Itemid of a global blog section item as a fallback
			$cids[] = 0;

			// get Itemids of sections
			$query = "SELECT m.id AS Itemid, m.componentid AS categoryid"
			. "\n FROM #__menu AS m"
			. "\n WHERE ( m.type = 'content_category' OR m.type = 'content_blog_category' )"
			. "\n AND m.published = 1"
			. ( $access ? "\n AND m.access <= " . (int) $my->gid : '' )
			. "\n AND ( m.componentid=" . implode( " OR m.componentid=", $cids ) . " )"
			. "\n ORDER BY m.type DESC, m.id DESC"
			;
			$database->setQuery( $query );
			$itemids = $database->loadObjectList( 'categoryid' );
			
			

			foreach ($rows as $row) {
				if (isset( $itemids[$row->id] )) {
					$link = sefRelToAbs( "index.php?option=com_content&amp;task=blogcategory&amp;id=". $row->id . "&amp;Itemid=" . $itemids[$row->id]->Itemid );
				} else if (isset( $itemids[0] )) {
					$link = sefRelToAbs( "index.php?option=com_content&amp;task=blogcategory&amp;id=". $row->id . "&amp;Itemid=" . $itemids[0]->Itemid );
				} else {
					$link = sefRelToAbs( "index.php?option=com_content&amp;task=blogcategory&amp;id=". $row->id );
				}

				$row->link = $link;

			}

		}
		return $rows;

	}
	
	function getThumb($text, $size=70, $reflections=false) {
		
		preg_match( "'src=(?:\"|\')?(?<imgSrc>[^>]*[^/].(?:jpg|bmp|gif|png))(?:\"|\')?'", $text, $matches );
		
		if (isset($matches[1])) {
			$image_path = $matches[1];
			
			//remove any protocol/site info from the image path
			$uri = $_SERVER['REQUEST_URI'];
			if (strpos($image_path,$uri) !== false ) {
				$image_path = substr($image_path,strpos($image_path, $uri)+strlen($uri));
			}
			
			//if after removing the uri, still has protocol then the image
			//is remote and we don't support thumbs for external images
			if (strpos($image_path,'http://') !== false ||
				strpos($image_path,'https://') !== false) {
				return false;
			}
			
			// create a thumb filename
			$file_div = strrpos($image_path,'.');
			$thumb_ext = substr($image_path, $file_div);
			$thumb_prev = substr($image_path, 0, $file_div);
			$thumb_path = $thumb_prev . "_thumb" . $thumb_ext;
	
			// check to see if this file exists, if so we don't need to create it
			if (!file_exists($thumb_path)) {
				// file doens't exist, so create it and save it
				include_once('thumbnail.inc.php');
				$thumb = new Thumbnail($image_path);
				$thumb->resize($size);
				if ($reflections) {
					$thumb->createReflection(30,30,60,false);
				}
				if (!is_writable(dirname($thumb_path))) {
					$thumb->destruct();
					return false;
				}
				$thumb->save($thumb_path);
				$thumb->destruct();
			}
			return ($thumb_path);
		} else {
			return false;
		}
	}
	
	function prepareContent( $text, $length=200 ) {
		// strips tags won't remove the actual jscript

		$text = preg_replace( "'<script[^>]*>.*?</script>'si", "", $text );
		
		$text = preg_replace( '/{.+?}/', '', $text);
		// replace line breaking tags with whitespace
		$text = strip_tags(preg_replace( "'<(br[^/>]*?/|hr[^/>]*?/|/(div|h[1-6]|li|p|td))>'si", ' ', $text ));
		// cut off text at word boundary if required
		if (strlen($text) > $length) {
			$text = substr($text, 0, strpos($text, ' ', $length)) . "..." ;
		} 
		return $text;
	}
	
	function getList(&$params) {
		
		global $mainframe, $database, $my;
		
		$type 		= intval( $params->get( 'type', 1 ) );
		$count 		= 15;
		$catid 		= trim( $params->get( 'catid' ) );
		$secid 		= trim( $params->get( 'secid' ) );
		$show_front	= $params->get( 'show_front', 1 );
		
		$text_length = intval($params->get( 'preview_count', 200) );

		$now 		= _CURRENT_SERVER_TIME;
		$access 	= !$mainframe->getCfg( 'shownoauth' );
		$nullDate 	= $database->getNullDate();

		// select between Content Items, Static Content or both
		switch ( $type ) {
			case 2: 
			//Static Content only
				$query = "SELECT a.id, a.title, a.introtext, a.created, a.modified, a.images"
				. "\n FROM #__content AS a"
				. "\n WHERE ( a.state = 1 AND a.sectionid = 0 )"
				. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
				. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
				. ( $access ? "\n AND a.access <= " . (int) $my->gid : '' )
				. "\n ORDER BY a.created DESC"
				;
				$database->setQuery( $query, 0, $count );
				$rows = $database->loadObjectList();
				break;

			case 3: 
			//Both
				$whereCatid = '';
				if ($catid) {
					$catids = explode( ',', $catid );
					mosArrayToInts( $catids );
					$whereCatid = "\n AND ( a.catid=" . implode( " OR a.catid=", $catids ) . " )";
				}
				$whereSecid = '';
				if ($secid) {
					$secids = explode( ',', $secid );
					mosArrayToInts( $secids );
					$whereSecid = "\n AND ( a.sectionid=" . implode( " OR a.sectionid=", $secids ) . " )";
				}
				$query = "SELECT a.id, a.title, a.introtext, a.sectionid, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state, s.published AS sec_state, a.created, a.modified, a.images"
				. "\n FROM #__content AS a"
				. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
				. "\n LEFT JOIN #__categories AS cc ON cc.id = a.catid"
				. "\n LEFT JOIN #__sections AS s ON s.id = a.sectionid"
				. "\n WHERE a.state = 1"
				. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
				. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
				. ( $access ? "\n AND a.access <= " . (int) $my->gid : '' )
				. $whereCatid
				. $whereSecid
				. ( $show_front == '0' ? "\n AND f.content_id IS NULL" : '' )
				. "\n ORDER BY a.created DESC"
				;
				$database->setQuery( $query, 0, $count );
				$temp = $database->loadObjectList();

				$rows = array();
				if (count($temp)) {
					foreach ($temp as $row ) {
						if (($row->cat_state == 1 || $row->cat_state == '') &&  ($row->sec_state == 1 || $row->sec_state == '') &&  ($row->cat_access <= $my->gid || $row->cat_access == '' || !$access) &&  ($row->sec_access <= $my->gid || $row->sec_access == '' || !$access)) {
							$rows[] = $row;
						}
					}
				}
				unset($temp);
				break;

			case 1:  
			default:
			//Content Items only
				$whereCatid = '';
				if ($catid) {
					$catids = explode( ',', $catid );
					mosArrayToInts( $catids );
					$whereCatid = "\n AND ( a.catid=" . implode( " OR a.catid=", $catids ) . " )";
				}
				$whereSecid = '';
				if ($secid) {
					$secids = explode( ',', $secid );
					mosArrayToInts( $secids );
					$whereSecid = "\n AND ( a.sectionid=" . implode( " OR a.sectionid=", $secids ) . " )";
				}
				$query = "SELECT a.id, a.title, a.introtext, a.sectionid, a.catid, a.created, a.modified, a.images"
				. "\n FROM #__content AS a"
				. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
				. "\n INNER JOIN #__categories AS cc ON cc.id = a.catid"
				. "\n INNER JOIN #__sections AS s ON s.id = a.sectionid"
				. "\n WHERE ( a.state = 1 AND a.sectionid > 0 )"
				. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
				. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
				. ( $access ? "\n AND a.access <= " . (int) $my->gid . " AND cc.access <= " . (int) $my->gid . " AND s.access <= " . (int) $my->gid : '' )
				. $whereCatid
				. $whereSecid
				. ( $show_front == '0' ? "\n AND f.content_id IS NULL" : '' )
				. "\n AND s.published = 1"
				. "\n AND cc.published = 1"
				. "\n ORDER BY a.created DESC"
				;
				$database->setQuery( $query, 0, $count );
				$rows = $database->loadObjectList();
				break;
		}
		
		$i		= 0;
		$lists	= array();
		
		// needed to reduce queries used by getItemid for Content Items
		if ( ( $type == 1 ) || ( $type == 3 ) ) {
			$bs 	= $mainframe->getBlogSectionCount();
			$bc 	= $mainframe->getBlogCategoryCount();
			$gbs 	= $mainframe->getGlobalBlogSectionCount();
		}
		
		global $_MAMBOTS;
		$_MAMBOTS->loadBotGroup( 'content' );
		
		foreach ( $rows as $row )
		{
			// get Itemid
			switch ( $type ) {
				case 2:
					$query = "SELECT id"
					. "\n FROM #__menu"
					. "\n WHERE type = 'content_typed'"
					. "\n AND componentid = " . (int) $row->id
					;
					$database->setQuery( $query );
					$Itemid = $database->loadResult();
					break;

				case 3:
					if ( $row->sectionid ) {
						$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
					} else {
						$query = "SELECT id"
						. "\n FROM #__menu"
						. "\n WHERE type = 'content_typed'"
						. "\n AND componentid = " . (int) $row->id
						;
						$database->setQuery( $query );
						$Itemid = $database->loadResult();
					}
					break;

				case 1:
				default:
					$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
					break;
			}

			// Blank itemid checker for SEF
			if ($Itemid == NULL) {
				$Itemid = '';
			} else {
				$Itemid = '&amp;Itemid='. $Itemid;
			}
			
			//fire the plugin bot
			$row->text = $row->introtext;
			
			// process mambots
			$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$params, 0 ), true );

			$link = sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='. $row->id . $Itemid );
			
			$lists[$i]->id = $row->id;
			$lists[$i]->thumb = $i > 1 ? false : modRokMiniNewsHelper::getThumb($row->text);
			$lists[$i]->created = $row->created;
			$lists[$i]->modified = $row->modified;
			$lists[$i]->link = $link;
			$lists[$i]->title = htmlspecialchars( $row->title );
			$lists[$i]->introtext = $i > 4 ? false : modRokMiniNewsHelper::prepareContent( $row->introtext, $text_length);
			$i++;
		}
		
		return $lists;
		
	}
}
