<?php
/*
 * RokMooMenu Version 3.0
 * Copyright RocketTheme, LLC - 2008
 */


/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
/* returns a properly nested UL menu */

class RokmenuItem {
	var $id;
	var $name;
	var $parent;
	var $link;
	var $path;
	var $level;
	var $index;
	var $children;
	var $browsernav;
	var $type;
}

class RokMenu {
	var $_menu;
    var $_menutype;
    var $_module_type;
    var $_openall;
    var $_start;
    var $_end;
    var $_open;
    var $_class_sfx;
    var $_menu_sfx;
    var $_menu_name;
    var $_menu_name_extra;
    var $_output;
    var $_showmenuname;
	var $_active_path;
	var $_path_array;
	var $_menucolors;
	var $_defaultcolor;
    
    function __construct($menutype) {
		global $Itemid;
		
	
        $this->_menutype = $menutype;
        $this->_open = array(); //should not be needed
		$this->_menu_array = array();
		$this->_active_path = array();
		$this->_path_array = array();
        $this->_menu_name = '';
        $this->_menu_name_extra = " Menu";
		$this->_menucolors = null;
		$this->_itemid = $Itemid;
		
		// itemid weirdness
		if ($this->_itemid > 99999) $this->_itemid = 1;
		
		$this->init();
    }

    /* for php4 */
    function RokMenu($menutype) {
        $this->__construct($menutype);
    }

	function configure($menu_sfx, $module_sfx, $module_type=-1, $showmenuname=false, $openall=false, $start=0, $end=10) {

		$this->_menu_sfx = $menu_sfx;
		$this->_module_sfx = $module_sfx;
		$this->_module_type = $module_type;
		$this->_showmenuname = $showmenuname;
        $this->_openall = $openall;
        $this->_start = $start;
        $this->_end = $end;
        $this->_class_sfx = null;
		$this->_output = ""; //reset output
	}


    function init() {
     	global $database, $my, $cur_template;
     	global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_shownoauth;
     	
      	$class_sfx = null;
     	$hilightid = null;
     	$startid = 0;

     	if ($mosConfig_shownoauth) {
            $database->setQuery("SELECT m.id,m.name,m.link,m.parent,m.browserNav,m.type, count(p.parent) as child_count" .
            "\nFROM #__menu AS m" .
            "\nLEFT JOIN #__menu AS p ON p.parent = m.id" .
            "\nWHERE m.menutype='$this->_menutype' AND m.published='1'" .
            "\nGROUP BY m.id ORDER BY m.parent, m.ordering ");
        } else {
            $database->setQuery("SELECT m.id,m.name,m.link,m.parent,m.browserNav,m.type, sum(case when p.published=1 then 1 else 0 end) as child_count" .
            "\nFROM #__menu AS m" .
            "\nLEFT JOIN #__menu AS p ON p.parent = m.id" .
            "\nWHERE m.menutype='$this->_menutype' AND m.published='1' AND m.access <= " . (int)$my->gid .
            "\nGROUP BY m.id ORDER BY m.parent, m.ordering ");
        }

     	$menu = $database->loadObjectList( 'id' );
     	echo $database->getErrorMsg();

		$this->_menu = $menu;

		$path = array();
		$path[0] = 0;
		$level = 0;
		
		$this->_menu_array = $this->getMenuChildren( 0, $path, $level);
		
		if ($this->_itemid) {
			$this->_active_path = $this->_path_array[$this->_itemid];
		}
    
    }

	function getMenuChildren($parent, $path, $level) {

		$children = array();
		$count = 0;

		foreach ($this->_menu as $key => $value) {
			
			$childmenuitem =& $this->_menu[$key];

			if ($childmenuitem->parent == $parent) {
				
				$item = new RokmenuItem();
				$item->id = $childmenuitem->id;
				$item->name = $childmenuitem->name;
				$item->link = $childmenuitem->link;
				$item->parent = $childmenuitem->parent;
				$item->path = $path;
				$item->path[$childmenuitem->id] = $childmenuitem->id;
				$item->level = $level;
				$item->index = $count++;
				$item->browsernav = $childmenuitem->browserNav;
				$item->type = $childmenuitem->type;

				$child_array = $this->getMenuChildren($childmenuitem->id, $item->path, $level+1);
				

				if ($child_array !== false) {
					$item->children = $child_array;
				} else {
					$item->children = false;
				}

				$children[$item->id] = $item;
				$this->_path_array[$item->id] = $item->path;


			} 
		}

		if (sizeof($children) == 0) {
			return false;
		}

		return $children;
	}

	function display() {
		$starting = $this->_getStartingChild();
		$this->_output = $this->_renderList($starting, $this->_start);
		
		if (!$this->_output) return false;

        switch ($this->_module_type) {
            case -2:
                $pre = "<div class=\"moduletable$this->_module_sfx\">\n";
                $post = "</div>\n";
                break;
            case -3:
                $pre = "<div class=\"module$this->_module_sfx\"><div><div><div>\n";
                $post = "</div></div></div></div>\n";
                break;
            default:
                $pre = "";
                $post = "";
                break;
        }

        if ($this->_showmenuname) {
            $pre .= "<h3>" . $this->_menu_name . $this->_menu_name_extra . "</h3>\n";
        }

        return $pre . $this->_output . $post;
        return $this->_output;
    }
	
	function _getStartingChild() {
		
		$child = $this->_menu_array;
		foreach ($this->_active_path as $pathid) {
			if ($pathid > 0 ) {
			
				if ($child[$pathid]->level < $this->_start && $child[$pathid]->children) {
					$this->_menu_name = $child[$pathid]->name;
					$child = $child[$pathid]->children;
				} else {
					break;
				}
			}
		}
		return ($child);
	}
	
	function _renderList( &$children, $level ) {
		
		$output = "";
		$has_output = false;

		if (is_array($children) && sizeof($children)>0) {
			
			$ulstyle = "";
			if($this->_start==$level) {
    		    $ulstyle .= ' class="menu' . $this->_menu_sfx . '" ';
    		} 
    		if($level==0) {
    		    $ulstyle .= ' id="horiznav"'; 
    		}
			
			$output .= "\n<ul" . $ulstyle . ">\n";
			foreach ($children as $key => $value) {

				$menuitem =& $children[$key];	
				
				
				$class = "";
				if (in_array($menuitem->id, $this->_active_path)) $class .= "active ";
				if ($menuitem->children) $class .= "parent ";
				
				//check for colors at top level
				if ($level==0 && $this->_menucolors) {
					
					if (isset($this->_menucolors[$menuitem->index])) {
						$color = $this->_menucolors[$menuitem->index];
					} else {
						$color = $this->_defaultcolor;
					}
					$class .= $color;
				}
			
				if ($menuitem->level == $level) {
					$has_output = true;
					$output .= "<li class=\"$class\">";
					$output .= $this->getLinkUrl($menuitem);

					if (((is_array($menuitem->children) && in_array($this->_itemid, array_keys(&$menuitem->children))) 
						|| $menuitem->id == $this->_itemid ||	$this->_openall) 
						&& (($this->_end - $menuitem->level) > 1 && $menuitem->children)) {
							$output .= $this->_renderList($menuitem->children,$level+1);
					}
					$output .= "</li>\n";
				}
			}
			$output .= "</ul>\n";
		}
		if ($has_output) return $output;
		else return false;
	}
	
	
	function getLinkUrl(&$mitem) {
		
		$class = "";
		$output = null;
		
		switch ($mitem->type) {
      		case 'separator':
	      		$mitem->browsernav = 3;
	      		break;
      		case 'url':
	      		if ( eregi( 'index.php\?', $mitem->link ) && !eregi( 'Itemid=', $mitem->link ) ) $mitem->link .= '&Itemid='. $mitem->id;
	      		break;
      		default:
      			$mitem->link .= "&Itemid=$mitem->id";
      			break;
      	}
		
		$mitem->link = str_replace( '&', '&amp;', $mitem->link );
    	$mitem->name = stripslashes( ampReplace($mitem->name) );

    	if (strcasecmp(substr($mitem->link,0,4),"http")) {
    		$mitem->link = sefRelToAbs($mitem->link);
    	}
		
		if ($mitem->children) $class = $mitem->level == 0 ? "class=\"topdaddy\"" : "class=\"daddy\"";
		
		switch ($mitem->browsernav) {
    		// cases are slightly different
    		case 1:
				//new window
				$output = "<a $class target=\"_window\" href=\"$mitem->link\"><span>$mitem->name</span></a>";
	    		break;
    		case 2:
				//popup
    			$output = "<a $class href=\"#\" onClick=\"javascript: window.open('$mitem->link', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550');\"<span>>$mitem->name</span></a>\n";
    			break;
    		case 3:
    			// don't link it
        		$output = "<a $class href=\"#><span>$mitem->name</span></a>\n";
    			break;
    		default:
    			// open in parent window
    			$output = "<a $class href=\"$mitem->link\"><span>$mitem->name</span></a>";
            	break;
		}
		return $output;
	}

	// sets the menu colors
	function setColors($colors, $default) {
		$this->_menucolors = explode(',',$colors);
		$this->_defaultcolor = $default;

	}
	
	// function to set the extra menu name
	function setExtraMenuName($name) {
		$this->_menu_name_extra = $name;
	}

    // gets the color based on the parent
    function getColor() {
	
		$keys = array_keys($this->_active_path);
		$parent_id = $this->_active_path[$keys[1]];
		$parent = $this->_menu_array[$parent_id];

		if (isset($this->_menucolors[$parent->index])) {
			return $this->_menucolors[$parent->index];
		} else {
			return $this->_defaultcolor;
		}
	}

    
    function ismenu() {
        if (strlen($this->_output) > 5) return true;
        else return false;
    }
      
}

?>