-- phpMyAdmin SQL Dump
-- version 2.11.6
-- http://www.phpmyadmin.net
--

--
-- Table structure for table `#__banner`
--

DROP TABLE IF EXISTS `#__banner`;
CREATE TABLE IF NOT EXISTS `#__banner` (
  `bid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `type` varchar(30) NOT NULL default 'banner',
  `name` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `imptotal` int(11) NOT NULL default '0',
  `impmade` int(11) NOT NULL default '0',
  `clicks` int(11) NOT NULL default '0',
  `imageurl` varchar(100) NOT NULL default '',
  `clickurl` varchar(200) NOT NULL default '',
  `date` datetime default NULL,
  `showBanner` tinyint(1) NOT NULL default '0',
  `checked_out` tinyint(1) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `editor` varchar(50) default NULL,
  `custombannercode` text,
  `catid` int(10) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `publish_up` datetime NOT NULL default '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL default '0000-00-00 00:00:00',
  `tags` text NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY  (`bid`),
  KEY `viewbanner` (`showBanner`),
  KEY `idx_banner_catid` (`catid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__banner`
--

INSERT INTO `#__banner` (`bid`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `imageurl`, `clickurl`, `date`, `showBanner`, `checked_out`, `checked_out_time`, `editor`, `custombannercode`, `catid`, `description`, `sticky`, `ordering`, `publish_up`, `publish_down`, `tags`, `params`) VALUES
(1, 1, 'banner', 'OSM 1', 'osm-1', 0, 248, 0, 'osmbanner1.png', 'http://www.opensourcematters.org', '2004-07-07 15:31:29', 1, 0, '0000-00-00 00:00:00', '', '', 0, '', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', ''),
(2, 1, 'banner', 'OSM 2', 'osm-2', 0, 217, 0, 'osmbanner2.png', 'http://www.opensourcematters.org', '2004-07-07 15:31:29', 1, 0, '0000-00-00 00:00:00', '', '', 0, '', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__bannerclient`
--

DROP TABLE IF EXISTS `#__bannerclient`;
CREATE TABLE IF NOT EXISTS `#__bannerclient` (
  `cid` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `contact` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `extrainfo` text NOT NULL,
  `checked_out` tinyint(1) NOT NULL default '0',
  `checked_out_time` time default NULL,
  `editor` varchar(50) default NULL,
  PRIMARY KEY  (`cid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__bannerclient`
--

INSERT INTO `#__bannerclient` (`cid`, `name`, `contact`, `email`, `extrainfo`, `checked_out`, `checked_out_time`, `editor`) VALUES
(1, 'Open Source Matters', 'Administrator', 'admin@opensourcematters.org', '', 0, '00:00:00', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__bannertrack`
--

DROP TABLE IF EXISTS `#__bannertrack`;
CREATE TABLE IF NOT EXISTS `#__bannertrack` (
  `track_date` date NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL
) ENGINE=MyISAM;

--
-- Dumping data for table `#__bannertrack`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__categories`
--

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE IF NOT EXISTS `#__categories` (
  `id` int(11) NOT NULL auto_increment,
  `parent_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `image` varchar(255) NOT NULL default '',
  `section` varchar(50) NOT NULL default '',
  `image_position` varchar(30) NOT NULL default '',
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `editor` varchar(50) default NULL,
  `ordering` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `count` int(11) NOT NULL default '0',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `cat_idx` (`section`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__categories`
--

INSERT INTO `#__categories` (`id`, `parent_id`, `title`, `name`, `alias`, `image`, `section`, `image_position`, `description`, `published`, `checked_out`, `checked_out_time`, `editor`, `ordering`, `access`, `count`, `params`) VALUES
(1, 0, 'Latest', 'Latest News', 'latest', 'taking_notes.jpg', '1', 'left', 'The latest news from the Joomla! Team', 1, 0, '0000-00-00 00:00:00', '', 0, 0, 1, ''),
(2, 0, 'Joomla!', 'Joomla!', 'joomla', 'clock.jpg', 'com_weblinks', 'left', 'A selection of links that are all related to the Joomla! Project.', 1, 0, '0000-00-00 00:00:00', '', 0, 0, 0, ''),
(3, 0, 'Newsflash', 'Newsflash', 'newsflash', '', '2', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 0, 0, 0, ''),
(4, 0, 'Joomla!', 'Joomla!', 'joomla', '', 'com_newsfeeds', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 2, 0, 0, ''),
(5, 0, 'Business: general', 'Business: general', 'business-general', '', 'com_newsfeeds', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, ''),
(7, 0, 'Examples', 'Example FAQs', 'examples', 'key.jpg', '3', 'left', 'Here you will find an example set of FAQs.', 1, 0, '0000-00-00 00:00:00', '', 0, 0, 2, ''),
(9, 0, 'Finance', 'Finance', 'finance', '', 'com_newsfeeds', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 5, 0, 0, ''),
(10, 0, 'Linux', 'Linux', 'linux', '', 'com_newsfeeds', 'left', '<br />\r\n', 1, 0, '0000-00-00 00:00:00', '', 6, 0, 0, ''),
(11, 0, 'Internet', 'Internet', 'internet', '', 'com_newsfeeds', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 7, 0, 0, ''),
(12, 0, 'Contacts', 'Contacts', 'contacts', '', 'com_contact_details', 'left', 'Contact Details for this website', 1, 0, '0000-00-00 00:00:00', '', 0, 0, 0, ''),
(13, 0, 'North America', 'North America', 'north-america', '', '4', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 6, 0, 0, 'imagefolders=*2*'),
(14, 0, 'South America', 'South America', 'south-america', '', '4', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 5, 0, 0, 'imagefolders=*2*'),
(17, 0, 'Europe', 'Europe', 'europe', '', '4', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 3, 0, 0, 'imagefolders=*2*'),
(16, 0, 'Asia', 'Asia', 'asia', '', '4', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 4, 0, 0, 'imagefolders=*2*'),
(18, 0, 'Africa', 'Africa', 'africa', '', '4', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 2, 0, 0, 'imagefolders=*2*'),
(19, 0, 'Australia', 'Australia', 'australia', '', '4', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, 'imagefolders=*2*'),
(20, 0, 'Soccer', 'Soccer', 'soccer', '', '5', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 4, 0, 0, 'imagefolders=*2*'),
(21, 0, 'Olympics', 'Olympics', 'olympics', '', '5', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 5, 0, 0, 'imagefolders=*2*'),
(22, 0, 'Motor Sport', 'Motor Sport', 'motor-sport', '', '5', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 3, 0, 0, 'imagefolders=*2*'),
(23, 0, 'Football', 'Football', 'football', '', '5', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 2, 0, 0, 'imagefolders=*2*'),
(24, 0, 'Golf', 'Golf', 'golf', '', '5', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, 'imagefolders=*2*'),
(25, 0, 'Markets', 'Markets', 'markets', '', '6', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 4, 0, 0, 'imagefolders=*2*'),
(26, 0, 'Economics', 'Economics', 'economics', '', '6', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 3, 0, 0, 'imagefolders=*2*'),
(27, 0, 'Sectors', 'Sectors', 'sectors', '', '6', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 2, 0, 0, 'imagefolders=*2*'),
(28, 0, 'Commentary', 'Commentary', 'commentary', '', '6', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, 'imagefolders=*2*'),
(29, 0, 'Space', 'Space', 'space', '', '7', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 4, 0, 0, 'imagefolders=*2*'),
(30, 0, 'Computers', 'Computers', 'computers', '', '7', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 3, 0, 0, 'imagefolders=*2*'),
(31, 0, 'Science', 'Science', 'science', '', '7', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 2, 0, 0, 'imagefolders=*2*'),
(32, 0, 'Gadgets', 'Gadgets', 'gadgets', '', '7', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, 'imagefolders=*2*'),
(33, 0, 'Fashion and Beauty', 'Fashion and Beauty', 'fashion-and-beauty', '', '8', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 4, 0, 0, 'imagefolders=*2*'),
(34, 0, 'Food and Drink', 'Food and Drink', 'food-and-drink', '', '8', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 2, 0, 0, 'imagefolders=*2*'),
(35, 0, 'Home and Gardens', 'Home and Garden', 'home-and-gardens', '', '8', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 3, 0, 0, 'imagefolders=*2*'),
(36, 0, 'Health', 'Health', 'health', '', '8', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, 'imagefolders=*2*'),
(37, 0, 'Hotels', 'Hotels', 'hotels', '', '9', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 4, 0, 0, 'imagefolders=*2*'),
(38, 0, 'Restaurants', 'Restaurants', 'restaurants', '', '9', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 3, 0, 0, 'imagefolders=*2*'),
(39, 0, 'Trip Deals', 'Trip Deals', 'trip-deals', '', '9', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 2, 0, 0, 'imagefolders=*2*'),
(40, 0, 'Blog', 'Blog', 'blog', '', '9', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, 'imagefolders=*2*'),
(41, 0, 'Rotator News', 'Rotator News', 'rotator-news', '', '10', 'left', '', 1, 0, '0000-00-00 00:00:00', '', 1, 0, 0, 'imagefolders=*2*');

-- --------------------------------------------------------

--
-- Table structure for table `#__components`
--

DROP TABLE IF EXISTS `#__components`;
CREATE TABLE IF NOT EXISTS `#__components` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `link` varchar(255) NOT NULL default '',
  `menuid` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned NOT NULL default '0',
  `admin_menu_link` varchar(255) NOT NULL default '',
  `admin_menu_alt` varchar(255) NOT NULL default '',
  `option` varchar(50) NOT NULL default '',
  `ordering` int(11) NOT NULL default '0',
  `admin_menu_img` varchar(255) NOT NULL default '',
  `iscore` tinyint(4) NOT NULL default '0',
  `params` text NOT NULL,
  `enabled` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `parent_option` (`parent`,`option`(32))
) ENGINE=MyISAM;

--
-- Dumping data for table `#__components`
--

INSERT INTO `#__components` (`id`, `name`, `link`, `menuid`, `parent`, `admin_menu_link`, `admin_menu_alt`, `option`, `ordering`, `admin_menu_img`, `iscore`, `params`, `enabled`) VALUES
(1, 'Banners', '', 0, 0, '', 'Banner Management', 'com_banners', 0, 'js/ThemeOffice/component.png', 0, 'track_impressions=0\ntrack_clicks=0\ntag_prefix=\n\n', 1),
(2, 'Banners', '', 0, 1, 'option=com_banners', 'Active Banners', 'com_banners', 1, 'js/ThemeOffice/edit.png', 0, '', 1),
(3, 'Clients', '', 0, 1, 'option=com_banners&c=client', 'Manage Clients', 'com_banners', 2, 'js/ThemeOffice/categories.png', 0, '', 1),
(4, 'Web Links', 'option=com_weblinks', 0, 0, '', 'Manage Weblinks', 'com_weblinks', 0, 'js/ThemeOffice/component.png', 0, 'show_comp_description=1\ncomp_description=\nshow_link_hits=1\nshow_link_description=1\nshow_other_cats=1\nshow_headings=1\ntarget=0\nlink_icons=weblink.png\n\n', 1),
(5, 'Links', '', 0, 4, 'option=com_weblinks', 'View existing weblinks', 'com_weblinks', 1, 'js/ThemeOffice/edit.png', 0, '', 1),
(6, 'Categories', '', 0, 4, 'option=com_categories&section=com_weblinks', 'Manage weblink categories', '', 2, 'js/ThemeOffice/categories.png', 0, '', 1),
(7, 'Contacts', 'option=com_contact', 0, 0, '', 'Edit contact details', 'com_contact', 0, 'js/ThemeOffice/component.png', 1, 'contact_icons=0\nicon_address=\nicon_email=\nicon_telephone=\nicon_fax=\nicon_misc=\nshow_headings=1\nshow_position=1\nshow_email=0\nshow_telephone=1\nshow_mobile=1\nshow_fax=1\nbannedEmail=\nbannedSubject=\nbannedText=\nsession=1\ncustomReply=0\n\n', 1),
(8, 'Contacts', '', 0, 7, 'option=com_contact', 'Edit contact details', 'com_contact', 0, 'js/ThemeOffice/edit.png', 1, '', 1),
(9, 'Categories', '', 0, 7, 'option=com_categories&section=com_contact_details', 'Manage contact categories', '', 2, 'js/ThemeOffice/categories.png', 1, 'contact_icons=0\nicon_address=\nicon_email=\nicon_telephone=\nicon_fax=\nicon_misc=\nshow_headings=1\nshow_position=1\nshow_email=0\nshow_telephone=1\nshow_mobile=1\nshow_fax=1\nbannedEmail=\nbannedSubject=\nbannedText=\nsession=1\ncustomReply=0\n\n', 1),
(10, 'Polls', 'option=com_poll', 0, 0, 'option=com_poll', 'Manage Polls', 'com_poll', 0, 'js/ThemeOffice/component.png', 0, '', 1),
(11, 'News Feeds', 'option=com_newsfeeds', 0, 0, '', 'News Feeds Management', 'com_newsfeeds', 0, 'js/ThemeOffice/component.png', 0, '', 1),
(12, 'Feeds', '', 0, 11, 'option=com_newsfeeds', 'Manage News Feeds', 'com_newsfeeds', 1, 'js/ThemeOffice/edit.png', 0, 'show_headings=1\nshow_name=1\nshow_articles=1\nshow_link=1\nshow_cat_description=1\nshow_cat_items=1\nshow_feed_image=1\nshow_feed_description=1\nshow_item_description=1\nfeed_word_count=0\n\n', 1),
(13, 'Categories', '', 0, 11, 'option=com_categories&section=com_newsfeeds', 'Manage Categories', '', 2, 'js/ThemeOffice/categories.png', 0, '', 1),
(14, 'User', 'option=com_user', 0, 0, '', '', 'com_user', 0, '', 1, '', 1),
(15, 'Search', 'option=com_search', 0, 0, 'option=com_search', 'Search Statistics', 'com_search', 0, 'js/ThemeOffice/component.png', 1, 'enabled=0\n\n', 1),
(16, 'Categories', '', 0, 1, 'option=com_categories&section=com_banner', 'Categories', '', 3, '', 1, '', 1),
(17, 'Wrapper', 'option=com_wrapper', 0, 0, '', 'Wrapper', 'com_wrapper', 0, '', 1, '', 1),
(18, 'Mail To', '', 0, 0, '', '', 'com_mailto', 0, '', 1, '', 1),
(19, 'Media Manager', '', 0, 0, 'option=com_media', 'Media Manager', 'com_media', 0, '', 1, 'upload_extensions=bmp,csv,doc,epg,gif,ico,jpg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,EPG,GIF,ICO,JPG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\nupload_maxsize=10000000\nfile_path=images\nimage_path=images/stories\nrestrict_uploads=1\ncheck_mime=1\nimage_extensions=bmp,gif,jpg,png\nignore_extensions=\nupload_mime=image/jpeg,image/gif,image/png,image/bmp,application/x-shockwave-flash,application/msword,application/excel,application/pdf,application/powerpoint,text/plain,application/x-zip\nupload_mime_illegal=text/html\nenable_flash=1\n\n', 1),
(20, 'Articles', 'option=com_content', 0, 0, '', '', 'com_content', 0, '', 1, 'show_noauth=0\nshow_title=1\nlink_titles=0\nshow_intro=1\nshow_section=0\nlink_section=0\nshow_category=0\nlink_category=0\nshow_author=0\nshow_create_date=0\nshow_modify_date=0\nshow_item_navigation=0\nshow_readmore=1\nshow_vote=0\nshow_icons=0\nshow_pdf_icon=0\nshow_print_icon=0\nshow_email_icon=0\nshow_hits=0\nfeed_summary=0\nfilter_tags=\nfilter_attritbutes=\n\n', 1),
(21, 'Configuration Manager', '', 0, 0, '', 'Configuration', 'com_config', 0, '', 1, '', 1),
(22, 'Installation Manager', '', 0, 0, '', 'Installer', 'com_installer', 0, '', 1, '', 1),
(23, 'Language Manager', '', 0, 0, '', 'Languages', 'com_languages', 0, '', 1, 'administrator=en-GB\nsite=en-GB', 1),
(24, 'Mass mail', '', 0, 0, '', 'Mass Mail', 'com_massmail', 0, '', 1, 'mailSubjectPrefix=\nmailBodySuffix=\n\n', 1),
(25, 'Menu Editor', '', 0, 0, '', 'Menu Editor', 'com_menus', 0, '', 1, '', 1),
(27, 'Messaging', '', 0, 0, '', 'Messages', 'com_messages', 0, '', 1, '', 1),
(28, 'Modules Manager', '', 0, 0, '', 'Modules', 'com_modules', 0, '', 1, '', 1),
(29, 'Plugin Manager', '', 0, 0, '', 'Plugins', 'com_plugins', 0, '', 1, '', 1),
(30, 'Template Manager', '', 0, 0, '', 'Templates', 'com_templates', 0, '', 1, '', 1),
(31, 'User Manager', '', 0, 0, '', 'Users', 'com_users', 0, '', 1, 'allowUserRegistration=0\nnew_usertype=Registered\nuseractivation=0\nfrontend_userparams=0\n\n', 1),
(32, 'Cache Manager', '', 0, 0, '', 'Cache', 'com_cache', 0, '', 1, '', 1),
(33, 'Control Panel', '', 0, 0, '', 'Control Panel', 'com_cpanel', 0, '', 1, '', 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__contact_details`
--

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE IF NOT EXISTS `#__contact_details` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `con_position` varchar(255) default NULL,
  `address` text,
  `suburb` varchar(100) default NULL,
  `state` varchar(100) default NULL,
  `country` varchar(100) default NULL,
  `postcode` varchar(100) default NULL,
  `telephone` varchar(255) default NULL,
  `fax` varchar(255) default NULL,
  `misc` mediumtext,
  `image` varchar(255) default NULL,
  `imagepos` varchar(20) default NULL,
  `email_to` varchar(255) default NULL,
  `default_con` tinyint(1) unsigned NOT NULL default '0',
  `published` tinyint(1) unsigned NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL default '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL default '0',
  `catid` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `mobile` varchar(255) NOT NULL default '',
  `webpage` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__contact_details`
--

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`) VALUES
(1, 'Name', 'name', 'Position', 'Street', 'Suburb', 'State', 'Country', 'Zip Code', 'Telephone', 'Fax', 'Miscellanous info', '', 'top', 'email@email.com', 0, 1, 0, '0000-00-00 00:00:00', 1, 'show_name=1\nshow_position=1\nshow_email=0\nshow_street_address=1\nshow_suburb=1\nshow_state=1\nshow_postcode=1\nshow_country=1\nshow_telephone=1\nshow_mobile=1\nshow_fax=1\nshow_webpage=1\nshow_misc=1\nshow_image=1\nallow_vcard=0\ncontact_icons=0\nicon_address=\nicon_email=\nicon_telephone=\nicon_mobile=\nicon_fax=\nicon_misc=\nshow_email_form=1\nemail_description=\nshow_email_copy=1\nbanned_email=\nbanned_subject=\nbanned_text=', 0, 12, 0, '', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__content`
--

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE IF NOT EXISTS `#__content` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `title_alias` varchar(255) NOT NULL default '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL default '0',
  `sectionid` int(11) unsigned NOT NULL default '0',
  `mask` int(11) unsigned NOT NULL default '0',
  `catid` int(11) unsigned NOT NULL default '0',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `created_by` int(11) unsigned NOT NULL default '0',
  `created_by_alias` varchar(255) NOT NULL default '',
  `modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `modified_by` int(11) unsigned NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL default '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL default '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` text NOT NULL,
  `version` int(11) unsigned NOT NULL default '1',
  `parentid` int(11) unsigned NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(11) unsigned NOT NULL default '0',
  `hits` int(11) unsigned NOT NULL default '0',
  `metadata` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_section` (`sectionid`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__content`
--

INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(1, 'Welcome to Joomla!', 'welcome', 'Welcome', 'If you''ve read anything at all about Content Management Systems (CMS), you''ll probably know at least three things: CMS are the most exciting way to do business, CMS can be really, I mean <i>really</i>, complicated and lastly Portals are absolutely, outrageously, often <i>unaffordably</i> expensive. <br /><br /><div class="mosimage"  style=" border-width: 1px; float: left; width: 120px;" align="center"><img src="images/stories/asterisk.png" width="70" height="67" hspace="6" alt="Joomla! Logo" title="Joomla! Logo" border="0" /><div class="mosimage_caption" style="text-align: center;" align="center">Example Caption</div></div>Joomla! is set to change all that ... Joomla! is different from the normal models for portal software. For a start, it''s not complicated. Joomla! has been developed for the masses. It''s licensed under the GNU/GPL license, easy to install and administer and reliable. Joomla! doesn''t even require the user or administrator of the system to know HTML to operate it once it''s up and running.', '<h4><font color="#ff6600">Joomla! features:</font></h4>\r\n<ul>\r\n<li>Completely database driven site engines </li>\r\n<li>News, products or services sections fully editable and manageable</li> \r\n<li>Topics sections can be added to by contributing authors </li>\r\n<li>Fully customisable layouts including left, center and right menu boxes </li>\r\n<li>Browser upload of images to your own library for use anywhere in the site </li>\r\n<li>Dynamic Forum/Poll/Voting booth for on-the-spot results </li>\r\n<li>Runs on Linux, FreeBSD, MacOSX server, Solaris and AIX \r\n</li></ul>\r\n<h4>Extensive Administration:</h4>\r\n<ul>\r\n<li>Change order of objects including news, FAQs, articles etc. </li>\r\n<li>Random Newsflash generator </li>\r\n<li>Remote author submission module for News, Articles, FAQs and Links </li>\r\n<li>Object hierarchy - as many sections, departments, divisions and pages as you want </li>\r\n<li>Image library - store all your PNGs, PDFs, DOCs, XLSs, GIFs and JPEGs online for easy use </li>\r\n<li>Automatic Path-Finder. Place a picture and let Joomla! fix the link </li>\r\n<li>News feed manager. Choose from over 360 news feeds from around the world </li>\r\n<li>Archive manager. Put your old articles into cold storage rather than throw them out </li>\r\n<li>Email-a-friend and Print-format for every story and article </li>\r\n<li>In-line Text editor similar to Word Pad </li>\r\n<li>User editable look and feel </li>\r\n<li>Polls/Surveys - Now put a different one on each page </li>\r\n<li>Custom Page Modules. Download custom page modules to spice up your site </li>\r\n<li>Template Manager. Download templates and implement them in seconds </li>\r\n<li>Layout preview. See how it looks before going live </li>\r\n<li>Banner manager. Make money out of your site</li></ul>', 1, 1, 0, 1, '2004-06-12 11:54:06', 62, 'Web Master', '2008-06-28 20:35:32', 62, 0, '0000-00-00 00:00:00', '2004-01-01 00:00:00', '0000-00-00 00:00:00', 'asterisk.png|left|Joomla! Logo|1|Example Caption|bottom|center|120', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 2, 0, 2, '', '', 0, 1, 'robots=\nauthor='),
(2, 'Newsflash 1', 'newsflash-1', '', 'Joomla! 1.0 - ''Experience the Freedom''!. It has never been easier to create\r\nyour own dynamic site. Manage all your content from the best CMS admin\r\ninterface.', '', 1, 2, 1, 3, '2004-08-09 08:30:34', 62, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2004-08-09 00:00:00', '0000-00-00 00:00:00', '', '', '', 1, 0, 1, '', '', 0, 0, ''),
(3, 'Newsflash 2', 'newsflash-2', '', 'Yesterday all servers in the U.S. went out on strike in a bid to get more RAM and better CPUs. A spokes person said that the need for better RAM was due to some fool increasing the front-side bus speed. In future, busses will be told to slow down in residential motherboards.', '', 1, 2, 1, 3, '2004-08-09 08:30:34', 62, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2004-08-09 00:00:00', '0000-00-00 00:00:00', '', '', '', 1, 0, 2, '', '', 0, 0, ''),
(4, 'Newsflash 3', 'newsflash-3', '', 'Aoccdrnig to a rscheearch at an Elingsh uinervtisy, it deosn''t mttaer in waht oredr the ltteers in a wrod are, the olny iprmoetnt tihng is taht frist and lsat ltteer is at the rghit pclae. The rset can be a toatl mses and you can sitll raed it wouthit porbelm. Tihs is bcuseae we do not raed ervey lteter by itslef but the wrod as a wlohe.', '', 1, 2, 1, 3, '2004-08-09 08:30:34', 62, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2004-08-09 00:00:00', '0000-00-00 00:00:00', '', '', '', 1, 0, 3, '', '', 0, 2, ''),
(5, 'Joomla! License Guidelines', 'joomla-license-guidelines', '', '<p>This website is powered by <a href="http://www.joomla.org/">Joomla!</a>  The software and default templates on which it runs are Copyright 2005 <a href="http://www.opensourcematters.org/">Open Source Matters</a>.  All other content and data, including data entered into this website and templates added after installation, are copyrighted by their respective copyright owners.</p><p>If you want to distribute, copy or modify Joomla!, you are welcome to do so under the terms of the <a href="http://www.gnu.org/licenses/gpl-2.0.html#SEC1">GNU General Public License</a>.  If you are unfamiliar with this license, you might want to read <a href="http://www.gnu.org/licenses/gpl-2.0.html#SEC4">''How To Apply These Terms To Your Program''</a> and the <a href="http://www.gnu.org/licenses/gpl-faq.html">''GNU General Public License FAQ''</a>.</p>', '', 0, 0, 0, 0, '2004-08-19 20:11:07', 62, '', '2004-08-19 20:14:49', 62, 0, '0000-00-00 00:00:00', '2004-08-19 00:00:00', '0000-00-00 00:00:00', '', '', 'menu_image=\nitem_title=1\npageclass_sfx=\nback_button=\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=', 1, 0, 17, '', '', 0, 12, ''),
(6, 'Example News Item 1', 'news1', 'News1', '<img src="images/stories/food/coffee.jpg" width="150" height="112" style="float: left;" hspace="6" alt="Image" title="Image" border="0" />Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat,\r\nsed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit\r\namet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam\r\nvoluptua. At vero eos et accusam et justo duo dolores et ea rebum.', '<p><img src="http://muffindcc.info:8888/rt/rtlauncher/migrator/jul08/images/stories/food/bread.jpg" width="150" height="159" style="float: right;" hspace="6" alt="Image" title="Image" border="0" />Duis autem vel eum iriure dolor in hendrerit in vulputate\r\nvelit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at\r\nvero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum\r\nzzril delenit augue duis dolore te feugait nulla facilisi. Lorem ipsum dolor\r\nsit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt\r\nut laoreet dolore magna aliquam erat volutpat.</p>\r\n\r\n<p>Ut wisi enim ad minim veniam, quis nostrud exerci tation\r\nullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis\r\nautem vel eum iriure dolor in hendrerit in vulputate velit esse molestie\r\nconsequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan\r\net iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis\r\ndolore te feugait nulla facilisi.</p>\r\n\r\n<p>Nam liber tempor cum soluta nobis eleifend option congue\r\nnihil imperdiet doming id quod mazim placerat facer possim assum. Lorem ipsum\r\ndolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod\r\ntincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim\r\nveniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut\r\naliquip ex ea commodo consequat.</p>\r\n\r\n<p>Duis autem vel eum iriure dolor in hendrerit in vulputate\r\nvelit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd\r\ngubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum\r\ndolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor\r\ninvidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero\r\neos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no\r\nsea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit\r\namet, consetetur sadipscing elitr, At accusam aliquyam diam diam dolore dolores\r\nduo eirmod eos erat, et nonumy sed tempor et et invidunt justo labore Stet\r\nclita ea et gubergren, kasd magna no rebum. sanctus sea sed takimata ut vero\r\nvoluptua. est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet,\r\nconsetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore\r\net dolore magna aliquyam erat.</p>\r\n\r\n<p>Consetetur sadipscing elitr, sed diam nonumy eirmod tempor\r\ninvidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero\r\neos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no\r\nsea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit\r\namet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut\r\nlabore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam\r\net justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata\r\nsanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur\r\nsadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore\r\nmagna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo\r\ndolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est\r\nLorem ipsum dolor sit amet.</p>', 1, 1, 0, 1, '2004-07-07 11:54:06', 62, '', '2008-06-28 20:34:15', 62, 0, '0000-00-00 00:00:00', '2004-07-07 00:00:00', '0000-00-00 00:00:00', 'food/coffee.jpg|left||0\r\nfood/bread.jpg|right||0', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 2, 0, 3, '', '', 0, 8, 'robots=\nauthor='),
(7, 'Example News Item 2', 'news2', 'News2', '<p><img src="images/stories/food/bun.jpg" width="150" height="112" style="float: right;" hspace="6" alt="Image" title="Image" border="0" />Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat,\r\nsed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit\r\namet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam\r\nvoluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem\r\nipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '', 1, 1, 0, 1, '2004-07-07 11:54:06', 62, '', '2008-06-28 20:34:22', 62, 0, '0000-00-00 00:00:00', '2004-07-07 00:00:00', '0000-00-00 00:00:00', 'food/bun.jpg|right||0', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 2, 0, 4, '', '', 0, 3, 'robots=\nauthor='),
(8, 'Example News Item 3', 'news3', 'News3', '<p><img src="images/stories/fruit/pears.jpg" width="150" height="96" style="float: right;" hspace="6" alt="Image" title="Image" border="0" />Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat,\r\nsed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit\r\namet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam\r\nvoluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem\r\nipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '', 1, 1, 0, 1, '2004-04-12 11:54:06', 62, '', '2008-06-28 20:34:30', 62, 0, '0000-00-00 00:00:00', '2004-07-07 00:00:00', '0000-00-00 00:00:00', 'fruit/pears.jpg|right||0', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 2, 0, 5, '', '', 0, 3, 'robots=\nauthor='),
(9, 'Example News Item 4', 'news4', 'News4', '<p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat,\r\nsed diam voluptua. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam\r\nvoluptua. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '<p><img src="images/stories/fruit/strawberry.jpg" width="150" height="112" style="float: left;" hspace="6" alt="Image" title="Image" border="0" />Duis autem vel eum iriure dolor in hendrerit in vulputate\r\nvelit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at\r\nvero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum\r\nzzril delenit augue duis dolore te feugait nulla facilisi. Lorem ipsum dolor\r\nsit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt\r\nut laoreet dolore magna aliquam erat volutpat.</p>\r\n\r\n<hr class="system-pagebreak" /><p><img src="images/stories/fruit/pears.jpg" width="150" height="96" style="float: right;" hspace="6" alt="Image" title="Image" border="0" />Ut wisi enim ad minim veniam, quis nostrud exerci tation\r\nullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis\r\nautem vel eum iriure dolor in hendrerit in vulputate velit esse molestie\r\nconsequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan\r\net iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis\r\ndolore te feugait nulla facilisi.</p>\r\n\r\n<p><img src="images/stories/fruit/cherry.jpg" width="150" height="112" style="float: left;" hspace="6" alt="Image" title="Image" border="0" />Nam liber tempor cum soluta nobis eleifend option congue\r\nnihil imperdiet doming id quod mazim placerat facer possim assum. Lorem ipsum\r\ndolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod\r\ntincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim\r\nveniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut\r\naliquip ex ea commodo consequat.</p>\r\n\r\n<p>Duis autem vel eum iriure dolor in hendrerit in vulputate\r\nvelit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd\r\ngubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum\r\ndolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor\r\ninvidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero\r\neos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no\r\nsea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit\r\namet, consetetur sadipscing elitr, At accusam aliquyam diam diam dolore dolores\r\nduo eirmod eos erat, et nonumy sed tempor et et invidunt justo labore Stet\r\nclita ea et gubergren, kasd magna no rebum. sanctus sea sed takimata ut vero\r\nvoluptua. est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet,\r\nconsetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore\r\net dolore magna aliquyam erat.</p>\r\n\r\n<hr class="system-pagebreak" /><p>Consetetur sadipscing elitr, sed diam nonumy eirmod tempor\r\ninvidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero\r\neos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no\r\nsea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit\r\namet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut\r\nlabore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam\r\net justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata\r\nsanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur\r\nsadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore\r\nmagna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo\r\ndolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est\r\nLorem ipsum dolor sit amet.</p>', 1, 1, 0, 1, '2004-07-07 11:54:06', 62, '', '2008-06-28 20:34:54', 62, 0, '0000-00-00 00:00:00', '2004-07-07 00:00:00', '0000-00-00 00:00:00', 'fruit/strawberry.jpg|left||0\r\nfruit/pears.jpg|right||0\r\nfruit/cherry.jpg|left||0', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 2, 0, 6, '', '', 0, 7, 'robots=\nauthor='),
(10, 'Example FAQ Item 1', 'faq1', 'FAQ1', '<p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat,\r\nsed diam voluptua. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam\r\nvoluptua. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '', 1, 3, 0, 7, '2004-05-12 11:54:06', 62, '', '2004-07-07 18:10:23', 62, 0, '0000-00-00 00:00:00', '2004-01-01 00:00:00', '0000-00-00 00:00:00', '', '', '', 1, 0, 1, '', '', 0, 10, ''),
(11, 'Example FAQ Item 2', 'faq2', 'FAQ2', '<p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat,\r\nsed diam voluptua. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam\r\nvoluptua. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '<p><img src="http://muffindcc.info:8888/rt/rtlauncher/migrator/jul08/images/stories/fruit/cherry.jpg" width="150" height="112" style="float: left;" hspace="6" alt="Image" title="Image" border="0" />Duis autem vel eum iriure dolor in hendrerit in vulputate\r\nvelit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at\r\nvero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum\r\nzzril delenit augue duis dolore te feugait nulla facilisi. Lorem ipsum dolor\r\nsit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt\r\nut laoreet dolore magna aliquam erat volutpat.</p>\r\n\r\n<p><img src="http://muffindcc.info:8888/rt/rtlauncher/migrator/jul08/images/stories/fruit/peas.jpg" width="150" height="91" style="float: right;" hspace="6" alt="Image" title="Image" border="0" />Ut wisi enim ad minim veniam, quis nostrud exerci tation\r\nullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis\r\nautem vel eum iriure dolor in hendrerit in vulputate velit esse molestie\r\nconsequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan\r\net iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis\r\ndolore te feugait nulla facilisi.</p>\r\n\r\n<p><img src="http://muffindcc.info:8888/rt/rtlauncher/migrator/jul08/images/stories/food/milk.jpg" width="150" height="183" style="float: left;" hspace="6" alt="Image" title="Image" border="0" />Nam liber tempor cum soluta nobis eleifend option congue\r\nnihil imperdiet doming id quod mazim placerat facer possim assum. Lorem ipsum\r\ndolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod\r\ntincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim\r\nveniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut\r\naliquip ex ea commodo consequat.</p>\r\n\r\n<p>Duis autem vel eum iriure dolor in hendrerit in vulputate\r\nvelit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. At\r\nvero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd\r\ngubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum\r\ndolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor\r\ninvidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero\r\neos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no\r\nsea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit\r\namet, consetetur sadipscing elitr, At accusam aliquyam diam diam dolore dolores\r\nduo eirmod eos erat, et nonumy sed tempor et et invidunt justo labore Stet\r\nclita ea et gubergren, kasd magna no rebum. sanctus sea sed takimata ut vero\r\nvoluptua. est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet,\r\nconsetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore\r\net dolore magna aliquyam erat.</p>\r\n\r\n<p>Consetetur sadipscing elitr, sed diam nonumy eirmod tempor\r\ninvidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero\r\neos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no\r\nsea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit\r\namet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut\r\nlabore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam\r\net justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata\r\nsanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur\r\nsadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore\r\nmagna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo\r\ndolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est\r\nLorem ipsum dolor sit amet.</p>', 1, 3, 0, 7, '2004-05-12 11:54:06', 62, 'Web master', '2004-07-07 18:10:23', 62, 0, '0000-00-00 00:00:00', '2004-01-01 00:00:00', '0000-00-00 00:00:00', 'fruit/cherry.jpg|left||0\r\nfruit/peas.jpg|right||0\r\nfood/milk.jpg|left||0', '', '', 1, 0, 2, '', '', 0, 11, ''),
(12, 'French Grand Prix', 'french-grand-prix', '', '<img src="images/stories/sport/motor/1c.jpg" alt="Grand Prix" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nDefending world champion Kimi Raikkonen claimed pole position for the French Grand Prix at Magny Cours with a lap of one minute 16.449 seconds.\r\n\r\n<p>Felipe Massa completed Ferrari''s third one-two in qualifying this season by lapping the Circuit de Nevers 0.041 seconds slower than his team mate.</p>\r\n\r\n<p>McLaren''s Lewis Hamilton qualified third in 1:16.693 but will drop 10 places on the grid after cauing accident at the preceding Canadian GP.</p>\r\nFernando Alonso of Renault will start from third...', ' ahead of Toyota''s Jarno Trulli and Heikki Kovalainen of McLaren.\r\n\r\n<p>Overall Formula One leader Robert Kubica of BMW Sauber struggled for pace and will start from sixth behind Hamilton''s McLaren team-mate Heikki Kovalainen.</p>\r\n\r\n<p>Kubica''s team-mate Nick Heidfeld nearly went out in qualifying one, before finishing 12th overall.</p>\r\n\r\n<p>The pole was the 16th of Raikkonen''s career and gives him a great chance of bouncing back in the drivers'' championship in which he is currently fourth behind Kubica, Hamilton and Massa.</p>\r\n\r\n<p>Afternoon qualifying began with the temperature rising to 27 degrees Celsius in the air and 45 degrees on the track.</p>\r\n\r\n<p>German Adrian Sutil and his Force India team-mate Italian Giancarlo Fisichella were soon eliminated and will be on the back row of the grid, behind the two Hondas of Briton Jenson Button and Brazilian Rubens Barrichello.</p>\r\n\r\n<p>Japanese Kazuki Nakajima of Williams followed and will start from 16th.</p>\r\n\r\n<p>German Heidfeld and Brazilian Nelson Piquet, who was fastest for Renault in the morning''s final practice session, were also unable to progress to the top-ten shootout.</p>\r\n\r\n<p>In the final session Trulli''s Toyota spun at the hairpin and Hamilton went off the circuit and across the trackside dirt, but both managed to resume</p>\r\n\r\n<p><a href="http://edition.cnn.com/2008/SPORT/06/21/motor.pole/index.html" title="Grand Prix">Source: CNN</a></p>', 1, 5, 0, 22, '2008-06-21 09:24:21', 63, '', '2008-06-23 14:21:46', 63, 0, '0000-00-00 00:00:00', '2008-06-21 09:23:57', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 10, 0, 5, '', '', 0, 8, ''),
(13, 'Capirossi to miss British MotoGP ', 'capirossi-to-miss-british-motogp-', '', '<img src="images/stories/sport/motor/2.jpg" alt="Capirossi MotoGP" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nLoris Capirossi will miss the British MotoGP at Donington after suffering a serious gash to his hand and dislocated finger in the Catalunya MotoGP...', '<p>\r\nThe Rizla Suzuki rider was injured when he crashed after being hit by Alex de Angelis on lap 11.\r\n</p><p>\r\n"I''m really disappointed not to be racing at Donington as it''s the team''s home race and I know a lot of fans will be there to see us," said the Italian.\r\n</p><p>\r\nHis place will be taken by American Superbikes champion Ben Spies.\r\n</p><p>\r\nCapirossi, 35, is a former world champion in the 125cc and 250cc classes, and is the most experienced rider on the MotoGP grid.\r\n</p><p>\r\nPreviously, he was with Ducati, moving to Suzuki at the end of last season to replace the departing John Hopkins.\r\n</p><p>\r\nSpies was already lined up to have a wildcard ride for Suzuki when the MotoGP championship goes to America, but has now had his debut brought forward.\r\n</p><p>\r\n"I was excited that my first GP was to be at Laguna Seca in the States, but I''m now more excited by this," he said.\r\n</p><p>\r\n"I think this will be a good thing for me to start out at Donington; it is a track I don''t know so I have no pressure.\r\n</p><p>\r\n"I haven''t done any testing on the bike or with race and qualifying tyres so I am not really expected to do anything much, so I can just go out there and learn how everything works and enjoy the event."\r\n</p><p>\r\nMeanwhile, it has been confirmed that Sete Gibernau is to test with his old team Ducati later this month.\r\n</p><p>\r\nThe hugely experienced 35-year-old Spaniard was one of Valentino Rossi''s main title challengers in the 2005 and 2006 seasons, before retiring at the end of that season when Ducati replaced him with Casey Stoner. </p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/motorsport/motorbikes/7450015.stm" title="Capirossi MotoGP">Source: BBC</a></p>', 1, 5, 0, 22, '2008-06-21 09:24:21', 63, '', '2008-06-23 14:22:18', 63, 0, '0000-00-00 00:00:00', '2008-06-21 09:23:57', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 4, '', '', 0, 6, ''),
(14, 'Haga seals double Nurburgring win', 'haga-seals-double-nurburgring-win', '', '<img src="images/stories/sport/motor/3.jpg" alt="Haga Win" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nNoriyuki Haga moved up to fourth in the World Superbike championship after claiming a double victory at the Nurburgring in Germany...', '<p>\r\nHaga beat championship leader Troy Bayliss in the first race by 2.025 seconds, and he won the rain-curtailed second race on the countback rule.\r\n</p><p>\r\nTroy Corser led when the race stopped on lap 16 but the result was decided by placings in the final completed lap.\r\n</p><p>\r\nHaga''s win was all the more impressive as he broke a collarbone two weeks ago.\r\n</p><p>\r\nHis double win takes his championship points tally to 172, 55 behind leader Bayliss, who ended the weekend with a second and a fourth place finish after making mistakes in both legs.\r\n</p><p>\r\nBayliss was leading the first race but he ran wide into turn one less than two laps from the end to hand victory to the Yamaha rider. \r\n</p><p>\r\nIn race two Bayliss made two mistakes on the fifth lap, dropping from the lead down to fifth before recovering to fourth. \r\n</p><p>\r\nSuzuki rider Max Neukirchner, who impressed the home fans by taking superpole in qualifying on Saturday, continued to shine with a pair of third place finishes.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/motorsport/motorbikes/7455801.stm" title="Haga Win">Source: BBC</a></p>', 1, 5, 0, 22, '2008-06-21 09:24:21', 63, '', '2008-06-23 14:22:10', 63, 0, '0000-00-00 00:00:00', '2008-06-21 09:23:57', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 3, '', '', 0, 6, ''),
(15, 'Hamilton still eyeing France win', 'hamilton-still-eyeing-france-win', '', '<img src="images/stories/sport/motor/4.jpg" alt="Hamilton" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nLewis Hamilton believes he can upset the odds in the forthcoming French Grand Prix to claim what would be a stunning victory.\r\n', '<p>Hamilton will start the race at Magny-Cours handicapped by a 10-place grid penalty following a pit lane crash at the Canadian Grand Prix. \r\n</p><p>"I feel confident we can win there - that''s my job. I have that belief in myself and the team," he said. \r\n</p><p>"The key is to score points, and we need to score as many as we can." </p>\r\n<p>The McLaren driver crashed into the back of title rival Kimi Raikkonen''s Ferrari at the end of the pit lane in Montreal, resulting in early retirement for both drivers. \r\n</p>		\r\n<p>Meanwhile, rival Raikkonen believes Hamilton - who trails Robert Kubica by four points in the title race - merited his sanction. \r\n</p><p>"I still can''t believe it, that someone can hit you while you are standing at the red light next to another car," said Raikkonen. \r\n</p><p>"I can''t imagine how Hamilton could not see the red lights and the two cars standing in front of him. \r\n</p><p>"I think Hamilton deserves his penalty. \r\n</p><p>"He loses 10 places for the next race in France, and at least it is not going to make things any easier for him." \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/motorsport/formula_one/7449111.stm" title="Hamilton">Source: BBC</a></p>', 1, 5, 0, 22, '2008-06-21 09:24:21', 63, '', '2008-06-23 14:22:01', 63, 0, '0000-00-00 00:00:00', '2008-06-21 09:23:57', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 2, '', '', 0, 5, ''),
(17, 'Faldo downplays Woods Cup absence', 'faldo-downplays-woods-cup-absence', '', '<img src="images/stories/sport/golf/1c.jpg" alt="Faldo Wood Cup" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>Europe captain Nick Faldo believes US Open champion Tiger Woods'' absence from September''s Ryder Cup could bring the United States team closer together.</b>\r\n<p>\r\nWoods, who was the leading US scorer in their 2006 defeat, will not play again this season because of a knee injury. \r\n</p><p>\r\n"On the one side it could be a loss, but on the other they know they don''t have the option to bank on Tiger this year," said Faldo...\r\n</p>', '<p>\r\n"I''m sure they''ll all pull together because of that."\r\n</p><p>\r\nWoods was leading scorer for the USA with three points out of five two years ago at The K Club, but has been on the winning side just once in five attempts.\r\n</p>\r\n<p>\r\nHe returned after a two-month absence following knee surgery to win the US Open last weekend but now requires a further operation.\r\n</p><p>\r\nDespite two nine-point wins in a row and not having to face Woods, Faldo is still expecting an even contest at Valhalla in September.\r\n</p><p>\r\n"I don''t think it''s a given that it improves our chances", he said.\r\n</p>\r\n<p>\r\n"On paper we''re coming off some strong wins and have a great tradition of team spirit in the Ryder Cup, but look at the rankings and you''ll see that the US has a wealth of talent.\r\n</p><p>\r\n"This is matchplay. You''re playing for pride and a point and that makes things pretty equal.\r\n</p><p>\r\n"Ultimately, we''ll just have to wait and see and, in the meantime, let''s hope that Tiger makes a swift recovery."\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/golf/7465360.stm" title="Faldo Wood Cup">Source: BBC</a></p>', 1, 5, 0, 24, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:20:37', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 5, '', '', 0, 9, ''),
(16, 'Alonso unsure on Renault future ', 'alonso-unsure-on-renault-future-', '', '<img src="images/stories/sport/motor/5.jpg" alt="Alonso Unsure" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nDouble world champion Fernando Alonso says he has not yet decided whether to stay with Renault next year.', '<p>The team have been uncompetitive this season and the Spaniard is believed to have a clause in his contract that would allow him to leave for 2009. \r\n</p><p>"I do not know what can happen. At the end of the year I will see where Renault is and decide," he said. \r\n</p><p>"The car has improved and I hope that by the end of the year there will be podiums and victories." \r\n</p><p>Alonso, who has been widely linked with a move to Ferrari in 2009 or 2010, admitted he was expecting more from his return to the team with which he won the world title in 2005 and 2006. \r\n</p><p>"The truth is that it has not been good so far," conceded Alonso, who rejoined Renault after a tempestuous year with McLaren as Lewis Hamilton''s team-mate in 2007. \r\n</p><p>"It''s worse than we expected and we are far from fighting for the podium and victories but we have not thrown in the towel and are working on the car day and night to improve." \r\n</p>\r\n<p>He is hopeful of progress thanks to some new parts that would be on the car at this weekend''s French Grand Prix. </p>\r\n<p>"During the week, the team have worked hard and have made improvements to the car in testing," he added. "We have made another step forward and we are on the right track." \r\n</p><p>Alonso left McLaren one year into a three-year contract after falling out with team boss Ron Dennis over what he saw as a failure to give him the treatment he deserved as a two-time champion. \r\n</p><p>Hamilton, who was in his first season in Formula One last year, finished on the podium in each of the first nine races. \r\n</p>\r\n<p>But the Englishman has been less consistent this season, making a number of high-profile errors, including crashing into title rival Kimi Raikkonen''s Ferrari in the pit lane in the last race in Canada. </p>\r\n<p>Alonso said the dip in Hamilton''s form was to be expected. \r\n</p><p>"I am not surprised at his mistakes," he stated. "What was unusual was the first nine races last year with nine podiums. Everything went for him and he was lucky. Not everything depends on the driver. This year is more normal." </p>\r\n\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/motorsport/formula_one/7458349.stm" title="Alonso Unsure">Source: BBC</a></p>', 1, 5, 0, 22, '2008-06-21 09:24:21', 63, '', '2008-06-23 14:21:54', 63, 0, '0000-00-00 00:00:00', '2008-06-21 09:23:57', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 1, '', '', 0, 5, ''),
(18, 'Kaymer surges ahead at BMW event ', 'kaymer-surges-ahead-at-bmw-event-', '', '<img src="images/stories/sport/golf/2.jpg" alt="Kaymer Ahead" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nRising German star Martin Kaymer seized the half-way lead at the BMW International Open in Munich with a magnificent nine-under-par round of 63...', '<p>\r\nRyder Cup hopeful Kaymer had nine birdies on his card as he finished with a 13-under total of 131.\r\n</p><p>\r\n"I''m hitting the ball really long this week. I don''t know why and it was a little scary to be honest," he said.\r\n</p><p>\r\nHis round left him five shots clear of England''s Benn Barham (68) and France''s Francois Delamontagne (66).\r\n<!-- E SF -->\r\n</p><p>\r\n"To play in your own country with all of the support is awesome," Kaymer added.\r\n</p><p>\r\nHis performance drew fulsome praise from playing partner Bernhard Langer, Germany''s greatest ever golfer, who himself carded a 72 to  finish on two-under.\r\n</p><p>\r\n"It''s great to see we have some youngsters who can hopefully take on the torch\r\nfor golf in Germany in the future.\r\n</p><p>\r\n"I told him ''you''re very aggressive, but you''re smart at the same time like Tiger Woods or Phil Mickelson''. He''s got an old head on young shoulders. Going by the last two days I don''t think there any limits for him if he keeps that up," said Langer.\r\n</p><p>\r\nKaymer''s round was just one short of the course record, but while the German had a fine day some high profile names failed to make the halfway cut.\r\n</p><p>\r\nNorthern Ireland''s Graeme McDowell missed out by a single shot after going into the water both with his pitch to the 16th for a double bogey and then with his drive down the last.\r\n</p><p>\r\nOrder of Merit leader Miguel Angel Jimenez also crashed out on level par, but his Ryder Cup spot looks pretty secure with John Daly also exiting on the same mark.\r\n</p><p>\r\nMeanwhile, Englishman Richard Finch is shot behind Barham and Delamontagne on seven under thanks to a round that included seven birdies.\r\n</p><p>\r\nPaul Casey, David Howell, Retief Goosen and Bradley Dredge are among those one further back, but Colin Montgomerie is down on three under and in danger of being an also-ran yet again.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/golf/7466520.stm" title="Kaymer Ahead">Source: BBC</a></p>\r\n\r\n', 1, 5, 0, 24, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:20:46', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 4, '', '', 0, 8, ''),
(19, 'Woods will be ''better than ever'' ', 'woods-will-be-better-than-ever-', '', '<img src="images/stories/sport/golf/3.jpg" alt="Woods better" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nTiger Woods''s coach Hank Haney insists the world number one will return stronger than ever after an operation on his damaged knee ligaments...\r\n', '<p>\r\nAfter fighting intense pain to win his third US Open title Woods, 32, will miss the rest of this season to recover from reconstructive knee surgery. \r\n</p><p>\r\nAnd some have questioned whether Woods may have sustained irreparable damage. \r\n</p>\r\n<p>\r\nWoods told ABC''s Good Morning America on Friday: "I was in bad shape going in and came out in just the same shape.\r\n</p><p>\r\n"So it will be nice to finally get fixed and feel healthy,\r\nwhich I haven''t felt in probably a decade."\r\n</p><p>\r\nThe impending operation, his fourth, has led some players and pundits to question his long-term future in the game. \r\n</p><p>\r\nFormer European Tour player Mark Roe told BBC Radio 5 Live: "Anyone who has played golf at the highest level knows that the left knee takes an immense pounding. \r\n</p><p>\r\n"As hard as Woods hits it, as aggressive as he plays, I think it could flare up again in the future. \r\n</p><p>\r\n"I think there is a cloud over Tiger Woods now. He will not come back until he is ready, but it could go again very easily." \r\n</p>\r\n<p>\r\n"Now he''s going to have a stable knee," said Haney, who has also coached double major winner Mark O''Meara. \r\n</p><p>\r\n"I just expect it will be such a positive thing for Tiger and his whole career, giving him more time to practice. He has been really limited in what he could do. \r\n</p>\r\n\r\n<p>\r\n"It''s really just the snapping of his leg as he comes through the ball," he said. \r\n</p><p>\r\n"This was something we worked on changing some five years ago. We eliminated some of the pressure off Tiger''s knee. \r\n</p><p>\r\n"That was the first thing he told me that he felt like he needed to do. He did it. He''s been doing that for a long time, swinging a different way for a long time. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/golf/7464742.stm" title="Woods Better">Source: BBC</a></p>', 1, 5, 0, 24, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:20:53', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 3, '', '', 0, 7, ''),
(20, 'O'' Malley shares lead in Munich ', 'o-malley-shares-lead-in-munich-', '', '<img src="images/stories/sport/golf/4.jpg" alt="O''Malley Shares Lead" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nAustralia''s Peter O''Malley fired a six-under-par round of 66 to take a share of the BMW International Open lead alongside three players in Munich...\r\n', '<p>\r\nChasing his first European Tour victory since the 2001 English Open, O''Malley shot a bogey-free round of six birdies.\r\n</p><p>\r\nSouth Africa''s Anton Haig, Singapore''s Mardan Mamat and Rafa Echenique of Argentina share the first-round lead.\r\n</p><p>\r\nEnglish pair Mark Foster and David Lynn lead the European charge on five under, with Scot Colin Montgomerie two under.\r\n</p><p>\r\nThe veteran shot five birdies and three bogeys to lay alongside England''s Paul Casey, while Spain''s Miguel Angel Jimenez and Retief Goosen of South Africa are well placed on three under.\r\n</p><p>\r\nThe always unpredictable John Daly carded 72 after five topsy-turvy holes from the 13th - two double bogeys, a bogey and two birdies.\r\n</p><p>\r\n"I just got some bad breaks. What can you do?" Daly said. "I am hitting better than I am scoring."\r\n</p><p>\r\nDaly still holds the tournament record for lowest score with his 2001 winning total of 27-under-par 261, but since then, organizers have thickened the Munich Eichenried rough to toughen up the course.\r\n</p><p>\r\nThe BMW International Open kicks off a series of lucrative events that includes the British Open, the PGA Championship and runs through the Ryder Cup 19-21 September.\r\n</p><p>\r\n"This is the time of year where you really want to be playing good golf and that''s what I''ve sort of set my goal for throughout the year," O''Malley said.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/golf/7464526.stm" title="O''Malley Shares Lead">Source: BBC</a></p>', 1, 5, 0, 24, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:21:10', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 2, '', '', 0, 8, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(21, 'Injured Woods out for the season', 'injured-woods-out-for-the-season', '', '<img src="images/stories/sport/golf/5.jpg" alt="Injured Wood" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nUS Open champion Tiger Woods will miss the rest of the season to have surgery on his injured left knee.\r\n<p>\r\nThat means Woods, 32, is ruled out of the...\r\n</p>', 'Open at Royal Birkdale, the Ryder Cup and the USPGA. \r\n<p>\r\n"It was important to me that I disclose my condition publicly at an appropriate time," Woods said on his website. \r\n</p><p>\r\n"Now, it is clear that the right thing to do is listen to my doctors, follow though with this surgery, and focus my attention on rehabilitating my knee."\r\n</p><p>\r\nWoods also stated he needed time to recover from a double stress fracture in his leg which were "attributed to Woods''s intense rehabilitation and preparations for the US Open". \r\n</p>\r\n<p>\r\nBBC Radio 5 Live golf correspondent Iain Carter said this was a career-saving operation for Woods.\r\n</p><p>\r\n"Let''s be blunt, this surgery is taking place to save what is becoming the most glittering career the game has ever seen.\r\n</p><p>\r\n"Woods gave nothing away about the true condition of his left knee," he said. \r\n</p>\r\n<p>\r\nOrganisers of the Open Championship, the Royal and Ancient (R&amp;A), said they were disappointed that Woods would not feature in the tournament due to start on 17 July. \r\n</p><p>\r\n"It''s a real shame," R&amp;A chief executive Peter Dawson told BBC Radio 5 Live. \r\n</p><p>\r\n"We''re sorry to hear about his continuing problems. The spectators at Birkdale will be very sad." \r\n</p><p>\r\nUS Ryder Cup captain <b>Paul Azinger</b> added: "I admire Tiger as a person, player and fan. \r\n</p><p>\r\n"This should not be about Tiger and the Ryder Cup now - this is about Tiger''s health and wellbeing and his march to history." \r\n</p>\r\n<p>\r\nThe American finally opted to have another arthroscopic procedure on 15 April to clean out cartilage in his left knee. \r\n</p><p>\r\nIt was hoped that by doing that, and avoiding knee ligament surgery, he could complete the 2008 season. \r\n</p><p>\r\nWoods added: "My rehabilitation schedule after the arthroscopic surgery was designed with the goal of returning to play at the Memorial (on 29 May), but the stress fractures that were discovered just prior to the tournament unfortunately prevented me from participating and had a huge impact on the timing for my return. \r\n</p><p>\r\n"I was determined, though, to do everything and anything in my power to play in the US Open at Torrey Pines, which is a course that is close to where I grew up and holds many special memories for me. \r\n</p>\r\n<p>\r\n"Although I will miss the rest of the 2008 season, I''m thrilled with the fact that last week was such a special tournament." \r\n</p><p>\r\nWoods announced his decision just two days after winning his 14th major by defeating Rocco Mediate in a sudden-death play-off at the US Open. \r\n</p><p>\r\nHe was limping throughout the four days of competition at Torrey Pines but stayed in contention forcing a play-off with an 18th hole birdie before repeating the feat on the final hole in the play-off. \r\n</p><p>\r\nThe Californian eventually sealed the victory on the sudden-death hole. \r\n</p><p>\r\nEight-times European number one <b>Colin Montgomerie</b> said: "This puts into sharp perspective what an extraordinary performance it was. \r\n</p><p>\r\n"To go 72 holes, then another 18, then have enough to win the play-off; it just shows the sheer willpower of the man. \r\n</p><p>\r\n"It is difficult in the middle of an extraordinary era to think of the rest of the year without Tiger. It''s a huge loss to golf." \r\n</p><p>\r\nAmerican world number two <b>Phil Mickelson</b> said: "I know how frustrating it was to lose most of last summer to my wrist injury. \r\n</p><p>\r\n"But I expect him to be back as strong as ever and look forward to competing with him as soon as possible." \r\n</p><p>\r\n2005 US Open winner <b>Michael Campbell</b> said: "To have such an icon like Tiger not play for the rest of the year, we will miss him. \r\n</p><p>\r\n"It will be quite different not to have Tiger in any events. He adds so much, another dimension to every tournament he plays in. \r\n</p><p>\r\n"You were not quite sure how bad the injury was, but obviously it was pretty bad and there were some serious things going on with the left knee. We just wish him the best." \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/golf/7458357.stm" title="Injured Wood">Source: BBC</a></p>', 1, 5, 0, 24, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:20:22', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 1, '', '', 0, 17, ''),
(22, 'Nigeria: Shell Shuts Down Oil Field ', 'shell-shuts-down-oil-field', 'shell shuts down oil field', '<!--IMAGE images/stories/rotator/4.jpg IMAGE--><img src="images/stories/world/africa/1.jpg" alt="Oil Rig" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nRoyal Dutch Shell yesterday said it shut down production from an offshore oil field that produces about 200,000 barrels per day. \r\n\r\nThis was after after the most powerful militant...', 'group in Nigeria launched an attack on an installation there.\r\n\r\n<p>The group also said it captured an American worker on a supply vessel in the area of the rig, Captain Jack Stone.</p>\r\n\r\n<p>A leader of the Movement for the Emancipation of the Niger Delta (MEND) told The Associated Press that militants attacked the Bonga oil field more than 65 miles from land. But the fighters weren''t able to enter a computer control room, which they had hoped to destroy.</p>\r\n\r\n<p>Sources, however, said the Chief Jephthah-led delegation may secure his release in the earliest possible time as talks have reached an advance stage with those responsible.</p>\r\n\r\n<p>But in an earlier statement of claim issued by the Leader of the MEND through e-mail, Gbomo Jomo claimed that the main computerized control room responsible for coordinating the entire crude oil export operations from the fields was the main target of the militias.</p>\r\n\r\n<p>It stated, that "Our detonation engineers could not gain access to blow it up but decided against smoking out the occupants by burning down the facility to avoid loss of life."</p>\r\n\r\n<p>The MEND promised that their next planned attack on the oil field would be deadly. "We therefore ask all workers in the Bonga fields to evacuate for their safety as the military cannot protect them".</p>\r\n\r\n<p>They offered that they would only release the American if the Federal Government releases persons of Niger Delta origin arrested on allegation of terrorism charges. "This man was supposed to only be released in exchange for all Niger Delta hostages being held in northern Nigeria by the Nigerian government. Because the criminals in the government and state security want to use this opportunity to make money from ransom. We have decided he will be released in the coming hours.</p>\r\n\r\n<p>"The location for today''s attack was deliberately chosen to remove any notion that off-shore oil exploration is far from our reach. The oil companies and their collaborators do not have any place to hide in conducting their nefarious activities. We use this opportunity to ask the oil majors to evacuate their expatriate staff from Nigeria until the issues in the Niger Delta have been addressed and resolved."</p>\r\n\r\n<p>Contacted on the development, the media officer of the Peace and Conflict Resolution Committee, Mr. Alfine Ogor, confirmed the development and said his boss, Chief James Jephthah, has immediately mobilised to the scene. "We are on our way to the place and we will get back details to you".</p>\r\n\r\n<p>Also contacted, the Commander of the Joint Military Task Force, Lt. Col. Chris Musa, told LEADERSHIP that they have also received the news of the kidnap of the expatriate but were waiting for details on the group responsible.</p>\r\n\r\n<p>Over 200 foreign hostages have been seized since an upsurge of violence that began in early 2006. The hostages are normally released unharmed after a ransom is paid.</p>\r\n\r\n<p>Attacks against offshore facilities are exceedingly rare. Oil industry officials consider their operations on the high seas much safer than those in the creeks and swamps of Niger Delta, where most of the attacks during two years of increased violence have taken place.</p>\r\n\r\n<p>Militant attacks on oil infrastructure have trimmed about a quarter of total oil production in Nigeria, which is Africa''s biggest producer and a member of OPEC.</p>\r\n\r\n<p>The turmoil in Nigeria''s south has helped send oil prices to historical heights, giving the militants more leverage in their drive to force the Federal Government to send more oil industry proceeds to their areas.</p>\r\n\r\n<p>Despite being the home of almost all of Nigeria''s petroleum reserves, the country''s south is as desperately poor as the rest of the country, which is Africa''s most populous with 140 million people.</p>\r\n\r\n<p>But criminality and militancy are closely linked, with many of the militant groups accused of stealing crude oil from wells and pipelines for sale in overseas market and helping politicians rig elections.</p>\r\n\r\n<p>Meanwhile, the Federal Government is losing 150 million standard cubic feet of gas and 200,000 barrels of oil daily as embattled oil gaint, Shell yesterday shut down production at its Bonga oil field following a fresh militant attack.</p>\r\n\r\n<p>Shell spokesman, Precious Okolobo, who disclosed this to the media yesterday said, "We shut down production at the Bonga oilfield following an attack by unknown militants this morning."</p>\r\n\r\n<p>The militants are yet to be identified, but Shell sources point accusing fingers at MEND which is headed by Henry Okah and has claimed responsibility for most of the attacks on oil facilities and kidnaps in the region.</p>\r\n\r\n<p>The militant attack on the Bonga deepwater oil and gas field located 120 kilometres offshore with a daily production capacity of 200,000 barrels of oil and 150 million standard cubic feet of gas is seen by industry experts as a major setback on the effort of the Federal Government to regain its lost position as number one oil producing and exporting nation in Africa and to regain the confidence of its international partners and bring lasting peace to the Niger Delta. Angola currently tops Nigeria in oil production and export in Africa, going by OPEC records.</p>\r\n\r\n<p>The implication of the shutting down of the Bonga deep water oil and gas fields and continued militant attacks on oil facilities are enormous. Already, Royal Dutch Shell has revealed that it can no longer honour June and July contracts from its Bonny terminal as a result of militant attacks two months ago. Meanwhile force majeure had been declared for April and May deliveries following similar attacks.</p>\r\n\r\n\r\n<p><a href="http://allafrica.com/stories/200806200552.html" title="Nigeria: Shell Shuts Down Oil Field After Attack">Source: AllAfrica.com</a></p>\r\n', 0, 4, 0, 18, '2008-06-21 10:45:05', 64, '', '2008-06-24 10:41:16', 62, 0, '0000-00-00 00:00:00', '2008-06-21 10:37:37', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 13, 0, 5, '', '', 0, 26, ''),
(23, 'Quarter-final 3: Netherlands v Russia', 'quarter-final-3-netherlands-v-russia', '', '<img src="images/stories/sport/soccer/1c.jpg" alt="Quarter-final 3: Netherlands v Russia" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<p>\r\n<b>Netherlands coach Marco van Basten is set to revert back to his favoured starting XI after resting a host of players last time out against Romania.</b>\r\n</p><p>\r\nThat could mean only Khalid Boulahrouz - who will play despite the death of his prematurely-born baby daughter - and Arjen Robben keep their places. \r\n</p><p>\r\nRuud van Nistelrooy, Andre Ooijer and Dirk Kuyt will all return to the side. \r\n</p><p>\r\nRussia coach Guus Hiddink will name an unchanged line-up to the one that beat Sweden 2-0...\r\n</p>', '<p>\r\nThat victory was inspired by Andrei Arshavin, the Zenit St Petersburg playmaker who had been suspended for the first two group games - a 4-1 defeat to Spain and a narrow 1-0 win over Greece. \r\n</p><p>\r\n</p><p>"I don''t think we needed to score that many goals in the Swedish game," said Arshavin. "We needed to save them for the next games and I hope we will score a few against the Dutch. \r\n</p><p>\r\n"If we didn''t have to play the Netherlands, we would feel much better, because I think they are the best side here. \r\n</p><p>\r\n"But fate has it that we have to play the strongest team in the tournament in the last eight. I hope we will be able to match them." \r\n</p><p>\r\nRussia''s performance in the win over Sweden prompted many observers to predict a possible upset against the Dutch, despite the Netherlands'' 100% record in the tournament so far. \r\n</p>\r\n<p>\r\nAnd Hiddink, who will reportedly earn a £400,000 bonus for leading Russia into the last eight, will hope to avenge Russia''s defeat to the Netherlands in the final of Euro ''88. \r\n</p><p>\r\nThe Netherlands, though, have been in superb form in this Championship, beating World Cup winners Italy 3-0, World Cup finalists France 4-1, and then Romania 2-0 with a side largely made up from fringe members of the squad. \r\n</p><p>\r\nNetherlands have announced that the players will wear black armbands in the quarter-final against Russia after Boulahrouz''s prematurely-born daughter died earlier this week. \r\n</p><p>\r\nMeanwhile, the Netherlands'' Nigel de Jong and Andre Ooijer, and Russia''s Ivan Saenko, Dmitry Torbinsky, Denis Kolodin, Andrei Arshavin and Sergei Semak, are all a booking away from missing a potential semi-final clash with either Spain or Italy. \r\n</p><h4>BIG MATCH STATS</h4>\r\n    <p>\r\n<b>Head-to-heads</b>\r\n</p><p>\r\nHolland have won four of the previous eight confrontations. Russia have won twice and two matches ended in a tie. \r\n</p><p>\r\nAll three competitive encounters have been in European Championship finals. In 1988, the Soviet Union beat Holland 1-0 in their opening group match before losing the final 2-0. In 1992, when Russia took part as the CIS, this match ended in a 0-0 draw in the group stage. Current Dutch coach Marco van Basten played in all three of those matches. His only goal was a memorable strike in the final of 1988 to put Holland 2-0 up. \r\n</p><p><b>Team facts - Netherlands</b>\r\n</p><p>\r\nNow reached the knock-out stages in six consecutive European Championship finals, which is a competition record. \r\n</p><p>\r\nBeen knocked out at the quarter-final stage only once; in 1996 with Guus Hiddink at the helm, they suffered a 5-4 defeat on penalties to France. \r\n</p><p>\r\nAfter beating Italy and France in Group C, Holland can now claim the scalp of a third former winner of this tournament by beating Russia. \r\n</p><p>\r\nSeven different Dutch players have scored at Euro 2008 which equals the record for most different goalscorers from a team in the tournament history. \r\n</p><p>\r\nThey have now scored nine times, which is five short of the competition record set by France in 1984. Their +8 goal differential is the highest by any team in the group stage in the history of this tournament.\r\n</p><p>Van Basten has now won 35 of his 51 matches in charge of Holland. He needs two more wins to equal Bob Glendenning''s record of 37 wins as Holland manager. \r\n</p><p>\r\nBeen shown just two yellow cards this tournament, fewer than any other team. \r\n</p><p>\r\n<b>Team facts - Russia</b>\r\n</p><p>\r\nSurvived the group phase for the first time since 1988, when they took part as the Soviet Union and finished runners-up to the Netherlands. \r\n</p><p>\r\nTrying to become only the second nation to win this tournament despite losing their opening match, following in the footsteps of the Netherlands in 1988. \r\n</p><p>\r\nCoach Guus Hiddink has maintained his 100% progression record at major tournaments (two European Championships, three World Cups). In his only previous European Championship finals, he was eliminated in the quarter-finals by France (1996). \r\n</p><p>\r\nHiddink has faced his native country twice before as a coach, both times in a friendly. In June 2006, Holland drew 1-1 with Hiddink''s Australia. In February 2007, he suffered a 4-1 defeat with Russia against the Netherlands. \r\n</p><p>\r\n<b>Player facts - Netherlands</b>\r\n</p><p>\r\nEdwin van der Sar looks set to play in his 16th match in European Championship finals, equalling the all-time record set by France''s Lilian Thuram earlier this tournament. \r\n</p><p>\r\nNigel de Jong and Andre Ooijer are one yellow card shy of a suspension. \r\n</p><p>\r\n<b>Player facts - Russia</b>\r\n</p><p>\r\nRoman Pavlyuchenko has taken 18 shots on goal (nine on, nine off target) in the group stage, more than any other player. \r\n</p><p>\r\nIgor Akinfeev is the goalkeeper with most saves (21) to his name after the first round of matches. \r\n</p><p>\r\nIf selected, Roman Adamov will be playing on his 26th birthday. \r\n</p><p>\r\nSergei Semak will win his 50th cap for Russia, if he takes the field. He made his debut in a 1-0 defeat to Italy on 15 November 1997. \r\n</p><p>\r\nDenis Kolodin, Dmitriy Torbinskiy, Ivan Saenko, Andrei Arshavin and Sergei Semak are one yellow card shy of a suspension. \r\n</p><p>\r\n</p><p>Big Match Stats source: Infostrada Sports \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/football/euro_2008/7363505.stm" title="Quarter-final 3: Netherlands v Russia">Source: BBC</a></p>', 1, 5, 0, 20, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:19:44', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 6, ''),
(24, 'Brilliant Hiddink targets the Netherlands', 'brilliant-hiddink-targets-the-netherlands', '', '<img src="images/stories/sport/soccer/2.jpg" alt="Brilliant Hiddink" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nTournament football and Guus Hiddink are a match made in heaven.<br /><br />Five times the Dutch master manager has taken teams...', ' to major tournaments, and five times he has successfully steered them out of the group stages.<br /><br />To the Netherlands in Euro 1996 and the 1998 World Cup, South Korea in the 2002 World Cup and Australia in the 2006 World Cup, now add Russia at Euro 2008 to the roll of honour.<br /><br />It is a remarkable record and one made all the more satisfying for the 61-year-old from Varsseveld because of the way his teams have always gone about their business.<br /><br />For Guus Hiddink is a football purist, as anyone who watched his brilliant young Russian side dismantle Sweden in Innsbruck on Wednesday would testify.<br /><br />And now he has been rewarded with a quarter-final meeting with his fellow countrymen and the chance to cause one of the biggest shocks of the European Championship.<br /><br />After a 4-1 drubbing at the hands of England and a last-eight defeat on penalties to France when he was in charge of the Netherlands in 1996, Hiddink has gone about his work like a man with unfinished business with the European Championships.<br /><br />As with underdogs South Korea in 2002 and Australia in 2006 at the World Cup, he was careful before the tournament started not to put too much pressure on his impressionable young charges.<br /><br />Hiddink, much like Spain coach Luis Aragones, claimed Russia - who did not qualify for the last World Cup - would not reach their peak as a team until at least the 2010 World Cup in South Africa.<br /><br />A clever way to take the pressure off your players and one that, especially after the 4-1 drubbing they were handed by Spain in their opening game, has enabled Russia to play with a refreshing freedom that took Greece and especially the Swedes by surprise.<br /><br /></p><div class="rightquote"><span class="q1"></span>It will be an intriguing sub-plot to see who comes out on top between Arshavin and Sneijder<span class="q2"></span></div>Hiddink plays his games with the media too, like cheekily suggesting he might not necessarily recall playmaker Andrei Arshavin for the Sweden game after he was suspended for the first two matches.<br /><br />Arshavin''s sublime performance that immediately catapulted him into superstardom made Hiddink''s suggestion appear all the more like gamesmanship, but if it was designed to help ease his most outstanding player into the tournament, it worked a treat.<br /><br />As for Arshavin, he gave a frightening glimpse of his potential by ripping the ageing Swedish defence to shreds and his majestic display will have given every Dutch defender nightmares.<br /><br />His link-up play with Roman Pavlyuchenko was a constant menace and it will be an intriguing sub-plot to see who comes out on top between Arshavin, surely now top of every major club''s wanted list, and Real Madrid midfielder Wesley Sneijder, who brilliantly set the tempo in the Netherlands'' victories over Italy and France.<br /><br />Despite their undisputed quality, Russia are still second favourites to win in Basel, especially as worries over their defence after their hammering by the Spanish remain.<br /><br />But few observers would bet against the maverick Hiddink inspiring his troops to yet another triumph. It''s just what he does, and he''s better at it than pretty much any other coach in tournament history.<br /><br />It''s also why he is continually linked with all the top jobs in Europe when they become available and why plenty of England fans were more than frustrated that the Football Association chose not to pursue him more vigorously in 2006 instead of settling on the disastrous Steve McClaren.<br /><br />Maybe Hiddink prefers it this way. Maybe his unique coaching talents are better suited to a rapidly-improving, impressionable side like the Russians, rather than the cash-heavy, pressure-laden world of English football.<br /><br />Once again, a major tournament has benefited from his enormous expertise and, above all, quintessentially Dutch desire to see the game played in the right way.<br /><br />When the Netherlands played USSR in the Euro 1988 final, Hiddink was a mere spectator as his PSV Eindhoven charges Hans van Breukelen, Ronald Koeman, Berry van Aerle and Gerald Vanenburg helped the Dutch lift the Henri Delauney trophy.<br /><br />This time around, he is destined to have a far greater say on proceedings.\r\n\r\n<p><a href="http://www.bbc.co.uk/dna/606/A37515639" title="Brilliant Hiddink">Source: BBC</a></p>', 1, 5, 0, 20, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:25:28', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 4, ''),
(25, 'Liverpool pair attempt peace pact ', 'liverpool-pair-attempt-peace-pact-', '', '<img src="images/stories/sport/soccer/3.jpg" alt="Liverpool pair attempt peace pact" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nLiverpool co-owners George Gillett and Tom Hicks are attempting to mend their broken relationship...\r\n\r\nThe American pair have been at odds in a series...', 'with Liverpool manager Rafael Benitez also involved in differences behind the scenes.\r\n<p>\r\nGillett had previously described his partnership with Hicks as "unworkable".\r\n</p><p>\r\nBut he told Canadian radio station Fan590: "It''s fair to say communication between the Hicks''s and the Gilletts has been substantially improved."\r\n</p><p>\r\nEarlier this year, it was reported that Gillett had agreed to sell his stake in the club to Dubai International Capital, the investment arm of the Dubai government.\r\n</p>\r\n\r\n<p>\r\nBut he refused to say whether improved relations with Hicks meant he now wished to continue his involvement with the club.\r\n</p><p>\r\nGillett said: "Time is a healer and there were things that had happened previously. It took a while for both of us to realise that we weren''t communicating very well and the huge responsibility we have to the fans to do the right thing for the club."\r\n</p><p>\r\nLiverpool fans have been divided over which side to take during the Gillett-Hicks feud, with many unhappy with both parties.\r\n</p><p>\r\nGillett admitted to being taken aback by the passion of the club''s supporters but vowed to live up to his responsibility as joint custodian at Anfield.\r\n</p>\r\n\r\n<p>\r\nHe said: "Soccer is the leading sport in the world and it''s just shocking how popular Liverpool is. So it surprised me, but it really is an amazing responsibility.\r\n</p><p>\r\n"We''ve always felt that for the 40-plus years I''ve been around professional sport that we really hold these assets in trust for the fans and that we have an obligation to the fans."\r\n</p><p>\r\nGillett insisted he was now concentrating on backing Benitez''s attempts to improve on Liverpool''s trophy-less campaign last season.\r\n</p><p>\r\n"All of us are focused on the transfer window and we want to be ready for that and we want to have adequate resources and good communication with Rafa and our hope is that we''re making better progress, " he said.\r\n</p><p>\r\n"What did I think of last season''s performance? I''d rather let the fans make that decision. But for a club that has a history of winning trophies, any season that you don''t win one of the five or six trophies that we compete for, I suspect the fans, as well as the Hicks'' and Gilletts, are disappointed.\r\n</p><p>\r\n"We have to help Rafa try and be more competitive in the chase for the Premier League."\r\n</p>\r\n\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/football/teams/l/liverpool/7466183.stm" title="Liverpool pair attempt peace pact ">Source: BBC</a></p>', 1, 5, 0, 20, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:25:29', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 3, '', '', 0, 5, ''),
(26, 'Portsmouth land Reading''s Little ', 'portsmouth-land-readings-little-', '', '<img src="images/stories/sport/soccer/4.jpg" alt="Portsmouth land Reading''s Little " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nPortsmouth have signed winger Glen Little from Championship side Reading on a one-year deal.\r\n\r\nLittle is Pompey''s first...\r\n', 'signing of the close season and turned down the offer of a new contract at the Madejski Stadium in favour of Fratton Park. \r\n<p>The 32-year-old made only two appearances after an Achilles injury last season.\r\n</p><p>He spent four seasons at Reading after joining on a free transfer from Burnley in 2004. \r\n<p>Little had previously spent time on loan with the Royals in 2003, and then had a spell at Bolton. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/football/teams/p/portsmouth/7465979.stm" title="Portsmouth land Reading''s Little ">Source: BBC</a></p>\r\n\r\n', 1, 5, 0, 20, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:28:48', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 2, '', '', 0, 4, ''),
(27, 'Challenge Cup - first round draw ', 'challenge-cup-first-round-draw-', '', '<img src="images/stories/sport/soccer/5.jpg" alt="Challenge Cup - first round draw " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nSt Johnstone will open their defence of the Challenge Cup with a visit to Ross County next season.\r\n\r\nGretna face Clyde if...\r\n', ' their future can be guaranteed, while Partick Thistle host Glasgow rivals Queen''s Park.\r\n<p>\r\nDundee travel to Alloa Athletic, Peterhead entertain Montrose and Brechin City are at home to East Fife.\r\n</p><p>\r\nScottish Cup runners-up Queen of the South make the trip to Berwick Rangers, Livingston host Stranraer and Dumbarton travel to Airdrie United.\r\n</p><p>\r\nRaith Rovers and Morton were the teams to receive byes as the opening round of the tournament is divided into North-East and South-West regions.\r\n</p><p>\r\nAll matches are scheduled for Saturday 26 July.\r\n</p><p>\r\n<b>North/East draw: </b>\r\n</p><p>\r\nRoss County v St. Johnstone<br /> \r\nAlloa Athletic v Dundee<br /> \r\nArbroath v Forfar Athletic<br /> \r\nBrechin City v East Fife<br /> \r\nDunfermline Athletic v Stirling Albion<br /> \r\nPeterhead v Montrose<br /> \r\nElgin City v Cowdenbeath \r\n</p><p>\r\nBye: Raith Rovers\r\n</p><p>\r\n<b>South/West draw:</b>\r\n</p><p>\r\nEast Stirlingshire v Ayr United<br /> \r\nClyde v Gretna<br /> \r\nStenhousemuir v Albion Rovers<br /> \r\nPartick Thistle v Queen''s Park<br /> \r\nBerwick Rangers v Queen of the South<br /> \r\nLivingston v Stranraer<br /> \r\nAirdrie United v Dumbarton\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/football/scot_cups/7425254.stm" title="Challenge Cup - first round draw ">Source: BBC</a></p>', 1, 5, 0, 20, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:31:06', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 4, ''),
(28, 'Radcliffe ''on schedule'' for Games ', 'radcliffe-on-schedule-for-games-', '', '<img src="images/stories/sport/olympics/1c.jpg" alt="Radcliffe ''on schedule'' for Games " width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nUK Athletics performance director Dave Collins is hopeful Paula Radcliffe will recover from injury in time for the Olympic Games in Beijing.\r\n<p>\r\nThe 34-year-old marathon world record holder is recovering from a stress fracture to her left thigh which threatens her participation.\r\n</p><p>\r\nBut Collins said: "I think there is a progression we''d hope to see and that was laid down in the original plan. \r\n</p><p>\r\n"All the reports I am getting is that she is on schedule...\r\n</p>', '<p>\r\nLast month Radcliffe said she was determined to make the Olympics, despite medical advice claiming the injury would make it impossible for her to achieve full fitness in time. \r\n</p><p>\r\nSince learning of the injury, Radcliffe has returned to her training base at Font Romeu in the French Pyrenees in a bid to make a fourth successive Olympic appearance. \r\n</p>\r\n<p>Collins is closely monitoring the situation and added: "It''s a significant injury and certainly she''s been very committed and worked well. </p>\r\n<p>\r\n"She''s in the pool and cross training but not actually running. As you would expect from an athlete committed to putting herself on the start line, we will give her all the help we can." \r\n</p><p>\r\nCollins suggested they will wait until 20 July, when the final British team is announced, before making a decision on Radcliffe. \r\n</p><p>\r\n"I would want to give her as much time as possible to see if she is capable of taking her place," he added. \r\n</p><p>\r\nRadcliffe has been selected for Team GB along with Liz Yelling and Mara Yamauchi, with Hayley Haining waiting in the sidelines should be forced to withdraw. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/olympics/athletics/7466572.stm" title="Radcliffe ''on schedule'' for Games ">Source: BBC</a></p>', 1, 5, 0, 21, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:23:35', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 8, 0, 5, '', '', 0, 6, ''),
(29, 'Williamson heads to fifth Games ', 'williamson-heads-to-fifth-games-', '', '<img src="images/stories/sport/olympics/2.jpg" alt="Williamson heads to fifth Games " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nBritish archer Alison Williamson is going to her fifth Olympic Games after being named in the team for Beijing...', '<p>Williamson, who won bronze in Athens four years ago, is joined by Charlotte Burgess and Naomi Folkard in the women''s team. \r\n</p><p>The trio won World Cup team gold in the Dominican Republic earlier in the year. \r\n</p><p>Alan Wills, who won a World Cup grand final bronze last year, will compete with Larry Godfrey and Simon Terry in the men''s events. </p>\r\n    \r\n<p>Williamson may be a veteran in Olympic terms, but that has in no way lessened her desire for success in Beijing. \r\n</p><p>The 36-year-old said: "I am just as motivated now as I was when I went to my first Games in Barcelona in 1992. \r\n</p><p>"You might say that winning the bronze medal four years ago was as good as it gets, but I don''t see it like that, I am the kind of person who always sets myself new targets and fresh challenges." \r\n</p>\r\n\r\n<p>There is a good mix of experienced archers and first-time Olympians in the team and Hilda Gibson, Team GB''s archery team leader said: "I have no doubt that all six will be very competitive individually, and as teams, they will provide formidable opposition." \r\n</p><p>Folkard is going to her second Olympics, while for Burgess, it will be a new experience. \r\n</p><p>"I really did dream that one day I would go to the Olympics, and now I''m going," said the 21-year-old. \r\n</p><p>"It''s wonderful. I took up archery as a 10 year old and coming through this selection process and clinching a place in Beijing is just so exciting." \r\n</p>\r\n\r\n<p>For Wills the selection justifies his decision to give up a carpentry job to focus full-time on archery. \r\n</p><p>He said: "This is everything I''ve worked for, and all the sacrifices and hard work has now paid off. It''s a fantastic feeling." \r\n</p><p>And for Terry, who won two bronze medals in the individual and team competitions in Barcelona, it is a welcome return to the sport he quit around 13 years ago. \r\n</p><p>"I''m absolutely delighted I''ve made it to Beijing," said Terry, 34. \r\n</p><p>"It''s been a tough process, with a few ups - such as coming fourth at last year''s World Championships, and a few downs, like a dip in form earlier this year, which started to cause concern." \r\n</p><p>Eight archers, four men and four women, went into the competition and with only six places up for grabs, Tom Barber and Emma Downie were the two to miss out. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/olympics/archery/7465436.stm" title="Williamson heads to fifth Games ">Source: BBC</a></p>\r\n\r\n', 1, 5, 0, 21, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:24:02', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 4, '', '', 0, 4, ''),
(30, 'GB rowers reach World Cup finals ', 'gb-rowers-reach-world-cup-finals-', '', '<img src="images/stories/sport/olympics/3.jpg" alt="GB rowers reach World Cup finals " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nBritain''s rowing crews enjoyed a successful start to the final World Cup event of the season in Poland with three boats reaching Sunday''s finals.\r\n', '<p>\r\nThe GB men''s four, racing for the first time with the line-up of Tom James, Steve Williams, Peter Reed and Andy Hodge, won their heat in Poznan.\r\n</p><p>\r\nDaniel Harte and Chris Bartley advanced to the final of the lightweight men''s pair after another heat win.\r\n</p><p>\r\nAnd Anna Bebington and Elise Laverick reached the open double scull final.\r\n</p><p>\r\nThe decision to race the men''s four, with James and Hodge back from injury, was finally taken on Thursday.\r\n</p><p>\r\nWilliams said: "We could have done with another week together but it wouldn''t have felt right to sit at home.\r\n</p><p>\r\n"I think the amount of work we have done has put us in a competitive place."\r\n</p><p>\r\nLightweight double Zac Purchase and Mark Hunter beat the reigning world champions in their heat to reach Saturday''s semi-finals.\r\n</p><p>\r\nThe men''s and women''s eights and the two lightweight quadruple scull boats will also be in action on Saturday.\r\n</p><p>\r\nAnd GB features in repechages of the men''s pair, four and lightweight women''s double scull and men''s four as well as the final of the lightweight men''s pair and the semi-final of the lightweight men''s double.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/olympics/rowing/7466029.stm" title="GB rowers reach World Cup finals ">Source: BBC</a></p>', 1, 5, 0, 21, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:23:54', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 3, '', '', 0, 5, ''),
(31, 'Powell and Couch seal Beijing slots ', 'powell-and-couch-seal-beijing-slots-', '', '<img src="images/stories/sport/olympics/4.jpg" alt="Powell &amp; Couch seal Beijing slots " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nStacie Powell and Tonia Couch have both qualified for the 2008 Beijing Olympics after winning the 10m synchro event in Leeds...\r\n', '<p>\r\nPowell and Couch beat British champions Monique McCarroll and Sarah Barrow showing great composure to seal their places in the Team GB diving squad. \r\n</p><p>\r\nThe pair completed their efforts with a final score of 324.72, while McCarroll and Barrow finished on 321.72. \r\n</p><p>\r\n"I''m quite emotional, I didn''t think we would make it," Couch said.</p>\r\n\r\n<p>\r\n"It just hasn''t sunk in for me yet," Powell added. \r\n</p><p>\r\n"That was a personal best score for us and I think the whole situation will hit me when I speak to my family and friends." \r\n</p><p>\r\nCarol and Helen Galashan, who competed at their first international competition together just a week ago, finished in third place with a score of 304.71. \r\n</p><p>\r\nDivers will compete again on Saturday pushing for selection in the women''s 3m and 10m Individual events.\r\n</p><p>\r\nBlake Aldridge, who will be nominated to dive with Tom Daley in the men''s 10m Synchro in Beijing, has been forced to withdraw from action this weekend due to an injury he suffered in a motorcycle accident.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/olympics/diving/7466821.stm" title="Powell &amp; Couch seal Beijing slots ">Source: BBC</a></p>', 1, 5, 0, 21, '2008-06-21 10:29:45', 63, '', '2008-06-24 12:24:50', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 2, '', '', 0, 5, ''),
(32, 'Bree breaks breaststroke record ', 'bree-breaks-breaststroke-record-', '', '<img src="images/stories/sport/olympics/5.jpg" alt="Quarter-final 3: Netherlands v Russia" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nNetherlands coach Marco van Basten is set to revert back to his favoured starting XI after resting a host of players last time out against Romania...', '<p>\r\nThat could mean only Khalid Boulahrouz - who will play despite the death of his prematurely-born baby daughter - and Arjen Robben keep their places. \r\n</p><p>\r\nRuud van Nistelrooy, Andre Ooijer and Dirk Kuyt will all return to the side. \r\n</p><p>\r\nRussia coach Guus Hiddink will name an unchanged line-up to the one that beat Sweden 2-0 in their final group game.\r\n</p><p>\r\nThat victory was inspired by Andrei Arshavin, the Zenit St Petersburg playmaker who had been suspended for the first two group games - a 4-1 defeat to Spain and a narrow 1-0 win over Greece. \r\n</p><p>\r\n</p><p>"I don''t think we needed to score that many goals in the Swedish game," said Arshavin. "We needed to save them for the next games and I hope we will score a few against the Dutch. \r\n</p><p>\r\n"If we didn''t have to play the Netherlands, we would feel much better, because I think they are the best side here. \r\n</p><p>\r\n"But fate has it that we have to play the strongest team in the tournament in the last eight. I hope we will be able to match them." \r\n</p><p>\r\nRussia''s performance in the win over Sweden prompted many observers to predict a possible upset against the Dutch, despite the Netherlands'' 100% record in the tournament so far. \r\n</p>\r\n<p>\r\nAnd Hiddink, who will reportedly earn a £400,000 bonus for leading Russia into the last eight, will hope to avenge Russia''s defeat to the Netherlands in the final of Euro ''88. \r\n</p><p>\r\nThe Netherlands, though, have been in superb form in this Championship, beating World Cup winners Italy 3-0, World Cup finalists France 4-1, and then Romania 2-0 with a side largely made up from fringe members of the squad. \r\n</p><p>\r\nNetherlands have announced that the players will wear black armbands in the quarter-final against Russia after Boulahrouz''s prematurely-born daughter died earlier this week. \r\n</p><p>\r\nMeanwhile, the Netherlands'' Nigel de Jong and Andre Ooijer, and Russia''s Ivan Saenko, Dmitry Torbinsky, Denis Kolodin, Andrei Arshavin and Sergei Semak, are all a booking away from missing a potential semi-final clash with either Spain or Italy. \r\n</p><h4>BIG MATCH STATS</h4>\r\n    <p>\r\n<b>Head-to-heads</b>\r\n</p><p>\r\nHolland have won four of the previous eight confrontations. Russia have won twice and two matches ended in a tie. \r\n</p><p>\r\nAll three competitive encounters have been in European Championship finals. In 1988, the Soviet Union beat Holland 1-0 in their opening group match before losing the final 2-0. In 1992, when Russia took part as the CIS, this match ended in a 0-0 draw in the group stage. Current Dutch coach Marco van Basten played in all three of those matches. His only goal was a memorable strike in the final of 1988 to put Holland 2-0 up. \r\n</p><p><b>Team facts - Netherlands</b>\r\n</p><p>\r\nNow reached the knock-out stages in six consecutive European Championship finals, which is a competition record. \r\n</p><p>\r\nBeen knocked out at the quarter-final stage only once; in 1996 with Guus Hiddink at the helm, they suffered a 5-4 defeat on penalties to France. \r\n</p><p>\r\nAfter beating Italy and France in Group C, Holland can now claim the scalp of a third former winner of this tournament by beating Russia. \r\n</p><p>\r\nSeven different Dutch players have scored at Euro 2008 which equals the record for most different goalscorers from a team in the tournament history. \r\n</p><p>\r\nThey have now scored nine times, which is five short of the competition record set by France in 1984. Their +8 goal differential is the highest by any team in the group stage in the history of this tournament.\r\n</p><p>Van Basten has now won 35 of his 51 matches in charge of Holland. He needs two more wins to equal Bob Glendenning''s record of 37 wins as Holland manager. \r\n</p><p>\r\nBeen shown just two yellow cards this tournament, fewer than any other team. \r\n</p><p>\r\n<b>Team facts - Russia</b>\r\n</p><p>\r\nSurvived the group phase for the first time since 1988, when they took part as the Soviet Union and finished runners-up to the Netherlands. \r\n</p><p>\r\nTrying to become only the second nation to win this tournament despite losing their opening match, following in the footsteps of the Netherlands in 1988. \r\n</p><p>\r\nCoach Guus Hiddink has maintained his 100% progression record at major tournaments (two European Championships, three World Cups). In his only previous European Championship finals, he was eliminated in the quarter-finals by France (1996). \r\n</p><p>\r\nHiddink has faced his native country twice before as a coach, both times in a friendly. In June 2006, Holland drew 1-1 with Hiddink''s Australia. In February 2007, he suffered a 4-1 defeat with Russia against the Netherlands. \r\n</p><p>\r\n<b>Player facts - Netherlands</b>\r\n</p><p>\r\nEdwin van der Sar looks set to play in his 16th match in European Championship finals, equalling the all-time record set by France''s Lilian Thuram earlier this tournament. \r\n</p><p>\r\nNigel de Jong and Andre Ooijer are one yellow card shy of a suspension. \r\n</p><p>\r\n<b>Player facts - Russia</b>\r\n</p><p>\r\nRoman Pavlyuchenko has taken 18 shots on goal (nine on, nine off target) in the group stage, more than any other player. \r\n</p><p>\r\nIgor Akinfeev is the goalkeeper with most saves (21) to his name after the first round of matches. \r\n</p><p>\r\nIf selected, Roman Adamov will be playing on his 26th birthday. \r\n</p><p>\r\nSergei Semak will win his 50th cap for Russia, if he takes the field. He made his debut in a 1-0 defeat to Italy on 15 November 1997. \r\n</p><p>\r\nDenis Kolodin, Dmitriy Torbinskiy, Ivan Saenko, Andrei Arshavin and Sergei Semak are one yellow card shy of a suspension. \r\n</p><p>\r\n</p><p>Big Match Stats source: Infostrada Sports \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/sport1/hi/football/euro_2008/7363505.stm" title="Quarter-final 3: Netherlands v Russia">Source: BBC</a></p>', 1, 5, 0, 21, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:23:44', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 1, '', '', 0, 6, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(33, 'Sudan Crash Airline Is Grounded ', 'sudan-airline', 'sudan airline', '<img src="images/stories/world/africa/2.jpg" alt="Sudan Airline" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nSudan''s national airline has been banned from flying for a month for failing to comply with aviation rules.\r\n\r\nSudan Airways has been told that it will not be allowed...', 'to fly domestically or internationally from Monday.\r\n\r\n<p>It comes less than two weeks after a Sudan Airways plane burst into flames after landing at Khartoum International Airport, killing 30 people.</p>\r\n\r\n<p>However, the Civil Aviation Authority said the decision had nothing to do with the accident on 10 June.</p>\r\n\r\n<p>Its director of safety and flight operations, Mohamed Hassan al-Mujammar, said Sudan Airways had failed to undertake measures outlined by the Authority in an annual audit carried out at the end of May.</p>\r\n\r\n<p>He said it was time to stop this type of non-compliance with international standards.</p>\r\n\r\n<p>As a result the company''s Air Operators Certificate has been suspended from Monday, which will affect all international and domestic flights.</p>\r\n\r\n<p>Mr Mujammar said the national carrier said it had been too preoccupied by the crash to take the actions urged by the CAA.</p>\r\n\r\n<p>The airline has one month to appeal against the suspension or to carry out the necessary improvements.</p>\r\n\r\n<p>No-one was available for comment from Sudan Airways.</p>\r\n\r\n<p>An investigation into what caused the accident in June is under way.</p>\r\n\r\n<p>Sudan has a poor reputation for air safety, especially on domestic flights.</p>\r\n\r\n\r\n<p><a href="http://news.bbc.co.uk/2/hi/africa/7467423.stm" title="Sudan Crash Airline Is Grounded">Source: BBC</a></p>', 1, 4, 0, 18, '2008-06-21 11:20:53', 64, '', '2008-06-22 14:11:26', 63, 0, '0000-00-00 00:00:00', '2008-06-21 11:15:20', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 9, ''),
(34, 'S. Leone Arrests Illegal Migrants ', 's-leone-arrests-migrants', 's. leone arrests migrants', '<img src="images/stories/world/africa/3.jpg" alt="Sierra Leone" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nImmigration officers in Sierra Leone have started a manhunt for illegal immigrants living in the country.\r\n\r\nChief immigration officer Alpha Kolifa Koroma...', 'told the BBC the illegal immigrants were committing crimes such as drug dealing and people trafficking.\r\n\r\n<p>Several hundred have been arrested and four deported in the last week.</p>\r\n\r\n<p>The BBC''s Umaru Fofana in Sierra Leone says it is believed there are tens of thousands of foreigners, mainly from Nigeria, living there without records.</p>\r\n\r\n<p>Our correspondent says the number of Nigerians has soared dramatically since the mid 1990s because of the presence of Nigerian peacekeepers in Sierra Leone.</p> \r\n\r\n<p>Nigeria led a West African force that intervened during Sierra Leone''s brutal civil war.</p>\r\n\r\n<p>The Nigerian soldiers later joined the UN peace mission, which withdrew in 2005 - three years after the conflict officially ended.</p>\r\n\r\n<p>Our reporter says the news of the crackdown has prompted fear among the large Nigerian community - many fearing it may prompt xenophobic attacks.</p>\r\n\r\n<p>Mr Koroma said the operation had been launched because the country has become "plagued by so many anti-social activities orchestrated by alleged foreign nationals".</p>\r\n\r\n<p>"There are all kinds of drug trafficking, child trafficking orchestrated by these people and these are relatively new criminal activities in the country," he told the BBC''s Network Africa programme.</p>\r\n\r\n<p>He urged foreigners to come to the immigration headquarters to legalise their status. Two Algerians and two Nigerians have been deported since the crackdown began.</p>\r\n\r\n<p>Citizens of members of the regional body, the Economic Community Of West African States (Ecowas), do not require visas to stay in other member states.</p>\r\n\r\n<p>But after 90 days, Ecowas citizens should register if they wish to stay longer.</p>\r\n\r\n<p>Our correspondent says thousands of Nigerians live all over Sierra Leone, many running shops in business district of the capital, Freetown.</p>\r\n\r\n<p>But many Sierra Leoneans regard them with suspicion as they believe they are involved in crime, especially drug dealing or con tricks - known as 419 scams, he says.</p>\r\n\r\n<p>Nigerians in Freetown have voiced disquiet about the operation - some telling the BBC that as Ecowas citizens, they should have the right to remain, others fearing the move will entrench resentment towards them.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/2/hi/africa/7462973.stm" title="S Leone arrest illegal migrants">Source: BBC</a></p>', 1, 4, 0, 18, '2008-06-21 11:29:25', 64, '', '2008-06-22 14:47:57', 63, 0, '0000-00-00 00:00:00', '2008-06-21 11:23:45', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 7, ''),
(35, 'Insecticide ''killing Kenya lions''', 'killing-kenya-lions', 'killing Kenya lions', '<img src="images/stories/world/africa/4.jpg" alt="Kenya Lion" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nEnvironmentalists in Kenya are worried that an insecticide is being used by farmers to kill lions and other predators.\r\n\r\nCarbofuran is a very powerful and toxic insecticide...', '<p>Spread in the soil, it destroys bugs in the ground and is taken up by plants and kills insects which feed on the sap or foliage.</p>\r\n\r\n<p>It is so powerful and toxic that it has been banned in Europe.</p>\r\n\r\n<p>In the United States it cannot be used in granular form, and the US Environmental Protection Agency is seeking a total ban.</p>\r\n\r\n<p>But in Kenya, carbofuran can be bought across the counter without restriction.</p>\r\n\r\n<p>According to world-famous naturalist Dr Richard Leakey, it is being bought not by farmers wanting to control bugs and insects, but mainly by herdsmen who use it to kill lions, leopards and other predators.</p>\r\n\r\n<p>Among the latest incidents two lions were poisoned and killed in the Maasai Mara game reserve after eating the carcass of a hippo that had ingested carbofuran.</p>\r\n\r\n<p>Vets and wildlife rangers were called to watch the pathetic sight of the lions staggering and weakened from the effects of the poison.</p> \r\n\r\n<p>One of the lions was shot to bring a quick end to its suffering.</p>\r\n\r\n<p>Another lion died a few months ago from carbofuran poisoning on a private ranch in Laikipia.</p>\r\n\r\n<p>In November last year, a dead camel was apparently found laced with carbofuran near Lewa Wildlife Conservancy.</p>\r\n\r\n<p>The result was the death of at least two lions and 15 vultures which feasted on the carcass.</p>\r\n\r\n<p>Also near Lewa, several lions from the nearby Samburu Wildlife Reserve were poisoned; again, it is thought carbofuran was responsible.</p>\r\n\r\n<p>There are many other cases throughout Kenya of predators dying after eating meat contaminated with the chemical.</p>\r\n\r\n<p>Dr Leakey says carbofuran is "deadly poisonous" and he has called for it to be banned in Kenya.</p>\r\n\r\n<p>"It''s become known in rural communities in Kenya as an easy way to get rid of predators: lions, leopards and hyenas," he says.</p>\r\n\r\n<p>Dr Leakey says his research shows that Furadan, the trade name of the biggest-selling carbofuran insecticide in Kenya, is being bought not by farmers but by pastoralists who do not have any land for growing crops, and use the chemical to kill lions and leopards which threaten their herds.</p>\r\n\r\n<p>There is no record for the number of predators killed in Kenya by poisoning, but many naturalists believe carbofuran is responsible for thousands of deaths, not just of big cats but all carrion eaters.</p> \r\n\r\n<p>Simon Thomsett, a world renowned expert on vultures, eagles and other birds of prey, says there has been a "dramatic drop-off in the number of birds of prey in the past few years", and the finger of blame is being pointed at carbofuran.</p>\r\n\r\n<p>He gives the example of 187 vultures that died when they fed on a carcass of an animal that was apparently laced with the deadly poison in an area by the Athi River.</p>\r\n\r\n<p>Simon Thomsett says the poison cannot be detected when sprinkled on the carcass and is very fast to act.</p>\r\n\r\n<p>"I literally saw vultures dropping out of the sky just a few minutes after they had eaten the poisoned meat," he said.</p>\r\n\r\n<p>Carbofuran comes in granular form, tiny dust-like purple pellets.</p>\r\n\r\n<p>I went into several agricultural merchants in the capital, Nairobi, and found it easy to buy.</p> \r\n\r\n<p>Three shops said it posed no health threat to animals or humans.</p>\r\n\r\n<p>"It''s safe, it''s perfectly safe," one shop assistant told me.</p>\r\n\r\n<p>Others warned it was poisonous and one shop-keeper even described carbofuran as a "lion-killer".</p>\r\n\r\n<p>The container warns that it should be kept "locked away out of reach of children", but there is not a word on the label about a potential threat to wildlife.</p>\r\n\r\n<p>Kenya''s Pest Control and Products Board is carrying out research into carbofuran''s dangers and toxicity, and say it is too early to come to a conclusion.</p>\r\n\r\n<p>Dr Leakey says the evidence is there for all to see.</p>\r\n\r\n<p>His worries are shared by Thomas Manyibe, a vet with the Kenya Wildlife Service who carried out post-mortem tests on the lions that were killed in the Masai Mara.</p>\r\n\r\n<p>He says evidence shows that carbofuran is being used to target lions and leopards.</p>\r\n\r\n<p>I spoke to pastoralists who said they had heard that Furadan was used to kill big cats.</p>\r\n\r\n<p>On the edge of the Maasai Mara a young herdsman, Ndigwa, said he lost many cows every year to lions and leopards, but he said he would never resort to poison to take revenge on the predators.</p> \r\n\r\n<p>Others do not hesitate.</p>\r\n\r\n<p>Carbofuran comes from a number of different overseas suppliers, but the main producer is the US firm FMC Corporation.</p>\r\n\r\n<p>The company said in a statement: "We take stewardship of our products very seriously and condemn any intentional baiting misuse of carbofuran.</p>\r\n\r\n<p>"FMC is very concerned about reports of carbofuran (Furadan) being used to bait lions in Kenya and we have offered our services to the Kenya Pest Control Products Board in their investigation."</p>\r\n\r\n<p>Concerns about the use of carbofuran are not new.</p>\r\n\r\n<p>Fifteen years ago there were a number of cases of mass killings of birds in western Kenya; what is lacking is a comprehensive record of predators killed by poisoning.</p>\r\n\r\n<p>There is lots of circumstantial evidence but few hard facts.</p>\r\n\r\n<p>Detailed information is elusive, affected animals often disappear into the bush to die, and the evidence is then eaten by other carnivores.</p> \r\n\r\n<p><a href="http://news.bbc.co.uk/2/hi/africa/7460008.stm" title="Insecticide ''killing Kenya lions''">Source: BBC</a></p>\r\n\r\n', 1, 4, 0, 18, '2008-06-21 11:54:44', 64, '', '2008-06-23 08:41:55', 62, 0, '0000-00-00 00:00:00', '2008-06-21 11:44:45', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 10, 0, 2, '', '', 0, 6, ''),
(36, 'Madagascar: New Eco-Deals Protect Unique Forests', 'madagascar-forest-protection', 'madagascar forest protection', '<img src="images/stories/world/africa/5c.jpg" alt="Alonso Unsure" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<p>Madagascar has signed a series of environment agreements to protect unique forests and support local communities as part of a commitment by the government to ramp up environmental protection on the Indian Ocean island.</p>\r\n\r\n<p>In its largest ever debt-for-nature swap, Madagascar signed a deal with France this month, in which US$20 million of debt owed to the former colonial power was put into a conservation fund, the Foundation for Protected Areas and Biodiversity (FPAB).</p>\r\n\r\n<div style="height: 12px; display: block;"></div>\r\n"Thanks to this, the money will go into the protection...', 'of the Malagasy environment instead of to France," Nani Ratsifandrihamanana, the environment director of the World Wildlife Fund (WWF) told IRIN.\r\n\r\n<p>Her organisation played a crucial role in brokering the deal that will help protect Madagascar''s forests, home to many of the world''s most fascinating creatures. Nearly all the island''s land mammals, over 90 percent of its reptiles and 80 percent of its plants are found nowhere else.</p>\r\n\r\n<p>In a separate deal, Madagascar committed itself to selling nine million tons of carbon offsets to help protect its forests. The money will be used to protect the vast Makira forest, one of several under threat as a result of the poverty of the overwhelmingly rural population.</p>\r\n\r\n<p>Scientists say deforestation in the tropics contributes to about 20 percent of all carbon dioxide emissions and that reducing deforestation is one of the quickest ways to fight climate change. Deforestation in Africa is twice as high as anywhere else in the world, where some 13 million hectares of forest are cleared every year.</p>\r\n\r\n<p>Thanks to this, the money will go into the protection of the Malagasy environment.</p>\r\n\r\n<p>Conservation International (CI), a non-profit environmental group, said the main drivers of deforestation in Madagascar were slash-and-burn agriculture, charcoal production for use in towns and cities, mining, and the conversion of forest to plant maize.</p>\r\n\r\n<p>Reducing deforestation is a hard battle to win because more than 75 percent of the island''s 18 million people are rural and depend on land and natural resources.</p>\r\n\r\n<p>The new carbon credit deal, managed by the Wildlife Conservation Society (WCS), based at the Bronx Zoo in the US, represents an innovative way to tackle the problem.</p>\r\n\r\n<p>Offset schemes allow polluters to pay for emission cuts in other countries, while providing a source of precious foreign currency to developing countries.</p>\r\n\r\n<p>The Malagasy government has had some success in forest protection in recent years and has been able to increase the number and size of protected areas. According to environmentalists, the rate of deforestation has been dramatically cut in some of these areas.</p>\r\n\r\n<p>[ This report does not necessarily reflect the views of the United Nations ]</p>\r\n\r\n<p><a href="http://allafrica.com/stories/200806190973.html" title="Madagascar: New Eco-Deals Protect Unique Forests">Source: All Africa</a></p>', 1, 4, 0, 18, '2008-06-21 12:14:04', 64, '', '2008-06-23 08:41:33', 62, 0, '0000-00-00 00:00:00', '2008-06-21 12:09:09', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 11, 0, 1, '', '', 0, 6, ''),
(37, 'Picasso Prints Stolen From Brazil Museum', 'picasso-prints-stolen', 'picasso prints stolen', '<!--IMAGE images/stories/rotator/5.jpg IMAGE--><img src="images/stories/world/s-america/1.jpg" alt="Alonso Unsure" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nSÃO PAULO, Brazil (AP) -- Three heavily armed robbers stole two Pablo Picasso prints from an art museum in downtown São Paulo on Thursday, the city''s second high profile art theft...', 'in less than a year.\r\n\r\n<p>The bandits also took two oil paintings by well-known Brazilian artists Emiliano Di Cavalcanti and Lasar Segall, said Carla Regina, a spokeswoman for the Pinacoteca do Estado museum.</p>\r\n\r\n<p>The Picasso prints stolen were "The Painter and the Model" from 1963 and "Minotaur, Drinker and Women" from 1933, according to a statement from the São Paulo Secretary of State for Culture, which oversees the museum.</p>\r\n\r\n<p>The prints and paintings have a combined value of 1 million Brazilian reals ($612,000), the statement said.</p>\r\n\r\n<p>At noon, three armed men overpowered museum guards and grabbed the works, located on the second floor, the statement added. The museum was open to the public when the theft occurred, but it wasn''t immediately clear whether anyone was visiting at the time.</p>\r\n\r\n<p>In December, Picasso''s "Portrait of Suzanne Bloch" and "O Lavrador de Cafe" by Candido Portinari, an influential Brazilian artist, were stolen from the São Paulo Museum of Art by three men who used a crowbar and car jack to force open one of the museum''s steel doors.</p>\r\n\r\n<p>The framed paintings were found January 8, covered in plastic and leaning against a wall in a house on the outskirts of São Paulo, South America''s largest city.</p>\r\n\r\n<p>One of the suspects in that heist -- a former TV chef -- turned himself over to police in January, who already had two suspects in custody.</p>\r\n\r\n<p><a href="http://www.cnn.com/2008/WORLD/americas/06/12/picasso.robbery.ap/index.html?iref=newssearch" title="Picasso prints stolen from Brazil museum">Source: CNN</a></p>', 1, 4, 0, 14, '2008-06-21 12:19:23', 64, '', '2008-06-24 10:41:40', 62, 0, '0000-00-00 00:00:00', '2008-06-21 12:18:17', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 8, 0, 5, '', '', 0, 16, ''),
(38, 'ESPN, NFL Network discuss partnership', 'espn-nfl-network-discuss-partnership', '', '<img src="images/stories/sport/football/1c.jpg" alt="ESPN, NFL Network discuss partnership" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nNEW YORK (AP) -- The NFL Network and Walt Disney Co.''s ESPN are in talks about a partnership, a person familiar with the talks told The Associated Press.   <p> The person requested anonymity because the negotiations are ongoing.</p>   <p> A deal could end a long standoff between the league and cable carriers, some of whom said the NFL was asking them to pay too much for its programming.</p>   <p> The prospective deal first was reported by The Wall Street Journal on Friday...</p>', '   <p> The NFL''s discussions with Disney are being led by Steven Bornstein, the head of the NFL''s cable network who is also a previous chairman of ESPN and president of the ABC network, which is also owned by Disney, the Journal reported.</p>   <p> ESPN spokesman Mike Soltys declined to comment on the report but said the network has "a long-term and extensive relationship with the NFL and to that end we are always in discussions with them about mutual projects."</p>   <p> NFL Network spokesman <a href="http://sportsillustrated.cnn.com/football/nfl/players/5984">Dennis Johnson</a> also declined to say whether those specific talks were occurring, saying the company was "in talks with ESPN and our other broadcast partners all the time on a wide range of issues."</p>   <p> The NFL Network is carried on the satellite broadcaster DirecTV, but the network clashed with major cable providers like Time Warner Cable Inc., who said the league was demanding exorbitant carriage fees.</p>   <p> The NFL had tried to enhance the appeal of its own cable channel by withholding a number of live games from traditional broadcasts and reserving them for its own network.</p>\r\n\r\n<p><a href="http://www.sportsillustrated.com/2008/football/nfl/06/20/nfl.network.espn.ap/index.html" title="ESPN, NFL Network discuss partnership">Source: Sports Illustrated</a></p>', 1, 5, 0, 23, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:19:44', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 10, 0, 5, '', '', 0, 4, ''),
(43, 'Coca Cultivation Rises In Colombia, U.N. Says', 'coca-cultivation-rises', 'coca cultivation rises', '<!--IMAGE images/stories/rotator/2.jpg IMAGE--><img src="images/stories/world/s-america/2.jpg" alt="Coca Cultivation" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nBOGOTA, Colombia, June 18 -- The amount of land devoted to production of coca, the leaf used to make cocaine, has grown at a dramatic pace in Colombia despite a huge American-funded...', 'counter-drug program of aerial fumigation and aggressive interdiction, a U.N. agency said Wednesday.\r\n\r\n<p>In a 132-page report based on satellite imagery and on-the-ground surveys, the United Nations'' Office on Drugs and Crime said that Colombian farmers planted 245,000 acres of coca last year, 27 percent more than in 2006. Coca cultivation in the world''s three top producers, Colombia, Peru and Bolivia, increased 16 percent, to 448,743 acres, a swath of land slightly smaller than Delaware.</p>\r\n\r\n<p>"The increase in coca cultivation in Colombia is a surprise and shock," Antonio Maria Costa, director of the Office on Drugs and Crime, said in a statement. "A surprise because it comes at a time when the Colombian government is trying so hard to eradicate coca; a shock because of the magnitude of cultivation."</p>\r\n\r\n<p>The findings follow almost eight years of heavy aerial fumigation of drug crops in Colombia, an American-designed strategy that has cost more than $5 billion. That program includes military assistance that has helped Colombia''s army weaken the Revolutionary Armed Forces of Colombia, a peasant-based rebel group that has funded its war against the state in part through the cocaine trade.</p>\r\n\r\n<p>President Álvaro Uribe''s government has also disarmed thousands of fighters belonging to a right-wing anti-guerrilla group, which at one time was the leading trafficking cartel in the country.</p>\r\n\r\n<p>In a telephone interview, John P. Walters, the White House drug czar, said American aid in the form of funding, advice and training for Colombia''s security forces has helped stabilize a close ally and disrupt cocaine smuggling to the United States.</p>\r\n\r\n<p>"The power to do terror, and to put Colombians and others at risk, is weaker and weaker than it was five years ago," he said. "The situation for all of us is better."</p>\r\n\r\n<p>Walters said he believed that the U.N. estimate on coca cultivation could be higher now because improvements in its survey methodology might have permitted detection of coca fields that went unnoticed in the past.</p>\r\n\r\n\r\n<p>U.S. coca production estimates, which are based on different methodology, showed 388,449 acres in 2006, nearly as much as in 2001, the first full year of intensive aerial spraying. American estimates for 2007 are due in August. Some drug policy analysts said that the latest U.N. figures demonstrate that the U.S. anti-drug onslaught has failed to deliver, and that Washington should change course if it hopes to wean poor farmers from drug crops and permanently dismantle the cocaine trade. The dumping of herbicides on drug crops in Colombia, the only South American country that permits the practice, has prompted farmers to abandon large fields for smaller, harder-to-find plots, analysts said.</p>\r\n\r\n<p>"Forced eradication, including aerial spraying, only guarantees more replanting," said John M. Walsh, who studies the drug war for the Washington Office on Latin America, a policy analysis group. Walsh said the focus should shift to improving infrastructure and helping the poor farmers who grow the coca crops move into other, legal crops.</p>\r\n\r\n<p>"The easy pickings in terms of spraying coca in Colombia are over, and for there to be progress beyond this plateau there needs to be an alternative livelihood," Walsh said.</p>\r\n\r\n<p>The data in the U.N. report are sobering.</p>\r\n\r\n<p>Cocaine production in the Andes, at 994 metric tons in 2007, is higher than it was in 2001. In Peru and Bolivia, coca cultivation has been steadily rising in recent years, to the point where land devoted to the leaf is nearly at the levels of the late 1990s.</p>\r\n\r\n<p>In Colombia, homicides went up slightly last year after a four-year decline, and the U.N. refugee agency said this week that more than 3 million people here have fled their homes because of a long, simmering war.</p>\r\n\r\n<p>Markus Schultze-Kraft, Latin America director for the International Crisis Group, a Belgium-based organization that studies the conflict here, said that while rebel groups here may be weaker than before, the drug trade continues.</p>\r\n\r\n<p>"There''s a reshuffling in the criminal underworld," Schultze-Kraft said. "Since the business is there and continues to be lucrative, and is on the rise in terms of volume and trafficking, there definitely are enough criminal actors in Colombia that are there to pick up the game."</p> \r\n\r\n<p><a href="http://www.washingtonpost.com/wp-dyn/content/article/2008/06/18/AR2008061802950.html" title="Coca Cultivation Rises In Colombia, U.N. Says">Source: Washington Post</a></p>\r\n', 1, 4, 0, 14, '2008-06-21 12:45:33', 64, '', '2008-06-24 10:42:11', 62, 0, '0000-00-00 00:00:00', '2008-06-21 12:40:55', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 4, '', '', 0, 19, ''),
(39, 'Bills'' Lynch to plead guilty to accident-related charge ', 'bills-lynch-to-plead-guilty-to-accident-related-charge-', '', '<img src="images/stories/sport/football/2.jpg" alt="Bills'' Lynch to plead guilty to accident-related charge" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n \r\nBUFFALO, N.Y. (AP) -- <a href="http://sportsillustrated.cnn.com/football/nfl/teams/bills">Buffalo Bills</a> running back <a href="http://sportsillustrated.cnn.com/football/nfl/players/8266">Marshawn Lynch</a> is expected to plead guilty next week.\r\n \r\nThis to an unspecified charge stemming from...', 'a hit-and-run accident involving his SUV, Erie County District Attorney Frank Clark said Friday.\r\n<p> Clark declined to detail the charge but said a tentative plea agreement assumes Lynch was driving his 2008 Porsche Cayenne when it hit a woman crossing a Buffalo intersection early May 31, leaving the victim with a bruised hip and in need of stitches.</p>   <p> There was one other person in the SUV at the time, Clark said. He would not say who it was.</p>   <p> The announcement of an "agreement in principle" between lawyers came as a grand jury was scheduled to begin hearing testimony in the case. Several Bills players and front-office employees were subpoenaed by investigators frustrated by Lynch''s refusal to speak with them.</p>   <p> The prosecutor said he does not fault Lynch for exercising his right to stay silent, but acknowledged that his office and the Buffalo police could have used the nearly three weeks spent on the headline-grabbing Lynch case on more serious crimes.</p>   <p> "This, at its worst, is a vehicle and traffic misdemeanor. In the hierarchy of criminal conduct, this is certainly in the bottom third," he said.</p>   <p> Lynch, 22, was the Bills'' first-round draft pick in 2007. His lawyer, Michael Caffery, did not immediately respond to Clark''s announcement Friday. Earlier in the day he said by phone he was working toward a resolution. A message left with the player''s agent was not immediately returned.</p>   <p> Clark said Lynch, who left town after a Bills minicamp last week, is expected to appear in a Buffalo courtroom in the middle of next week.</p>   <p> "He is going to be back here. He is going to be in Buffalo. He is going to confront the matter directly. He''s going to do whatever he has to do to resolve it and then he''s going to make a statement," he said.</p>   <p> Although the accident has been under investigation since the end of May, plea negotiations began moving quickly forward late last week after Buffalo Bills team lawyers got involved, according to Clark. Bills chief operating officer Russ Brandon was among those served with a subpoena.</p>   <p> Bills spokesman Scott Berchtold said the organization was aware of Clark''s comments, "but will maintain our position that we will not comment until the process has been fully completed."</p>   <p> Clark said there was no reason to believe the delay in resolving the case affected the outcome.</p>   <p> "I think that the way this will be resolved will be in line with the way most of these cases are resolved and probably very much in line with the way it might have been resolved had all of this come together sooner," he said.</p>\r\n\r\n<p><a href="http://www.sportsillustrated.com/2008/football/nfl/06/20/lynch.guilty.ap/index.html" title="Bills'' Lynch to plead guilty to accident-related charge ">Source: Sports Illustrated</a></p>', 1, 5, 0, 23, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:06:23', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 4, '', '', 0, 3, ''),
(40, 'Broadcaster Summerall recovering', 'broadcaster-summerall-recovering', '', '<img src="images/stories/sport/football/3.jpg" alt="Broadcaster Summerall recovering" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nDALLAS (AP) -- Sports broadcaster Pat Summerall was recovering Friday from emergency surgery to stop internal bleeding, his wife said...\r\n', ' <p> Cheri Summerall said her 78-year-old husband was resting comfortably Friday in a Dallas-area hospital. Doctors told her that a new medicine he had recently started taking caused a reaction that induced the bleeding.</p>   <p> The surgery was Thursday.</p>   <p> "He has really turned the corner," Cheri Summerall said in a story Friday on The Dallas Morning News'' Web site. "The doctors are thrilled with Pat''s progress. We are expecting a full recovery."</p>   <p> Summerall, a former NFL kicker and lineman, underwent a liver transplant four years ago and hip replacement surgery in January.</p>\r\n\r\n<p><a href="http://www.sportsillustrated.com/2008/football/nfl/06/20/summerall.surgery.ap/index.html" title="Broadcaster Summerall recovering">Source: Sports Illustrated</a></p>', 1, 5, 0, 23, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:06:19', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 3, '', '', 0, 4, ''),
(41, 'Falcons rookie WR gets 4-year deal', 'falcons-rookie-wr-gets-4-year-deal', '', '<img src="images/stories/sport/football/4.jpg" alt="Falcons rookie WR gets 4-year deal" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nATLANTA (AP) -- The <a href="http://sportsillustrated.cnn.com/football/nfl/teams/falcons">Atlanta Falcons</a> have agreed to terms on a four-year deal with third-round draft pick Harry Douglas, a wide receiver from Louisville...\r\n', '   <p> The Falcons also announced the signing of free-agent safety <a href="http://sportsillustrated.cnn.com/football/nfl/players/6270">Deke Cooper</a> on Friday.</p>   <p> Cooper had three interceptions while starting 15 games for Carolina last season. He also has played for Jacksonville and San Francisco.</p>   <p> Douglas had 173 career catches and 15 touchdown catches at Louisville.</p>   <p> The Falcons released four players, including safety <a href="http://sportsillustrated.cnn.com/football/nfl/players/5034">Jamal Lewis</a> of Georgia Tech. The team also released offensive tackle Michael Butterworth, defensive end <a href="http://sportsillustrated.cnn.com/football/nfl/players/12869">Derrick Jones</a> and offensive lineman <a href="http://sportsillustrated.cnn.com/football/nfl/players/8608">Kurt Quarterman</a>.</p>\r\n<p><a href="http://www.sportsillustrated.com/2008/football/nfl/06/20/falcons.rookie.ap/index.html" title="Falcons rookie WR gets 4-year deal">Source: Sports Illustrated</a></p>\r\n\r\n', 1, 5, 0, 23, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:06:14', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 2, '', '', 0, 3, ''),
(42, 'Pacman''s home up for foreclosure', 'pacmans-home-up-for-foreclosure', '', '<img src="images/stories/sport/football/5.jpg" alt="Pacman''s home up for foreclosure" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nFRANKLIN, Tenn. (AP) -- A foreclosure sale has been published involving the home of former Tennessee Titan Adam "Pacman" Jones.\r\n\r\nHe has defaulted on the...', 'terms and conditions of a mortgage with U.S. Bank, according to a notice of foreclosure sale published Thursday in <i>The Tennessean</i> newspaper in Nashville.  <p> The home and 30 acres, located in a Nashville suburb, will be sold June 27 on the steps of the old Williamson County Courthouse.</p>   <p> Jones, a cornerback, was traded to the <a href="http://sportsillustrated.cnn.com/football/nfl/teams/cowboys">Dallas Cowboys</a> this year. He missed all of the 2007 season while serving an NFL suspension that hasn''t been completely lifted.</p>   <p> Tax records show he purchased the property in July 2006 for $1.5 million.</p> <p></p>\r\n\r\n<p><a href="http://www.sportsillustrated.com/2008/football/nfl/06/20/pacman.foreclosure.ap/index.html" title="Pacman''s home up for foreclosure">Source: Sports Illustrated</a></p>', 1, 5, 0, 23, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:08:42', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 1, '', '', 0, 6, ''),
(44, 'Treat knee pain with creams call ', 'treat-knee-pain-with-creams-call-', '', '<img src="images/stories/life/health/1c.jpg" alt="Treat knee pain with creams call" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>Gels or creams containing painkillers are better than tablets for chronic knee pain, NHS research suggests.</b>\r\n<p>A study of almost 600 patients aged over 50 found the anti-inflammatory creams worked as well as the oral versions and had fewer side-effects. \r\n</p><p>And although they cost more initially, topical treatments may save the NHS money in the long run, the Queen Mary University of London researchers said...\r\n</p>', '<p>It is estimated that a third of over 50s suffer from knee pain. \r\n</p><p>In half of those the problem is classed as severe. \r\n</p><p>The most common cause of pain in the knee is osteoarthritis - a condition caused by abnormal wearing of the cartilage. \r\n</p>\r\n<p>A total of 585 patients from 26 general practices around the UK took part in the study which looked specifically at non-steroidal anti-inflammatories (NSAIDs) - a class of drugs which includes ibuprofen. \r\n</p><p>Both tablets and creams containing the drugs had the same effect on knee pain, the study showed. \r\n</p><p>But those treated with oral medication had more minor adverse effects such as indigestion, increased blood pressure, or worsening asthma. \r\n</p><p><b>Uncertainty</b>\r\n</p><p>NSAIDs are well-known to be associated with sometimes serious side effects but the topical preparations deliver a smaller dose directly to the affected area and so are less likely to cause such problems. \r\n</p><p>Patients also preferred the gels and creams, the study which is published on the National Institute for Health Research website. \r\n</p><p>Study leader Professor Martin Underwood, who has since moved to Warwick University, said there had been uncertainty about which to use. \r\n</p><p>"There has been quite a lot of discouragement about using topical NSAIDs because it was thought they were more expensive and there was not good evidence they were beneficial." \r\n</p><p>He added that patients with more widespread pain may find tablets are better and should discuss the choice with their GP. \r\n</p><p>Royal College of GPs chairman Professor Steve Field said he had always been of the view that oral NSAIDs worked better. \r\n</p><p>"This is an important message for GPs and patients - that they should consider topical treatments to avoid side effects." \r\n</p><p>An Arthritis Research Campaign spokeswoman said GPs had probably under-prescribed topical creams in the past because they did not believe they were as effective. \r\n</p><p>"But this new research appears to show they both as effective and safer, with fewer of the side affects associated with NSAID tablets," she added.</p>\r\n\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/health/7466359.stm" title="Treat knee pain with creams call">Source: BBC</a></p>', 1, 8, 0, 36, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:37:06', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 3, ''),
(45, 'Smokers offered money to give up ', 'smokers-offered-money-to-give-up-', '', '<img src="images/stories/life/health/2.jpg" alt="Smokers offered money to give up " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nSmokers in the poorest areas of Dundee are being offered £150 worth of groceries by the health service if they are able to give up cigarettes.', '<p>Participants in a 12-week scheme will be given £12.50 a week by NHS Tayside if a carbon monoxide breath test proves they have not been smoking. \r\n</p><p>The money will be credited onto an electronic card which cannot be used for cigarettes or alcohol. \r\n</p><p>There are 36,000 smokers in Dundee, about half of whom live in poverty. </p>\r\n<p>The scheme is similar to a project used by the trust to encourage pregnant women to give up smoking. </p>\r\n\r\n<p>Sandy Watson, chairman of the health board, said: "Last year the Scottish Government challenged NHS Tayside to address smoking in disadvantaged areas. This project seeks to deliver on that and if successful could be replicated nationally. \r\n</p><p>"Smoking in Dundee is a difficult problem to tackle but we are hopeful that this innovative approach will encourage smokers to stop smoking for good and therefore make a real difference to their long-term health." </p>\r\n		\r\n<p>The convener of Dundee City Council''s social work and health committee, Helen Wright, added: "A lot of good work has already been done by the city council and NHS Tayside with expectant mothers which has shown that providing incentives to smokers to help them quit is a tactic that can work." \r\n</p><p>Andrew Radley, consultant in public health and the founder of the scheme, added: "We are excited to be launching a health improvement scheme that will engage with the disadvantaged communities in Dundee and potentially make a real difference to their long-term health. \r\n</p><p>"Giving up smoking is the single most important lifestyle decision that anyone can make to improve their health immediately." </p>               \r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/tayside_and_central/7465908.stm" title="Smokers offered money to give up ">Source: BBC</a></p>\r\n\r\n', 1, 8, 0, 36, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:37:37', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 4, '', '', 0, 6, ''),
(46, 'School affects smoking in young ', 'school-affects-smoking-in-young-', '', '<img src="images/stories/life/health/3.jpg" alt="School affects smoking in young " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nPupils who experience positive and inclusive social environments in school are less likely to take up smoking, according to new research.', '<p>\r\nA study of high-school children suggested that current school-based anti-smoking interventions were "largely ineffective". \r\n</p><p>\r\nBut the Medical Research Council (MRC) found that the wider school environment made a difference. \r\n</p><p>\r\nIt looked at more than 5,000 pupils in 24 Scottish schools.\r\n</p><p>\r\nThe study was led by Marion Henderson of the MRC social and public health sciences unit in Glasgow. \r\n</p><p>\r\nShe said: "The social environment of schools, in particular the quality of teacher-pupil relationships, pupils'' attitude to school and the school''s focus on caring and inclusiveness, all influence both boys'' and girls'' smoking habits." \r\n</p><p>\r\nDecreases in adult smoking rates in recent years have not been matched in younger smokers. \r\n</p><p>\r\nDr Henderson and her colleagues found that, on average, 25% of males and 39% of females aged 15-16, reported that they either regularly or occasionally smoked. \r\n</p>\r\n<p>\r\nSpeaking about current school-based anti-smoking measures she said: "Most focus on individual characteristics rather than the environment in which adolescents smoke. \r\n</p><p>\r\n"Our research has shown that this environment acts to either encourage or discourage smoking." \r\n</p><p>\r\nThe research showed "school effects" remained even after other factors, such as whether pupils smoked before joining, whether they lived with both parents and how much personal spending money they had, were taken into account. \r\n</p><p>\r\nDr Henderson said: "Our results suggest that investing in the social environment of schools and endeavouring to make school a positive experience even for less academically able pupils may have the potential to reduce smoking rates, particularly for boys." \r\n</p><p>\r\nThe research has been published in the open access journal BMC Public Health.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/7464172.stm" title="School affects smoking in young ">Source: BBC</a></p>', 1, 8, 0, 36, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:37:29', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 3, '', '', 0, 4, ''),
(47, 'Dummy use link to ear infections', 'dummy-use-link-to-ear-infections', '', '<img src="images/stories/life/health/4.jpg" alt="Bills'' Lynch to plead guilty to accident-related charge" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nParents should avoid using a dummy in infants who are prone to ear infections, research suggests.\r\n<p>In a five-year study...</p>', 'of almost 500 Dutch children researchers found almost double the risk of recurrent ear infections in those who used a dummy.\r\n<p>\r\nWriting in the Family Practice journal they said doctors should advise parents of the risk.  \r\n</p><p>\r\nScientifically known as acute otitis media, ear infections are very common in young children.\r\n</p><p>\r\nAntibiotics do not generally work and the infection tends clear on its own within a few days but some children are prone to repeated bouts.\r\n</p>\r\n<p>\r\nThe researchers from University Medical Center, Utrecht said some studies before had found a link between dummy use and ear infections but they had not been very accurate.\r\n</p><p>\r\nTheir research followed 476 children aged under four years, 216 of whom used a dummy.\r\n</p><p>\r\nThere was a 90% increased risk of recurrent ear infections in those who sucked a dummy compared with those who did not.\r\n</p><p>\r\n<b>Susceptibility</b>\r\n</p><p>\r\nThe researchers said results suggested that the first infection may increase susceptibility to future ear infections.\r\n</p><p>\r\nAnd using a dummy may allow bacteria to more easily migrate from secretions in the nose to the middle ear, they suggested.\r\n</p><p>\r\nStudy leader, Dr Maroeska Rovers, said: "Paediatricians and GPs can use this information in their daily practice - they can dissuade parents from using a pacifier [dummy] once their child has been diagnosed with acute otitis media to avoid recurrent episodes."\r\n</p><p>\r\nProfessor Steve Field, chair of the Royal College of GPs said there had been previous studies but they had not been put together very well.\r\n</p><p>\r\n"This is a very useful piece of research that shows use of dummies in children under the age of four who have a history of ear infections is not a good idea.\r\n</p><p>\r\n"There''s no need to panic but - in those children - not using a dummy is likely to prevent recurrence."</p>                     \r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/health/7463911.stm" title="Dummy use link to ear infections">Source: BBC</a></p>', 1, 8, 0, 36, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:37:21', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 2, '', '', 0, 5, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(48, 'Ageing muscle ''given new vigour''', 'ageing-muscle-given-new-vigour', '', '<img src="images/stories/life/health/5.jpg" alt="Ageing muscle ''given new vigour''" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nScientists have found a way to give old, tired muscles a new lease of life.\r\n\r\nThey tweaked biochemical signals in mice...', 'to boost the ability of the animal''s stem cells to repair damaged tissue, restoring its youthful vigour.\r\n\r\n<p>\r\nThe breakthrough raises hopes of new treatments for age-related degenerative diseases such as Alzheimer''s and Parkinson''s.\r\n</p><p>\r\nThe study, by the University of California, Berkeley, is published in the journal Nature.\r\n</p>\r\n<p>\r\nAdult stem cells play a key role in helping to repair the mature, differentiated cells that make up the body''s working tissues.\r\n</p><p>\r\nThe Berkeley  team identified two key regulatory pathways that control how well adult stem cells carry out their repair work.\r\n</p><p>\r\nThey were then able to modify the way stem cells reacted to those biochemical signals to revive the ability of muscle tissue in old mice to repair itself nearly as well as the muscle in the mice''s much younger counterparts.\r\n</p><p>\r\nUsing adult stem cells to rejuvenate tissue would eliminate the ethical controversy surrounding the use of cells taken or derived from embryos.\r\n</p><p>\r\nResearcher Dr Morgan Carlson said: "We are one step closer to having a point of intervention where we can rejuvenate the body''s own stem cells so we don''t have to suffer from some of the debilitating diseases associated with ageing."\r\n</p><p>\r\n<b>Regeneration capacity</b>\r\n</p><p>\r\nThe Berkeley team compared muscle regeneration capacity of two-year-old mice - comparable in age to a human aged 75-85 - to that in two-month old mice, comparable to a human aged 20-25.\r\n</p><p>\r\nAs expected, they found the muscle tissue in the young mice easily replaced damaged cells with healthy new cells, while areas of damaged muscle in the older animals was full of scar tissue.\r\n</p><p>\r\nBut when they effectively disabled the "ageing pathway" by blocking production of a key protein called TGF-beta, the level of cellular regeneration in the older animals was comparable the much younger mice.\r\n</p><p>\r\nHowever, the researchers warned that closing down the ageing pathway completely could run a risk of many health problems, for instance the ability to suppress cell division is key to controlling the development of cancer.\r\n</p><p>\r\nLead researcher Dr Irina Conboy said the key was to find the right balance between the biochemical pathway which promoted healing, and that which promoted ageing.\r\n</p><p>\r\n"We need to find out what the levels of these chemicals are in the young so we can calibrate the system when we''re older.\r\n</p><p>\r\n"If we can do that, we could rejuvenate tissue repair for a very long time."\r\n</p><p>\r\nRebecca Wood, of the Alzheimer''s Research Trust, said: "Since Alzheimer''s causes brain cells to gradually die, research into ways to regenerate them could eventually lead to revolutionary new treatments for this devastating disease.\r\n</p><p>\r\n"More research is needed as this study was conducted on muscle tissue rather than the complex nerve cells in the brain and there are many health problems associated with the suppression of cell division."\r\n</p><p>\r\nDr Susanne Sorensen, of the Alzheimer''s Society, said the research was interesting as it had recently been shown that stem cells in the brain might be able to help create new tissue after damage has been done.\r\n</p><p>\r\n"This new research gives further hope that our own stem cells can be used to help regenerate cells in the body."</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/health/7463466.stm" title="Ageing muscle ''given new vigour''">Source: BBC</a></p>', 1, 8, 0, 36, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:37:09', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 1, '', '', 0, 3, ''),
(49, 'Key ocean mission goes into orbit ', 'key-ocean-mission-goes-into-orbit-', '', '<img src="images/stories/tech/space/1c.jpg" alt="Key ocean mission goes into orbit " width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>A space mission that will be critical to our understanding of climate change has launched from California.</b>\r\n<p>\r\nThe Jason-2 satellite will become the primary means of measuring the shape of the world''s oceans, taking readings with an accuracy of better than 4cm.\r\n</p><p>\r\nIts data will track not only sea level rise but reveal how the great mass of waters are moving around the globe...\r\n</p>', '<p>\r\nThis information will be fundamental in helping weather and climate agencies make better forecasts.\r\n</p><p>\r\nThe satellite left Earth at 0746 GMT atop a Delta-2 rocket from the Vandenberg Air Force Base.\r\n</p><p>\r\nThe spacecraft, built by Thales Alenia Space, represents the joint efforts of the US and French space agencies (Nasa and CNES), and the US and European organisations dedicated to studying weather and climate from orbit (Noaa and Eumetsat).\r\n</p><p>\r\n<b>Down below</b>\r\n</p><p>\r\nJason-2 will provide a topographic map of 95% of the Earth''s ice-free oceans every 10 days.  Although we think of our seas as being flat, they are actually marked by "hills" and "valleys", where the highs and lows may be as much as two metres apart.</p>\r\n<p>Elevation is a key parameter for oceanographers.  Just as surface air pressure reveals what the atmosphere is doing above, so ocean height will betray details about the behaviour of water down below.\r\n</p><p>\r\nThe data gives clues to temperature and salinity.  When combined with gravity information, it will also indicate current direction and speed.\r\n</p><p>\r\nThe oceans store vast amounts of heat from the Sun; and how they move that energy around the globe and interact with the atmosphere are what drive our climate system. \r\n</p><p>\r\n"The ocean constitutes the long-term memory of the climate system; the time-scales over which the ocean is changing are the climatic timescales," explained Mikael Rattenborg, the director of operations at Eumetsat.  \r\n</p><p>\r\n"In order to understand climate, in order to be able to predict the evolution of the atmosphere over months, years, and decades even, you need to understand the ocean."\r\n</p><p>\r\n<b>Number one</b>\r\n</p><p>\r\nJason-2 is a continuation of a programme that started in 1992 with the Topex/Poseidon mission and is currently maintained by the Jason-1 satellite launched in 2001. </p>\r\n<p>\r\nThe project provides the global reference data for satellite-measured ocean height.  \r\n</p><p>\r\nAlthough other spacecraft in service today can acquire similar data sets, none can match the precision achieved by Jason-1; and Jason-2, when in service, will be the benchmark against which all other spacecraft will be judged and calibrated.\r\n</p><p>\r\nAt the heart of the latest mission is the Poseidon 3 solid-state altimeter.  The instrument constantly bounces microwave pulses off the sea surface.  By timing how long the signal takes to make the return trip, it can determine sea surface height.\r\n</p><p>\r\nAdditionally, the signal can indicate the height of waves and wind speed.\r\n</p><p>\r\n"It is not a revolution between Jason-1 and Jason-2; it is an evolution, because the main objective is to ensure continuity," explains Francois Parisot, the Jason-2 project chief at Eumetsat.\r\n</p><p>\r\n"Nevertheless, there are some improvements in the instruments.  We hope to make better measurements closer to the coast [and over inland waters and rivers]; and also, we will deliver near-realtime products - products that will be available within three hours of the measurements."\r\n</p><p>\r\n<b>Whale watching</b>\r\n</p><p>\r\nThe latter will be particularly useful in storm prediction.  Jason will see the surface waters rise as warm eddies fuel hurricanes.  The data will tell meteorologists how a storm is likely to intensify and allow them to issue better, more timely warnings.\r\n</p>\r\n \r\n<p>\r\nJason-2 data will have many other uses that may not be immediately obvious.  Industry will take the information to make decisions about when conditions are most suitable for undersea drilling or cable laying.</p>  \r\n<p>\r\nJason can help identify where wreckage or pollution will drift; and the satellite will assist marine biologists as they track whales by pinpointing waters with the potential to be prime feeding and breeding grounds.</p>\r\n<p>\r\nOne very important use will be in maritime navigation.\r\n</p><p>\r\n"Now that the fuel price is going up, saving fuel for the companies that run ships has become very sensitive; and knowing the currents, you can select your route so that you go faster and save fuel," said Philippe Escudier, a space oceanography at CLS (Collecte Localisation Satellites), Toulouse, France.\r\n</p><p>\r\n"You can save up to 5% on fuel consumption by making best use of the currents."\r\n</p><p>\r\n<b>Formation flying</b>\r\n</p><p>\r\nJason-2 will spend its first few months flying a "tandem mission" with Jason-1.  \r\n</p><p>\r\nThe two spacecraft will be positioned so that they sweep around the Earth, one following the other, with a separation of just 60 seconds. \r\n</p><p>\r\nThis will enable, essentially, the two satellites to measure the same patch of ocean surface at very nearly the same time.</p>\r\n\r\n<p>\r\nScientists will use this opportunity to cross-calibrate the instruments so that when Jason-1 is retired (or fails), the future data collected by its successor will be directly comparable with past records.\r\n</p><p>\r\nThis continuity of information will be critical in recognising long-term trends in ocean behaviour.  It is the data which underpins the observation that global sea level is rising by about three millimetres per year.\r\n</p><p>\r\nOnce the tandem phase is completed, Jason-1 will be moved to the side, doubling the return of data.  The importance of the Jason programme means both spacecraft will almost certainly be run for as long as they are serviceable.\r\n</p><p>\r\nDiscussions are already in progress on a Jason-3 satellite.  Given Europe''s role in the project, there is a compelling case for the next mission to be included in the GMES (Global Monitoring for Environment and Security) programme.  This would attract significant EU money.\r\n</p>\r\n                       \r\n<p><a href="http://news.bbc.co.uk/1/hi/sci/tech/7457818.stm" title="Key ocean mission goes into orbit ">Source: BBC</a></p>', 1, 7, 0, 29, '2008-06-23 10:29:45', 63, '', '2008-06-29 16:29:55', 62, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 6, 0, 5, '', '', 0, 11, 'robots=\nauthor='),
(50, 'Space cameras to monitor forests', 'space-cameras-to-monitor-forests', '', '<img src="images/stories/tech/space/2.jpg" alt="Space cameras to monitor forests" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nPlans to use a state-of-the-art camera onboard a satellite to monitor deforestation levels in Africa''s Congo Basin have been unveiled...\r\n', '<p>\r\nThe high resolution RALCam3 camera, designed and built by UK scientists, will provide the first detailed view of the area''s rate of forest cover loss.\r\n</p><p>\r\nThe project is part of the Congo Basin Forest Fund, a £108m joint-initiative by the UK and Norwegian governments.\r\n</p><p>\r\nThe fund aims to curb climate change by preventing deforestation in the region.\r\n</p><p>\r\nSpeaking at the launch of the scheme, UK Prime Minister Gordon Brown said: "We are pledging to work together to secure the future of one of the world''s last remaining ancient forests.\r\n</p><p>\r\n"Preserving our forests is vital if we are going to reduce global emissions and tackle climate change."\r\n</p><p>\r\n<b>Ecological hotspot</b>\r\n</p><p>\r\nThe Congo rainforest is the second largest in the world, containing more than a quarter of the planet''s remaining tropical rainforest.</p>\r\n<p>\r\nIt is also home to more than 50m people, and supports an estimated 10,000 plant species, 1,000 types of birds and 400 different kinds of mammals.\r\n</p><p>\r\nA UN study warned that unless action was taken to tackle deforestation in the region, more than 66% of the rainforest would be lost by 2040. \r\n</p><p>\r\nThe high definition camera will be made by a team at the UK''s Rutherford Appleton Laboratory (RAL).\r\n</p><p>\r\n"We''re delighted to be involved in this very important and timely project," said Nick Waltham, head of RAL''s Imaging Systems Division.\r\n</p><p>\r\n"RALCam3 will provide 10-metre per pixel ground sampling from an orbit of 650 km (400 miles) altitude," he told BBC News.\r\n</p><p>\r\n"The image [width] is 88km (55 miles) thereby enabling large areas of the terrain to be imaged in one satellite pass."\r\n</p><p>\r\nDr Waltham said the system would also have other applications, including surveillance of environmental change and offshore pollution.\r\n</p><p>\r\nThe camera is one of the first projects to be supported by the fund, which is headed by former Canadian Prime Minister Paul Martin and Nobel Peace Prize winner Wangari Maathai.\r\n</p><p>\r\n"The Congo Basin Forest Fund is a joint response to a global problem whereby an innovative and consensual mechanism has been embraced," Professor Maathai explained.\r\n</p><p>\r\n"It involves various partners committed to preserve and protect one of the most unique ecosystems in the world."\r\n</p><p>\r\nThe fund, which has received an initial £58m (73m euros) from the UK government and £50m (63m euros) from the Norweigan goverment, will support anti-logging projects in the region until 2012.</p>     \r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/sci/tech/7459472.stm" title="Space cameras to monitor forests">Source: BBC</a></p>', 1, 7, 0, 29, '2008-06-21 10:29:45', 63, '', '2008-06-23 11:22:33', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 6, ''),
(51, 'Two of the Milky Way''s Spiral Arms go Missing', 'two-of-the-milky-ways-spiral-arms-go-missing', '', '<img src="images/stories/tech/space/3.jpg" alt="Two of the Milky Way''s Spiral Arms go Missing" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nSt. Louis, Mo. -- For decades, astronomers have been blind to what our galaxy, the Milky Way, really looks like. After all, we sit in the midst...\r\n', ' of it and can''t step outside for a bird''s eye view. \r\n<br /><br />\r\nNow, new images from NASA''s Spitzer Space Telescope are shedding light on the true structure of the Milky Way, revealing that it has just two major arms of stars instead of the four it was previously thought to possess. \r\n<br /><br />\r\n"Spitzer has provided us with a starting point for rethinking the structure of the Milky Way," said Robert Benjamin of the University of Wisconsin, Whitewater, who presented the new results at a press conference today at the 212th meeting of the American Astronomical Society in St. Louis, Mo. "We will keep revising our picture in the same way that early explorers sailing around the globe had to keep revising their maps." \r\n<br /><br />\r\nAn artist''s concept of the structure of our two-armed Milky Way is online at <a href="http://www.nasa.gov/mission_pages/spitzer/multimedia/20080603a.html">http://www.nasa.gov/mission_pages/spitzer/multimedia/20080603a.html</a>. \r\n<br /><br />\r\nSince the 1950s, astronomers have produced maps of the Milky Way. The early models were based on radio observations of gas in the galaxy, and suggested a spiral structure with four major star-forming arms, called Norma, Scutum-Centaurus, Sagittarius and Perseus. In addition to arms, there are bands of gas and dust in the central part of the galaxy. Our sun lies near a small, partial arm called the Orion Arm, or Orion Spur, located between the Sagittarius and Perseus arms. \r\n<br /><br />\r\n"For years, people created maps of the whole galaxy based on studying just one section of it, or using only one method," said Benjamin. "Unfortunately, when the models from various groups were compared, they didn''t always agree. It''s a bit like studying an elephant blind-folded."\r\n\r\n<br /><br />\r\nLarge infrared sky surveys in the 1990s led to some major revisions of these models, including the discovery of a large bar of stars in the middle of the Milky Way. Infrared light can penetrate through dust, so telescopes designed to pick up infrared light get better views of our dusty and crowded galactic center. In 2005, Benjamin and his colleagues used Spitzer''s infrared detectors to obtain detailed information about our galaxy''s bar, and found that it extends farther out from the center of the galaxy than previously thought. \r\n<br /><br />\r\nThe team of scientists now has new infrared imagery from Spitzer of an expansive swath of the Milky Way, stretching 130 degrees across the sky and one degree above and below the galaxy''s mid-plane. This extensive mosaic combines 800,000 snapshots and includes over 110 million stars. \r\n<br /><br />\r\nBenjamin developed software that counts the stars, measuring stellar densities. When he and his teammates counted stars in the direction of the Scutum-Centaurus Arm, they noticed an increase in their numbers, as would be expected for a spiral arm.  But, when they looked in the direction where they expected to see the Sagittarius and Norma arms, there was no jump in the number of stars. The fourth arm, Perseus, wraps around the outer portion of our galaxy and cannot be seen in the new Spitzer images.\r\n<br /><br />\r\nThe findings make the case that the Milky Way has two major spiral arms, a common structure for galaxies with bars. These major arms, the Scutum-Centaurus and Perseus arms, have the greatest densities of both young, bright stars, and older, so-called red-giant stars. The two minor arms, Sagittarius and Norma, are filled with gas and pockets of young stars. Benjamin said the two major arms seem to connect up nicely with the near and far ends of the galaxy''s central bar.\r\n<br /><br />\r\n"Now, we can fit the arms together with the bar, like pieces of a puzzle," said Benjamin,  "and, we can map the structure, position and width of these arms for the first time." Previous infrared observations found hints of a two-armed Milky Way, but those results were unclear because the position and width of the arms were unknown.\r\n<br /><br />\r\nThough galaxy arms appear to be intact features, stars are actually constantly moving in and out of them as they orbit the center of the Milky Way, like London commuters in a busy traffic circle. Our own sun might have once resided in a different arm. Since it was formed more than 4 billion years ago, it has traveled around the galaxy 16 times.  \r\n<br /><br />\r\nCo-investigators of this research include Ed Churchwell, Marilyn Meade and Brian Babler of the University of Wisconsin, Madison; Barbara Whitney of the Space Science Institute, Madison, Wis.; Rémy Indebetouw of the University of Virginia, Charlottesville; and Christer Watson of Manchester College, Ind. NASA''s Jet Propulsion Laboratory, Pasadena, Calif., manages the Spitzer mission for NASA''s Science Mission Directorate, Washington. Science operations occur at the Spitzer Science Center at the California Institute of Technology, also in Pasadena. For more information about Spitzer, visit <a href="http://www.spitzer.caltech.edu/spitzer">http://www.spitzer.caltech.edu/spitzer</a> \r\nand <a href="/mission_pages/spitzer/main/index.html" target="_self">http://www.nasa.gov/spitzer</a> .</p>\r\n\r\n<p><a href="http://www.nasa.gov/mission_pages/spitzer/news/spitzer-20080603-10am.html" title="Two of the Milky Way''s Spiral Arms go Missing">Source: Nasa</a></p>', 1, 7, 0, 29, '2008-06-21 10:29:45', 63, '', '2008-06-23 11:20:32', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 4, ''),
(52, 'Spitzer Captures Stellar Coming of Age in our Galaxy', 'spitzer-captures-stellar-coming-of-age-in-our-galaxy', '', '<img src="images/stories/tech/space/4.jpg" alt="Spitzer Captures Stellar Coming of Age in our Galaxy" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nMore than 800,000 snapshots from NASA''s Spitzer Space Telescope have been stitched together to create a new "coming of age" portrait of stars in our inner Milky Way galaxy...\r\n', '<br /><br />\r\nThe image, which depicts an area of sky 120 degrees wide by two degrees tall, can be viewed at <a href="http://www.nasa.gov/mission_pages/spitzer/multimedia/20080603.htm">http://www.nasa.gov/mission_pages/spitzer/multimedia/20080603.html</a>. It was unveiled today at the 212th meeting of the American Astronomical Society in St. Louis, Mo. \r\n<br /><br />\r\n"This is the highest-resolution, largest, most sensitive infrared picture ever taken of our Milky Way," said Sean Carey of NASA''s Spitzer Science Center at the California Institute of Technology, Pasadena, Calif. Carey is lead investigator for one of two teams responsible for the new picture. "Where previous surveys saw a single source of light, we now see a cluster of stars. With this data, we can learn how massive stars form, map galactic spiral arms and make a better estimate of our galaxy''s star-formation rate," Carey explained.\r\n<br /><br />\r\n"I suspect that Spitzer''s view of the galaxy is the best that we''ll have for the foreseeable future. There is currently no mission planned that has both a wide field of view and the sensitivity needed to probe the Milky Way at these infrared wavelengths," said Barbara Whitney of the Space Science Institute, Madison, Wis. Whitney is a member of the second astronomy team. \r\n<br /><br />\r\nBecause Earth sits inside our dusty, flat, disk-shaped Milky Way, we have an edge-on view of our galactic home. We see the Milky Way as a blurry, narrow band of light that stretches almost completely across the sky. With Spitzer''s dust-piercing infrared eyes, astronomers peered 60,000 light-years away into this fuzzy band, called the galactic plane, and saw all the way to the other side of the galaxy. \r\n<br /><br />\r\nThe result is a cosmic tapestry depicting an epic coming-of-age tale for stars. Areas hosting stellar embryos are identified by swaths of green, which are organic molecules, called polycyclic aromatic hydrocarbons, illuminated by light from nearby newborn stars. On Earth, these molecules are found in automobile exhaust and charred barbeque grills, essentially anywhere carbon molecules are burned incompletely.    \r\n<br /><br />\r\nThe regions where young stars reside are revealed as "bubbles," or curved ridges in the green clouds. These bubbles are carved by the winds from young starlets blowing away their natal dust. The starlets appear as yellow and red dots, and the wisps of red that fill most bubbles are composed of graphite dust particles, similar to very small pieces of pencil lead.\r\n<br /><br />\r\nBlue specks sprinkled throughout the photograph are individual older Milky Way stars. The bluish-white haze that hovers heavily in the middle two panels is starlight from the galaxy''s older stellar population.  A deep, careful examination of the image also shows the dusty remnants of dying and dead stars as translucent orange spheres.\r\n<br /><br />\r\n"With these Spitzer data, we''ve been able to catalogue more than 100 million stars," said Edward Churchwell of the University of Wisconsin, at Madison. Churchwell is principal investigator of one of the teams.\r\n<br /><br />\r\n"This picture shows us that our Milky Way galaxy is a crowded and dynamic place. We have a lot to learn. I''ve definitely found a lot of things in this map that I didn''t expect to see," said Carey. \r\n<br /><br />\r\nThis infrared composite incorporates observations from two Spitzer instruments. Data from the infrared array camera were collected and processed by The Galactic Legacy Infrared Mid-Plane Survey Extraordinaire team, led by Churchwell. The Multiband Imaging Photometer for Spitzer Galactic Plane Survey Legacy team, led by Carey, processed observations from Spitzer''s multiband imaging photometer. Blue represents 3.6-micron light, green shows light of 8 microns and red is 24-micron light. \r\n<br /><br />\r\nNASA''s Jet Propulsion Laboratory, Pasadena, Calif., manages the Spitzer Space Telescope mission for NASA''s Science Mission Directorate, Washington. Science operations are conducted at the Spitzer Science Center at the California Institute of Technology, also in Pasadena. Caltech manages JPL for NASA. \r\n<br /><br />\r\n\r\nFor more information about Spitzer, visit <a href="http://www.spitzer.caltech.edu/spitzer">http://www.spitzer.caltech.edu/spitzer</a> \r\nand <a href="/mission_pages/spitzer/main/index.html" target="_self">http://www.nasa.gov/spitzer</a> .</p>        \r\n\r\n<p><a href="http://www.nasa.gov/mission_pages/spitzer/news/spitzer-20080603-11am.html" title="Spitzer Captures Stellar Coming of Age in our Galaxy">Source: Nasa</a></p>\r\n\r\n', 1, 7, 0, 29, '2008-06-21 10:29:45', 63, '', '2008-06-23 11:24:27', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 2, '', '', 0, 6, ''),
(53, 'Excitement Builds as GLAST Readies Its Gamma-ray Vision!', 'excitement-builds-as-glast-readies-its-gamma-ray-vision', '', '<img src="images/stories/tech/space/5.jpg" alt="Excitement Builds as GLAST Readies Its Gamma-ray Vision!" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\n\r\nScientists around the world are excited about all the things that the Gamma-ray Large Area Space Telescope, or GLAST, is going to uncover after it launches on June 5 from Cape Canaveral Air Force Station, Fla...', 'There are many reasons for worldwide excitement about GLAST. Not only is the equipment state-of-the-art, but it will allow us to see objects in space differently. <br /><br />\r\n\r\n"The Universe looks remarkably different outside the narrow range of colors in the spectrum that we can see with our eyes," said David Thompson, GLAST Deputy Project Scientist at NASA Goddard Space Flight Center, Greenbelt, Md. "GLAST will give us a spectacular high-energy ''gamma-ray vision,''" said Thompson. Gamma rays are the highest-energy form of light in the electromagnetic spectrum and cannot be seen by the naked eye.<br /><br />\r\n\r\n\r\nThompson noted "If you''re in space with gamma-ray vision, there are gamma-rays coming from all directions. The Milky Way would be a brilliant swath of light, and you''d see a sky constantly changing with objects dimming and brightening on different time scales. If you see a blinding flash, that would be a gamma-ray burst!"<br /><br />\r\n\r\n\r\nGLAST''s "Gamma-ray vision" will help scientists answer a lot of questions like: How do black holes accelerate jets of material to nearly light speed? What is the mysterious dark matter? What mechanism produces the stupendously powerful explosions known as gamma-ray bursts? How do solar flares generate high-energy particles? How do pulsars work? What is the origin of cosmic rays? and What else out there is shining gamma rays?<br /><br />\r\n\r\n"One thing that''s exciting is the cutting-edge instrumentation of the Large Area Space Telescope or LAT, said Peter Michelson, LAT Principal Investigator, Stanford University, Calif. "That''s where gamma-rays convert to matter and anti-matter within the telescope designed to detect them. By the direction of the particles, we can detect which direction the gamma-ray came from and find its origin in space. The LAT makes breakthrough improvements in all the key capabilities.<br /><br />\r\n\r\n\r\n"Another exciting thing is that the GLAST LAT is the first imaging gamma-ray observatory to survey the entire sky every three hours over a huge energy range," said Steve Ritz, GLAST Project Scientist at Goddard. This is important because the gamma-ray sky is constantly changing in stunning ways. The GLAST observatory, which also includes the GLAST Burst Monitor, spans a factor of 10 million in energy from the highest to the lowest energy gamma rays it will detect.<br /><br />\r\n\r\n\r\nAnticipation and excitement are near peak for the GLAST launch from Cape Canaveral Air Force Station CCAFS, Fla. Liftoff is set for June 5 during a window that runs from 11:45 a.m. to 1:40 p.m. EDT.<br /><br />\r\n\r\n\r\nThe preparations leading up to the launch are almost complete. During the weekend of May 17, GLAST was rolled out to CCAFS'' Launch Pad 17-B and hoisted atop the Delta II rocket. After the spacecraft was placed in the Delta II rocket, technicians then successfully completed the state-of-health checks for the spacecraft.<br /><br />\r\n\r\n\r\nThe GLAST spacecraft is 9.2 feet high by 8.2 feet in diameter when stowed, where it is just under the 9-foot diameter allowed in the fairing. The fairing is basically just the outside shells of the rocket. Once GLAST is launched into space, it becomes a little bit taller and much wider when the Ku-band antenna deploys and the solar arrays are extended.<br /><br />\r\n\r\n\r\nFive days later, on May 22, the Flight Program Verification was conducted. This is an electrical and mechanical test of the rocket and spacecraft working together as a single, integrated system during countdown and launch milestones. With this test completed, spacecraft closeouts began. On May 27, the Delta II Rocket fairings were closed around the GLAST satellite. <br /><br />\r\n\r\n\r\n\r\nBecause there were 18 institutions in six countries involved in the creation of GLAST, everyone is now eagerly awaiting the launch. NASA''s GLAST mission is an astrophysics and particle physics partnership, developed in collaboration with the U.S. Department of Energy, along with important contributions from academic institutions and partners in France, Germany, Italy, Japan, Sweden, and the U.S.<br /><br />\r\n\r\n\r\nEveryone is excited about GLAST''s blast-off!\r\n</p>\r\n\r\n<p><a href="http://www.nasa.gov/mission_pages/GLAST/news/gamma_vision.html" title="Excitement Builds as GLAST Readies Its Gamma-ray Vision!">Source: Nasa</a></p>', 1, 7, 0, 29, '2008-06-21 10:29:45', 63, '', '2008-06-23 11:24:30', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 4, ''),
(54, 'Firefox claims download success ', 'firefox-claims-download-success-', '', '<img src="images/stories/tech/computers/1c.jpg" alt="Firefox claims download success " width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nMozilla is claiming a download record for the release of Firefox 3\r\n<p>In the first 24 hours the web browser was available the software was downloaded more than 8 million times, says Mozilla. \r\n</p><p>Statistics from the download servers are being scrutinised to produce an official figure that will be passed to the Guinness World Record organisation. \r\n</p><p>But the launch was marred by news from security firms who have found the first flaws in the software...\r\n</p>', '<p><b>Big figures</b>\r\n</p><p>The attempt to set the download record was scheduled to begin at 1300 PST (2000 GMT) on 17 June. \r\n</p><p>However, the record attempt was almost wrecked from the start as the servers handling the downloads collapsed under the weight of visitors checking to see if new version was available. \r\n</p><p>Once the servers were up and functioning normally the record attempt began. \r\n</p><p>At their busiest the servers were handling more than 9,000 downloads per minute. Within five hours the number of downloads for Version 3.0 exceeded the 1.6 million set by Firefox 2.0 in October 2006. \r\n</p><p>In total Firefox 3.0 was downloaded 8.3 million times over the 24 hour record setting period. The figure beats the five million Mozilla predicted before the day. \r\n</p><p>Logs from the download servers have been handed to the Open Source Labs at Oregon State University for auditing. The scrutiny will ensure duplicate and unfinished downloads are not counted. The verification process could take a week to complete. \r\n</p><p>The surge of interest in Firefox 3.0 has continued and Mozilla has reported that the software has now been downloaded more than 10 million times. \r\n</p><p>However, some of the shine of the launch was removed by reports that a security firm had already found a flaw in the browser. \r\n</p><p>DV Labs/Tipping Point reported a flaw only five hours after Firefox 3.0 debuted. The flaw potentially lets an attacker take over a PC if a user clicks on a booby-trapped link. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/technology/7462900.stm" title="Firefox claims download success ">Source: BBC</a></p>', 1, 7, 0, 30, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:30:22', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 11, 0, 5, '', '', 0, 4, ''),
(59, 'Physics agency instigates review ', 'physics-agency-instigates-review-', '', '<img src="images/stories/tech/science/1c.jpg" alt="Physics agency instigates review " width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>The body overseeing UK astronomy and physics is to commission an independent review of its operations.</b>\r\n<p>The probe into the effectiveness of the Science and Technology Facilities Council (STFC) follows widespread concern over the status of its budget. \r\n</p><p>The council says its settlement from government has left it no choice but to find £80m of savings through to 2011. \r\n</p>\r\nThis puts at risk a number of current science...', 'projects and the recent growth in research grants.<p>An assessment of where the STFC''s yearly half-a-billion-pound budget should be focussed is currently under way and will be published next month. \r\n</p><p>Disciplines such as solar-terrestrial physics, which studies the connection between the Sun and Earth, fear they will be subjected to major cuts. \r\n</p><p><b>Peer review</b>\r\n</p><p>The announcement on Tuesday of the independent review was made as the government responded to MPs'' misgivings over the activities of the STFC. \r\n</p><p>In April, the Innovation, Universities, Science and Skills Committee had criticised the STFC for not consulting the scientific community adequately. It also said that some of the council''s decisions - particularly on the issue of membership of international science programmes - had left the UK looking like an "unreliable" and "incompetent" partner.</p>\r\n<p>The government, in its formal response, acknowledged a number of the committee''s observations but robustly rejected others. It disagreed with the notion that ministers had been trying to "micromanage" some programmes and described the MPs'' criticism of the STFC''s peer review system as "unhelpful and damaging". \r\n</p><p>"Government funding for science has more than doubled over the last decade, rising to more than £4bn by 2010/11," a spokesman in the Department for Innovation, Universities and Skills (DIUS) said. \r\n</p><p>"While it is right that government sets the overarching strategy, the research community and scientists themselves set priorities and distribute funds through a process of peer review." \r\n</p><p><b>''On notice''</b>\r\n</p><p>One of the explanations the STFC has given for its current predicament is the move towards the funding of university research grants at their "full economic cost" (FEC). \r\n</p><p>This means that grants now take into account lab space, lighting, heating, technical support, etc. In the past, universities covered these costs, effectively subsidising research. \r\n</p><p>The MPs, in their report, said the government should have put extra money into the STFC settlement to cover FEC. \r\n</p><p>In its response, the government said: "[The committee] is entitled to argue that there should have been an even bigger increase but the government regard that an average increase of 2.7% per year in real terms [in the science budget] over the next three years is a strong settlement in a tight fiscal environment." \r\n</p><p>Committee chairman Phil Willis commented that he would have liked to have seen a clear commitment to hold off any cuts until the Wakeham Review into physics funding reported its findings in the Autumn. \r\n</p><p>"I am somewhat disappointed that the government has shelved responsibility for the whole affair to the STFC," he told BBC News. "But to balance that, I am pleased with the general tone of their response - that they accept that all is not well at the council, and that they have put the chief executive and the board on notice." \r\n</p><p>The independent STFC review will also report in the autumn.</p>\r\n\r\n                       \r\n<p><a href="http://news.bbc.co.uk/1/hi/sci/tech/7460162.stm" title="Physics agency instigates review ">Source: BBC</a></p>', 1, 7, 0, 31, '2008-06-21 07:29:45', 63, '', '2008-06-29 16:35:03', 62, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 9, 0, 1, '', '', 0, 4, 'robots=\nauthor='),
(55, 'Microsoft''s browser gets upgraded', 'microsofts-browser-gets-upgraded', '', '<img src="images/stories/tech/computers/2.jpg" alt="Microsoft''s browser gets upgraded" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nMicrosoft has made Internet Explorer 7 (IE 7) available to the general public.\r\nThe new version is the first upgrade to the web browsing program for more than five years...\r\n', '<p>New features include tabbed browsing, the ability to search the net directly and an anti-fraud system to thwart phishing attacks.\r\n</p>\r\n<p>The new program is available as a free download on 19 October, but many will get it as an automatic update to Windows XP in November.</p><p><b>Phish fighter</b></p>\r\n<p>The new version of the browser has gone through a long testing regime and five test or "beta" versions have been made available in the last 14 months. \r\n</p>\r\n<p>Despite this IE 7 is still seen as an attempt by Microsoft to catch up with rival browsers as it includes features that have long been seen in competitors such as Firefox and Opera.</p>\r\n<p>With the new version, it is possible to open up tabs rather than windows for new webpages and subscribe to RSS feeds via the browser.</p>\r\n<p>One feature is the addition of a box that lets people search the net directly from the browser rather than through a dedicated webpage.</p><p>\r\nIn early releases of IE 7 this defaulted to Microsoft''s own search engine, but the software company has let users choose which search site this feature should call upon.</p>\r\n<p>Built in to the browser is an anti-fraud system that changes the colour of the address bar to red when a user visits a known phishing site. Other warnings will pop-up if an IE 7 user strays onto a site displaying suspicious activity.\r\n</p>\r\n<p>The security features on IE 7 mean that many people will get the browser as part of the monthly updates Microsoft issues to address bugs in its software. Home users will get the option to install the browser, and businesses will be able to block its installation on their machines.\r\n</p>\r\n<p>Version 6 of Microsoft''s browser has regularly been hit by a series of attacks by malicious hackers that attempt to exploit weaknesses in it to take over users'' PCs.</p>\r\n<p>IE 7 will also be the default browser for the next version of Microsoft Windows, known as Vista, that is due to be launched in 2007.</p>\r\n<p>The release comes at a time when the numbers of people using Microsoft''s Internet Explorer are shrinking. In 2004, 93% of net users browsed the web via IE. Now that proportion has dropped to 86%. Much of that market share has been taken by the Firefox browser, which is used by 11% of net users.\r\n</p><p>On the day IE 7 was released, a trial version of Version 2.0 of Firefox was also put online for downloading. The finished version is due to be released in the next couple of weeks.</p>\r\n\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/technology/6066650.stml" title="Microsoft''s browser gets upgraded">Source: BBC</a></p>\r\n\r\n', 1, 7, 0, 30, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:30:36', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 11, 0, 4, '', '', 0, 7, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(56, 'Yahoo goes back to its roots ', 'yahoo-goes-back-to-its-roots-', '', '<img src="images/stories/tech/computers/3.jpg" alt="Yahoo goes back to its roots " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nFor millions of people worldwide Yahoo remains synonymous with the internet itself, but after Microsoft walked away from buying the firm what does the future hold?...\r\n', '<p>\r\nThe famous exclamation mark at the end of  the Yahoo! logo has seemingly become more of a question mark in recent months. \r\n</p><p>\r\nIt has been left wounded by Microsoft''s failed takeover approach, seemingly embarrassed as it trialled rival Google''s advertising technology on its own search and vulnerable after losing its spot as the most visited place on the internet among US users.\r\n</p><p>\r\nYahoo itself says the company is looking to the future with an ambitious effort to "re-wire" the whole organisation into a giant social hub.\r\n</p><p>\r\nBrad Garlinghouse, Yahoo''s head of communities and communications, told BBC News: "Rumours of our demise are greatly exaggerated.\r\n</p><p>\r\n"We are in a very healthy position. We generate a billion and a half dollars in cash flow a year."\r\n</p><p>\r\nMr Garlinghouse  was quick to point out that Yahoo Mail remained the world''s leading mail service, used by almost a third of the world''s internet users, and services like Yahoo messenger, homepage and news were market leaders in the US.\r\n</p><p>\r\nHe said that Flickr, the firm''s popular photo sharing site, had seen registered users rise from 300,000 to 24 million in the last few years.\r\n</p><p>\r\n"The fact people are looking at it and say it is dying or doing poorly seems strange to me," said JupiterResearch analyst Nate Elliott.\r\n</p><p>\r\n"It is a very strong player in almost everything it does. Our industry tends to be blind to anything outside of search. \r\n</p><p>\r\n"For Yahoo, unfortunately, they are dominant in everything outside search."\r\n</p><p>\r\nMr Elliott added: "It''s worth looking at the numbers: It''s a massive company, with incredibly large revenues, that makes money and is still growing."\r\n</p><p>\r\nAccording to the firm''s first quarter results, its revenues and gross profit are both up about 10% on the same time last year.\r\n</p>\r\n<p>\r\nAfter a difficult few months Yahoo is beginning to focus more on returning to its roots.\r\n</p><p>\r\n Mr Garlinghouse is well-known for a leaked internal memo, in which he compared Yahoo''s complex and disjointed strategy on many different fronts to spreading peanut butter thinly across many places.\r\n</p><p>\r\nTwo years on from that memo and much had changed, he said,\r\n</p><p>\r\nYahoo was now focused on making the entire organisation more open for consumers, he added. \r\n</p><p>\r\n"We really shouldn''t be thinking abut communications as a group as separate from communities.\r\n</p><p>\r\n"We feel like we want all of Yahoo to be more social; how to bring people to the core of the experience."\r\n</p><p>\r\nYahoo is hoping to combine its success in bringing audiences to content, via the home page or the \r\nnews page, as well as its mail service, with the social networking features that have become so important to MySpace and Facebook, and others.\r\n</p><p>\r\nAs a first step the company will be letting users pull in information to their Yahoo Mail page from other services and content companies, as well as exporting their Yahoo information to other destinations.\r\n</p>\r\n<p>\r\n\r\nMr Garlinghouse said: "Social as a silo isn''t where we''ll be in a couple of years as an industry. Social makes things more relevant.\r\n</p><p>\r\n"I own my social connections - not Facebook, MySpace or Yahoo. Our philosophy inside Yahoo is that this is ultimately your data; we are going to let you take it with you, let you have access to it in a very open way."\r\n</p><p>\r\nPerhaps unsurprisingly, given the importance of e-mail to the company, Mr Garlinghouse said that Yahoo Mail could be a really big catalyst for making all of Yahoo more social.</p><p>\r\nA smart inbox that orders e-mails from your most relevant contacts, as well as "vitality updates" from friends, and alerts based on friends'' activities at other sites, will be combined inside Yahoo Mail.\r\n\r\n</p><p>\r\nLonger term, he said Yahoo was looking at making e-mail itself smarter, using a protocol called XMTP, which would allow e-mail to pull in users'' social connections into messages.</p><p>\r\n</p><p>\r\n"There is an opportunity for e-mail to be a richer experience by being more social," he said.\r\n</p><p>\r\nHe added: "It''s not just social networking for the sake of social networking - it''s enabling connections to give richer experiences."\r\n</p><p>\r\nMr Garlinghouse said the company was committed to pulling down walls users are confronted with across Yahoo sites.\r\n</p><p>\r\n"There are today over two dozen different profiles you can have on Yahoo. Where we are going you will have one profile on Yahoo, one social graph on Yahoo."\r\n</p><p>\r\nMr Elliott lauded the ambition but said others had tried similar things and failed.\r\n</p><p>\r\n"It''s a great idea - but this is just the beginning. I don''t know if anyone has successfully proven that giving people their content and information to take with them is a great strategy for building revenues.\r\n</p>\r\n<p>\r\n\r\n"It will be interesting to see how it works for Yahoo because it seems easier to me to build things on top of a social graph, than to build a social graph into established content and services.\r\n</p><p>\r\n"We''ve seen MySpace and Facebook start with a social graph and then building these content and services on top. I''ve not seen anyone reverse engineer the process."\r\n</p><p>\r\nHe added: "If they can make it work then they are in great shape."\r\n</p><p>\r\nMr Elliott said Yahoo''s biggest challenge remained competing with Google in search.</p><p>\r\n</p><p>\r\n"Search share numbers are frightening. Google is so completely dominant in so many European markets".\r\n</p><p>\r\nYahoo has been criticised in some quarters for a limited trial of Google''s advertising technology on its own search pages.\r\n</p><p>\r\nMr Garlinghouse said the trial was about transparency.\r\n</p><p>\r\nHe said: "We learned a lot from that. It helps us make better decisions. To me it demonstrates an openness and willingness to ask hard questions."\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/technology/7446600.stm" title="Yahoo goes back to its roots ">Source: BBC</a></p>', 1, 7, 0, 30, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:30:44', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 8, 0, 3, '', '', 0, 5, ''),
(57, 'Google''s experimental Gmail toys ', 'googles-experimental-gmail-toys-', '', '<img src="images/stories/tech/computers/4.jpg" alt="Google''s experimental Gmail toys " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nIn a first, Google is opening up its testing process by calling on tens of millions of Gmail users to put new features of the service through their paces...', '<p>\r\nGmail Labs has launched 13 settings for users to play around with and tell engineers directly what they think of them.\r\n</p><p>\r\nThe new developments, which are only available in the UK and the US, show up\r\n as a red tab at the top of the page.</p>\r\n<p>\r\nGmail product manager Keith Coleman says: "This marks a big change in the way the company does product development."\r\n</p><p>\r\nGenerally speaking products are tested internally on Google staff for weeks if not months and then refined before being released to the public.  \r\n</p><p>\r\nNever before has the firm opened up the testing process and brought in outsiders on such a large scale.  Smaller scale usability tests have been done with invited visitors.\r\n</p><p>\r\nMr Coleman says: "We want to take the next step and let Gmail users help us do that refinement."\r\n</p><p>\r\n<b>Old Snakey</b>\r\n</p><p>\r\nThe new settings include things like Pictures in Chat, which puts portraits in chat sessions, and Superstars, which lets you put different icons on mail. Old Snakey lets you play the classic game in Gmail and E-mail Addict forces you to take a screen break by locking you out of the Gmail for 15 minutes.\r\n</p><p>\r\n</p><p>\r\nMr Coleman says the features are "really rough and have gone through no filtering in terms of product  analysis or design analysis".</p>\r\n<p>\r\n"They have just gone through a general code review process to make sure they are safe to run.\r\n</p><p>\r\n"They have also gone through less testing than a typical feature would. But what this is is a way to take our ideas and get them out to the public."\r\n</p><p>\r\nAfter testing, users will get the chance to tell the developers directly what they think of them.  The most popular are likely to become a regular part of the Gmail product.\r\n</p><p>\r\n<b>Time for ideas</b>\r\n</p><p>\r\nThe service was unveiled to a small group of journalists, including the BBC, who had been invited to Building 47 at the Googleplex for a rare view of the team at work. \r\n</p>\r\n\r\n<p>\r\nNormally such spaces are off-limits to people outside the company.\r\n</p><p>\r\nAs well as being shown the new service ahead of release, we were also walked through the offices where engineers take 20% of their time to come up with ideas and work on them.  The 20% time is part of Google''s core ethos.\r\n</p><p>\r\n"The idea behind Labs is that any engineer can go to lunch, come up with a cool idea, code it up, and ship it as a Labs feature to tens of millions of users," explains Mr Coleman.\r\n</p><p>\r\nStaff write suggestions on a whiteboard to keep track of everything being played around with and who is working on what.\r\n</p><p>\r\nAnother display shows how many bugs an upcoming application needs to get fixed and which engineer is working on it.  \r\n</p><p>\r\n<b>Spam Tsar</b>\r\n</p><p>\r\nThe whole workspace is divided into areas covering various aspects of Gmail from the calendar to documents and from the reader to spam.\r\n</p>\r\n\r\n<p>\r\nThe guys fighting to keep spam out of the Gmail inbox are tucked away in a dark corner of the office.  Brad Taylor is known as the Spam Tsar, a title he quite enjoys.\r\n</p><p>\r\nHe has been working on Gmail since its public launch in 2004 and says he has seen a real growth in the amount of unsolicited e-mail flooding into the system.\r\n</p><p>\r\n"Originally when we launched 25% of e-mail was spam. We caught a lot of that. Over time it''s grown and grown and  currently around 75% of all e-mail is spam and so our job has got a lot harder."\r\n</p><p>\r\n<b>Top secret</b>\r\n</p><p>\r\nIn the heart of this open space is the so-called "war room".  \r\n</p><p>\r\nHere half a dozen engineers are huddled into a cramped office to work on top secret projects.  Everyone there was tight-lipped about what the next big thing coming out of the room would be but helpfully quipped that it was a new colour. \r\n</p><p>\r\nTodd Jackson, another Gmail product manager, was more serious when he said that the engineers didn''t leave until they had either solved a particular problem or fully developed a new feature.\r\n</p><p>\r\nSituated next to the office cafe is the Usability Lab, where Gmail invites small groups of six to eight people to test new applications to see how they will fare with the general public.\r\n</p><p>\r\nNika Smith, who helps run the Lab, says instead of having a two-way mirror to watch participants and how they interact with a product, they are a little more high-tech.\r\n</p><p>\r\n"We have this little hidden camera next to some flowers and one in the corner of the room.  We just want to know how they use Gmail and see from the users'' perspective what their experience is like.\r\n</p><p>\r\n"Then we just watch how they  interact with the product and work out what improvements are needed."\r\n</p><p>\r\n<b>A-Team</b>\r\n</p><p>\r\nPerhaps one of the coolest areas in the Gmail Lab is the site reliability room, which is just past a sign that says "Hippies Use Backdoor".\r\n</p><p>\r\nDecked out with a slew of monitors and computers, there is also a selection of drinks, a drum kit and a couple of guitars.  On the wall hangs a whiteboard with a wish-list of things like "surround sound, a Wii Fit machine and a bigger TV".\r\n</p><p>\r\nThe overall Lab space is like any other nondescript office, albeit with a few fun quirks here and there such as naming every printer and copier after TV shows like The A-Team and All in the Family.\r\n</p><p>\r\nBut sometimes things do get serious, and everyone is on a pager and gets an alert when something goes amiss with the site.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/technology/7441132.stm" title="Google''s experimental Gmail toys ">Source: BBC</a></p>', 1, 7, 0, 30, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:30:48', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 8, 0, 2, '', '', 0, 3, ''),
(58, 'Nintendo dominates May game sales', 'nintendo-dominates-may-game-sales', '', '<img src="images/stories/tech/computers/5.jpg" alt="Nintendo dominates May game sales " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nUS video game sales in May were up 37% on 2007 says market research firm NPD.\r\n\r\nTotal spending on video games for May...\r\n', 'was $1.12bn (£574m). Total sales for the year so far are $6.6bn (£3.38bn).\r\n<p>\r\nThe figures were boosted by continuing strong sales of Grand Theft Auto IV (GTA IV) which was the best-selling title for a second month.\r\n</p><p>\r\nThe highly praised game kept the top spot despite competition from other new releases such as Mario Kart and Wii Fit for Nintendo''s popular console.\r\n</p><p>\r\nSeven of the top selling titles in May were for the Nintendo Wii console or its handheld DS game-playing gadget.\r\n</p><p>\r\nTop-selling title GTA IV sold 1.31 million units in May taking its total since its launch in late April to 4.2 million units\r\n</p><p>\r\nHowever, NPD said the strong sales of GTA IV was not boosting console sales.\r\n</p><p>\r\n"The continued success of GTA 4 is not translating into big hardware sales for either the PS3 or the 360 but there may yet be a lift in June due to gift giving for Father''s Day and graduations," NPD analyst Anita Frazier said in a statement.\r\n</p><p>\r\nIn May Nintendo maintained its top spot as the most popular console and managed to sell 675,000 Wiis. By comparison Sony sold 209,000 PlayStation 3 machines and Microsoft 187,000 Xbox 360 consoles, according to NPD.\r\n</p><p>\r\nThe figures mean that total US sales of the Nintendo Wii number 10.2 million - on a par with Microsoft''s Xbox 360 which has sold 10.27 million.\r\n</p><p>\r\nNPD projects that game sales could reach $23bn for 2008 - far higher than the $18bn reached in 2007, which was a 43% jump over 2006.\r\n</p>\r\n                       \r\n<p><a href="http://news.bbc.co.uk/1/hi/technology/7452387.stm" title="Nintendo dominates May game sales ">Source: BBC</a></p>', 1, 7, 0, 30, '2008-06-21 10:29:45', 63, '', '2008-06-23 10:45:28', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 1, '', '', 0, 4, ''),
(60, 'Climate book is judges'' hot pick ', 'climate-book-is-judges-hot-pick-', '', '<img src="images/stories/tech/science/2.jpg" alt="Climate book is judges'' hot pick" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nA book about global warming has won this year''s Royal Society prize for popular science writing.\r\n<p>\r\nMark Lynas'' Six Degrees:...</p>', 'Our Future on a Hotter Planet has already been turned into a TV programme and is now almost certain to experience a jump in sales.  \r\nThe book explains how Earth will change for every degree rise in temperature - from droughts to mass extinctions.\r\n<p>\r\nMr Lynas was presented with the winner''s £10,000 cheque at a ceremony hosted by the UK academy of science.\r\n</p><p>\r\nThe award is one of the major publishing events of the year in the UK.  Previous winners have included Bill Bryson, Stephen J Gould, Roger Penrose, and Stephen Hawking. \r\n</p><p>\r\nSix Degrees uses published scientific data and interviews with leading researchers to illustrate the changes we could witness in a warmer world.  \r\n</p><p>\r\nProfessor Jonathan Ashmore, the chair of the judges, described the book as "compelling and gripping". \r\n</p><p>\r\n"It presents a series of scientifically plausible, worst-case scenarios without tipping into hysteria," he said.\r\n</p><p>\r\n"Six Degrees is not just a great read, written in an original way, but also provides a good overview of the latest science on this highly topical issue. \r\n</p><p>\r\n"This is a book that will stimulate debate and that will, Lynas hopes, move us to action in the hope that this is a disaster movie that never happens. Everyone should read this book."\r\n</p><p>\r\nThe bookies'' favourite had been A Life Decoded, the autobiography of genetics pioneer Craig Venter.   \r\n</p><p>\r\nThe six books shortlisted for the Royal Society''s General Prize were:\r\n</p>\r\n<ul>\r\n<li><b>A Life Decoded</b>, by J Craig Venter (<i>Penguin Allen Lane</i>)</li>\r\n<li><b>Coral: A Pessimist in Paradise</b>, by Steve Jones (<i>Little, Brown</i>)</li>\r\n<li><b>Gut Feelings</b> by Gerd Gigerenzer (<i>Penguin - Allen Lane</i>)</li>\r\n<li><b>Six Degrees: Our Future on a Hotter Planet</b>, by Mark Lynas (<i>Fourth Estate</i>)</li>\r\n<li><b>The Sun Kings</b>,<b> </b>by Stuart Clark (<i>Princeton University Press</i>)</li>\r\n<li><b>Why Beauty is Truth</b>, by Ian Stewart (<i>Basic Books</i>)</li>\r\n</ul>\r\n<p>\r\n</p><p>The Big Book of Science Things to Make and Do, written by Rebecca Gilpin and Leonie Pratt and designed and illustrated by Josephine Thompson, won in the junior science books category.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/sci/tech/7457317.stm" title="Climate book is judges'' hot pick">Source: BBC</a></p>', 1, 7, 0, 31, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:32:20', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 5, '', '', 0, 4, ''),
(64, 'iriver''s cute little Lplayer gets reviewed', 'irivers-cute-little-lplayer-gets-reviewed', '', '<img src="images/stories/tech/gadgets/1c.jpg" alt="iriver''s cute little Lplayer gets reviewed" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<p>iriver''s Lplayer, which we just got done handling ourselves, made it over to the review crew at PC Magazine. As expected, both design and interface were smiled upon, and critics also felt the price was fair. Upon using the admittedly wee device, they seemed to have problems getting the click buttons to respond like they wanted, but aside from that, hardly anything negative was said. \r\n</p>\r\nThe broad codec support was praised, the built-in equalizer worked as advertised and the FM tuner / voice recorder were welcome extras. All in all, it was seen as a worthy rival to the iPod nano...', ', and if you''re the type that prefers something different in the pocket, this puppy just might be the ticket.</p>\r\n\r\n<p><a href="http://www.engadget.com/2008/06/21/irivers-cute-little-lplayer-gets-reviewed/" title="iriver''s cute little Lplayer gets reviewed">Source: Engadget</a></p>', 1, 7, 0, 32, '2008-06-21 10:29:45', 63, '', '2008-06-23 10:41:19', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 5, ''),
(61, 'Greenland whale hunt ''commercial'' ', 'greenland-whale-hunt-commercial-', '', '<img src="images/stories/tech/science/3.jpg" alt="Greenland whale hunt ''commercial'' " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nAnimal welfare campaigners say Greenland''s whaling, held under rules permitting subsistence hunting, has become too...\r\n', 'commercial in character.\r\n<p>The World Society for the Protection of Animals (WSPA) found that a quarter of last year''s catch was traded for profit through a private food company. \r\n</p><p>International Whaling Commission (IWC) rules allow hunting where there is a nutritional and cultural need. \r\n</p><p>The IWC annual meeting gets underway next week in Santiago, Chile. \r\n</p><p>WSPA campaigners are presenting their report this week to a preliminary meeting of the organisation''s committee on aboriginal (or subsistence) whaling. </p>\r\n<p>"Greenland has been on the slippery slope towards commercial whaling for years, and now, demonstrably, they''ve crossed the line," said WSPA''s marine mammals manager Claire Bass. \r\n</p><p>"The IWC has heard anecdotally about these processing operations, but this is the first time it''s been quantified, so we''re expecting it to be explosive," she told BBC News \r\n</p><p><b>Vows renewed</b>\r\n</p><p>Quotas for the five communities claiming a need for subsistence hunting were renewed at last year''s IWC meeting in Anchorage, Alaska. \r\n</p><p>At the time, some delegates queried Greenland''s plans to expand its hunt to include bowhead and humpback whales - two species it had not previously targeted - and noted allegations that whalemeat regularly changed hands for money.</p>\r\n<p>IWC rules do not explicitly prohibit commercial trade, but they specify that permits are granted only "to satisfy aboriginal subsistence need". \r\n</p><p>Delegates eventually voted to allow the bowhead quota, but rejected the request for humpbacks. Denmark, which speaks for Greenland in the IWC, is bidding for humpbacks again this year.\r\n</p><p>Over the last 12 months, WSPA visited markets and harbours around Greenland. Investigators posed as a documentary film crew reporting on local traditions and culture.\r\n</p><p>They concluded that at least a quarter of the whalemeat landed around the coasts was traded through a single company, Arctic Green Food, with supermarkets the principal destination. \r\n</p><p>The company advertises packets of whalemeat for sale within Greenland on its website. Products include steak, mince, salted blubber, and cuts from the fins and tails of minke whales, as well as unspecified meat from fin whales. \r\n</p><p>Tonnes Berthelsen, managing director of Arctic Green Food, told BBC News his company traded meat from about 40 whales each year.\r\n</p><p>"We''re selling it frozen; and if we didn''t sell it like that, if people weren''t able to buy it frozen, then the waste would be very high."\r\n</p><p>But whereas the IWC says that "the meat and products are to be used exclusively for local consumption", WSPA points out that because the meat is sold in supermarkets, anyone can buy and consume it, even foreign nationals, raising the question of whether there is a genuine nutritional and cultural need.\r\n</p><p><b>Broken record</b>\r\n</p><p>WSPA is one of the few groups to campaign against subsistence whaling.</p>\r\n<p>The majority of conservation organisations support it as providing a sustainable resource to communities that need the meat.\r\n</p><p>There was a tacit agreement among anti-whaling NGOs not to oppose the renewal of subsistence quotas at last year''s IWC meeting, an agreement that WSPA did not support on animal welfare grounds.\r\n</p><p>"The record of these hunts is really bad," said Ms Bass.\r\n</p><p>"Only one in five whales dies within a minute. These are the worst whale hunts in the world on welfare grounds."\r\n</p><p>Records submitted to the IWC show that in 2006, fin whales took on average 35 minutes to die, with one taking nearly six hours. Norway''s overtly commercial hunters, by contrast, kill the majority of their prey within one minute.\r\n</p><p>The IWC''s various committees are coming to the end of their series of meetings in Santiago before the full organisation convenes on Monday.\r\n</p><p>Its week-long meeting is likely to be dominated by South American proposals for a whale sanctuary in the South Atlantic, and by discussions on whether pro- and anti-whaling blocs can find a path towards eventual compromise.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/sci/tech/7458155.stm" title="Greenland whale hunt ''commercial'' ">Source: BBC</a></p>', 1, 7, 0, 31, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:32:06', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 4, ''),
(62, 'Bush calls for offshore drilling', 'bush-calls-for-offshore-drilling', '', '<img src="images/stories/tech/science/4.jpg" alt="Bush calls for offshore drilling " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nPresident George W Bush has called on Congress to end a 27-year ban on drilling for oil in US coastal waters, to reduce...\r\n', 'dependence on imports.\r\n<p>\r\nMr Bush said existing restrictions on offshore drilling were "outdated and counter-productive".\r\n</p><p>\r\nHis move comes as US consumers are calling for action to tackle high oil prices that have pushed prices at the pump to more than $4 (£2) a gallon. \r\n</p><p>\r\nUS energy needs are set to be a key issue in November''s presidential poll.\r\n</p>\r\n<p>\r\nRepublican John McCain favours offshore oil drilling, whereas his Democratic rival, Barack Obama, opposes it. \r\n</p><p>\r\nIn a news conference at the White House, Mr Bush told Congress there was "no excuse for delay" in lifting the ban.\r\n</p><p>\r\n"Families across the country are looking to Washington for a response," he said.\r\n</p><p>\r\nEnvironmentalists have reacted with alarm to Mr Bush''s call, arguing that off-shore drilling would take at least a decade to have any effect on oil supply and would exacerbate climate change.        \r\n</p><p>\r\n<b>US dependence</b>\r\n</p><p>\r\nSince 1981, a congressional moratorium has prohibited oil and gas drilling along the east and west coasts and in the eastern Gulf of Mexico, an area accounting for some 80% of the US''s Outer Continental Shelf. \r\n</p>\r\n<p>\r\nMr Bush''s father, George Bush, imposed a moratorium on coastal oil exploration in 1990.\r\n</p><p>\r\nSince then offshore drilling and exploration have only been allowed in the Western and Central Gulf of Mexico regions plus parts of Alaska.\r\n</p><p>\r\nThe federal bans were enacted in part to protect tourism and lessen the chance of oil spills washing on to beaches. \r\n</p><p>\r\nThe Democrats, and some Republicans who represent coastal states, oppose ending the moratorium. \r\n</p><p>\r\n"We are in this situation because of our dependence on traditional petroleum-based oil," said California Governor Arnold Schwarzenegger, a Republican.\r\n</p><p>\r\nHe advocated "new technologies and new fuel choices for consumers" instead.\r\n</p><p>\r\nMr Bush, who has repeatedly pushed for an end to the ban, has accused Democrats of using their control of Congress to undermine attempts to boost domestic oil production. \r\n</p><p>\r\nThe president also renewed his call on Wednesday for the Arctic National Wildlife Refuge in Alaska to be opened up to drilling.\r\n</p><p>\r\n<b>''Failed policy''</b>\r\n</p><p>\r\n"It''s cynical to say that we can drill our way out of this mess," Athan Manuel, director of lands protection for the Sierra Club, told Reuters news agency.\r\n</p>\r\n<p>\r\n"The solution to $4 gas [petrol] is not off our coast."\r\n</p><p>\r\nKassie Siegel, climate programme director at the California-based Center for Biological Diversity, condemned the Bush offshore initiative.\r\n</p><p>\r\n"This is the culmination of the failed Bush-Cheney energy policy of the last eight years," she told the BBC News website.\r\n</p><p>\r\n"It would do absolutely nothing for petrol prices because it would take at least a decade to produce any oil and even if the oil did flow, there would be the greenhouse gases from the additional fossil fuel development."\r\n</p><p>\r\nShe points out that the US government recently calculated there was a 33-51% chance of a major spill in the lifetime of an offshore oil and gas lease in the Chukchi Sea off Alaska.\r\n</p><p>\r\nSuch a spill, defined as a release of 1,000 barrels or more from a platform or pipeline, could affect bowhead whales, polar bears and other wildlife.\r\n</p><p>\r\nHowever, the government''s environmental impact statement concluded that "an area affected by such a spill relative to the size of the Chukchi Sea decreases the likelihood that the resources would be widely contacted by the spill".\r\n</p><p>\r\n<b>''Political posturing''</b>\r\n</p><p>\r\nSenator McCain, the Republicans'' presumptive presidential candidate, is opposed to opening up Alaska and had previously backed the moratorium on drilling in coastal waters. \r\n</p>\r\n<p>\r\nBut speaking in Houston on Tuesday, Mr McCain called for the ban to be lifted to help counter US dependence on foreign oil. \r\n</p><p>\r\n"We must take control over our own energy future and become once again the master of our fate," he said. \r\n</p><p>\r\nMr McCain said the US had enormous energy reserves and was acquiring methods of using them in clean and responsible ways.\r\n</p><p>\r\nSenator Obama dismissed Mr McCain''s call as "political posturing".\r\n</p><p>\r\n"His decision to completely change his position and tell a group of Houston oil executives exactly what they wanted to hear today was the same Washington politics that has prevented us from achieving energy independence for decades," Mr Obama said. \r\n</p><p>\r\nHe called for conservation and the search for alternative green energy supplies. \r\n</p><p>\r\nAnalysts say drilling for offshore oil and developing alternatives will both prove slow to reduce US dependence on imported oil. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/americas/7460767.stm" title="Bush calls for offshore drilling ">Source: BBC</a></p>\r\n\r\n', 1, 7, 0, 31, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:32:00', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 2, ''),
(63, 'New ''lookouts'' for climate change ', 'new-lookouts-for-climate-change-', '', '<!--IMAGE images/stories/rotator/6.jpg IMAGE--><img src="images/stories/tech/science/5.jpg" alt="New ''lookouts'' for climate change" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nCorries high in the Scottish mountains are to become "lookout posts" in an effort to better monitor the effects of climate change Scottish Natural Heritage (SNH) is leading the Snowbed Project...', '<p>\r\n which will attempt to uncover evidence of warming temperatures on fauna and flora.\r\n</p><p>\r\nCorries are large circular, hollow depressions on a mountainside.\r\n</p><p>\r\nClimate change models predict a decrease in the amount of snow on the mountains into the summer.\r\n</p><p>\r\nSNH said observations had shown these snow patches had been smaller and shorter lived in the past 10 years than in the preceding 25.\r\n</p><p>\r\nSurvey sites will be established in the Cairngorms and on Aonach Mor, Ben Dearg, Ben Alder and Ben Wyvis.\r\n</p><p>\r\nBacked by the Scottish Government, the project will investigate the effects of less snow and warmer conditions on plants such as moss and liverwort, and impacts further up the food chain on birds such as snow bunting.\r\n</p><p>\r\nThe University of Bergen in Norway and Royal Botanic Garden in Edinburgh are also involved.\r\n</p><p>\r\nSNH said the project would build on the work done by scientist and mountaineer Gordon Rothero.</p>\r\n<p>He said climate change had already influenced plant growth since he began his studies almost 20 years ago.</p>\r\n<p>\r\nMr Rothero said: "Comparison of the photographs I took of various snowbed sites in 1989 with those taken during this project last summer show clear changes in the pattern of vegetation.\r\n</p><p>\r\n"Analysis of the 2007 data from the plant communities on the sites shows some changes in species composition, but these changes are not easy to interpret."\r\n</p><p>\r\nSNH estimated Scotland had 2,470 acres of snowbed habitat.\r\n</p><p>\r\nThis area supports rare species, many living on the most southern fringes of their range.\r\n</p><p>\r\nDr David Genney, of SNH, said: "Indeed these areas of Scotland could be said to have more in common with the mountains of Scandinavia, the high arctic of Spitzbergen and parts of Greenland than they do with the Carse of Stirling for example."\r\n</p><p>\r\nLarger flowering plants, able to grow at higher altitudes because of warmer conditions, have been found taking over sites of mosses and liverworts.\r\n</p><p>\r\nDr Genney added: "Any loss of this habitat will pose a direct threat to birds such as ptarmigan, snow bunting and dotterel which feed on the insects that live in the moss and so the impact will spread through links in the food chain."\r\n</p><p>\r\nEnvironment Minister Michael Russell said the initiative was a "milestone" in understanding the influences of changing climate on high places.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/highlands_and_islands/7460879.stm" title="New ''lookouts'' for climate change">Source: BBC</a></p>', 1, 7, 0, 31, '2008-06-22 10:29:45', 63, '', '2008-06-29 16:29:19', 62, 0, '0000-00-00 00:00:00', '2008-06-22 10:27:46', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 10, 0, 2, '', '', 0, 9, 'robots=\nauthor='),
(74, 'Underage alcohol sales examined', 'underage-alcohol-sales-examined', '', '<img src="images/stories/life/food/1c.jpg" alt="Underage alcohol sales examined" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>Derbyshire police have been checking which shops and bars have sold alcohol to people under 18.  </b><p>\r\nWith the help of underage volunteers, officers visited 74 premises in Derby and South Derbyshire on 14 June.\r\n</p><p>\r\nOf the bars and pubs they visited, 25% sold alcohol to the teenagers, while 47% of the off-licences sold it to underage customers. \r\n</p>\r\nOfficers said licence holders must be...\r\n', ' more careful and parents should take more responsibility.\r\n<p>\r\nPolice and trading standards officers are working with staff on the premises which failed their checks to stop it happening again. \r\n</p><p>\r\nSupt Andy Hough, of Derby police, said: "It''s very disappointing to see so many premises selling alcohol to underage people.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/leicestershire/7467253.stm" title="Underage alcohol sales examined">Source: BBC</a></p>\r\n', 1, 8, 0, 34, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:35:15', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 2, ''),
(65, 'Nerdiest brain-computer interface yet', 'nerdiest-brain-computer-interface-yet', '', '<img src="images/stories/tech/gadgets/2.jpg" alt="Nerdiest brain-computer interface yet" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nBrain-computer interfaces have been popping up left and right lately, but the latest system from Germany''s Technical University of... \r\n', 'Braunschweig, might be the silliest one we''ve seen so far. While the system doesn''t involve the careful placement of electrodes, it does require you to don a large metal helmet fitted with sensors, which can even detect brain activity through hair -- and makes you look like Magneto on a bad day. The system is solid enough to allow test subjects to control an RC car and researchers say the tech is similarly applicable to wheelchairs and prosthetics. Yeah, that''s great -- we''ll stick with the dangerous neurosurgery implantation over this contraption, guys. Video after the break.</p>\r\n\r\n<p><a href="http://www.engadget.com/2008/06/21/german-scientists-develop-nerdiest-brain-computer-interface-yet/" title="Nerdiest brain-computer interface yet">Source: Engadget</a></p>\r\n', 1, 7, 0, 32, '2008-06-21 10:29:45', 63, '', '2008-06-23 10:43:53', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 4, '', '', 0, 3, ''),
(73, 'Consumer inflation ''could top 4%'' ', 'consumer-inflation-could-top-4-', '', '<img src="images/stories/life/food/3.jpg" alt="Consumer inflation ''could top 4%''" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nRising food and energy prices could push UK consumer inflation above 4% this year, the governor of the Bank of England has warned...', '<p>\r\nHe was speaking after the Office for National Statistics (ONS) said the Consumer Prices Index (CPI) rose by 3.3% in May, up from 3% in April. \r\n</p><p>\r\nThis is the fastest rate since the CPI measure began in 1997, the ONS said. \r\n</p><p>\r\nThe wider Retail Prices Index measure of inflation rose to 4.3% from 4.2% the previous month.\r\n</p><p>\r\nThe biggest contributor to consumer inflation was the rising price of food and non-alcoholic drinks, the ONS said. \r\n</p>\r\n<p>\r\nThis was mainly due to the increasing cost of meat products, particularly bacon, and vegetables. \r\n</p><p>\r\nIncreasing household energy bills were also a significant factor, along with the rising cost of books, stationery and foreign holidays. \r\n</p><p>\r\nHowever, this rise in the cost of leisure and recreation was offset by a fall in the price of DVDs, according to the ONS. \r\n</p><p>\r\n<b>''Considerable uncertainties''</b>\r\n</p><p>\r\nIf inflation rises more than one percentage point above the government''s 2% target, the Bank of England governor must write a letter to the government to explain what action it is taking to control consumer prices. \r\n</p><p>\r\nIn his letter to the chancellor, Bank of England governor Mervyn King blamed sharp rises in the prices of food and energy for the increase in the rate of inflation. \r\n</p>\r\n<p>\r\n"As things stand, inflation is likely to rise sharply in the second half of the year, to above 4%," Mr King told the chancellor. \r\n</p><p>\r\n"I must stress however, that there are considerable uncertainties, in both directions, around this, and any such projection is particularly sensitive to changes in domestic gas and electricity prices," he said. \r\n</p><p>\r\nMr King has had to write such a letter to the chancellor only once before, when inflation hit 3.1% in April 2007. \r\n</p><p>\r\nThe governor said that the rate of inflation should peak towards the end of this year, as long as there were no "unexpected increases in oil and commodity prices". \r\n</p><p>\r\nShould the UK avoid severe external shocks, then the rate of inflation will begin to fall back towards the 2% target next year, Mr King said. \r\n</p><p>\r\nIn reply, Chancellor Alistair Darling agreed with the Bank of England''s assessment for the rising rate of inflation.\r\n</p><p>\r\nThe two main opposition parties have criticised the Labour Government for the rising cost of living.\r\n</p><p>\r\nThey blame years of borrowing for sustaining the economic boom of the past few years, which means now the government cannot afford to make tax cuts or offer financial incentives to help consumers.\r\n</p><p>\r\nShadow chancellor George Osborne said: "Gordon Brown''s economic reputation has gone bust. His years of boom and borrowing have left Britain ill prepared to face the double evil of rising inflation and falling growth."\r\n</p><p>\r\n<b>Economic slowdown</b>\r\n</p><p>\r\nThe higher-than-expected rise in consumer price inflation has transformed expectations for interest rates, according to the BBC''s Economics Editor, Hugh Pym.\r\n</p><p>\r\nHe also suggested that prices will rise at a faster rate in the coming months. </p>\r\n \r\n<p>\r\nConfident talk of two or more cuts in borrowing costs from the present level of 5% has been replaced by forecasts of unchanged or even higher rates in the months ahead, our editor says. \r\n</p><p>\r\nMr King and his colleagues are unlikely to cut interest rates further until they are convinced that the inflationary threat has passed - despite pleas from those struggling in the housing market. \r\n</p><p>\r\nHowever, analysts warn that raising interest rates to curb inflation could dampen an economy already dented by slowing growth and the weakening housing market. \r\n</p><p>\r\n"The key factor [deciding the direction of interest rates] will be whether increased inflationary expectations feed through into greater wage demands and second round effects  at the moment average earnings growth is stable, but the MPC will be watching it closely through 2008," said economist Charles Davis from the Centre for Economics and Business Research. \r\n</p><p>\r\nIn his letter, the chancellor called for "restraint" in pay rises awarded in both the public and private sector. \r\n</p><p>\r\n"To return now to inflationary pay settlements would undermine rather than raise people''s living standards, with a damaging circle of wage increases eroded by steadily increasing prices," the chancellor said.\r\n</p><p>\r\nPrime Minister Gordon Brown said ministers would not accept a pay rise for this financial year.\r\n</p><p>\r\n</p>\r\n<p>\r\nConsumers and companies around the world have been feeling the effects of higher energy and food bills. \r\n</p><p>\r\n"The global nature of these price changes is evident in inflation rates not only in the UK, but also overseas," Mervyn King said. \r\n</p><p>\r\nIn the past 12 months, world agricultural prices have increased by 60% and retail food prices by 8%, the governor said. \r\n</p><p>\r\nOil prices have nearly doubled over the past year and on Monday the price hit a fresh high of almost $140 a barrel in New York. \r\n</p><p>\r\nWholesale gas prices are up by about 160% in the past year and UK household energy bills have risen by about 10%. \r\n</p><p>\r\nThose increases have prompted many people to rein in their spending in other areas.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7458209.stm" title="Consumer inflation ''could top 4%''">Source: BBC</a></p>', 1, 8, 0, 34, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:35:25', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 3, '', '', 0, 2, ''),
(66, 'Shenzhen EM-2811 "Latte ICE" is actually kind of neat', 'shenzhen-em-2811-qlatte-iceq-is-actually-kind-of-neat', '', '<img src="images/stories/tech/gadgets/3.jpg" alt="Shenzhen EM-2811 Latte ICE is actually kind of neat" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nThese days, it''s pretty wild and crazy if a PMP manufacturer manages to do anything different than what''s already out there, so we''ve got a soft...', 'spot for Shenzhen''s EM-2811, being sold as the "Latte ICE." Sure, nothing spectacular, and the 1GB-4GB capacity is seriously amature hour, but we like the look of the device, and the interface is pretty strong for a no-name DAP. There''s a miniSD slot to overcome that capacity handicap, a 2.8-inch QVGA screen, FM radio, voice support, AVI / MPEG video playback, and a built-in speaker. Tetris is included, but with the button layout we''re hoping they can finagle a couple emulators on there. Battery life of 4 hours video and 8 hours audio is painful, but overall the Latte ICE isn''t at all bad for a $70 starting price. Video is after the break.\r\n<p><a href="http://www.engadget.com/2008/06/21/shenzhen-em-2811-latte-ice-is-actually-kind-of-neat/" title="Shenzhen EM-2811 Latte ICE is actually kind of neat">Source: Engadget</a></p>', 1, 7, 0, 32, '2008-06-21 10:29:45', 63, '', '2008-06-23 10:43:54', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 3, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(72, 'Inquiry into food affordability ', 'inquiry-into-food-affordability-', '', '<img src="images/stories/life/food/2.jpg" alt="Inquiry into food affordability" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nAn inquiry into the affordability of food in light of global price rises is to take place, the Scottish Government has announced...', '<p>The move is one of a range of measures unveiled as Scotland moves towards its first national policy for food and drink. \r\n</p><p>Top chef Martin Wishart will lead a campaign to improve the quality and visibility of home-grown produce. \r\n</p><p>Ministers have already carried out a discussion exercise on the policy. \r\n</p><p>There will also be an investigation into "Scottish" labelling on food and drink, to make it easier for shoppers to identity products and trust the labels on them. \r\n</p><p>A "cooking bus" will tour the country teaching people healthy cooking skills and improving food education. \r\n</p><p>And the government will award a new catering contract which has a greater emphasis on healthier menus and fresh, seasonal produce. \r\n</p>\r\n<p>The administration will also support the creation of a world class health and nutrition centre, through a future merging of the Rowett Research Institute in Aberdeen and Aberdeen University. \r\n</p><p>The moves were announced by rural affairs and environment secretary Richard Lochhead during a visit to the Royal Highland Show. \r\n</p><p>He said: "The time is right for a fresh new future for Scottish food and drink."\r\n</p><p>He added that his aim was to "promote Scotland''s sustainable economic growth by ensuring the focus of all food and drink-related activity by government offers quality, health and wellbeing and sustainability, whilst recognising the need for access to affordable food for all". \r\n</p><p>"I know that government alone cannot bring about a change in attitude towards food and drink - winning over the hearts and minds of the people of Scotland will be key to continuing this revolution." \r\n</p><p><b>''Genuine benefits''</b>\r\n</p><p>Farmers leaders in Scotland have called the proposals "exciting and ambitious". \r\n</p><p>NFU Scotland president, Jim McLaren said farmers were willing to play their part but added: "That willingness is tempered by the current agricultural climate." \r\n</p><p>The Food Standards Agency Scotland also welcomed the announcement. \r\n</p><p>Fiona Moriarty, the director of the Scottish Retail Consortium, said she was looking forward to working with the Scottish Government to "identify those issues where there are genuine benefits to customers and food supply in Scotland from a distinctive Scottish approach, while highlighting areas where consistency with UK and EU policy is required". \r\n</p><p>The Sustainable Development Commission said it was "essential" that the "Government stay the course with its original holistic vision of Scotland''s food policy". \r\n</p>\r\n               \r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/7463552.stm" title="Inquiry into food affordability">Source: BBC</a></p>', 1, 8, 0, 34, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:35:36', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 4, '', '', 0, 2, ''),
(67, 'Samsung''s Snapdragon super-MID just days away?', 'samsungs-snapdragon-super-mid-just-days-away', '', '<img src="images/stories/tech/gadgets/4.jpg" alt="Samsung''s Snapdragon super-MID just days away?" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nWhile we haven''t found an official press release on the subject, AVING is reporting a June 2008 retail release of a Samsung Snapdragon MID...', ' This according to a Qualcomm official. It''s unclear to what extent Sammy''s device will make good on Snapdragon''s list of "supported" features like 12 megapixel camera, GPS, HD video playback, WiFi, Bluetooth, all day battery life, digital broadcast television (MediaFLO, DVB-H, and/or USDB-T) and dual-mode EV-DO Rev. B and UMTS/HSDPA/HSUPA riding atop a 1GHz processor and Qualcomm''s 600MHz always-on DSP. All we''ve got is this picture of an engineering prototype (actually based on Snapdragon this time) on display right now at the World IT Show.\r\n\r\n<p><a href="http://www.engadget.com/2008/06/19/samsungs-snapdragon-super-mid-just-days-away/" title="Samsung''s Snapdragon super-MID just days away?">Source: Engadget</a></p>', 1, 7, 0, 32, '2008-06-21 10:29:45', 63, '', '2008-06-23 10:45:09', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 3, 0, 2, '', '', 0, 2, ''),
(71, 'Australia ire over chef''s f-words ', 'australia-ire-over-chefs-f-words-', '', '<img src="images/stories/life/food/1.jpg" alt="Australia ire over chef''s f-words " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nThe oaths and expletives for which colourful British TV chef Gordon Ramsay is famed have brought him to the attention...', ' of Australian lawmakers.<br />\r\nAn inquiry was initiated by Liberal Senator Cory Bernardi, after he watched Ramsay''s Kitchen Nightmares programme. \r\n<p>\r\nSenator Bernardi claimed that one episode had contained "the f-word" 80 times in 40 minutes. \r\n</p><p>\r\n"And I''m not referring to fondue," he said, according to the Australian Associated Press.\r\n</p><p>\r\nMr Bernardi said there was "no excuse for gratuitous bad language to be broadcast repeatedly" when it could be "beeped out". \r\n</p><p>\r\nA Senate committee has made a number of recommendations to help parents police what shows their children are watching. \r\n</p><p>\r\n<b>Irony</b>\r\n</p><p>\r\nBut senators stopped short of imposing an outright ban on swearwords, citing a lack of an "overwhelming community consensus" in favour of such a ban. \r\n</p><p>\r\nInstead, they backed a number of safeguards, such as permanently displaying the classification mark of a programme on-screen, and new technology that would allow parents to block unsuitable programmes. \r\n</p><p>\r\nThey also recommended some changes to the way Australian broadcasters handled complaints. \r\n</p><p>\r\nCommentators say there is a tinge of irony in this controversy, given Australians'' legendary penchant for swearing. \r\n</p><p>\r\nLast year, Australia''s tourist board was rapped by the UK advertising watchdog for running ads with the strapline: "So where the bloody hell are you?" in Britain. \r\n</p><p>\r\n<b>''Praise''</b>\r\n</p><p>\r\nRamsay''s UK-made programmes are extremely popular in Australia. \r\n</p><p>\r\nNine Network, which broadcasts Kitchen Nightmares and Hell''s Kitchen, says they now typically attract 1.4 million viewers. \r\n</p><p>\r\nNetwork executives have defended the inclusion of Ramsay''s expletives in the programme, saying he sometimes used them as praise, and pointing out that they received only one written complaint for every 117,000 viewers. \r\n</p><p>\r\nBut they said Ramsay''s single use of another, more offensive, profanity was unacceptable and would not be broadcast again. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/7462876.stm" title="Australia ire over chef''s f-words ">Source: BBC</a></p>', 1, 8, 0, 34, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:34:57', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 3, ''),
(68, 'Takara Tomy''s RPG Piggy Bank: level up by saving up', 'takara-tomys-rpg-piggy-bank-level-up-by-saving-up', '', '<img src="images/stories/tech/gadgets/5.jpg" alt="Takara Tomy''s RPG Piggy Bank: level up by saving up" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nNow here''s a novel concept. Takara Tomy''s BankQuest is half piggy bank, half old school RPG. Essentially, gamers / penny pinchers...', ' can purchase items to help them fend off pixelated ogres and the like by saving more money. The more coinage that gets deposited, the better the journey becomes. So, do you get some kind of prize when you cash it all out to buy your mum something nice, or what?\r\n                       \r\n<p><a href="http://www.engadget.com/2008/06/21/takara-tomys-rpg-piggy-bank-level-up-by-saving-up/" title="Takara Tomy''s RPG Piggy Bank: level up by saving up">Source: Engadget</a></p>', 1, 7, 0, 32, '2008-06-21 10:29:45', 63, '', '2008-06-23 10:45:10', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 3, 0, 1, '', '', 0, 2, ''),
(69, 'Chavez Protests EU With Oil Threat', 'chavez-protest', 'chavez protest', '<!--IMAGE images/stories/rotator/1.jpg IMAGE--><img src="images/stories/world/s-america/3.jpg" alt="Hugo Chavez" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n(CNN) -- Venezuelan President Hugo Chavez threatened not to sell oil to European Union countries.\r\n<p>\r\nThe threat is for those that follow new rules on immigration, but oil analysts...\r\n</p>', ' said the threat was largely symbolic since no European country buys oil from Venezuela.\r\n\r\n<p>Instead, Venezuela sends what crude it does export to Europe to its own refineries there.</p>\r\n\r\n<p>"Our oil shouldn''t go to those countries" that voted for the EU''s new policy, approved on Wednesday of detaining and deporting illegal immigrants, Chavez said in a televised address from Caracas.</p>\r\n\r\n<p>The legislation lays out re-entry bans and maximum 18-month detention periods but also includes legal safeguards.</p>\r\n\r\n<p>The directive "will encourage the voluntary return of illegal immigrants but otherwise lay down minimum standards for their treatment," according to the EU in a news release.</p>\r\n\r\n<p>Parliament adopted the measure by a vote of 369 to 197, with 106 abstentions.</p>\r\n\r\n<p>Britain and Ireland have not adopted the policy.</p>\r\n\r\n<p><a href="http://www.cnn.com/2008/WORLD/americas/06/19/chavez.eu/index.html" title="Chavez Protests EU with oil threat">Source: CNN</a></p>\r\n', 1, 4, 0, 14, '2008-06-21 16:22:21', 64, '', '2008-06-24 10:42:31', 62, 0, '0000-00-00 00:00:00', '2008-06-21 16:18:29', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 13, 0, 3, '', '', 0, 18, ''),
(149, 'Typography', 'typography', '', '<blockquote>This page shows all of the typography styles and settings for terrantribune in action. If you would like to read more detailed information on inserting the included typography into your content, check out the <a href="index.php?option=com_content&amp;task=view&amp;id=162&amp;Itemid=83">TerranTribune Typography Tutorial.</a></blockquote>\r\n\r\n<h3>Font Control</h3>\r\n\r\nTerranTribune allows you to have the option of simply switching the font of all the text in the template with the Template Manager settings, located in the Joomla Administrator (select the font name to preview):-\r\n\r\n<pre style="overflow: auto; width: 850px;">\r\n$font_family = "default";  // <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=helvetica">helvetica</a> | <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=geneva">geneva</a> | <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=optima">optima</a> | <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=helvetica">helvetica</a> | <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=trebuchet">trebuchet</a> | <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=lucida">lucida</a> | <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=georgia">georgia</a> | <a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60&amp;fontfamily=palatino">palatino</a>\r\n</pre>\r\n\r\n<div class="componentheading">This is a ComponentHeading</div> \r\n\r\n<p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</p>\r\n\r\n<div class="contentheading">This is a Contentheading</div>\r\n\r\n<p>Proin ac nunc eu nunc condimentum accumsan. Phasellus odio justo, euismod vitae, egestas a, porttitor in, urna. Maecenas vitae mauris. Donec vestibulum, nunc eu varius pharetra, massa est sagittis odio, sit amet eleifend elit dolor id tortor. </p>\r\n\r\n<h1>This is an H1 Header</h1>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Proin sit amet odio quis sapien molestie ultrices. Vivamus quis lectus. Praesent eu mi. Curabitur pharetra leo sed nisl. Nunc vel nisi. Aliquam nulla. Etiam at est. Pellentesque arcu diam, tempus nec, sodales eu, ullamcorper quis, risus. </p>\r\n\r\n<h2>This is an H2 Header</h2>\r\n\r\n<p>Proin ac nunc eu nunc condimentum accumsan. Phasellus odio justo, euismod vitae, egestas a, porttitor in, urna. Maecenas vitae mauris. Donec vestibulum, nunc eu varius pharetra, massa est sagittis odio, sit amet eleifend elit dolor id tortor. </p>\r\n\r\n<h3>This is an H3 Header</h3>\r\n\r\n<p>Mauris euismod. In ac massa vitae quam tincidunt dapibus. Ut at tortor nec mi mattis blandit. Maecenas venenatis lorem at nulla. Phasellus a libero. Sed odio odio, eleifend dignissim, feugiat vel, tempor nec, ligula. Suspendisse lacinia convallis nulla. Vestibulum posuere, lacus aliquet pulvinar faucibus, tortor urna luctus diam, vitae ultrices ante magna non tellus.</p>\r\n\r\n<h4>This is an H4 Header</h4>\r\n\r\n<p>Mauris euismod. In ac massa vitae quam tincidunt dapibus. Ut at tortor nec mi mattis blandit. Maecenas venenatis lorem at nulla. Phasellus a libero. Sed odio odio, eleifend dignissim, feugiat vel, tempor nec, ligula. Suspendisse lacinia convallis nulla. Vestibulum posuere, lacus aliquet pulvinar faucibus, tortor urna luctus diam, vitae ultrices ante magna non tellus.</p>\r\n\r\n<h5>This is an H5 Header</h5>\r\n\r\n<p>Mauris euismod. In ac massa vitae quam tincidunt dapibus. Ut at tortor nec mi mattis blandit. Maecenas venenatis lorem at nulla. Phasellus a libero. Sed odio odio, eleifend dignissim, feugiat vel, tempor nec, ligula. Suspendisse lacinia convallis nulla. Vestibulum posuere, lacus aliquet pulvinar faucibus, tortor urna luctus diam, vitae ultrices ante magna non tellus.</p>\r\n\r\n<h4>Notice Styles are shown below</h4>\r\n\r\n<span class="attention">This is a sample of the ''attention'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="attention"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="notice">This is a sample of the ''notice'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="notice"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="alert">This is a sample of the ''alert'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="alert"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="download">This is a sample of the ''download'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="download"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="approved">This is a sample of the ''approved'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="approved"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="media">This is a sample of the ''media'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="media"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="note">This is a sample of the ''note'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="note"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="cart">This is a sample of the ''cart'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="cart"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="camera">This is a sample of the ''camera'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="camera"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<span class="doc">This is a sample of the ''doc'' style.  Use this style to denote very important information to your users. To use this use the folllowing html: <b>&lt;span class="doc"&gt;....&lt;/span&gt;</b></span>\r\n\r\n<pre>\r\nThis is a sample <b>&lt;pre&gt;...&lt;/pre&gt;</b> tag:\r\n\r\ndiv.modulebox-black div.bx1 {\r\n  background: url(../images/black/box_bl.png) 0 100% no-repeat; \r\n}\r\n\r\ndiv.modulebox-black div.bx2 {\r\n  background: url(../images/black/box_tr.png) 100% 0 no-repeat;\r\n}\r\n\r\ndiv.modulebox-black div.bx3 {\r\n  background: url(../images/black/box_tl.png) 0 0 no-repeat;\r\n  padding: 0;\r\n  margin: 0;\r\n}\r\n</pre>\r\n\r\n<h3><a name="blockquotes" href="#blockquotes">Blockquote Styles</a></h3>\r\n\r\n<blockquote><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote&gt;....&lt;/blockquote&gt;</b>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="blue"><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">blue</em>&quot;&gt;<em style="font-weight: normal !important;">...</em>&lt;/blockquote&gt;</b> Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="red"><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">red</em>&quot;&gt;<em style="font-weight: normal !important;">...</em>&lt;/blockquote&gt;</b>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="green"><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">green</em>&quot;&gt;<em style="font-weight: normal !important;">...</em>&lt;/blockquote&gt;</b>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="purple"><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">purple</em>&quot;&gt;<em style="font-weight: normal !important;">...</em>&lt;/blockquote&gt;</b>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="orange"><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">orange</em>&quot;&gt;<em style="font-weight: normal !important;">...</em>&lt;/blockquote&gt;</b>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="brown"><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">brown</em>&quot;&gt;<em style="font-weight: normal !important;">...</em>&lt;/blockquote&gt;</b>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="grey"><b>This is a blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">grey</em>&quot;&gt;<em style="font-weight: normal !important;">...</em>&lt;/blockquote&gt;</b>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</blockquote>\r\n\r\n<blockquote class="quotes"><p><b>This is blockquote, you will want to use the following formatting: &lt;blockquote class=&quot;<em style="font-weight: normal !important;">quotes</em>&quot;&gt;<em style="font-weight: normal !important;">&lt;p&gt;...&lt;/p&gt;</em>&lt;/blockquote&gt;</b>.Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</p></blockquote>\r\n\r\n\r\n<div>\r\n<h3><a name="bullets" href="#bullets">List Styles - Bullets</a></h3>\r\n<p>Below is a list with <em style="font-weight: normal !important;">bullets</em>.  To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">class name</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b></p>\r\n\r\n<ul class="bullet-1">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-1</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n<ul class="bullet-2">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-2</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n<ul class="bullet-3">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-3</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n<ul class="bullet-4">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-4</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n<ul class="bullet-5">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-5</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n<ul class="bullet-6">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-6</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n<ul class="bullet-7">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-7</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n<ul class="bullet-8">\r\n  <li>To use this style create a list in the following format: <b>&lt;ul class="</b><em style="font-weight: normal !important;">bullet-8</em><b>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt;</b>.</li>\r\n</ul>\r\n</div>\r\n\r\n<h3><a name="numbers" href="#numbers">Span Styles - Number</a></h3>\r\n<p>Below is a list with <em style="font-weight: normal !important;">number</em>.  To use this style create a list in the following format: <b>&lt;span class=&quot;number-[color2]&quot;&gt;1[any number]&lt;/span&gt;</b></p>\r\n\r\n<p><span class="number">1</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number</em>&quot;&gt;<em style="font-weight: normal !important;">1</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n<p><span class="number">2</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number</em>&quot;&gt;<em style="font-weight: normal !important;">2</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n<p><span class="number">3</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number</em>&quot;&gt;<em style="font-weight: normal !important;">3</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p><br />\r\n\r\n<p><span class="number-red">1</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number-red</em>&quot;&gt;<em style="font-weight: normal !important;">1</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n<p><span class="number-blue">2</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number-blue</em>&quot;&gt;<em style="font-weight: normal !important;">2</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n<p><span class="number-green">3</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number-green</em>&quot;&gt;<em style="font-weight: normal !important;">3</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p><br />\r\n\r\n<p><span class="number-purple">1</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number-purple</em>&quot;&gt;<em style="font-weight: normal !important;">1</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n<p><span class="number-orange">2</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number-orange</em>&quot;&gt;<em style="font-weight: normal !important;">2</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n<p><span class="number-brown">3</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number-brown</em>&quot;&gt;<em style="font-weight: normal !important;">3</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n<p><span class="number-grey">4</span>To use this style create a list in the following format: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">number-grey</em>&quot;&gt;<em style="font-weight: normal !important;">3</em>&lt;/span&gt;.<em style="font-weight: normal !important;">...some content...</em>.&lt;/p&gt;</b></p>\r\n\r\n<h3><a name="highlights" href="#highlights">Highlight Styles</a></h3>\r\n\r\nThis is a span that allows you to <span class="highlight">highlight words or phases</span>. Use the following format: <b>&lt;span class=&quot;<em style="font-weight: normal !important;">highlight</em>&quot;&gt;...&lt;/span&gt;</b><br /><br />\r\n\r\nThis is a span that allows you to <span class="highlight-red">highlight words or phases</span>. Use the following format: <b>&lt;span class=&quot;<em style="font-weight: normal !important;">highlight-red</em>&quot;&gt;...&lt;/span&gt;</b><br /><br />\r\n\r\nThis is a span that allows you to <span class="highlight-blue">highlight words or phases</span>. Use the following format: <b>&lt;span class=&quot;<em style="font-weight: normal !important;">highlight-blue</em>&quot;&gt;...&lt;/span&gt;</b><br /><br />\r\n\r\nThis is a span that allows you to <span class="highlight-green">highlight words or phases</span>. Use the following format: <b>&lt;span class=&quot;<em style="font-weight: normal !important;">highlight-green</em>&quot;&gt;...&lt;/span&gt;</b><br /><br />\r\n\r\nThis is a span that allows you to <span class="highlight-orange">highlight words or phases</span>. Use the following format: <b>&lt;span class=&quot;<em style="font-weight: normal !important;">highlight-orange</em>&quot;&gt;...&lt;/span&gt;</b><br /><br />\r\n\r\nThis is a span that allows you to <span class="highlight-bold">highlight words or phases</span>. Use the following format: <b>&lt;span class=&quot;<em style="font-weight: normal !important;">highlight-bold</em>&quot;&gt;...&lt;/span&gt;</b><br /><br />\r\n\r\n<h3><a name="insets" href="#insets">Inset Styles</a></h3>\r\n\r\n<p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<span class="inset-right">You will need to use the following formatting: <font style="font-weight: normal !important;">&lt;span class=&quot;inset-left&quot;&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/span&gt;</font></span>Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</p><p>Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n\r\n<p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<span class="inset-left">You will need to use the following formatting: <font style="font-weight: normal !important;">&lt;span class=&quot;inset-left&quot;&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/span&gt;</font></span>Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</p><p>Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p><br />\r\n\r\n<h3><a name="dropcap" href="#dropcap">DropCap Styles</a></h3>\r\n\r\n<p><span class="dropcap">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<p><span class="dropcap-red">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap-red</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<p><span class="dropcap-blue">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap-blue</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<p><span class="dropcap-green">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap-green</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<p><span class="dropcap-purple">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap-purple</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<p><span class="dropcap-orange">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap-orange</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<p><span class="dropcap-brown">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap-brown</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<p><span class="dropcap-grey">P</span>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.<br /><br />You will need to use the following formatting: <b>&lt;p&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">dropcap-grey</em>&quot;&gt;<em style="font-weight: normal !important;">P</em>&lt;/span&gt;&lt;/p&gt;</b></p>\r\n\r\n<h3><a name="important" href="#important">Important Emphasis Styles</a></h3>\r\n\r\n<div class="important"><span class="important-title">Sample Title</span>\r\n<span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">important</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></span></div><br />\r\n\r\n<div class="important-blue"><span class="important-title-blue">Sample Title</span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">blue</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title-blue</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></div><br />\r\n\r\n<div class="important-red"><span class="important-title-red">Sample Title</span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">red</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title-blue</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></div><br />\r\n\r\n<div class="important-green"><span class="important-title-green">Sample Title</span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">green</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title-blue</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></div><br />\r\n\r\n<div class="important-purple"><span class="important-title-purple">Sample Title</span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">purple</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title-blue</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></div><br />\r\n\r\n<div class="important-brown"><span class="important-title-brown">Sample Title</span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">brown</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title-blue</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></div><br />\r\n\r\n<div class="important-orange"><span class="important-title-orange">Sample Title</span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">orange</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title-blue</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></div><br />\r\n\r\n<div class="important-grey"><span class="important-title-grey">Sample Title</span>This is a span that lets you place all of the content into a nice well formed section. You will need to use the following formatting: <b>&lt;div class=&quot;<em style="font-weight: normal !important;">grey</em>&quot;&gt;&lt;span class=&quot;<em style="font-weight: normal !important;">important-title-blue</em>&quot;&gt;<em style="font-weight: normal !important;">Sample Title</em>&lt;/span&gt;<em style="font-weight: normal !important;">...some content...</em>&lt;/div&gt;</b></div><br />', '', 1, 0, 0, 0, '2008-06-24 08:58:34', 63, '', '2008-06-28 11:07:53', 62, 0, '0000-00-00 00:00:00', '2008-06-24 08:57:39', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 5, 0, 16, '', '', 0, 89, 'robots=\nauthor='),
(70, 'FDA Visits Mexico Farms Tainted Tomatoes', 'fda-tomato-farms', 'fda - tomato farms', '<!--IMAGE images/stories/rotator/3.jpg IMAGE--><img src="images/stories/world/s-america/4.jpg" alt="Tomatoes In Mexico" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nThere might be a break in the salmonella case -- or not.\r\n\r\nFood and Drug Administration inspectors headed for farms in Florida and Mexico on Friday as new clues emerged to the...\r\n\r\n', 'possible source of salmonella-tainted tomatoes that have sickened more than 500 people.\r\n\r\n<p>The FDA wouldn''t say where in Florida and Mexico the hunt is centering. But officials stressed that the clues don''t necessarily mean that a particular farm will turn out to be the culprit.</p>\r\n\r\n<p>Investigators will pay special attention to big packinghouses or distribution warehouses that handle tomatoes from many farms and where contamination could be spread, leading to what appears to be the nation''s largest-ever salmonella outbreak from tomatoes.</p>\r\n\r\n<p><a href="http://www.orlandosentinel.com/features/food/orl-tomato2108jun21,0,6200734.story" title="FDA Visits Farms In Mexico - Tainted Tomatoes">Source: Orlando Sentinel</a></p>', 1, 4, 0, 14, '2008-06-21 16:40:42', 64, '', '2008-06-26 14:14:07', 62, 0, '0000-00-00 00:00:00', '2008-06-21 16:37:36', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 11, 0, 2, '', '', 0, 29, ''),
(76, 'High winds force closure of homes ', 'high-winds-force-closure-of-homes-', '', '<img src="images/stories/life/home/1c.jpg" alt="High winds force closure of homes" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>Stately homes and gardens in Cheshire have been closed because of high winds expected to batter northern England.</b>\r\n<p>\r\nGusts of up to 65mph were forecast for parts of the UK, with the North West expected to bear the brunt.\r\n</p><p>\r\nAs a result, The National Trust decided to close its properties including Quarry Bank Mill, Dunham Massey and Lyme Park on safety grounds.\r\n</p><p>\r\nTatton Park remained open to allow up to 3,000 runners to take part in a Race for Life event.\r\n</p>', '<p>\r\nThe 5km event follows a route around the park grounds.\r\n</p><p>\r\nBBC forecaster Tomasz Schafernaker said the weather was abnormal for June.\r\n</p><p>\r\n"Although it''s not unusual to have this kind of weather during the winter it''s rare to see this kind of gale this time of year," he said.\r\n</p><p>\r\n"The vicious gusts of wind will not only be reserved to coastal districts but may happen further inland too. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/7467815.stm" title="High winds force closure of homes">Source: BBC</a></p>', 1, 8, 0, 35, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:38:34', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 2, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(75, 'Police crackdown on drink-driving ', 'police-crackdown-on-drink-driving-', '', '<img src="images/stories/life/food/5.jpg" alt="Police crackdown on drink-driving " width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nMore than 50 people have been caught drink-driving in Leicestershire three weeks into a summer campaign...\r\n', '<p>\r\nSince 1 June, 50 men and five women have been found to be over the drink-drive limit when stopped by officers from Leicestershire Police.\r\n</p><p>\r\nA total of 812 drivers have been breathalysed since the start of the campaign, with 33% of those found over the limit under the age of 25.\r\n</p><p>\r\nAll those found guilty of breaking the law face a 12-month driving ban.\r\n</p><p>\r\nJohn Budulis, a road safety officer from Leicestershire Police, said: "The majority of these drivers were caught between 2200 BST and 0400 BST, as you would expect.\r\n</p><p>\r\n"However, three were caught between 0600 BST and 0800 BST and a further 10 drivers between 1400 BST and 2000 BST. It''s important to remember that you could still be over the legal alcohol limit the morning after the night before."\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/leicestershire/7464991.stm" title="Police crackdown on drink-driving">Source: BBC</a></p>', 1, 8, 0, 34, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:35:05', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 2, ''),
(77, '19th Century garden is reopened', '19th-century-garden-is-reopened', '', '<img src="images/stories/life/home/2.jpg" alt="19th Century garden is reopened" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nA 19th Century garden has officially reopened after a £1m revamp.\r\n\r\nThe Grade II listed St Leonards Gardens in St Leonards...', 'East Sussex were being opened by garden designer Roddy Llewellyn at a ceremony on Saturday.\r\n<p>\r\nAs part of the Heritage Lottery funded plan, a mixture of new plants and trees have been introduced to ensure the gardens are colourful all year round.\r\n</p><p>\r\nSeveral events were planned for the opening day, including a tour of the gardens and children''s play activities.\r\n</p><p>\r\nThere was also afternoon tea, story telling and riddles, as well as an abridged performance of Shakespeare''s Midsummer Night''s Dream.\r\n</p><p>\r\nSt Leonards Gardens were designed by the British architect James Burton, and founded in 1828.\r\n</p><p>\r\nThey were originally home to several private estates, before Hastings Corporation acquired them and opened them to the public in 1880. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/sussex/7467304.stm" title="19th Century garden is reopened">Source: BBC</a></p>\r\n\r\n', 1, 8, 0, 35, '2008-06-21 10:29:45', 63, '', '2008-06-23 13:07:54', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 2, ''),
(78, 'Quarry dust concerns in village', 'quarry-dust-concerns-in-village', '', '<img src="images/stories/life/home/3.jpg" alt="Quarry dust concerns in village" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nResidents of a Somerset village have spoken of their concerns after cars and garden furniture were covered in "gritty white dust flakes"...', '<p>\r\nA fault at the nearby Batts Combe quarry, on 3 June, caused a dust plume to rise from the site\r\n</p><p>\r\nCheddar resident Jo Hill, 44, said people accepted the need for the quarry but said dust levels should be closely monitored and regulated.\r\n</p><p>\r\nA quarry spokesman confirmed the plant was shut while the fault was fixed.\r\n</p><p>\r\nMrs Hill said she was leaving for work on 10 June and noticed her car was covered in the dust.\r\n</p><p>\r\n"It''s best described as sticky, gritty white dust flakes," the mother-of-three said.\r\n</p><p>\r\n<b>''Health effects''</b>\r\n</p><p>\r\n"As I travelled to work I could see other people in the village using their wipers to try to clean their windscreens.\r\n</p><p>\r\n"But I am most concerned about the possible health effects on my young children."\r\n</p><p>\r\nDavid Weeks, spokesman for quarry owners Hanson UK, apologised for the nuisance at the Batts Combe quarry but insisted there was no threat to health.\r\n</p><p>\r\n"The lime kiln normally runs 24/7 but an emergency shutdown was instigated after a blockage in the system.\r\n</p><p>\r\n"This sent a visible plume and [emission] readings on site went higher than our licence allows.\r\n</p><p>\r\n"The plant was shutdown for some 12 to 14 hours and the Environment Agency informed. After 20 minutes, on-site readings were back to normal and regular tests were made." \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/somerset/7463642.stm" title="Quarry dust concerns in village">Source: BBC</a></p>', 1, 8, 0, 35, '2008-06-21 10:29:45', 63, '', '2008-06-23 13:07:55', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 3, '', '', 0, 2, ''),
(82, 'Designer shortlisted for award', 'designer-shortlisted-for-award', '', '<img src="images/stories/life/fashion/1c.jpg" alt="Designer shortlisted for award" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>A designer from the Highlands and Islands said she was "very flattered" to be short listed for an honour at the Scottish Fashion Awards.</b>\r\n<p>\r\nLewis-born Sandra Murray, who lives and works in Inverness, has been included in the textile brand category.\r\n</p><p>\r\nAward winners will be announced at a ceremony on 29 June.\r\n</p>\r\nMs Murray made a thistle-coloured outfit for the Queen for the official...', 'opening of the Scottish Parliament in Edinburgh in 1999.\r\n<p>\r\nThe eldest of four children, the designer''s father is a retired boat builder and former college lecturer and her mother ran a knitwear business.\r\n</p><p>\r\nShe studied drawing and painting at Glasgow School of Art and her early career was as an art teacher, before turning to fashion design.\r\n</p><p>\r\nA bikini made from Harris Tweed was showcased at last year''s Cannes Film Festival.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/highlands_and_islands/7430952.stm" title="Designer shortlisted for award">Source: BBC</a></p>', 1, 8, 0, 33, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:33:53', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 2, ''),
(79, 'Gardeners warned over wood mould ', 'gardeners-warned-over-wood-mould-', '', '<img src="images/stories/life/home/4.jpg" alt="Gardeners warned over wood mould" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nGardeners have been warned about a mould called Aspergillus that grows on compost and decaying wood...', '<p>\r\nHe developed severe breathing problems after working with rotting wood and plant mulch in his garden.\r\n</p><p>\r\nMedical journal The Lancet reported that the man, aged 47, died despite hospital anti-fungal treatment.\r\n</p><p>\r\nAn expert said a dust-mask was a good idea when moving large quantities of mouldy bark chippings or compost.\r\n</p>\r\n<p>\r\nThe Aspergillus mould is very common in UK gardens and is better known as an allergy trigger, but serious illness linked to it remains relatively rare.\r\n</p><p>\r\n<b>Lung inflammation</b>\r\n</p><p>\r\nThe case of the Buckinghamshire man dates from May 2007, when he arrived at hospital with worsening shortness of breath, a fever and muscle pain.\r\n</p><p>\r\nThe results of the X-ray meant that doctors at first thought that pneumonia was the problem and gave him antibiotics.\r\n</p><p>\r\nThese had no effect and tests suggested the inflammation in his lungs was getting more severe.\r\n</p><p>\r\nBy now he had been transferred to the intensive care unit, but even this made no difference, and he was transferred to a bigger hospital for a last-ditch treatment to get oxygen into his body.\r\n</p><p>\r\nAt this point, the laboratory found Aspergillus in two samples, and talking to his partner revealed that the day before symptoms started he had been engulfed by clouds of dust while he shifted rotting tree and plant compost.\r\n</p><p>\r\nUnfortunately, although anti-fungal treatments were then given, he died a few days later.\r\n</p><p>\r\nThe speed of his decline surprised doctors as, apart from smoking and a job as a welder, he seemed to be in good health.\r\n</p><p>\r\n<b>Alerting doctors</b>\r\n</p><p>\r\nDavid Denning, of the University of Manchester, said that while Aspergillus itself could be found in many gardens, it would generally be dangerous only if disturbed in large quantities and the resulting dust inhaled.\r\n</p><p>\r\nHe said: "This should not be a problem for your average small-scale gardener who is using small quantities of compost at one time.\r\n</p><p>\r\n"However, if you are moving it in very large amounts, then perhaps wearing a face-mask would be advisable."\r\n</p><p>\r\nProf Denning said that the key to recovery in severe cases was rapid identification of the problem, and prompt anti-fungal therapy, as many doctors would not see any cases of "Aspergillosis" in their career, and try antibiotics first.\r\n</p><p>\r\nHe said: "This article aims to alert doctors that this may be a possibility when patients present with these symptoms."\r\n</p>             \r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/health/7451439.stm" title="Gardeners warned over wood mould">Source: BBC</a></p>', 1, 8, 0, 35, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:38:42', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 1, ''),
(81, 'A marriage of modesty and style', 'a-marriage-of-modesty-and-style', '', '<img src="images/stories/life/fashion/1.jpg" alt="A marriage of modesty and style" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n"Frumpy" clothing for Muslim women have inspired a Leicester designer aiming to fill a gap in the market...', '<p>\r\nSophia Kara, 35, from Leicester said she steered away from the traditional clothing because she was "always so scared of wearing this black frumpy garment".\r\n</p><p>\r\nAfter her marriage, when she decided to adopt dressing modestly as part of her life, she began designing her own garments that appealed to her aesthetic nature.\r\n</p><p>\r\n"I thought, oh my god I cannot wear this because this is not me. It just was not my identity at all," she said. \r\n</p><p>\r\n"That is why I started designing - something that suited me, that I was more confident in."\r\n</p><p>\r\nNow those designs, made by her Imaan Collections label, are being sold in US, and her international clientele stretches from France, Germany and the Netherlands to South Africa and Canada.\r\n</p>\r\n<p>\r\nShe said she was inspired to provide a new look that "fuses western fashion with modesty".\r\n</p><p>\r\nMrs Kara''s online business is the result of her fascination with fashion as a child.\r\n</p><p>\r\n"I remember cutting fabrics and making my own clothes with my mother''s help when I was about nine or 10 years old," she said.\r\n</p><p>\r\nShe honed her skills through short courses that required home study and apprenticeships with designers, and opened her own business in March 2006.\r\n</p><p>\r\nApart from casual garments and seasonal collections, her designs include a selection of corporate wear for the large number of professional customers - working women who want a marriage of smart with modesty in their outfits.\r\n</p><p>\r\nMrs Kara designs "modern Islamic clothing for Muslim women", "contemporary clothing" that "fuses western fashion - the cuts, colours, fabrics" with "the modesty for Islamic attire - more voluminous fits, lower hemlines, smaller necklines".\r\n</p><p><b>Modern jilbab</b>\r\n</p><p>\r\nWhile dark colours are still the more popular variety, younger women are becoming braver in the colour choice, especially when they go on holiday, she said.\r\n</p><p>\r\nAll that was available for women when she was younger were the black jilbabs, the full length loose garments that cover the body, and the accompanying black headscarves. \r\n</p><p>\r\n"I brought the jilbab into the new era," she said.\r\n</p>\r\n<p>\r\nHer designs also include hijabs (headscarves) and other garments.\r\n</p><p>\r\nIt was the experience of seeing a young woman in a Leicester supermarket wearing her creation that pleased Mrs Kara the most.\r\n</p><p>\r\n"It was exactly that customer I had in mind, that would be wearing my garment," she said.\r\n</p><p>\r\nThere are other designers who are catching on to the trend - one in London and another in the US - but Mrs Kara said they are few and far between.\r\n</p><p>\r\nAfter six years of "modernising the jilbab", her company Imaan Collections has notched up several successes, including a recent showing at Illinois.\r\n</p><p>\r\nMrs Kara''s target customer is young, trendy and fashionable but wants to retain her modesty. \r\n</p><p>\r\nIn fact, some of them are not even Muslim, she said, but women who want to "hide their lumps and bumps".\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/leicestershire/7427576.stm" title="A marriage of modesty and style">Source: BBC</a></p>', 1, 8, 0, 33, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:33:43', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 1, ''),
(80, 'House prices ''to fall 9% in 2008''', 'house-prices-to-fall-9-in-2008', '', '<img src="images/stories/life/home/5.jpg" alt="House prices ''to fall 9% in 2008''" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nHBOS, the UK''s biggest mortgage lender, has forecast that UK house prices are set to fall by 9% this year...\r\n', '<p>\r\nThe banking group, which owns the Halifax, had earlier predicted that the decline would be less severe.\r\n</p><p>\r\nIn a trading update, HBOS said the housing market remained "subdued" and  the number of transactions this year would be down by 45% on 2007''s level.\r\n</p><p>\r\nIts comments came ahead the launch of its rights issue through which it is aiming to raise £4bn from shareholders.\r\n</p>\r\n<p>\r\nIn February, HBOS said house prices would be "flat" in 2008. Then, in April, the Halifax house price survey predicted "a mid single digit percentage decline".\r\n</p><p>\r\nFigures last week from the Nationwide building society suggested that house prices were down by 4.7% in the first five months of the year, and by 3.2% in the past three months. \r\n</p><p>\r\n<b>Arrears</b>\r\n</p><p>\r\nHBOS said that falling house prices meant it would have to write off more of its loan book as potential bad debts - and said it was also seeing a rise in mortgage arrears levels.\r\n</p>\r\n<p>\r\nThe proportion of its mortgages which are in arrears has risen from 1.3% at the end of December 2007 to 1.43% at the end of May.\r\n</p><p>\r\nArrears in its mainstream home loans have gone up in that time from 1.16% to 1.22%.\r\n</p><p>\r\nBut the situation is much worse with self-certified mortgages, which amount to 13% of all the bank''s home loans.\r\n</p><p>\r\nBorrowers did not have to present any real evidence of their ability to repay before they were granted these loans, and arrears among them have risen from 2.51% to 3.11%.\r\n</p><p>\r\nThe bank pointed out that the profitability of its mortgage lending should improve next year.\r\n</p><p>\r\nOne-third of its current stock of home loans will be charged at higher interest rates in the course of 2008, because of new customers being offered more expensive deals then before, and existing customers also switching to loans at higher rates once their current fixed or introductory rates have expired.\r\n</p><p>\r\n<b>''Global dislocation''</b>\r\n</p><p>\r\nAlso in its trading update, the bank added that write-downs linked to the credit crunch had risen by £58m to £1.03bn since the end of March.\r\n</p><p>\r\nIt said that it was "not immune from the global dislocation in financial markets", but added it was "on track to demonstrate a resilient performance in 2008".\r\n</p><p>\r\nAnalysts had said that HBOS''s outlook would help determine whether its rights issue was a success. \r\n</p><p>\r\nBut in an interview with the Reuters news agency, chief executive Andy Hornby said it would go ahead even if shares fell back below issue price.\r\n</p><p>\r\n"We''re underwritten and this rights issue is going ahead. It''s as simple as that. We are not for turning," he said.\r\n</p><p>\r\nEarlier this month, the Royal Bank of Scotland announced a strong take-up for its £12bn rights issue. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7462773.stm" title="House prices ''to fall 9% in 2008''">Source: BBC</a></p>', 1, 8, 0, 35, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:38:50', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 1, ''),
(83, 'Fashion king Saint Laurent dies', 'fashion-king-saint-laurent-dies', '', '<img src="images/stories/life/fashion/3.jpg" alt="Fashion king Saint Laurent dies" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nYves Saint Laurent, considered by many as the greatest fashion designer of the 20th Century, has died in Paris at the age of 71...\r\n', '<p>Saint Laurent changed the face of the fashion industry when he became chief designer of the House of Dior at 21. \r\n</p><p>He designed clothes that reflected women''s changing role in society: more confident personally, sexually and in the work-place. \r\n</p><p>He retired from haute couture in 2002 and had been ill for some time. \r\n</p><p>Saint Laurent died on Sunday evening in the French capital, the Pierre-Berge-Saint Laurent Foundation announced. \r\n</p><p>Pierre Berge, the designer''s former business and personal partner, said he had died at his home after a long illness. He did not give details. \r\n</p><p>French President Nicolas Sarkozy paid tribute to Saint Laurent''s "creative genius". \r\n</p><p><b>''I draw on woman''</b>\r\n</p><p>"I found my style through women," Saint Laurent once said. \r\n</p>\r\n<p>He changed forever what women wear, introducing trouser suits, safari jackets and sweaters, BBC arts correspondent Razia Iqbal says. \r\n</p><p>Saint Laurent was a great innovator, helping to revitalise haute couture while making ready-to-wear design popular. \r\n</p><p>The editor of British Vogue, Alexandra Shulman, said he had helped democratise fashion: \r\n</p><p>"Before that people had small salons for rich people. \r\n</p><p>"Saint Laurent brought it to the people. \r\n</p><p>"He was young and groovy. Pop stars were hanging out with him and younger generations related to him." \r\n</p><p><b>''Devastating'' news</b>\r\n</p><p>President Sarkozy said the designer had been "the first to elevate haute couture to the rank of art and that gave him global influence". \r\n</p>\r\n<p>"Yves Saint Laurent infused his label with his creative genius, elegant and refined personality... because he was convinced that beauty was a necessary luxury for all men and all women," he added. \r\n</p><p>Speaking on French radio, Pierre Berge said his former partner had empowered women. \r\n</p><p>"In this sense he was a libertarian, an anarchist and he threw bombs at the legs of society," he said. \r\n</p><p>"That''s how he transformed society and that''s how he transformed women." \r\n</p><p>Famous French embroiderer Francois Lesage, who worked 40 years with the designer, said he was "devastated" by news of his death. \r\n</p><p>"I have never known a designer who would give so much thought to something when it was proposed to him," he told French TV. \r\n</p><p>"It is a great grief for me." \r\n</p><p><b>Life of ill-health</b>\r\n</p><p>Born in the Algerian city of Oran at a time when the North African country was a French colony, he had a precocious talent. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/europe/7430487.stm" title="Fashion king Saint Laurent dies">Source: BBC</a></p>', 1, 8, 0, 33, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:34:04', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 1, ''),
(84, 'Compost clothing taken to catwalk', 'compost-clothing-taken-to-catwalk', '', '<img src="images/stories/life/fashion/4.jpg" alt="Compost clothing taken to catwalk" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nFashion students in the Scottish Borders have designed a range of clothes to be worn in the garden and then thrown on a compost heap...\r\n', '<p>\r\nThe biodegradable outfits are on show at the Gardening Scotland exhibition at the Royal Highland Centre in Edinburgh.\r\n</p><p>\r\nStudents at Heriot Watt University''s School of Textile and Design in Galashiels came up with the clothes.\r\n</p><p>\r\nThey are part of an eco-fashion show taking place in BBC Scotland''s Beechgrove Theatre at the event.\r\n</p><p>\r\nThe students have produced two collections entitled Gardening Meets Haute Couture and Gardening Clothing Using Green Fibres.\r\n</p><p>\r\nThey were challenged to make the clothes using organically produced or eco-friendly fabrics.\r\n</p><p>\r\n<b>''Actually wearable''</b>\r\n</p><p>\r\nA range of materials including hemp and potato starch were used to put together the outfits.\r\n</p><p>\r\nThe project involved year two students on the BSc Clothing, Design and Manufacturing course.\r\n</p><p>\r\nEach one produced two garments for the show.\r\n</p><p>\r\nAccording to director of learning and teaching Jayne Smith the challenge was to make "something a gardener would actually wear".\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/south_of_scotland/7425752.stm" title="Compost clothing taken to catwalk">Source: BBC</a></p>\r\n\r\n', 1, 8, 0, 33, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:34:12', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 2, '', '', 0, 1, ''),
(85, 'Lab cooks up hi-tech fashion firm', 'lab-cooks-up-hi-tech-fashion-firm', '', '<img src="images/stories/life/fashion/5.jpg" alt="Lab cooks up hi-tech fashion firm" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nA publicly-backed research lab plans to launch a spin-off company specialising in incorporating technology into clothes...\r\n', '<p>\r\nDistance Lab in Forres, Moray, receives seed funding from Highlands and Islands Enterprise (HIE). \r\n</p><p>\r\nThe company, called Lost Values, would develop ideas such as parasols and fans fitted with solar panels. \r\n</p><p>\r\nCharged by sunlight during the day, the accessories would provide ambient light in rooms at night.\r\n</p><p>\r\nDistance Lab, which is hosting a public open day later, has also set goals to expand staff numbers and strengthen links with business partners this year. \r\n</p><p>\r\nThe institute - based in the Horizon Scotland building in Forres'' Enterprise Park - is also developing a fighting game called Remote Impact and a toy, SeamuSays, on which parents could record voice messages to their children. \r\n</p><p>\r\nLaunched a year and half ago, Distance Lab is emerging as an example of how new technologies are being increasingly used and developed in the Highlands and Islands. \r\n</p>\r\n<p>\r\nChief executive Stefan Agamanolis and senior research associate Elena Corchero told the BBC Scotland news website the spin-off venture would focus on products mixing technology and fashion. \r\n</p><p>\r\nMs Corchero, a fine artist trained in textile technologies, has already developed a range called Solar Vintage. \r\n</p><p>\r\nShe said: "The parasol and fan are antique accessories and look like something used in the 18th and 19th Centuries. \r\n</p><p>\r\n"Tied into them are renewable energies. \r\n</p><p>\r\n"They have solar panels which could be charged up during a picnic and when people get home the fan could be put on the table and the parasol hanged upside down like a chandelier to produce ambient light." \r\n</p><p>\r\nMs Corchero said circuitry on the devices were designed to look ornate and her hope was to get more women interested in science and technology. \r\n</p><p>\r\nMeanwhile, Distance Lab also intends to apply for a patent on elements of its life-size fighting game, Remote Impact. \r\n</p>\r\n<p>\r\nPlayers can punch, kick and throw themselves at a silhouette of an opponent projected on to a mattress. \r\n</p><p>\r\nCompetitors could be in the same building or on the other side of the world. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/highlands_and_islands/7423140.stm" title="Lab cooks up hi-tech fashion firm">Source: BBC</a></p>', 1, 8, 0, 33, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:34:18', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 1, '', '', 0, 1, ''),
(86, 'Darling calls for pay restraint', 'darling-calls-for-pay-restraint', '', '<img src="images/stories/business/economics/1c.jpg" alt="Darling calls for pay restraint" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>Chancellor Alistair Darling says pay rises for people "from the boardroom to the shopfloor" need to be "consistent" with the 2% inflation target.</b>\r\n<p>\r\nHe told BBC One''s Andrew Marr show the need to keep inflation under control "applies to each and every one of us".\r\n</p><p>\r\nHe said above-inflation pay increases would be "extremely damaging".\r\n</p>\r\nMr Darling said the UK economy was "far better equipped" than in the 1970s, 1980s and 1990s... ', 'but "despite that we are in for a tough time".\r\n<p>\r\nThe government''s preferred inflation measure, the Consumer Prices Index rose, to 3.3% in May, with the Bank of England warning it may reach 4%. \r\n</p><p>\r\nThe wider Retail Prices Index measure of inflation - the one used for many pay negotiations - is already at 4.3%.\r\n</p><p>\r\nAsked if people should accept their living standards were going to fall this year - as they get pay rises below the level of inflation - Mr Darling said that everyone "had a vested interest" in not allowing inflation to take hold.\r\n</p><p>\r\nHe said: "We''ve got to make sure that we keep inflation under control because if we don''t what will happen is that people may get a pay increase but every penny of it will be eaten up by rising prices in the shops.\r\n</p><p>\r\n"Now none of us want to see that happen, it''s in no-one''s interest and that applies from the top to the bottom, public and private sector alike."\r\n</p><p>\r\nThe chancellor was speaking as BPIX opinion poll for the Mail on Sunday suggested Labour was trailing the Conservative Party by 49% to 26% -with the Lib Dems on 14%.\r\n</p><p>\r\nThe poll - which saw 2,385 people questioned online between 18 and 20 June - comes ahead of Gordon Brown''s first  anniversary as prime minister, on Friday.\r\n</p><p>\r\nAsked about Mr Brown''s position, Mr Darling told the programme: "I have always taken the view that we can turn this round. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/uk_politics/7467810.stm" title="Darling calls for pay restraint">Source: BBC</a></p>', 1, 6, 0, 26, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:26:35', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 5, '', '', 0, 5, ''),
(87, 'Europe split over oil price plan', 'europe-split-over-oil-price-plan', '', '<img src="images/stories/business/economics/2.jpg" alt="Europe split over oil price plan" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nEuropean Union leaders have agreed to a 3-month study to find ways of cushioning the impact of soaring energy prices on the region''s citizens...', '<p>\r\nAt an energy summit in Brussels, ministers discussed plans to ease the pain of record oil and gas prices on consumers and companies.\r\n</p><p>\r\nThey asked French President Nicolas Sarkozy to report back to the commission with a plan by October.\r\n</p><p>\r\nThe plan follows protests across Europe by farmers, truckers and fishermen.\r\n</p><p>\r\nBut opinion was divided about what action the European countries should take. \r\n</p><p>\r\nEuropean Commission President Jose Manuel Barroso said there were no easy solutions.\r\n</p><p>\r\n"We have sent out a very clear message that there will not be a quick fix for the issue of the oil prices," Mr Barroso said.  \r\n</p><p>\r\nThe EU wants to prevent another spate of militant action across the region, but there is little common ground on exactly how to tackle the oil prices spike. \r\n</p><p>\r\nFrance had proposed to cap Value Added Tax (VAT) on fuel, a plan that was rejected by Germany. \r\n</p><p>\r\nPresident Nicolas Sarkozy said: "I will not give way, I will fight for the issue."\r\n</p><p>\r\n"It is a case of justice," he added. \r\n</p><p>\r\n<b>''Cool response''</b>\r\n</p><p>\r\nThe Italian government has introduced a windfall tax on oil companies, with the money being redistributed to the needy. \r\n</p><p>\r\nThis plan received a cool response from other EU nations, who said it was difficult to decide who should get the money. \r\n</p><p>\r\nMeanwhile, oil companies complain the tax will prevent them from reinvesting their profits into further exploration. \r\n</p><p>\r\nIn the official concluding document of the summit, European leaders said they would support investment in energy efficiency and the use of renewable energy resources. \r\n</p><p>\r\nBut they stopped short of backing France and Italy''s radical proposals.\r\n</p><p>\r\nEU Energy Commissioner Andris Piebalgs told the BBC: "There are already EU directives which can be used to help the most vulnerable families to counter the effect of high fuel prices.\r\n</p><p>\r\n"Heads of government should agree to restructure some industries so that they can respond to higher oil prices," he said.  \r\n</p><p>\r\nThe meeting comes as key energy consuming and producing countries meet this weekend in Saudi Arabia to discuss the volatile world oil market.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7466446.stm" title="Europe split over oil price plan">Source: BBC</a></p>\r\n\r\n', 1, 6, 0, 26, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:52:43', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 8, 0, 4, '', '', 0, 3, ''),
(88, 'Women''s low pay ''behind poverty''', 'womens-low-pay-behind-poverty', '', '<img src="images/stories/business/economics/3.jpg" alt="Women''s low pay ''behind poverty''" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nTackling the low pay of women is the key to ending child poverty in the UK, according to the TUC.\r\n\r\nA third of women in work earn less than £100 a week...', 'but the figure falls to 14% for men, the TUC says.\r\n<p>\r\nThe government has pledged to halve child poverty by 2010 and end it a decade later.\r\n</p><p>\r\nBut the latest figures showed that the number of children living in poverty rose for a second year to 2.9 million, before housing costs, in 2006-2007.\r\n\r\n</p><p>\r\nThe main measure of relative poverty used by the government is the number of people living in households with income 60% below the median household, with the poverty line adjusted for family size. \r\n</p><p>\r\n<b>Mothers ''trapped''</b>\r\n</p><p>\r\nResearch by the TUC, the End Child Poverty coalition and the Fawcett Society said that women''s low pay had "huge implications" for their children''s living standards.\r\n</p>			\r\n<p>\r\nHalf of all the child poor lived in working households, the report said. Women in Britain were more likely to be poor than others in Europe from the moment they conceived.\r\n</p><p>\r\nThe TUC said that mothers were being trapped in part-time, low-paid jobs. More than 75% of part-time workers were female.\r\n</p><p>\r\nThe gender pay gap for full-time workers was 17.2%, with the average hourly wage for men at £14.98 compared with £12.40 for women.\r\n</p><p>\r\n<b>Action needed</b>\r\n</p><p>\r\n"As 40% of households are now headed by single mothers, this has concerning implications for tackling child poverty," said TUC general secretary Brendan Barber.\r\n</p>\r\n<p>\r\n"It is vital the government tackles low pay and takes action to stop discrimination against mothers now."\r\n</p><p>\r\nMinister for Women Harriet Harman said the government had taken action to help mothers stay in work and increase their income, including improved maternity pay and affordable childcare.\r\n</p><p>\r\n"The gender pay gap has narrowed in the last 10 years by 5%, with the minimum wage being a significant factor," she said.\r\n</p><p>\r\n"But the government is determined to do more. That is why we will have a strong Equality Bill which we will set out to Parliament later this month."\r\n</p><p>\r\nThe Institute for Fiscal Studies has said that the government will have to reduce child poverty by 300,000 a year for the four years following 2006-07 to meet its target of halving child poverty by 2010-11. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7465136.stm" title="Women''s low pay ''behind poverty''">Source: BBC</a></p>', 1, 6, 0, 26, '2008-06-21 10:29:45', 63, '', '2008-06-23 09:51:06', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 3, ''),
(89, 'Nigeria ''shock'' after oil attack', 'nigeria-shock-after-oil-attack', '', '<img src="images/stories/business/economics/4.jpg" alt="Nigeria ''shock'' after oil attack" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nOil production at an oil installation off the Nigerian coast remains halted because staff are suffering from shock after a militant attack, officials say...\r\n', '<p>The attack on the Royal Dutch Shell facility stopped about 10% of Nigeria''s oil production. Shell also said the militants had damaged equipment. \r\n</p><p>An American hostage was released after a few hours. \r\n</p><p>It is the first attack on an offshore facility, previously thought safe despite a wave of inshore attacks. \r\n</p><p>Shell also said the emergency shutdown might have damaged equipment, which would have to be repaired. \r\n</p><p>The raid took place on the Bonga oil platform about 120km (75 miles) off the coast of the Niger Delta. \r\n</p><p>Shell has also been blamed for an oil spill in the Ogoni region of the Delta. \r\n</p><p>Oil is gushing from disused pipes abandoned by the company when it left the region nearly 15 years ago, following local protests. \r\n</p><p>Attacks on the inshore Niger Delta have helped drive up world oil prices and previously cut Nigeria''s output by about 20%. \r\n</p>\r\n<p>The Movement for the Emancipation of the Niger Delta (Mend) claimed it carried out the attack in an e-mail sent to journalists. \r\n</p><p>Several people were reported to have been injured. Mend says it is campaigning for a greater share of the region''s oil wealth to be kept by local people, but the government says they are criminals, motivated by the ransoms they receive from oil companies. \r\n</p><p><b>Ogoni spill</b>\r\n</p><p>Our correspondent says Bonga was new, expensive and working well despite the difficulties and repeated attacks affecting the company''s inshore operations in the Delta. \r\n</p><p>The militants in the Delta are getting more sophisticated and better equipped and armed, he says. \r\n</p>\r\n<p>Now they have proven that in terms of distance at least, all of Nigeria''s facilities are within their reach. \r\n</p><p>Local activists in the Ogoni region have asked Shell to come and contain the oil spill that has covered farmland. \r\n</p><p>The yellow brown oil is flowing through the village of Kpor and into a stream about a mile away. \r\n</p><p>Villagers told the BBC they heard a "thunderous noise" and ran to the spot to see oil spraying all over their land. \r\n</p><p>Last week the government revoked Shell''s rights to drill for oil in Ogoni saying the company had "lost the trust" of the local community. \r\n</p><p>Shell stopped drilling there in 1993 after pressure from the Movement for the Survival of the Ogoni People (Mosop) and it has not returned since. \r\n</p><p>A Shell spokesman said in the past such spills have been because saboteurs damaged sealed well heads. </p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/africa/7465766.stm" title="Nigeria ''shock'' after oil attack">Source: BBC</a></p>', 1, 6, 0, 26, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:26:41', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 2, '', '', 0, 6, ''),
(90, 'Vietnam to increase rice exports', 'vietnam-to-increase-rice-exports', '', '<img src="images/stories/business/economics/5.jpg" alt="Vietnam to increase rice exports" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nVietnam is to raise rice exports as it tries to maximise the benefits of rising global prices while, at the same time, guarantee domestic supplies...', '<p>\r\nThe world''s second biggest rice producer raised its 2008 export target from 4 million to 4.5 million tonnes.\r\n</p><p>\r\nRice inflation has made it more profitable for farmers to grow more.\r\n</p><p>\r\nBut Prime Minister Nguyen Tan Dung had been reluctant to raise exports until now because he feared domestic supplies would be jeopardised.\r\n</p><p>\r\nThe price of rice traded on the Chicago Board of Trade has jumped 75% over the past year.\r\n</p><p>\r\n<b>Food shortages</b>\r\n</p><p>\r\nAsia''s key rice producers have had to weigh up the needs of their own people, such as the amount and cost of rice available, and global demand for the staple crop. \r\n</p>\r\n<p>\r\nRecord oil and food prices have stoked fears that the world''s poorest nations will face food shortages. \r\n</p><p>\r\nEarlier in the year, Vietnam announced limits to rice exports. \r\n</p><p>\r\nThe government wanted to bring domestic prices down and secure its supply in the face of rising inflation, which hit 25% last month. \r\n</p><p>\r\nThe price spike and speculation about a grain shortage lead to a run on supplies at Vietnam''s supermarkets in April. \r\n</p><p>\r\nAnalysts said that increasing exports could reassure world markets. \r\n</p><p>\r\n"The move perhaps could even help the global prices calm down a bit," said Jonathan Pincus, economist at the United Nations Development Programme. \r\n</p><p>\r\n<b>Export income</b>\r\n</p><p>\r\nBut it is these high prices that encourage farmers to plant and harvest more rice. \r\n</p><p>\r\nVietnam earned $1.2bn from exports in the five months to May, an increase of 94% over the same period last year. \r\n</p><p>\r\n"It''s very attractive to export now and Vietnam certainly wants to earn that export revenue," said Mr Pincus. \r\n</p><p>\r\nThe government said rice production would rise by one million tonnes to 37 million this year. \r\n</p><p>\r\nSince the start of the year, the country has shipped more than 2.2 million tonnes, a 19% rise on the previous year. \r\n</p><p>\r\nAsia''s other top rice producers are also increasing output, with Thailand - the world''s biggest rice exporter - harvesting 30% more crops. \r\n</p><p>\r\nAnalysts blamed the sharp rise in rice prices on higher energy and fertiliser costs, rising global demand, loss of land to biofuel crops and drought conditions.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7465366.stm" title="Vietnam to increase rice exports">Source: BBC</a></p>', 1, 6, 0, 26, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:26:22', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 1, '', '', 0, 2, ''),
(91, 'Plea by PM at talks on oil price', 'plea-by-pm-at-talks-on-oil-price', '', '<img src="images/stories/business/markets/1c.jpg" alt="Plea by PM at talks on oil price" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>Gordon Brown has called for a "new deal" on energy at talks in Saudi Arabia on the high price of oil.</b>\r\n<p>\r\nThe prime minister wants oil producers to invest in a £100bn drive towards long-term energy projects in Britain, such as wind farms and nuclear power. \r\n</p><p>\r\nAt the Jeddah Energy Meeting, Mr Brown also pressed for an increase in oil production to help bring down prices. \r\n</p><p>\r\nThe Conservatives said Mr Brown did not understand the oil market. The Lib Dems accused him of a "futile gesture"...\r\n</p>', '<p>\r\nMr Brown said the world is experiencing "the third great oil shock in as many decades", hitting living standards.\r\n</p><p>\r\nOil prices touched close to $140 a barrel in New York last week.\r\n</p><p>\r\nMr Brown''s four-point plan, as discussed with EU leaders in Brussels, included: \r\n</p><p>\r\n</p><ul><li>Making the market work better to reduce volatility in oil prices</li><li>Making the most of the world''s existing oil reserves </li><li>Accelerating the switch to alternative sources of energy </li><li>Enabling oil producers to invest in alternative energy supplies </li></ul>\r\n<p>\r\nAnd he called for action to make sure the international oil market functioned more efficiently.\r\n</p><p>\r\n"Wherever there are shortages and gaps, they are addressed," he said.\r\n</p><p>\r\n"Wherever there are investment bottlenecks they are dealt with. Whenever there is protectionism it is tackled. So that instead of uncertainty and unpredictability there is greater certainty. And instead of instability there is greater stability."\r\n</p><p>\r\nHe also said that the UK would host a follow-up oil conference following the G8 meetings later this year.\r\n</p><p>\r\n<b>''Prices trebled''</b>\r\n</p><p>\r\nMr Brown said the current crisis was worse than the one of the 1970s, and called for a "more balanced energy market".\r\n</p>\r\n<p>\r\n"We''re living through the third big oil shock in 30 years. This is probably the most difficult one. Oil prices have trebled in every country of the world," Mr Brown said.\r\n</p><p>\r\nHe also said he wanted to reduce UK dependence on oil by investing in nuclear and renewables.\r\n</p><p>\r\n"I want the oil-producing countries also to diversify out of oil and I want us to get a more balanced energy market, which will mean that all of us will be reducing our dependence on oil in the years to come." \r\n</p><p>\r\nThe prime minister said that the effect of the oil crisis was being felt by "everybody who''s a consumer of oil, whether they are a driver with a car, or whether they have gas and electricity bills coming in". \r\n</p><p>\r\nMr Brown is facing public anger over the cripplingly high price of fuel, largely due to the cost of oil from the producers'' cartel, the Organisation of Petroleum Exporting Countries (Opec). \r\n</p>\r\n<p>\r\nThe UK, US and other consumers have urged Opec to boost supply, blaming lack of capacity for the recent price surge.  \r\n</p><p>\r\nHowever King Abdullah of Saudi Arabia has blamed price increases on speculators, a point he made when opening the Jeddah conference.\r\n</p><p>\r\nAnd shadow Secretary of State for business Alan Duncan told BBC One''s Andrew Marr Show that Saudi Arabia could only increase production of a kind of oil which refineries did not have the capacity to deal with.\r\n</p><p>\r\n"So the idea that Opec can just go like that and flood the market with oil and bring the price down, just shows that Gordon Brown does not understand global markets."\r\n</p><p>\r\nLiberal Democrat treasury spokesman Vince Cable suggested Mr Brown''s trip was "designed to persuade the British public that he can do something about world oil prices". \r\n</p><p>\r\nMr Cable added that the only alternative view was that Mr Brown genuinely believed - "a little bit like King Canute ordering the tides" - he could bring down oil prices.\r\n</p><p>\r\nHe added, on the BBC News Channel, that Mr Brown''s call for Opec to increase oil production was a "futile gesture".\r\n</p><p>\r\n<b>Nuclear technology</b>\r\n</p><p>\r\nBut Chancellor Alistair Darling told the Andrew Marr Show: "If the markets think that production will increase that will bring downward pressure on prices.\r\n</p><p>\r\n"I think secondly we need to reduce our dependence in the long term on oil and gas, and we need to encourage some of the oil producing [countries] like the Saudis, like Abu Dhabi, to invest in those new sources because in the long term that''s as much in their interests as it is in ours."\r\n</p><p>\r\nSaudi Arabia, the top world supplier, has made slight increases but says market speculation, not lack of supply, has driven prices to there current highs.\r\n</p><p>\r\nMr Brown said he wanted his Saudi hosts and the other big oil producers to consider putting some of the estimated $3 trillion they have made out of the recent "oil shock" into new nuclear technology. \r\n</p><p>\r\nIn Jeddah, Mr Brown urged joint ventures between Gulf states - the United Arab Emirates, Qatar, and others - and UK firms to invest in UK energy, including the next wave of nuclear power plants.\r\n</p><p>\r\nFunding could either come directly or from the sovereign wealth funds of oil-rich Gulf states.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/uk_politics/7467151.stm" title="Plea by PM at talks on oil price">Source: BBC</a></p>', 1, 6, 0, 25, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:27:18', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 5, '', '', 0, 3, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(92, 'Saudi oil price summit under way ', 'saudi-oil-price-summit-under-way-', '', '<img src="images/stories/business/markets/2.jpg" alt="Saudi oil price summit under way" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nA crucial meeting of oil producing and consuming nations to discuss soaring prices is under way in Saudi Arabia.\r\n', '<p>\r\nThe US and other consumers have urged producers to boost supply, blaming lack of capacity for the recent price surge.\r\n</p><p>\r\nTop world supplier Saudi Arabia has made slight increases but says market speculation, not lack of supply, has driven prices to nearly $140 a barrel. \r\n</p><p>\r\nSeveral nations have faced protests as rising fuel costs have hit industries and helped push up food prices.\r\n</p><p>\r\nEnergy ministers from more than 30 countries, as well as senior executives from the world''s largest oil companies, are attending the conference in the city of Jeddah amid concerns that recent record oil prices are helping tip the US and other major economies towards recession.\r\n</p><p>\r\nThey have announced a follow-up meeting will take place in London in October.\r\n</p><p>\r\nThe BBC''s economics correspondent Andrew Walker in Jeddah said it was possible that those present would not agree on any specific action on prices, reflecting their differing views on why the cost of oil has soared. \r\n</p>\r\n<p>\r\nOn the eve of the conference, US Energy Secretary Samuel Bodman said rising demand, especially from developing countries like China and India, was growing faster than supply. \r\n</p><p>\r\n"Market fundamentals show us that production has not kept pace with growing demand for oil, resulting in increasing prices and increasingly volatile prices," Mr Bodman said. \r\n</p><p>\r\nSaudi Arabia and countries from Opec - the Organisation of Petroleum Exporting Countries - resist this interpretation, blaming the soaring price, which has risen from about $10 a barrel to nearly $140 in the space of a decade, on market speculators. \r\n</p><p>\r\nOpec president Chakib Khelil insisted on Sunday that the price of oil was "disconnected from fundamentals" of supply and demand, according to French news agency, AFP.\r\n</p><p>\r\nQatar''s Energy Minister Abdullah Al-Attiya said the world was not facing an oil supply crisis.\r\n</p><p>\r\nBut, in an apparent contradictory signal, Kuwait oil minister Mohammed al-Olaim was quoted as saying OPEC members "will not hesitate" to increase output if the market requires it.\r\n</p><p>\r\n<b>''New deal''</b>\r\n</p><p>\r\nThe Saudis raised production by 300,000 barrels a day in May, and are widely reported to be preparing a further rise of 200,000 barrels a day in July. \r\n</p><p>\r\nBut analysts say this is unlikely to have much of an effect on the price, given that the world''s daily oil production is about 80 million barrels. \r\n</p>\r\n<p>\r\nBut correspondents say other oil producing countries have little spare capacity to boost output. \r\n</p><p>\r\nEfforts to control the price received a further blow this week, following militant attacks on Shell and Chevron facilities in Nigeria which cut the country''s production by more than 300,000 barrels a day. \r\n</p><p>\r\nConsumers are calling on producers to increase refinery capacity, which limits the amount of oil that can be shipped. \r\n</p><p>\r\nBritish Prime Minister Gordon Brown, who is attending the Jeddah meeting, has said he will call for a "new deal" on energy. \r\n</p><p>\r\n"I''m going to make it absolutely clear that we are going to reduce our dependence on oil by investing in nuclear and renewables," he said. \r\n</p><p>\r\n"I want the oil-producing countries also to diversify out of oil and I want us to get a more balanced energy market," he said. \r\n</p><p>\r\n"We''re living through the third big oil shock in 30 years. This is probably the most difficult one. Oil prices have trebled in every country of the world," he said. \r\n</p><p>\r\n"People who use oil are feeling the pinch, and it is hitting people''s standards of living very heavily. \r\n</p><p>\r\n</p><hr>\r\n<p>\r\n<b>Have you been badly affected by the high oil price? What would you like the summit to achieve? Send us your comments using the form below.</b>\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7467653.stm" title="Saudi oil price summit under way">Source: BBC</a></p>', 1, 6, 0, 25, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:28:06', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 2, ''),
(93, 'Students: Customers or learners?', 'students-customers-or-learners', '', '<img src="images/stories/business/markets/3.jpg" alt="Students: Customers or learners?" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nShould university students be seen as learners or customers?\r\n<p>While you might argue they are both, the dividing line...</p>', 'between the two has become dangerously blurred. This was underlined by two news stories this week. \r\n<p>First there was the allegation from a senior academic that league tables have put universities under pressure to mark too leniently and to overlook plagiarism. \r\n</p><p>Second there was the whistleblower who claimed that degrees are being awarded to overseas students who lacked basic English language skills because of the lucrative nature of the foreign student market. \r\n</p><p>There was a third story, a few weeks back, on a related issue. This was the discovery that two university lecturers had urged students to exaggerate the scores they gave to their institution in the National Student Survey because, they claimed, everyone else was doing so. \r\n</p><p>There is a common theme to each of these stories: the pressures on academics to make sure that their universities are marketable to current and potential customers. \r\n</p><p>These pressures are understandable but must be resisted. They are understandable because it is bums-on-seats that determines the bulk of university funding, particularly at universities which receive little research funding. \r\n</p><p><b>Wall of silence</b>\r\n</p><p>The notion of undergraduate and postgraduate students as customers is still relatively new. Its effect has been ratcheted up by the introduction of variable or top-up fees and the increasing reliance on fees from overseas students. \r\n</p>\r\n<p>However we have got to the point now where we really must decide whether a university is just another service provider or a community of scholars. \r\n</p><p>I believe many university leaders are, at least in public, complacent about this. \r\n</p><p>I was at a public debate on education this week when the two news stories about lenient marking were raised. None of the educationalists that spoke were willing to acknowledge that these pressures even existed. \r\n</p><p>Indeed the one vice-chancellor present felt there was simply no case to answer. \r\n</p><p>There is still an official wall of silence about such allegations. A common response is that the whistleblowers are letting the side down and are damaging the reputation of British universities. \r\n</p><p>Yet you only have to read the large number of responses to the BBC News website to see that the allegations chime with many academics. It is a sad state of affairs that many clearly felt they had to remain anonymous. \r\n</p><p>Whatever happened to academic freedom? \r\n</p><p>The spread of the consumer model of university education is not just a result of the actions of competitive and cash-strapped vice-chancellors. \r\n</p><p><b>Consumerism</b>\r\n</p><p>The policies of successive governments have encouraged this model through the squeeze on per student funding, the imperative to expand, and the attempt to introduce a market in fees and bursaries. \r\n</p><p>Students, and increasingly parents, have also stressed the consumerist aspect of their role. They are now more directly aware of a cash relationship with universities. \r\n</p><p>Nor is this just about money. The concept of the "helicopter parent" (that is the parent who continues to hover over their offspring even after they have left home for university) owes much to a generation of mothers and fathers who have been encouraged to be active consumers as their children have gone through the school system. \r\n</p><p>University league tables and the National Student Survey are of a piece with school performance tables and Ofsted reports. They encourage a shopping around approach. \r\n</p><p>One result has been that universities now face more complaints from students. Last year, the Office of the Independent Adjudicator for Higher Education in England and Wales received 734 complaints. \r\n</p><p>That was a 25% increase on the previous year. Remember too that these are only the tip of the iceberg since most complaints are settled within institutions. \r\n</p><p><b>Complaints culture</b>\r\n</p><p>Interestingly 26% of complaints came from international students and 36% were from postgraduates. Almost two-thirds of the complaints related to academic results. \r\n</p><p>But universities must bear much of the blame for this rise in the complaints culture. \r\n</p><p>The glossy brochures and the expensive advertising campaigns that are offered by many universities often exceed the reality that greets students when they arrive. \r\n</p><p>As one admirably straight-talking vice-chancellor, Eric Thomas from Bristol University, told a conference recently: "the hyperbole" many universities use to describe themselves is "quite eye-watering". He added that the picture painted by many prospectuses was as real as "la-la land". \r\n</p><p>Higher Education Minister Bill Rammell has acknowledged that students are less deferential than in the past. He told a recent conference on "Student Satisfaction" that "students are becoming more demanding partly because they want value for money but also as we see more older and articulate students". \r\n</p><p>It is probably also true to say that students are more concerned now about their degree level than they were in the past. Twenty to thirty years ago simply having a degree made you marketable to employers. Now there is great pressure to get at least a 2:1. \r\n</p><p><b>Pressure</b>\r\n</p><p>All of this has made it inevitable that students will be more demanding about the quality of their courses, teaching, assessment and facilities. \r\n</p><p>It is right that they should know how many hours of teaching they will receive and how often they will meet their tutors. \r\n</p><p>It may even be that we need better, and more specific, contacts between universities and students. So long as the focus is on delivering good quality teaching and research facilities this element of consumer satisfaction is a good thing. \r\n</p><p>But we must not lose sight of what a university is fundamentally about: it is a place of learning where students and teachers should be part of a learning community not just providers and customers. \r\n</p><p>The responsibility to ensure that we do not succumb to a purely customer model falls squarely on university leaders. It cannot be on the government since, quite rightly, universities insist they are independent bodies. \r\n</p><p>As such they must regulate themselves. Vice-chancellors must put competition for students and markets in second place behind the need to preserve academic standards and independence. \r\n</p><p>The only pressure academics should be under when marking students'' work is the pressure of their peers to maintain standards and the pressure from students for fair and equal treatment. \r\n</p><p>If vice-chancellors are unable to resist these pressures individually then they must, collectively through organisations such as Universities UK, take a stand against those who put marketing and consumerism above academic integrity. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/education/7466279.stm" title="Students: Customers or learners?">Source: BBC</a></p>', 1, 6, 0, 25, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:27:46', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 3, '', '', 0, 2, ''),
(94, 'Fuel move boosts Chinese shares', 'fuel-move-boosts-chinese-shares', '', '<img src="images/stories/business/markets/5.jpg" alt="Fuel move boosts Chinese shares" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nChinese shares have closed 3% higher after the government raised energy prices in an effort to cool the nation''s rising energy consumption.\r\n', '<p>\r\nThe Shanghai Composite Index initially fell 2% in early trade but bounced back to close 3% up at 2.917.33. \r\n</p><p>\r\nChina increased retail and wholesale prices for fuel and electricity by as much as 18% on Thursday, pushing global oil prices down by almost $5 a barrel. \r\n</p><p>\r\nBut analysts fear the move may fuel inflation which is near a 12-year high.\r\n</p><p>\r\nThe main beneficiaries of Beijing''s energy price hike are the nation''s oil refiners. \r\n</p><p>\r\nAs energy prices rise, refiners have suffered deep losses as they buy oil on the international markets but sell to consumers at a discount set by the Chinese government.\r\n</p><p>\r\nThe move will not only close the gap between state-set domestic prices and world oil markets but somewhat curb China''s demand for oil, analysts said.   \r\n</p>\r\n<p>\r\nChina accounts for around 40% of the increase in world oil consumption, as its red-hot economy continues to expand at a furious pace.\r\n</p><p>\r\n"It is going to eat into demand. I''m pretty sure of that," said Dave Ernsberger, Asia director of global energy for research firm Platts. \r\n</p><p>\r\nState price controls in the world''s second largest oil consumer after the US have also been blamed for making global markets more volatile. \r\n</p><p>\r\nBut there are also concerns that higher fuel prices may fuel inflation and spark civil unrest.\r\n</p><p>\r\nAnnual consumer price inflation hit 8.5% in April, while food costs rose 22%.\r\n</p><p>\r\nIn a move to appease its citizens, the government said it had set aside $2.9bn in subsidies to help those most affected by the price rises.\r\n</p><p>\r\nChina''s action came just two days before an international oil summit in Saudi Arabia to discuss rising energy costs. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7465221.stm" title="Fuel move boosts Chinese shares">Source: BBC</a></p>\r\n\r\n', 1, 6, 0, 25, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:27:35', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 2, '', '', 0, 3, ''),
(95, 'Chancellor Darling calls for pay restraint', 'chancellor-darling-calls-for-pay-restraint', '', '<img src="images/stories/business/economics/1.jpg" alt="Darling calls for pay restraint" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nChancellor Alistair Darling says pay rises for people "from the boardroom to the shopfloor" need to be "consistent" with the 2% inflation target.', '<p>\r\nHe told BBC One''s Andrew Marr show the need to keep inflation under control "applies to each and every one of us".\r\n</p><p>\r\nHe said above-inflation pay increases would be "extremely damaging".\r\n</p><p>\r\nMr Darling said the UK economy was "far better equipped" than in the 1970s, 1980s and 1990s, but "despite that we are in for a tough time".\r\n</p><p>\r\nThe government''s preferred inflation measure, the Consumer Prices Index rose, to 3.3% in May, with the Bank of England warning it may reach 4%. \r\n</p><p>\r\nThe wider Retail Prices Index measure of inflation - the one used for many pay negotiations - is already at 4.3%.\r\n</p><p>\r\nAsked if people should accept their living standards were going to fall this year - as they get pay rises below the level of inflation - Mr Darling said that everyone "had a vested interest" in not allowing inflation to take hold.\r\n</p><p>\r\nHe said: "We''ve got to make sure that we keep inflation under control because if we don''t what will happen is that people may get a pay increase but every penny of it will be eaten up by rising prices in the shops.\r\n</p><p>\r\n"Now none of us want to see that happen, it''s in no-one''s interest and that applies from the top to the bottom, public and private sector alike."\r\n</p><p>\r\nThe chancellor was speaking as BPIX opinion poll for the Mail on Sunday suggested Labour was trailing the Conservative Party by 49% to 26% -with the Lib Dems on 14%.\r\n</p><p>\r\nThe poll - which saw 2,385 people questioned online between 18 and 20 June - comes ahead of Gordon Brown''s first  anniversary as prime minister, on Friday.\r\n</p><p>\r\nAsked about Mr Brown''s position, Mr Darling told the programme: "I have always taken the view that we can turn this round. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/uk_politics/7467810.stm" title="Darling calls for pay restraint">Source: BBC</a></p>', 1, 6, 0, 25, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:27:27', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 3, ''),
(96, 'India urged to focus on farming', 'india-urged-to-focus-on-farming', '', '<img src="images/stories/business/sectors/1c.jpg" alt="India urged to focus on farming" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<b>India must focus more on its agricultural sector in order to sustain long-term economic growth, a leading industrialist has said.</b>\r\n<p>Bharti Group boss Sunil Bharti Mittal called for "serious intervention".\r\n</p><p>He said the government, private sector and foreign investors all needed to play their part if they wanted to see India''s economy grow at the same rate.\r\n</p><p>"Without agriculture, India cannot move forward," said Mr Mittal in an exclusive interview with the BBC.\r\n</p>', '<p><b>''Change needed''</b>\r\n</p><p>Mr Mittal said the biggest concern for the Indian economy today was not rising oil prices but the huge disparities that exist in India.\r\n</p><p>Some reform in this sector has meant that the country has gone from being unable to feed itself to being the world''s largest producer of milk and second largest producer of fruit and vegetables.\r\n</p><p>Yet the average size of a farm is just four acres and at least 40% of the harvest is wasted.\r\n</p><p>"A significant policy change is needed in terms of land reforms, cold-chains, farming techniques, alternate cropping and so on,'''' said Mr Mittal, who is a former president of the Confederation of Indian Industries.\r\n</p><p>PepsiCo boss Indira Nooyi echoed similar thoughts, saying one could not imagine a successful India unless its agricultural practices improved markedly with the application of new technologies and techniques.\r\n</p><p>"India needs a second green revolution," Ms Nooyi told a gathering of US and Indian corporate executives and opinion makers in the US capital, Washington.\r\n</p><p>But she said that, for all the importance of the high-tech revolution, India would not advance by new technology alone.\r\n</p><p>"We need to recognise that the future of large segments of the Indian population will rest, for years to come, on improvements in agricultural processes,'''' said Ms Nooyi, whose company has major agri-initiatives in Punjab, Maharashtra, Uttar Pradesh and West Bengal states.\r\n</p><p>Mr Mittal''s companies are also venturing into agriculture.\r\n</p><p>Both he and Ms Nooyi said India needed to protect subsistence farmers in trade talks.\r\n</p><p>"Any damage to the 700 million people tied with agriculture would mean India will have to pay a heavy price in the future," Mr Mittal said.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/south_asia/7462139.stm" title="India urged to focus on farming">Source: BBC</a></p>', 1, 6, 0, 27, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:28:53', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 5, '', '', 0, 2, ''),
(97, 'Fruit pickers'' free for all ends', 'fruit-pickers-free-for-all-ends', '', '<img src="images/stories/business/sectors/2.jpg" alt="Fruit pickers'' free for all ends" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nFruit farms have stopped "pick your own" strawberries due to people eating too much produce without paying.\r\n', '<p>\r\nHacker''s Fruit Farm, near Cambridge, had offered pickers the chance to select their own strawberries for the last 40 years.\r\n</p>\r\n<p>\r\nMark Spight, who runs the farm, said he was annoyed at the number of people not paying for the strawberries.\r\n</p><p>\r\nOne family were caught dipping the berries in cream as they picked them.\r\n</p><p>\r\nMr Spight said he used to get angry watching people gorging themselves then only taking a handful of fruit to be paid for.\r\n</p><p>\r\n<b>Bowl of cream</b>\r\n</p><p>\r\nHe said some people were eating up to £15 worth of strawberries and would come to the checkout covered in juice.\r\n</p><p>\r\nThere had also been an increasing problem with unruly behaviour leading to plants being trampled and fruit damaged.\r\n</p><p>\r\n"We don''t mind people going picking and trying some strawberries, but we once had a family come with a bowl of cream. It was shocking," said Mr Spight.\r\n</p><p>\r\n"We used to have a lot of children playing in the fields and trampling the plants. We thought it was not worth it."\r\n</p><p>\r\nThis year the farm does not have any strawberry plants to be picked but sells them in the farm shop grown by other local farmers.\r\n</p><p>\r\nMr Spight has replaced them with rows of redcurrants, blackcurrant, loganberries, tayberries and gooseberries.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/cambridgeshire/7461724.stm" title="Fruit pickers'' free for all ends">Source: BBC</a></p>\r\n\r\n', 1, 6, 0, 27, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:29:25', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 8, 0, 4, '', '', 0, 3, ''),
(98, 'Diesel hybrids could enter Le Mans', 'diesel-hybrids-could-enter-le-mans', '', '<img src="images/stories/business/sectors/3.jpg" alt="Diesel hybrids could enter Le Mans" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nAudi and Peugeot will do battle for victory in the prestigious but gruelling Le Mans 24 Hours motor race this weekend.\r\n', '<p>\r\nIt is expected to be a tense, nail-biting contest between two of Europe''s top motor companies. \r\n</p>\r\n<p>\r\nAnd remarkably, they will both enter the race with cars powered by diesel engines.\r\n</p><p>\r\nIt is part of a process that has already transformed the public image of the humble diesel engine, almost beyond recognition. \r\n</p><p>\r\nOnce derided as noisy, smelly and slow, diesels were considered suitable only for lorries, delivery vans and taxis. \r\n</p><p>\r\nThey gave good fuel mileage, but they were not in any way appealing to ordinary motorists. \r\n</p><p>\r\nYet nowadays diesel engines power some of the most best-selling cars on the market. \r\n</p><p>\r\nAudi has even created a diesel version of its 186mph R8 supercar. \r\n</p><p>\r\n<b>Hybrid future</b>\r\n</p><p>\r\nThe rise of the diesel has been prompted by the increasing price of crude oil and mounting environmental concerns, both of which have placed a premium on fuel efficiency.\r\n</p>\r\n<p>\r\nBut that has created yet more problems. \r\n</p><p>\r\nThere are so many diesel engines out there, that supplies of the fuel itself are becoming scarcer, and prices are rising fast. \r\n</p><p>\r\nSo the next step may be even more ambitious: the development of a diesel-electric hybrid, combining an electric motor with a high-tech diesel engine. </p><p>\r\nPetrol-electric hybrids are very much in vogue at the moment. \r\n</p><p>\r\nThey use less fuel than conventional petrol-powered cars, and are popular with the eco-conscious motorist. \r\n</p><p>\r\nThe market leader is the iconic Toyota Prius. \r\n</p><p>\r\nMore than a million models have now been sold. \r\n</p><p>\r\n<b>Future solution</b>\r\n</p><p>\r\nBut beneath the hype lies an uncomfortable truth. \r\n</p><p>\r\nConsumer tests have shown that the current generation of petrol electric hybrids are little more efficient than a top of the range diesel. \r\n</p><p>\r\nSo another step is needed. \r\n</p><p>\r\nThe logical conclusion is to get the best of both worlds, by building a diesel electric hybrid. \r\n</p><p>\r\n"Diesel hybrids are basically a good idea", says Paul Nieuwenhuis, an automotive industry expert at Cardiff University. \r\n</p><p>\r\n"They give you an extra 15-20% fuel saving over a normal hybrid." \r\n</p><p>\r\nOne manufacturer intending to take advantage is PSA Peugeot Citroen. \r\n</p><p>\r\nThe French car manufacturer is planning to have its first diesel hybrid passenger car hit the road by 2010. \r\n</p><p>\r\n"We need to decrease the fuel consumption of the car and reduce its environmental footprint", says the company''s spokesman Marc Boque. \r\n</p><p>\r\n"Diesel hybrids bring a real breakthrough in terms of consumption and CO2 emissions. We are quite sure that hybrid technology, and particularly diesel hybrid technology has a big future." \r\n</p><p>\r\nOther manufacturers, including the US giant General Motors and Volkswagen, have also developed diesel-electric prototypes, and could have cars in production within a few years. \r\n</p><p>\r\n<b>Cost concerns</b>\r\n</p><p>\r\nBut not everyone believes that diesel hybrids are the future. \r\n</p>\r\n<p>\r\nAmong the sceptics is the current market leader in hybrid technology, Toyota. \r\n</p><p>\r\nThe company has repeatedly said it has no plans make diesel-hybrid passenger cars - although it does use the technology for some commercial vehicles.\r\n</p><p>\r\nThe reason for its reluctance is cost. \r\n</p><p>\r\nDiesels generally cost more to make than petrol cars, while hybrid technology is also expensive. \r\n</p><p>\r\nToyota thinks combining the two would add thousands of pounds to the cost of a new car, pricing too many consumers out of the market and making diesel hybrids difficult to sell. \r\n</p><p>\r\n"Already the diesel [price] premium is quite high, then you''d have to pay a hybrid premium, so we''re not seeing that there''s a market," Toyota Motor Europe chief executive Tadashi Arashima told BBC News in 2006.\r\n</p><p>\r\nPeugeot disagrees. \r\n</p><p>\r\n"Of course it is an expensive technology, so we will begin with top of the range cars in each segment of the market," says Mr Boque. \r\n</p><p>\r\n"But we will very quickly develop the technology for the mass market as well."\r\n</p><p>\r\n<b>Hybrid racer</b>\r\n</p><p>\r\nIn the meantime, like other manufacturers, Peugeot is also developing so-called "micro-hybridisation". \r\n</p><p>\r\nThis involves using electric systems to stop and start the engine of a car when it is stuck in traffic, minimising fuel wastage. \r\n</p><p>\r\nSome experts believe that as these fuel saving systems become more sophisticated, full-scale hybridisation could even become unnecessary. \r\n</p><p>\r\nPeugeot, though, thinks diesel hybrids in particular have a valuable future and is planning to make a very public gesture to prove it. \r\n</p><p>\r\nThis year, it wants to win at Le Mans with a diesel car. \r\n</p><p>\r\nBy 2009, it is expected to go one step further and enter the race with a diesel hybrid. </p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7437245.stm" title="Diesel hybrids could enter Le Mans">Source: BBC</a></p>', 1, 6, 0, 27, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:29:17', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 2, ''),
(99, 'Car firm to create 600 new jobs', 'car-firm-to-create-600-new-jobs', '', '<img src="images/stories/business/sectors/4.jpg" alt="Car firm to create 600 new jobs" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nUp to 600 jobs are to be created at car manufacturer Jaguar Land Rover in the Midlands.\r\n<p>\r\nThe announcement comes just weeks after a £700m...</p>', ' investment which came when the marques were bought by Indian giant Tata from Ford for £1.2bn.\r\n</p>\r\n<p>\r\nThe firm wants engineers to work on developing new technology aimed at reducing vehicle emissions. \r\n</p><p>\r\nThe majority of the jobs will be based at its development centre in Gaydon, Warwickshire.\r\n</p><p>\r\nJaguar Land Rover said it would also start a graduate programme for more than 80 graduates to join the business in September.\r\n</p><p>\r\n<b>''Exciting era''</b>\r\n</p><p>\r\nOther jobs will be advertised for its purchasing, finance and human resources departments.\r\n</p><p>\r\nChief executive David Smith said: "This recruitment drive demonstrates Jaguar Land Rover''s confidence in our future. \r\n</p><p>\r\n"With our new owners, we have entered an exciting era with stunning new models and ambitious technologies. \r\n</p><p>\r\n"I can''t remember a better time to be part of the British car industry, and certainly it is a brilliant time for Jaguar Land Rover."\r\n</p>\r\n<p>\r\nThe company said worldwide sales of Jaguars were increasing, through the popularity of the new XF saloon while Land Rovers had achieved three successive years of record sales.\r\n</p><p>\r\nDes Thurlby, the firm''s HR Director, said: "The work on offer is cutting-edge and the rewards impressive. \r\n</p><p>\r\n"This business has a bright future and we think it will be a very attractive place to work for the best in our industry here in the UK."\r\n</p><p>\r\nThe company currently employs about 16,000 staff at UK plants in the West Midlands and Merseyside. \r\n</p><p>\r\nIt has sites at Solihull and Castle Bromwich in the West Midlands, Whitley in Coventry, Gaydon in Warwickshire and Halewood in Merseyside.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/coventry_warwickshire/7460602.stm" title="Car firm to create 600 new jobs">Source: BBC</a></p>', 1, 6, 0, 27, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:29:06', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 2, ''),
(101, 'Shutdown ''risks petrol shortages''', 'shutdown-risks-petrol-shortages', '', '<img src="images/stories/business/commentary/1c.jpg" alt="Shutdown ''risks petrol shortages''" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n	\r\n<b>Bosses at Scotland''s only crude oil refinery have started a shutdown after claiming an impending strike will compromise safety.</b>\r\n<p>\r\nIneos said the Grangemouth refinery could shut for "at least a month", and warned of major fuel shortages. \r\n</p><p>\r\nAbout 1,200 members of the Unite union are to strike on 27 and 28 April in a dispute over pensions.\r\n</p><p>\r\nScottish ministers urged both sides to try to resolve the dispute, instead of "trading commentary" in the...\r\n</p>', 'media.\r\n<p>\r\nThe Unite union said Ineos'' proposed pension changes were "unreasonable".\r\n</p><p>\r\nIneos said in a statement that it had taken the decision to start shutting down the Grangemouth facility on safety grounds.\r\n</p>\r\n<p>\r\nThe statement added: "Fuel shortages are likely to begin in Scotland as early as Friday 25 April and the whole of Scotland could be without fuel for at least a month.   \r\n</p><p>\r\n"It is important that the plant is not only shut down safely but also remains safe through the strike period and this process can take many days."\r\n</p><p>\r\nThe first stage of the closure began on Friday night, with the first plant on the site due to shut completely on Monday.\r\n</p><p>\r\nThe remaining plants would be taken offline in a phased shutdown which would be completed by Friday. \r\n</p><p>\r\nThe statement said that the action would also effectively shut down much of the North Sea''s oil and gas production, a large proportion of which goes through Grangemouth, causing supplies to dry up and leading to shortages across Scotland and the north of England.\r\n</p><p>\r\nGrangemouth supplies Scotland, Cumbria, Northumberland and parts of Yorkshire. \r\n</p><p>\r\n<b>''Panic buying''</b>\r\n</p><p>\r\nGeoff Dossetter, of the Freight Transport Association, told BBC Radio Five Live he was concerned the shutdown could spark panic buying.\r\n</p><p>\r\n"That starts off for fuel but then of course the next step is to be concerned about the delivery of goods to shops and so on - this is where my members within the Freight Transport Association have some concern."\r\n</p><p>\r\nThe Scottish Motor Trade Association, which acts for petrol retailers, urged drivers not to fill up tanks as shortages were often sparked by such panic buying.\r\n</p>\r\n<p>\r\nTom Crotty, CEO of Ineos Olefins, said the union was "well aware" a 48-hour strike would cause "fuel chaos" in Scotland and the north of England.\r\n</p><p>\r\n"This is a huge oil refinery and they know you can''t just turn it on and off like a tap. A month is our best guess but safety considerations will be at the forefront of everything we do. \r\n</p><p>\r\n"They have deliberately chosen a course of action that is the minimum pain for them, but which will inflict the maximum pain on Scotland and the whole UK."\r\n</p><p>\r\nMr Crotty described the union''s claim that the refinery made £3m a day as "nonsense" and said Ineos needed to invest £750m into the site.\r\n</p><p>\r\nHe claimed that the strike threatened that investment, as well as hundreds of jobs, and would damage the UK economy.\r\n</p><p>\r\n<b>Talks urged</b>\r\n</p><p>\r\n Phil McNulty, national officer of Unite, insisted that the company was profitable and the pension scheme was well-funded and affordable.\r\n</p><p>\r\nThe union has previously said that Ineos is planning to close the final salary pension scheme after taking £40m from it and slashing its own contributions.\r\n</p><p>\r\nMr McNulty added: "The changes to the scheme Ineos are proposing are unreasonable, unnecessary and have forced our members at Grangemouth to take industrial action for the first time."\r\n</p><p>\r\nScottish ministers said contingency measures were already in place and they were being kept informed by the UK Government, which has responsibility for continuity of oil, gas and fuel supplies.\r\n</p><p>\r\nA spokeswoman added: "The Scottish Government is closely monitoring the situation and is fully aware of the potential disruption that could arise.\r\n</p><p>\r\n"The Scottish Government is calling on both sides to get together to negotiate and resolve their differences to avert this action, rather than trading commentary in the media."\r\n</p><p>\r\nIneos acquired the Grangemouth site from BP in 2005 and is now the biggest privately-owned chemical business in the UK.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/scotland/tayside_and_central/7356235.stm" title="Shutdown ''risks petrol shortages''">Source: BBC</a></p>', 1, 6, 0, 28, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:24:58', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 5, '', '', 0, 3, ''),
(100, 'Part-time soldiers ''proud to serve''', 'part-time-soldiers-proud-to-serve', '', '<img src="images/stories/business/sectors/5.jpg" alt="Part-time soldiers ''proud to serve''" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nAs the Territorial Army celebrates its centenary with a pageant in The Mall, serving members describe life in the TA and explain what inspires them to serve in the reserve force.\r\n    \r\n	', '<p><b>CORP KEVIN BURGESS, 28 ENGINEER REGIMENT, 412 AMPHIBIOUS ENGINEER TROOP</b>\r\n</p><p>\r\nCorp Burgess, 37, joined the TA in Germany in 2001. A member of 412 Amphibious Engineer Troop, his job is to drive, pilot and command the Army''s M3 amphibious vehicles, which are used to ferry troops and equipment across rivers or create temporary bridges.  </p>\r\n\r\n<p>Originally from the Isle of Wight, Corp Burgess had settled down with a German woman after years of regular Army service in Germany and did not want to return to the UK when his contract expired. </p> \r\n<p>\r\nNow based in Hameln, Germany, he runs an IT consultancy and a pub as well as being a member of the 412 Amphibious Engineer Troop - the only TA unit based outside the UK and which was deployed in Iraq in 2003.\r\n</p><p>\r\nCorp Burgess says being in the TA has enabled him to continue soldiering, as well as a welcome chance to speak English and rediscover the camaraderie of his regular Army days. \r\n</p><p>\r\n\r\nHe says: "Most of us have got jobs working with Germans, so to be able to work with English soldiers again is quite relaxing. It''s an opportunity to get away from your normal, everyday life. \r\n</p><p>\r\n"Also, with 412 making the contribution they are in Iraq, it brings a very real sense of pride and you can talk about doing the very same things as your regular counterparts.\r\n\r\n"One of the things you do miss after a good amount of regular service is the camaraderie. It''s something only a soldier can really understand. But in the TA we talk to each other in the way we would as soldiers and treat each other as soldiers."\r\n</p><p><b>DRUM MAJOR STEVE WARD, ROYAL SIGNALS (NORTHERN) BAND</b></p>\r\n<p>Drum Major Steve Ward, 60, is a member of the Royal Signals (Northern) Band, taking part in parades, fetes, tattoos and other events the length and breadth of the country. \r\n</p><p>\r\nHe joined the TA 16 years ago after serving in the regular Army with the Coldstream Guards and Household Division from the age of 15, retiring as a senior drum major who led parades at prestigious events such as the Trooping of the Colour. \r\n</p><p>\r\nHe said: When I left I felt like continuing it, so I found a local TA band in Middlesbrough, rang them up and asked if they needed a drum major. They said come along. \r\n</p><p>\r\n"It also gave me the opportunity to become a musician, and I had to learn an instrument. \r\n</p><p>\r\n"In the regular Army I had been a fifer and drummer, but the way it works in the military is you are a soldier first and a fifer and drummer second.\r\n</p><p>\r\n"Since joining the TA band I''ve learned the cornet, the tenor sax and the baritone sax and I also play tenor horn in a brass band. It has given me, not a hobby, but another track."\r\n</p><p>\r\n\r\n</p><p>For his day job, Drum Major Ward, of Northallerton, North Yorks, now works as an accommodation services accountant for the Army, sorting out furnishings for soldiers'' homes. \r\n</p><p>\r\n</p><p>\r\nAlthough he plans to retire from the TA shortly after leading Saturday''s 100th anniversary parade, membership has brought him much satisfaction. \r\n</p><p>\r\nHe says: "It gives me a sense of pride and a sense of service, it''s a contribution to the community. \r\n</p><p>\r\n"We do fetes within the community, keeping the TA in the public eye, it''s very difficult to get out of that when you retire."</p>\r\n<p>In 2006, she was deployed to Iraq for a six-month tour with the Royal Dragoon Guards.</p>\r\n<p>\r\nShe says: "I''m from a family with a long history of involvement with the TA. My great-grandfather was a founder member in 1908. Since then, my mother, father, uncle and brother have all been in the TA and I''ve been serving in green one way or another since I was a cadet.\r\n</p><p>\r\n\r\n</p><p>\r\n"I trained as a first aid instructor and was in the First Aid Nursing Yeomanry, which is a civilian volunteer organisation, not TA. \r\n</p><p>\r\n"Then the medics that went to Iraq in the very early days were writing, saying conditions were really tough and \r\nI knew I could make myself useful."\r\n</p><p>\r\n\r\n</p><p>\r\nTrooper Beattie volunteered for Iraq, was transferred to the TA and by spring 2006 she was on duty in Al Muthaba province. \r\n</p><p>\r\n\r\n\r\nThere she set to work supporting Army medics, teaching first aid to British and Iraqi troops and carrying out first aid herself. \r\n</p><p>\r\n\r\nShe says: "\r\nI looked after boys who had a bit of diarrhoea - it wasn''t very glamorous but it was helpful. \r\n</p><p>\r\n"Those boys work very hard - it''s physically demanding to go out on patrol in the back of a Land Rover, so anything I could do to help was welcome - from powdering their athlete''s foot to bringing tea and toast when they had the squits or just passing bandages to the doctor when he needed them, or clearing up afterwards." \r\n</p><p>\r\nShe also attended seriously wounded men, including some who died from their injuries, and came under mortar fire herself. \r\n\r\n</p><p>\r\nShe said: "It''s actually less terrifying than you imagine \r\nit to be because you''re all in it together. You''re all in the same circumstances and you can all laugh and joke and let off steam about it afterwards."\r\n</p><p>\r\n\r\n</p><p>\r\n"My family were very worried about me, despite the fact I come from such a heavily TA family. My brother went to Bosnia and Northern Ireland repeatedly and my father went all over the place. \r\n</p><p>\r\n"But it seemed to come as a surprise to them that I would too. No one wants to have their child being mortared. I just wrote letters tried to lessen their worries."\r\n\r\n</p><p>\r\nTrooper Ward, of Dulwich, south-east London, says her experience of the TA has given her a "sense of purpose, a sense of contributing something useful and a sense of service". \r\n</p><p>\r\nShe says: "Being in London when my Army friends are under threat in Iraq - it''s all very fine going shopping and having the perfect shoe collection or seeing the latest films at the cinema but you''re not helping anybody.\r\n</p><p>\r\n"I''m so grateful and proud of the fact I was able to help the lads going out on patrol. And I''m really looking forward to going back as soon as I can."</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/uk/7467375.stm" title="Part-time soldiers ''proud to serve''">Source: BBC</a></p>', 1, 6, 0, 27, '2008-06-21 10:29:45', 63, '', '2008-06-23 10:07:45', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 1, '', '', 0, 1, ''),
(102, 'Date set for crackdown on agents', 'date-set-for-crackdown-on-agents', '', '<img src="images/stories/business/commentary/2.jpg" alt="Date set for crackdown on agents" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nA delayed scheme to deal with complaints against estate agents will start in October, according to the Office of Fair Trading...', '<p>\r\nAll estate agents will have to be members of an approved free ombudsman service that will deal with complaints and could order compensation.\r\n</p><p>\r\nThe planned start date in April was put back owing to a delay over endorsement of schemes by the OFT.\r\n</p><p>\r\nA report earlier in the week said agents should be formally regulated.\r\n</p><p>\r\n<b>Common gripes</b>\r\n</p><p>\r\nComplaints about estate agents include inaccurate description of properties or delays in passing on offers to sellers.\r\n</p><p>\r\nBut at the end of 2006, only 60% of estate agents were members of voluntary ombudsman schemes. A disproportionate number of complaints about estate agents are about firms not in these schemes.\r\n</p><p>\r\nThese cases were highlighted the most during the boom years of the housing market as anyone can set up as an estate agent in the unregulated industry.\r\n</p><p>\r\nFrom 1 October, under the Consumers, Estate Agents and Redress Act of 2007, an estate agent can be prevented from operating if it is not attached to an OFT-approved ombudsman service that can resolve disputes and offer compensation.\r\n</p><p>\r\nThe OFT has now given approval to the Ombudsman for Estate Agents Company Limited to run one of these schemes, and is considering bids from two more.\r\n</p>\r\n<p>\r\n"House buyers and sellers will soon have access to a free, easily accessible and speedy estate agents redress scheme that will ensure independence, fairness and transparency," said John Fingleton, OFT chief executive.\r\n</p><p>\r\nIn a report published earlier in the week Sir Bryan Carsberg, who used to head the OFT, called for estate agents to be members of ombudsman schemes in one of his 30 recommendations.\r\n</p><p>\r\nHe also said estate agents, letting agents and managing agents, who handle residential property, should be subjected to formal regulation and complete basic qualifications in order to offer customers better protection.\r\n</p><p>\r\n"It is clear that consumers have significant dissatisfaction with the present situation and want something done to improve it," Sir Bryan said.\r\n</p><p>\r\n<b>Abuse of position</b>\r\n</p><p>\r\nThe OFT does have powers to ban any agents who break the laws about misdescribing a property, handling a client''s money, not declaring an interest in a property, or are found to have engaged in some other form of dishonesty.\r\n</p><p>\r\nFor example, this week the OFT banned Daniel Zane, ex-director of former Hertfordshire estate agents Vue Estates Ltd, from estate agency work.\r\n</p><p>\r\nThe regulator said he had failed to give written details of his fees and charges before a entering a contract with a prospective buyer. He also failed to pass on offers promptly and misrepresented the status of a potential buyer.\r\n</p><p>\r\n"This is a very serious example of an estate agent abusing his position to act for his own benefit," said Mike Haley, the OFT''s director of consumer protection.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7465346.stm" title="Date set for crackdown on agents">Source: BBC</a></p>', 1, 6, 0, 28, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:25:38', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 4, '', '', 0, 2, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(103, 'Retail surge fans rate rise fear', 'retail-surge-fans-rate-rise-fear', '', '<img src="images/stories/business/commentary/3.jpg" alt="Retail surge fans rate rise fear" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nA record level of spending has provided a rest from dull economic predictions but has also fanned fears of high interest rates...\r\n', '<p>\r\nSales rose by 3.5% during May, the strongest monthly growth since January 1986, statistical office figures show.\r\n</p><p>\r\nShocked analysts said the figures ran contrary to signs of a slowing economy and weak consumer confidence. \r\n</p><p>\r\nEarlier, the Bank of England warned it would act to rein in inflation and said the UK was heading for difficult times.\r\n</p><p>\r\nThe Bank of England''s governor, Mervyn King, said the UK was facing its "most difficult economic challenge for two decades".\r\n</p>\r\n<p>\r\nSpeaking at the Mansion House in London on Wednesday night, Mr King made it clear that inflation was set to rise, while growth and house prices were likely to fall. \r\n</p><p>\r\nMr King also warned that real take-home pay would stagnate, making life difficult for some families. \r\n</p><p>\r\n<b>''Different plane''</b>\r\n</p><p>\r\nAnalysts and companies have been echoing these negative sentiments in recent weeks, with mortgage providers such as HBOS forecasting a 9% drop in house prices, which is why the retail sales figures came as such a shock.\r\n</p><p>\r\n"I''m staggered," said Philip Shaw, chief economist at Investec. \r\n</p>\r\n<p>\r\n"The figures are on a completely different plane compared to what markets were expecting."\r\n</p><p>\r\nSome questions were raised over the accuracy of the figures because they were so out of kilter when compared with other reports. \r\n</p><p>\r\nEven the Bank of England has questioned the statistical office reports, and after last month''s retail sales figures release said that it was giving more weight to other indicators of High Street activity, which were showing more of a slowdown.\r\n</p><p>\r\n"The retail sales numbers do look somewhat stronger than really a raft of surveys," Bank of England chief economist Charlie Bean told the BBC''s economics editor Stephanie Flanders.\r\n</p><p>\r\nMr Bean added that given the uniformity of the picture from all of this other evidence the Bank of England "has put some weight on that other evidence relative to the official retail sales data".\r\n</p><p>\r\n<b>Inflation worries</b>\r\n</p><p>\r\nEven so, May''s retail figures make for surprising reading. Food sales rose 3.3% as people bought salads and stocked up for barbecues, while clothing sales jumped 9.2% as shoppers sought out new summer outfits.\r\n</p><p>\r\nThe better-than-expected figures took the annual sales increase to 8.1%, the fastest rate since April 2002.\r\n</p><p>\r\nComparing the period between March and May with the previous three months - which is seen as a better measure of underlying growth - sales rose by 1.8%. This was against growth of 1.5% in the February to April period.\r\n</p><p>\r\nInflation, it seems, has become policymakers'' biggest worry and not the state of the UK economy.\r\n</p><p>\r\n"Today''s very strong set of retail sales numbers suggests that, despite all the doom and gloom, the UK consumer continues to shop," said Ian Kernohan, economist at Royal London Asset Management.\r\n</p><p>\r\n"Unfortunately this ''shop till we drop'' attitude will sow the seeds of its own demise. The risk of rate rises followed by a recession has just gone up."\r\n</p><p>\r\n<b>''Clear message''</b>\r\n</p><p>\r\nThe fear is that even if the surge in consumer spending can be attributed to a spell of warm weather in May, high food and fuel prices will force the Bank of England to raise interest rates at a time when the UK economy is already slowing. \r\n</p><p>\r\nOn Wednesday, the BBC was told by senior industry sources that household energy bills could increase by as much as 40% this winter. \r\n</p><p>\r\nThat could mean households paying £400 more a year on average for their gas and electricity. An increase on that scale would be far more than analysts have predicted in recent months. \r\n</p>\r\n<p>\r\nThe effect of higher fuel prices can already be seen on the rate of inflation. \r\n</p><p>\r\nThe latest inflation figures showed that the rate of consumer price growth had accelerated to 3.3% in May, well above the government''s target of 2%.\r\n</p><p>\r\nAt its last rate-setting meeting, the Bank of England''s Monetary Policy Committee (MPC) voted eight-to-one to keep borrowing costs on hold at 5%.\r\n</p><p>\r\nIn his speech on Wednesday night, Mr King said the MPC was "prepared to take whatever action is needed" to bring inflation back down to the government''s 2% target. \r\n</p><p>\r\n"The message from the Bank of England governor is now very clear," said Howard Wheeldon of BGC Partners. \r\n</p><p>\r\n"Learn to live with inflation, learn to accept that purchasing power will shrink and get real to a view that if wage claims get out of hand, then the MPC will have no hesitation in pushing interest rates up."\r\n</p><p>\r\n<b>Pay restraint</b>\r\n</p><p>\r\nHowever, Mr King added that monetary policy alone could not prevent the current effects of rising food and energy prices on living standards. \r\n</p><p>\r\nNeither have interest rate cuts coaxed banks, which are currently re-evaluating risk and keeping a tight grasp on their balance sheet, to be more generous in their lending to house buyers. \r\n</p><p>\r\nChancellor of the Exchequer Alistair Darling has also warned about the perils of inflation. In his first Mansion House speech, he emphasised the need to tackle price growth. \r\n</p><p>\r\nMr Darling reiterated his call for pay restraint in both the private and public sectors, warning against a return to the spiralling rates of inflation last seen in the 1970s.\r\n</p><p>\r\nHe also laid out plans to give the Bank of England new responsibilities for ensuring the UK''s financial stability. \r\n</p><p>\r\nPart of the reforms will include setting up a new Financial Stability Committee, which will guide the Bank''s operations in this field.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7462945.stm" title="Retail surge fans rate rise fear">Source: BBC</a></p>', 1, 6, 0, 28, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:25:31', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 3, '', '', 0, 1, ''),
(104, 'Warning on private pension choice', 'warning-on-private-pension-choice', '', '<img src="images/stories/business/commentary/5.jpg" alt="Warning on private pension choice" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nA former government pensions adviser has warned that hundreds of thousands of people who have invested in private pension funds have lost out...', '<p>\r\nRos Altmann said they had received a lower retirement income as the option to shop around had not been made clear.\r\n</p><p>\r\nExperts say that if they had shopped around they could have received an extra 15% on top of their pension. \r\n</p><p>\r\nThey stress that people do not have to take their retirement income from the same company that they have saved with.\r\n</p><p>\r\n<b>Final salary schemes</b> \r\n</p><p>\r\nRetiring on a works pension used to be straightforward. Most people put money into a final salary scheme and their pension was automatically paid when they retired. \r\n</p><p>\r\nNow final salary schemes are not an option for many people and their pensions are much more complicated. The options include personal, stakeholder and money purchase deals.\r\n</p>\r\n<p>\r\nWhat they all mean is that while you are working, you pay money into a pot but when you retire you need to convert that pot into a retirement income - money that you receive every month.   \r\n</p><p>\r\nBut you do not have to take that monthly income from the company you saved with, you can shop around and may get a much better return.\r\n</p><p>\r\nThe financial regulator, the Financial Services Authority, studied letters sent by 55 pension companies and found that 40% of them failed to meet its rules.\r\n</p><p>\r\nA significant number failed to explain that by shopping around for a pension income, people could be better off.\r\n</p><p>\r\n<b>Jargon busting</b>\r\n</p><p>\r\nFelicity Strom took her private pension four years ago and says she has missed out because she did not realise she could shop around.\r\n</p>\r\n<p>\r\n"I found that I could not understand the jargon," she said.\r\n</p><p>\r\n"It wasn''t at all clear to me and I just wished that I had been aware at that time that I could actually have shopped around."\r\n</p><p>\r\nRos Altmann, a former pensions adviser to the government, says the government knew in 2000 that pensioners were losing out, but did not do anything. \r\n</p><p>\r\nShe estimates that well over a million pensioners have lost out as a result of the government''s refusal to tackle the problem. \r\n</p><p>\r\n"The Government has just ignored the problem and allowed the insurance industry to continue with its practices which are opaque, which people just don''t understand," she said.\r\n</p><p>\r\n"The insurance companies should definitely be doing more and the government should be requiring them to be doing more."\r\n</p><p>\r\n<b>''Mixed quality''</b>\r\n</p><p>\r\nBuying an annuity is a once in a lifetime decision, according to pensions expert Tom McPhail from Hargreaves Lansdown.\r\n</p><p>\r\n"The importance of shopping around is that once you start drawing your retirement income you''re locked in," he said.  \r\n</p><p>\r\n"But typically you can get a 15% increase if you shop around.  But if you don''t do that you''ve missed out and it''s gone for life."\r\n</p>\r\n<p>\r\nThe Association of British Insurers (ABI), admitted that the letters needed to be clearer.\r\n</p><p>\r\n"We''ve said the standard of communication sent out to customers has been of mixed quality," said the ABI''s Jonathan French. \r\n</p><p>\r\n"That''s why we''re doing all the work we''re doing to make things much clearer to make sure consumers have all the knowledge that they can shop around and ultimately get best value for money from their retirement income product."  \r\n</p><p>\r\nThe ABI says the insurance companies will start sending out the new style letters; which will be between one and two pages long, in the summer.\r\n</p><p>\r\nMeanwhile the government says it has already published a review of the market for retirement income and will be updating its progress in the autumn.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7465964.stm" title="Warning on private pension choice">Source: BBC</a></p>\r\n\r\n', 1, 6, 0, 28, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:25:24', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 1, ''),
(105, 'US tanker deal thrown into doubt', 'us-tanker-deal-thrown-into-doubt', '', '<img src="images/stories/business/sectors/1.jpg" alt="US tanker deal thrown into doubt" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n	\r\nBoeing should get a second chance to bid for a $35bn US Air Force contract, a US government agency has said.\r\n<p>The Government...</p>\r\n', 'Accountability Office  (GAO) upheld Boeing''s protest against the awarding of the air tanker deal to rivals Northrop Grumman and EADS.\r\n<p>\r\nIt said that the Air Force had made a "number of errors" that could have swung the outcome of the competition. \r\n</p><p>\r\nThe GAO''s ruling is not binding, but it puts huge pressure on the Air Force to put the process out to tender again.\r\n</p><p>\r\nThe GAO said in a statement: "The Air Force made a number of significant errors that could have affected the outcome of what was a close competition.\r\n</p><p>\r\n"We therefore sustained Boeing''s protest."\r\n</p><p>\r\n<b>Massive victory</b>\r\n</p><p>\r\nThe decision is a massive victory for Boeing, paving the way for it to win back all or part of the contract, which was for 179 new aircraft.\r\n</p>\r\n<p>\r\nIt was welcomed by many US lawmakers, who had been angered over the possibility that US jobs could be lost to Europe, particularly with the economy so fragile.\r\n</p><p>\r\nThe Air Force said it would review the ruling and set out its response.\r\n</p><p>\r\n"The Air Force will select the best value tanker for our nation''s defence, while being good stewards of the taxpayer dollar," it added.\r\n</p><p>\r\nThe news was met with disappointment from Airbus parent firm EADS, but chief executive Louis Gallois remained upbeat.\r\n</p><p>\r\n"It''s important to recognise that the announcement  is an evaluation of the selection process, not the merits of the aircraft," he said.\r\n</p><p>\r\nRandy Belote at Northrop Grumman said, "We continue to believe that Northrop Grumman offered the most modern and capable tanker."\r\n</p><p>\r\nThe Northrop tanker - the KC-30 - would be based on the Airbus A330, while Boeing''s offering is the  KC-767, a new version of the Boeing 767.</p>\r\n                    \r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/business/7462665.stm" title="US tanker deal thrown into doubt">Source: BBC</a></p>', 1, 6, 0, 28, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:25:14', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 1, '', '', 0, 4, ''),
(106, '7 night Egyptian Nile cruise special', '7-night-egyptian-nile-cruise-special', '', '<img src="images/stories/travel/deals/1c.jpg" alt="7 night Egyptian Nile cruise special" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nAll&nbsp;transfers, taxes and fuel surcharge included.\r\n<p>Save up to £230pp on a 4* Egyptian Nile cruise and experience Egypt''s finest ancient monuments from just £299pp. </p>\r\n<p>Flights depart from Gatwick or Manchester (for a £35pp supplement) on a selection of dates between June and November. The £299pp price is available on 23rd and 30th June and prices are based on two sharing.</p>', '<p>The 7 night cruise includes full board accommodation on the 4* M.S. Fleurette and 10 free excursions as you cruise the Nile.&nbsp; These include a visit to the famous Karnak Temple, a chance to see Aga Khan''s Mausoleum and Botanical Garden plus a visit to the Valley of the Kings. You can also take an optional full day excursion by air to visit Cairo and the Pyramids near the end of your stay.</p>\r\n<p>All cabins on board the M.S. Fleurette&nbsp;are bright and airy and have a private bathroom, hairdryer, air-conditioning, telephone, fridge, television and a large window. The ship also has a restaurant, gift shops, a lounge with a bar, a small swimming pool and a laundry service.</p>\r\n<p>5* cruises aboard the M.S. Da Vinci are also available on the same departure dates from as little as £349pp.</p>\r\n<p>This deal can only be booked by calling <strong>0845 345 0014 </strong>and quoting&nbsp;reference TS08. Make sure you book before 28th June to take advantage of these prices.</p>\r\n<p>To find out more information about the cruise itinerary and the ten free excursions on offer, click below.</p>\r\n\r\n<p><a href="http://www.travelsupermarket.com/c/top-deals/deals/180608-6/" title="7 night Egyptian Nile cruise from just £299pp including 10 free excursions">Source: TravelSupermarkets</a></p>', 1, 9, 0, 39, '2008-06-23 11:29:45', 63, '', '2008-06-24 10:27:17', 62, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 10, 0, 5, '', '', 0, 10, ''),
(119, 'Negresco - Manchester', 'negresco-manchester', '', '<img src="images/stories/travel/restaurants/1c.jpg" alt="Negresco - Manchester" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nThis fantastic baroque-influenced restaurant is a dining experience not to be missed! Not for the faint-hearted, Negresco - located in Deansgate, Manchester -  is a kooky affair with kinky neo-gothic, Kubrick-esque décor.  Named after an infamous historic hotel in the south of France, Negresco serves superb Italian/French cuisine. The stylish interior - featuring red lanterns, candlelit banquettes, moody black walls and taxidermy  has a naughty-private-members-club vibe, and is a memorable setting for dates and private dinner parties. We love the Riviera-style Polpette pizza  with pork and beef meatballs and parmesan...\r\n', '<p><a href="http://www.toptable.co.uk/venues/restaurants/?id=7170" title="Negresco - Manchester">Source: TopTable</a></p>', 1, 9, 0, 38, '2008-06-20 11:29:45', 63, '', '2008-06-23 14:41:36', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 3, '', '', 0, 1, ''),
(111, 'Paraguay''s New President May be Moderate', 'paraguay-president', 'paraguay president', '<img src="images/stories/world/s-america/5c.jpg" alt="Fernando Lugo" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<p><b>Paraguayan President-elect Fernando Lugo was all smiles as he and Venezuela''s Hugo Chavez embraced, talked of a revolution for the poor and pledged to build a united Latin America.</b></p>\r\n\r\n<p>But as the former Roman Catholic priest ended a three-nation tour Thursday that also included visits to Venezuela''s leftist allies in Bolivia and Ecuador, political analysts predicted he will take a less radical approach to governing.</p>\r\n\r\n<p>''He sees himself on the side of the progressive forces that want to change the relationship between Latin...</p>', 'American countries and the United States,'' said Fred Rossen, an analyst at the New York-based North American Congress on Latin America.\r\n\r\n<p><a href="http://www.topix.com/world/south-america/2008/06/paraguays-new-president-expected-to-be-moderate" title="Paraguay''s New President Expected To Be Moderate">Source: Topix</a></p>\r\n', 1, 4, 0, 14, '2008-06-22 08:31:17', 64, '', '2008-06-27 19:43:20', 62, 0, '0000-00-00 00:00:00', '2008-06-22 08:28:18', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 17, 0, 1, '', '', 0, 20, ''),
(107, 'EXCLUSIVE 7 nights Cyprus deal from £329', 'exclusive-7-nights-cyprus-deal-from', '', '<img src="images/stories/travel/deals/2.jpg" alt="EXCLUSIVE 7 nights 4* Cyprus deal from just £329" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nBook by 25th June\r\n<p>Spend 7 nights in Limassol, Cyprus for just £329 this July with half board accommodation ...</p>', 'at the 4* Ajax Hotel. Flights depart from&nbsp;Gatwick, Manchester, Luton and Belfast throughout&nbsp;July.\r\n<p>To get this exclusive £329pp price&nbsp;which is <strong>only available to travelsupermarket.com customers&nbsp;</strong>you need to travel&nbsp;on 2nd or 5th July 2008. Departures are also available on&nbsp;6th, 9th or 16th July 2008 for £349pp and departures from Belfast International are only&nbsp;available on&nbsp;18th July for £349pp.&nbsp;Half board accommodation is included but full board&nbsp;can be added for a supplement.</p>\r\n<p>The family-run Ajax Hotel was renovated in 2007 and is&nbsp;located in the heart of Limassol within easy reach of the beach and the town centre. The hotel has an excellent range of leisure facilities including an indoor swimming pool and outdoor whirlpool&nbsp;plus free use of the gym, sauna and tennis court. </p>\r\n<p>This deal can only be booked by calling <strong>0844 815 6550 </strong>and quoting BK but you can find out more about the hotel by clicking below. </p>\r\n<p><strong>Booking tip:</strong> The price you see on the Olympic website doesn''t include the&nbsp;exclusive travelsupermarket.com discount so make sure you quote reference BK when you phone to book.</p>\r\n\r\n<p><a href="http://www.travelsupermarket.com/c/top-deals/deals/180608-2/" title="EXCLUSIVE 7 nights 4* Cyprus deal from just £329pp">Source: TravelSupermarkts</a></p>', 1, 9, 0, 39, '2008-06-21 10:29:45', 63, '', '2008-06-28 20:59:05', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 8, 0, 4, '', '', 0, 7, 'robots=\nauthor='),
(118, 'Livebait - Manchester', 'livebait-manchester', '', '<img src="images/stories/travel/restaurants/2.jpg" alt="Livebait - Manchester" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nLivebait has got just the right stuff to lure hungry diners into its bright, friendly restaurant. The atmosphere is brasserie-ish...\r\n\r\n', ' in the sense that it''s informal and relaxed, but with witty conversation bouncing off the\r\nwhite-tiled walls it''s anything but  subdued. This particular branch is arranged over two floors, and it has the same high-quality super-fresh fish and shellfish that makes the food so memorable in other locations. The most popular dish is the Livebait Platter, a huge international grouping of Nova Scotia lobster, Dorset crab, Madagascan crevettes, Atlantic prawns and Indian Ocean crevettes that serves at.\r\n\r\n<p><a href="http://www.toptable.co.uk/venues/restaurants/?id=3147" title="Livebait - Manchester">Source: TopTable</a></p>', 1, 9, 0, 38, '2008-06-20 10:29:45', 63, '', '2008-06-23 13:42:33', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 4, '', '', 0, 1, ''),
(108, '7 nights 4* all-inclusive Majorca for just £341', '7-nights-4-all-inclusive-majorca-for-just', '', '<img src="images/stories/travel/deals/3.jpg" alt="7 nights 4* all-inclusive Majorca for just £341" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nFree suitcase with all bookings\r\n<p>Spend 7 nights in Majorca this summer for just £341 with this...</p>', ' great 4* all-inclusive deal.&nbsp;You even get a free suitcase&nbsp;to bring home all your shopping - just make sure you book before 27th June.</p>\r\n<p>Flights depart from airports nationwide between 1st July - 31st August and prices are based on two people sharing a twin room. Airport transfers aren''t included but can be bought separately when booking for £24pp.</p>\r\n<p>The 4* Ola Hotel Maioris is the ideal choice for anyone looking for a relaxing all inclusive holiday. Situated in peaceful gardens with an attractive and spacious pool terrace, the hotel offers the perfect retreat. </p>\r\n<p>There are plenty of amenities and facilities on offer including restaurants, bars, a swimming pool, tennis courts and gym to name just a few. There''s also a wide range of kids clubs and the entertainment team perform shows on a nightly basis making it ideal for couples and families alike.</p>\r\n<p>Here is&nbsp;just one example of when you can travel:</p>\r\n<ul>\r\n<li>Departing from Gatwick on Tuesday 1st July for 7 Nights all-inclusive for just £341.50pp based on 2 people sharing a twin room.</li></ul>\r\n<p>To book your stay on the BookMe2.co.uk website, select ''Beach Holidays'' in the box on the left,&nbsp;then ''Spain'', then choose ''Balearics - Majorca''. Next add in your chosen departure airport, the date you would like to travel, the number of nights you want to stay for, and how many are travelling. In the bottom box that asks for the hotel name, enter:&nbsp; Hotel Ola Maioris, and the search will take you to the hotel, once you have chosen your flight.<br /></p>\r\n<p></p>\r\n\r\n<p><a href="http://www.travelsupermarket.com/c/top-deals/deals/180608-7/" title="7 nights 4* all-inclusive Majorca for just £341pp">Source: TravelSupermarkets</a></p>', 1, 9, 0, 39, '2008-06-21 11:28:45', 63, '', '2008-06-28 20:59:20', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 8, 0, 3, '', '', 0, 9, 'robots=\nauthor='),
(115, 'Double HHonors Base points - Up Your Points in the English Uplands', 'double-hhonors-base-points-up-your-points-in-the-english-uplands', '', '<img src="images/stories/travel/hotels/1c.jpg" alt="Double HHonors Base points - Up Your Points in the English Uplands" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nOn your next visit to Northern England, why not enjoy double Hilton HHonors® Base points with your Yorkshire pudding?<p>Make the most of the weekend. Stay two nights or more at a choice of three Hilton hotels in Yorkshire before 5th September 2008, and you''ll earn double Hilton HHonors® Base points.<br /></p><p>Experience the excitement of Bradford, Leeds or Sheffield - three of England''s most vibrant cities. Then explore the picturesque rolling hills of the nearby Yorkshire Dales...<br /></p>', '<p>Indulge in a delicious dinner on your first night and start each morning with the famous Hilton Breakfast. Stays must be a minimum of two nights and include Friday and Saturday.<br /></p><p><b>Participating hotels</b>:<br />Hilton Bradford hotel<br />Hilton Leeds City hotel<br />Hilton Sheffield hotel<br /></p><p>To claim your double Hilton HHonors® Base points, don''t miss out - <b>book online now</b>!<br /></p>\r\n<p><a href="http://www.hilton.co.uk/dispatch?ShowOfferDetailsEvent=&amp;oid=12012507&amp;formName=ShowOfferDetailsForm" title="Double HHonors Base points - Up Your Points in the English Uplands">Source: Hilton International</a></p>\r\n\r\n', 1, 9, 0, 37, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:40:17', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 2, ''),
(116, 'Triple HHonors Points at the Niseko Village', 'triple-hhonors-points-at-the-niseko-village', '', '<img src="images/stories/travel/hotels/5.jpg" alt="Triple HHonors Points at the New Hilton Niseko Village" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nThe brand new Hilton Niseko Village opens its doors on 1st July 2008. To celebrate, we are offering you the chance to earn Base points...', '<p>In order to qualify, simply enjoy a stay with the Opening Triple Point plan in luxury and comfort. Hilton Niseko Village is set in a truly stunning location, at the foot of Mount Yotei, making it the perfect place for blissful relaxation.<br /></p><p>Whether youre playing golf on a choice of two 18-hole courses, soaking in a natural hot spring bath or indulging in teppanyaki in our stylish restaurant, youre sure to enjoy every second of your stay.<br /></p><p>*  Triple Base points means you will receive a bonus double the number of Base points earned during a stay. Bonus points earned on Base points do not count toward VIP tier qualification.<br /></p><p><b>Book online now</b>!<br /></p>\r\n\r\n<p><a href="http://www.hilton.co.uk/dispatch?ShowOfferDetailsEvent=&amp;oid=12022817&amp;formName=ShowOfferDetailsForm" title="Triple HHonors Points at the New Hilton Niseko Village">Source: Hilton International</a></p>', 1, 9, 0, 37, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:40:03', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 2, ''),
(109, 'Luxury North London hotel', 'luxury-north-london-hotel', '', '<img src="images/stories/travel/deals/4.jpg" alt="EXCLUSIVE luxury North London hotel - just £99 per room per night" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nAvailable until 2nd July\r\n<p>Make the most of this exclusive travelsupermarket .com offer...</p>', ' at the&nbsp;4* Hendon Hall Hotel in North London&nbsp;where you can stay&nbsp;for just £99 per room per night.\r\n<p>All bookings made before 2nd July also include a free room upgrade to ''Executive'' class, full traditional breakfast and 15% discount off hotel dining.</p>\r\n<p>Hendon Hall is a 16th Century mansion in North London and&nbsp;perfect for a relaxing break. Whilst secluded enough to enjoy a peaceful atmosphere you are also on the doorstep of Wembley Stadium and the West End.</p>\r\n<p>The luxurious rooms are all individual in character and tastefully decorated with modern comforts including satellite television, hairdryer, iron and tea/coffee making facilities. The hotel also has&nbsp;a restaurant,&nbsp;cocktail bar, WIFI internet access&nbsp;and landscaped gardens.</p>\r\n<p>Some of the dates when you can stay for £99 per room per night include 21st - 22nd June, 22nd - 23rd June or 28th - 29th June.</p>\r\n<p>To book, click ''Discover more about Hendon Hall Hotel'' on the Hand Picked Hotels website and then click ''Book Online'' and search for your dates.</p> \r\n\r\n<p><a href="http://www.travelsupermarket.com/c/top-deals/deals/180608-8/" title="EXCLUSIVE luxury North London hotel - just £99 per room per night">Source: TravelSupermarkets</a></p>', 1, 9, 0, 39, '2008-06-23 09:29:45', 63, '', '2008-06-23 14:43:01', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 2, '', '', 0, 11, ''),
(112, 'Hilton Weekly Specials in the UK', 'hilton-weekly-specials-in-the-uk', '', '<img src="images/stories/travel/hotels/1.jpg" alt="Hilton Weekly Specials in the UK" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nIf you''re looking for somewhere to get away this weekend, new Hilton Weekly Specials offer fantastic last minute rates at selected hotels...', 'Our offers in the UK and Ireland are below, for offers in Europe, <a href="http://www.hilton.co.uk/dispatch?ShowOfferDetailsEvent=&amp;oid=11752959&amp;formName=ShowOfferDetailsForm"> click here</a>.<br /><br />To book, simply choose your hotel from the options below to get the best available rate. The rates shown are for our Hilton Value room only rate, but you can also choose a bed &amp; breakfast, dinner bed &amp; breakfast rate or one of our fully flexible rates. By clicking the "book" button, all available rates will be displayed. <br /><br />Be sure to keep checking the website for new deals as they change each week. You can also receive these offers by email, <a href="http://www.hilton.co.uk/dispatch/NewsLetterForm?OfferNewsletterEvent=&amp;formName=NewsLetterForm&amp;">subscribe now</a>.<br /></p>\r\n\r\n<p><a href="http://www.hilton.co.uk/dispatch?ShowOfferDetailsEvent=&amp;oid=11752958&amp;formName=ShowOfferDetailsForm" title="Hilton Weekly Specials in the UK">Source: Hilton International</a></p>', 1, 9, 0, 37, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:39:54', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 2, ''),
(110, '10% off worldwide car hire', '10-off-worldwide-car-hire', '', '<img src="images/stories/travel/deals/5.jpg" alt="10% off worldwide car hire" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n	            \r\nBook before 30th June\r\n<p>Get 10% off worldwide car hire with easyCar.com''s June sale. Pick-up points are available...</p>', 'in over 60 countries and the discount applies to all bookings made until 1st October.\r\n<p>Some of their best deals include Malaga for just £10&nbsp;per day between 1st - 8th July, Washington State for £14 per day between 8th - 15th July&nbsp;and Rome for £18 per day between 22nd - 29th July.</p>\r\n<p>easyCar.com have a&nbsp;huge range of cars&nbsp;from super-mini run-arounds to the more luxurious premium models and everything in between. Just make sure you book before 30th June for the 10% discount.</p>                 	\r\n\r\n<p><a href="http://www.travelsupermarket.com/c/top-deals/deals/180608-9/" title="10% off worldwide car hire">Source: TravelSupermarkts</a></p>', 1, 9, 0, 39, '2008-06-23 09:29:45', 63, '', '2008-06-23 14:42:39', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 7, 0, 1, '', '', 0, 10, ''),
(113, 'Hilton Weekly Specials in Europe and beyond', 'hilton-weekly-specials-in-europe-and-beyond', '', '<img src="images/stories/travel/hotels/2.jpg" alt="Hilton Weekly Specials in Europe &amp; beyond" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nIf you''re looking for somewhere to get away this weekend, new Hilton Weekly Specials brings you fantastic last minute rates at selected hotels...', 'Our European deals are below, for UK offers, <a href="http://www.hilton.co.uk/dispatch?ShowOfferDetailsEvent=&amp;oid=11752958&amp;formName=ShowOfferDetailsForm"> click here</a>.</p><p>To book, simply choose your hotel from the options below to get the best available rate. The rates shown are for our Hilton Value room only rate, but you can also choose a bed &amp; breakfast, dinner bed &amp; breakfast rate or one of our fully flexible rates. By clicking the "book" button, all available rates will be displayed. </p><p>Be sure to keep checking the website for new deals as they change each week. You can also receive these offers by email, <a href="http://www.hilton.co.uk/dispatch/NewsLetterForm?OfferNewsletterEvent=&amp;formName=NewsLetterForm&amp;">subscribe now</a>.<br /></p>\r\n\r\n<p><a href="http://www.hilton.co.uk/dispatch?ShowOfferDetailsEvent=&amp;oid=11752959&amp;formName=ShowOfferDetailsForm" title="Hilton Weekly Specials in Europe &amp; beyond">Source: Hilton International</a></p>', 1, 9, 0, 37, '2008-06-21 10:29:45', 63, '', '2008-06-26 16:14:59', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 9, 0, 4, '', '', 0, 2, ''),
(117, 'City Cafe - Manchester', 'city-cafe-manchester', '', '<img src="images/stories/travel/restaurants/1.jpg" alt="City Cafe - Manchester" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nCity Café restaurant in the heart of Manchester has landed  a sleek and stylish eaterie in the award-winning City Inn in landmark...', 'Piccadilly Place.  The cool dining room in shades of fresh mushroom features luxurious fittings, white table linens and a lively ambience perfect for business or romance.  City Cafés terrace is the only place to be in sunny weather.  Innovative Head Chef David Gale brings experience of the New York Soho House and Asia de Cuba.  He uses fresh local produce to create the modern European a la carte and veggie a la carte menus, but Gale really shows his stuff in the twice-weekly changing Kitchen.\r\n\r\n<p><a href="http://www.toptable.co.uk/venues/restaurants/?id=4468" title="City Cafe - Manchester ">Source: TopTable</a></p>', 1, 9, 0, 38, '2008-06-20 10:29:45', 63, '', '2008-06-23 13:42:41', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 5, '', '', 0, 1, ''),
(114, 'Hilton Plus One - 5 nights for price of 4', 'hilton-plus-one-5-nights-for-price-of-4', '', '<img src="images/stories/travel/hotels/3.jpg" alt="Hilton Plus One - 5 nights for price of 4" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nExplore the Globe - get a free night in luxury!.Book an escape to any of Hilton''s hotels in Egypt, Arabian Peninsula, Indian Ocean and Africa...', '<p>Simply book a five night stay with breakfast at participating Hilton hotels, <b>and youll only pay for four nights</b>. So whether you''re looking for adventure or relaxation, booking your dream holiday couldn''t be easier!</p><p>Whats more, HHonors members will earn 1,000 HHonors bonus points and 1,000 bonus miles per stay when you book online. Not a member? <a href="https://www.hilton.co.uk/AboutHHonors/710_BecomeAMemberOfHHonors.jsp?&amp;secureSubmit&amp;">Enrol now</a>!</p><p>Hilton HHonors® offers Points &amp; Miles® and No Blackout Dates. HHonors remains the only hotel loyalty program that offers guests the opportunity to earn points and airline miles at the same time. <b>Book online now</b>!<br /></p>\r\n\r\n\r\n<p><a href="http://www.hilton.co.uk/dispatch?ShowOfferDetailsEvent=&amp;oid=12010824&amp;formName=ShowOfferDetailsForm" title="Hilton Plus One - 5 nights for price of 4">Source: Hilton International</a></p>', 1, 9, 0, 37, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:40:26', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 3, '', '', 0, 1, ''),
(123, 'Days to 280 to 284, Two Wee Devils in the City of Angels...', 'days-to-280-to-284-two-wee-devils-in-the-city-of-angels', '', '<img src="images/stories/travel/blogs/1c.jpg" alt="Days to 280 to 284, Two Wee Devils in the City of Angels..." width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nLos Angeles, the City of Angels has been fabulous. We have squeezed so much into our five days, this entry covers the first four. Our drive back from Vegas took us through the Mohabe desert. We started the road trip with the hood down, but we had to pull over to put it up and put the air con on, as the temperature was over 110F. Phew, now that is hot!\r\n\r\n<p>LA conjures up images of Hollywood and the rich and famous. We had made a list of things that we wanted to do and started off our sightseeing with a guided tour of the stars homes...</p>', '<p>Hollywood Blvd is the home of the walk of fame, this is a collection of over two thousand stars set into the pavement with the name of a person who has made what is considered a great contribution to the arts. They are separated into five categories, film, television, music recording, radio broadcasting and the theatre. It was interesting to learn that the stars have to pay $7500 for their own star and only one has ever been refused. The walk has spaces for new stars and these are spread out over the route so as all the newbies arent located in the same place! It is a little surreal walking the Hollywood walk of fame, we felt as though we were part of a movie. In fact most places in Hollywood tend to make you feel like this. We took loads of pictures of the stars, but these dont really translate into interesting material for our blog, so weve only included one to give you an idea, Walt Disney!.</p>\r\n\r\n\r\n<p>One of the points of interest on the tour was the Comedy store, starting place for many comedians including Eddie Murphy, Richard Prior, David Letterman, Rosanne Barr amongst many, many others. We decided to see a show that night. The sets were 15 to 20 minutes for each comedian and 7 out of the 8 comedians were really funny. The other was useless!!! There were various themes to the comedy including the upcoming Presidential election &amp; the Rodney King riotssee, comedy can be educational too! We did laugh a lot and really enjoyed out impromptu night at a West Hollywood icon.</p>\r\n\r\n<p><a href="http://www.travelblog.org/North-America/United-States/California/Los-Angeles/blog-288505.html" title="Days to 280 to 284, Two Wee Devils in the City of Angels...">Source: TravelBlog</a></p>', 1, 9, 0, 40, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:39:30', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 4, '', '', 0, 3, ''),
(120, 'The Grill on the Alley', 'the-grill-on-the-alley', '', '<img src="images/stories/travel/restaurants/4.jpg" alt="The Grill on the Alley" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nLocated off iconic Deansgate in Manchester, The Grill on the Alley is a classic steak and seafood restaurant bringing together...\r\n\r\n', 'contemporary décor with a traditional, yet innovative, menu. The cavernous interior is always buzzing with a stylish crowd, and the restaurant is popular for working lunches, dates, group celebrations and parties. Famous for its premium, aged organic steaks, grilled seafood and hearty traditional fare, favourite beasty-based dishes at The Grill include the clam and sweetcorn chowder; Kobe beef fillet; whole grilled lobster with fresh chips; and succulent Irish rock oysters. The Grill on the Alley.\r\n\r\n<p><a href="http://www.toptable.co.uk/venues/restaurants/?id=7307" title="The Grill on the Alley">Source: TopTable</a></p>', 1, 9, 0, 38, '2008-06-20 10:29:45', 63, '', '2008-06-23 13:42:46', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 2, '', '', 0, 1, ''),
(121, 'Podium Restaurant Bar', 'podium-restaurant-bar', '', '<img src="images/stories/travel/restaurants/5.jpg" alt="Podium Restaurant Bar &amp; Lounge" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nLocated in Manchester''s landmark hotel in the city centre, the Hilton Manchester Deansgate,  this cosmopolitan...', ' restaurant is an institution on the local dining scene. The Podium Restaurant, Bar and Lounge  with its discreet banquette seating, dim lighting and crisp linen tablecloths  has a sexy, old-school New York vibe and is an impressive setting for any occasion. The restaurant serves everything from smoothies and full English breakfasts with Bury black pudding, to a sophisticated international menu with local influences in the evening  our favourite dish being Podium''s signature Malaysian king prawn curry.\r\n\r\n<p><a href="http://www.toptable.co.uk/venues/restaurants/?id=7301" title="Podium Restaurant Bar &amp; Lounge">Source: TopTable</a></p>\r\n', 1, 9, 0, 38, '2008-06-20 10:29:45', 63, '', '2008-06-23 13:42:53', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 1, ''),
(124, 'I Love a Sunburnt Country', 'i-love-a-sunburnt-country', '', '<img src="images/stories/travel/blogs/3.jpg" alt="I Love a Sunburnt Country" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nWell, we have sent you all our blogs from all of our travels and I thought we may as well do one to update all the friends and fam now...', ' that we are pretty well settled into life back in Oz. After seeing so many beautiful places on earth you kind of forget or never get around to taking pictures of your own home. We wanted to share some with you.\r\n\r\n<p>It hasn''t been the easiest of roads coming home but we have done well to tackle all the obstacles come our way so far and I think we''ve done the hard yards already anyway - travelling and living in each others pockets for so long with no escape from each other!!\r\nSam was lucky to have found work pretty much straight away at a well known bathroom company on the coast, but it took me a little longer to land a job as admin/reception work is around but many people want to do it. In the end it came down to who I knew and I landed work at a Real Estate Agency. Both of us are at the bottom of our companies but its all good, can only</p>\r\n\r\n\r\n<p>We managed to get a fairly cheap little duplex to live in not far from the centre of town in Maroochydore, its peaceful and convenient and a good place to get back on our feet. We are around the corner from my highschool and on a sunday we try to get down to the sports oval and hit golf balls, We have both become pretty stoked on golf, we have our own clubs and try to get about having a whack on 9 holes whenever the weather is good.</p>\r\n<p>We enjoyed a very festive Australia Day back in February out at my good friend''s parents farm. Huddo owns a few acres which were put to good use with a bit of golf and backyard cricket. Sam and I were amongst the last few still standing at 3 in the morning taking control of the karaoke machine - good times!!\r\nAs my brother has quite a few racehorses too, we hit the local track up at Gympie (no - people don''t walk around in leather outfits) a few times for a day out at the races, country style complete with a dirt race track and quite.</p>\r\n\r\n<p>Sam has struggled the most adjusting to coast life - allthougth the beaches are beautiful and a plenty, the public transport system is unfortunately nowhere near on par with old London town and if you live in Oz - you must drive. We bought a little Ford Festiva off a friend and I set off to teach Sam how to drive (as a Londoner there is no need for a license) I can''t believe we didn''t kill each other, they say couples should never give each other driving lessons but no fights yet funny enough - he puts up with my bossiness behind the wheel!!</p>\r\n\r\n<p>After seeing so many national sports in our travels I felt bad for not have even seeing a game of AFL live in my own country. Sam was missing the footy back home and lucky for us a friend has season tickets to the Gabba to watch the Lions so we tagged along to watch them slaughter the Saints by 80 points. I hate to say it being an Aussie girl\r\n</p>\r\n\r\n\r\n<p><a href="http://www.travelblog.org/Oceania/Australia/blog-281975.html" title="I Love a Sunburnt Country">Source: TravelBlogs</a></p>', 1, 9, 0, 40, '2008-06-21 10:29:45', 63, '', '2008-06-23 13:14:28', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 3, 0, 3, '', '', 0, 2, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(122, 'Tales from the Pacific', 'tales-from-the-pacific', '', '<img src="images/stories/travel/blogs/1.jpg" alt="Tales from the South Pacific" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nLife goal #132: Learn to shake my hips as swiftly and rhythmically as the dancing ladies on the Cook Islands. (This ambition comes right...', '\r\n<p>Either the Captain had too much to drink or he blinked for a moment too long\r\nand greetings with kisses on the cheek (although to this day I''m still not sure if you''re suppose to air kiss on either side of the face or really kiss each cheek), we departed Tubuai and set sail for Captain Cooks historical landing. Good wind and smooth sailing past uninhabited Maria Island with only seven days at sea and one day of sea sickness. I''m getting better at this! Perhaps I''m cut out for life at sea after all!\r\n</p>\r\n<p>Rarotonga is beautiful from afar and grew even more breathtaking as we sailed closer and closer. Pity we couldn''t start exploring immediately. After arriving in a new port, we are not allowed off the boat until our yellow quarantine flag is taken down by Health and Immigration. No Sir. No matter how much our feet are itching to run and explore dry land ( or how much we really, really want to use a clean, non-marine toilet), we are left to twiddle our thumbs and stare at one another until we are officially cleared. Some islands are quick and efficient and these are the best. Others.....we wind up waiting an entire afternoon for officials to arrive and check our passports and boat registration. These are usually the same officials that a take our entire stock of perishables for safety reasons. It is well known to eat all the cucumbers, onions and apples on the boat before arriving in port. In explanation for walking off with our fruits and vegetables, they claim to be preserving their sacred ecosystem. True, yes, but I think these yummy perishables actually wind up on the dinner table instead of the incinerator.</p>\r\n\r\n<p>Luckily the Raro customs was friendly and speedy. They arrived handsomely dressed and took of their leather loafers before climbing onboard to firmly grip our hands and welcome us to their island. Before long, they were offering local advice and inviting us to the island dance show later in the week. (The Health Officer was also the MC of the show as everyone is multi-talented and holds down two or three jobs on the island.) We found out later that the choreographer of the dance show also owned Raros popular Whatever Bar!!</p>\r\n\r\n<p><a href="http://www.travelblog.org/Oceania/Cook-Islands/Palmerston/blog-273970.html" title="Tales from the South Pacific">Source: TravelBlog</a></p>', 1, 9, 0, 40, '2008-06-21 10:29:45', 63, '', '2008-06-23 13:14:27', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 3, ''),
(125, 'Back in the North', 'back-in-the-north', '', '<img src="images/stories/travel/blogs/4.jpg" alt="Back in the northern hemisphere" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\n<strong>The dry season arrives</strong><br />\r\nI''ve complained in previous Ecuador blogs about how bad the weather has been, but on 1st June, almost like clockwork...', '\r\n<p>This was excellent timing as we had chosen that day for our first summit attempt in Ecuador. We found ourselves in the market town of Otavalo, a couple of hundred kilometres north of Quito, and together with Trudy from Australia and Denis, our guide, originally from Ohio, but now living in Otavalo, we attempted to climb Fuya-Fuya, a 4365 metre volcano just south of town, overlooking the impressive Laguna Mojando.</p>\r\n\r\n<p>There is no public transport to the laguna, hence our need for a guide. He charged us a very reasonable 10 dollars each (other agencies in town charge at least 25), and picked us up from our hostel at 9am. While 4365 metres is a fairly high altitude (and in our top 10 highest summits), the walk up was mostly straightforward and we reached the first summit after 1.5 hours. From here there were good views of the laguna, of the other volcanoes nearby, and even of Quito, far away in the distance.</p>\r\n\r\n<p>Getting to the second and higher summit was a little more tricky, involving some scrambling and rock climbing on exposed parts of the rock face. We had no ropes or anything so one slip could have been, well, fatal. Denis and I went on to this summit, but the views weren''t so good here as the clouds had returned. In Quechua, Fuya-Fuya means, appropriately, Cloudy-Cloudy! All in all it was a good morning''s hiking, with enough scary moments near the top to make it memorable.</p>\r\n\r\n\r\n<p><a href="http://www.travelblog.org/South-America/Ecuador/Otavalo/blog-282291.html" title="Back in the northern hemisphere">Source: TravelBlog</a></p>\r\n\r\n', 1, 9, 0, 40, '2008-06-21 10:29:45', 63, '', '2008-06-23 13:16:38', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 2, ''),
(126, 'A Year at Pauatahanui Inlet', 'a-year-at-pauatahanui-inlet', '', '<img src="images/stories/travel/blogs/5.jpg" alt="A Year at Pauatahanui Inlet" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nLiving around the Pauatahanui Inlet for a year was amazing. It is such a beautiful place, whether enshrouded in mist...\r\n\r\n', '<p>The weekly Rotary meetings I attended were at the Paremata Boat Club, so I got to watch the last light of day on the Inlet once a week.</p>\r\n\r\n<p>I was lucky enough to go out on the water one Sunday during the Regatta, not on a sailboat but on one of the zodiacs that ''patrols'' during the regatta.</p>\r\n\r\n<p>I got a sunburn after spending one sunny spring afternoon wading in Brown''s Bay with some friends from school.</p>\r\n\r\n<p>I spent one unlucky day studying crabs on the mudflats for a biology class--unlucky because it poured with rain, and all of my observations were washed right off the page, and I had nothing to turn in. My classmates and I were soaked to the skin, and it took a lot</p>\r\n<p>The water was like glass on the day I left New Zealand\r\nof convincing to get our teachers to let us go straight home to dry off and warm up, instead of back to school.</p>\r\n\r\n<p>On my last morning in New Zealand, the inlet was like glass, reflecting a blue sky and fluffy clouds. It was so beautiful, and rather fitting, because I was doing a lot of reflecting myself that morning.</p>\r\n\r\n<p><a href="http://www.travelblog.org/Oceania/New-Zealand/North-Island/Wellington-Region/Porirua/blog-286178.html" title="A Year at Pauatahanui Inlet ">Source: TravelBlog</a></p>', 1, 9, 0, 40, '2008-06-21 10:29:45', 63, '', '2008-06-23 13:16:40', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 3, 0, 1, '', '', 0, 3, ''),
(127, 'US lawmakers pass wiretaps bill', 'us-lawmakers-pass-wiretaps-bill', '', '<img src="images/stories/world/n-america/1c.jpg" alt="US lawmakers pass wiretaps bill" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\nUS lawmakers have passed a bill to shield telephone companies who helped in the White House''s controversial warrantless wiretaps programme.\r\n<p>\r\nThe bill also grants the US government the power to continue with its warrantless surveillance scheme. \r\n</p><p>\r\nThe Bush administration faced criticism when details emerged of its programme to monitor the phone calls of foreign targets in the US without warrants. \r\n</p><p>\r\nPresident Bush said the scheme was needed to prevent attacks on the US.\r\n</p>', '<p>\r\nTelephone companies were facing as many as 40 lawsuits for their involvement in the scheme. \r\n</p><p>\r\n<b>Sticking point</b>\r\n</p><p>\r\nThe bill was passed in the House of Representatives with bipartisan support, after House Democrats reached a compromise with the Republicans over the provisions to grant telecommunications companies immunity from prosecution.\r\n</p>			\r\n<p>\r\nPrevious attempts to pass the bill - and allow the warrantless wiretap scheme to continue - had foundered on the issue of immunity for telecom firms.\r\n</p><p>\r\nDemocrats had been reluctant to grant the firms immunity, saying the courts should first determine what the companies did.\r\n</p><p>\r\nPresident Bush - backed by Republicans in Congress - wanted to ensure that firms which had helped his administration would not be liable for prosecution.\r\n</p><p>\r\nThe two sides reached a compromise, whereby telephone companies would not be automatically immune, but courts would be obliged to dismiss a suit against a firm if it is able to produce written certification that the White House asked it to participate in the program and assured the firm it was legal.\r\n</p><p>\r\nThe bill is expected to pass the other house of Congress - the Senate - without any difficulties and will shortly become law.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/americas/7466544.stm" title="US lawmakers pass wiretaps bill ">Source: BBC</a></p>', 1, 4, 0, 13, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:16:25', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 5, '', '', 0, 2, ''),
(128, 'US fears of teen ''pregnancy pact''', 'us-fears-of-teen-pregnancy-pact', '', '<img src="images/stories/world/n-america/2.jpg" alt="US fears of teen ''pregnancy pact''" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nOfficials in the US state of Massachusetts are investigating how 17 teenage girls from the same school have become pregnant.\r\n\r\nThe number is four ', 'times as high as the year before at Gloucester High School.\r\n<p>\r\nThere are reports that some of the girls - none of whom is older than 16 - entered into a pact to have their babies together. \r\n</p><p>\r\nThe girls and their families have so far made no comment. Officials are also investigating the ages of the fathers.\r\n<!-- E SF -->\r\n</p><p>\r\nSome are believed to be in their twenties and could face the possibility of being charged with having sex with minors.\r\n</p><p>\r\nIt is illegal to have sex with anyone younger than 16 in Massachusetts.\r\n</p><p>\r\n<b>Disturbing</b>\r\n</p><p>\r\nSome of the school''s own staff believe the sharp increase in the number of pregnancies was no accident.\r\n</p>\r\n<p>\r\n"Some girls seemed more upset when they weren''t pregnant than when they were," Gloucester High School principal Joseph Sullivan told Time magazine.\r\n</p><p>\r\nLocal officials say that nearly half of the girls had entered into a bizarre pact to have their babies together. \r\n</p><p>\r\nDr Elizabeth Guthrie, a paediatric psychiatrist at New York''s Columbia University, told the BBC that some girls might be viewing pregnancy as a fast-track to adulthood and independence.\r\n</p><p>\r\n"It may give you an opportunity for unconditional love and attention from the baby," she said.\r\n</p><p>\r\nLocal teenager Amanda Ireland, a mother who has just graduated from Gloucester High School, offered a blunt warning to other girls.\r\n</p>\r\n<p>\r\n"Don''t try to get pregnant. People say they know what it''s like because they have younger siblings, but they really have no idea," she told the BBC.\r\n</p><p>\r\nDavid Landry, a researcher at the Guttmacher Institute, a New York-based non-profit group focusing on reproductive issues, said the declining teenage pregnancy rate of recent years appeared to be reversing.\r\n</p><p>\r\nBirth rates for girls aged 15 to 17 rose by 3% in 2006, the first increase since 1991, according to preliminary data released in December by the National Center for Health Statistics.\r\n</p><p>\r\nThis trend was highlighted on Thursday when Britney Spears'' 17-year-old sister Jamie Lynn, star of a popular television show Zoey 101, gave birth to a baby girl, according to People magazine.\r\n</p><p>\r\nBut Mr Landry cautioned against attributing the pact or the worrying statistics to Hollywood. Recent hits have included Juno, in which a teenager gets pregnant and decides to have the baby, and Knocked Up, a comedy about a one-night stand.\r\n</p><p>\r\n"The trend emerged before those movies," he said.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/americas/7464925.stm" title="US fears of teen ''pregnancy pact''">Source: BBC</a></p>\r\n', 1, 4, 0, 13, '2008-06-21 10:29:45', 63, '', '2008-06-22 16:47:31', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 4, '', '', 0, 2, ''),
(129, 'US judge issues 50 Cent gun ban', 'us-judge-issues-50-cent-gun-ban', '', '<img src="images/stories/world/n-america/3.jpg" alt="US judge issues 50 Cent gun ban" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nRapper 50 Cent has been told by a New York judge to surrender any guns he might have after an ex-girlfriend obtained a restraining order.\r\n\r\nThe order bars the performer, ', 'whose real name is Curtis Jackson, from contacting Shaniqua Tompkins without the court''s permission. \r\n<p>Ms Tompkins is the mother of Mr Jackson''s 10-year-old son. \r\n</p><p>Mr Jackson''s lawyer, Brett Kimmel, said he would contest the order. "To my knowledge, he has no guns," he said. \r\n</p><p>Ms Tompkins has been involved legal row with Mr Jackson over money. She claims she is entitled to half of his estate, based on an oral agreement. \r\n</p><p>Last month a fire destroyed the rapper''s home in Long Island, where Ms Tompkins lived with their son. Police said they were treating the fire as suspicious. \r\n</p><p>Mr Jackson, who also owns a record label as well as clothing and footwear lines, has denied any involvement in the fire. \r\n</p><p>Separately on Friday, he filed a $20m (£10m) defamation lawsuit against Ms Tomkins for statements she made to the media. \r\n</p><p>"It''s completely baseless and it''s retaliatory," Ms Tompkins'' lawyer, Paul Catsandonis, said of the defamation action, which was filed in Mr Jackson''s home state of Connecticut. \r\n</p><p>"It''s nothing more than an attempt to rehabilitate his image." \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/entertainment/7467298.stm" title="US judge issues 50 Cent gun ban">Source: BBC</a></p>', 1, 4, 0, 13, '2008-06-21 10:29:45', 63, '', '2008-06-22 16:45:39', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 3, 0, 3, '', '', 0, 1, ''),
(130, 'What the UK can teach US cities', 'what-the-uk-can-teach-us-cities', '', '<img src="images/stories/world/n-america/4.jpg" alt="What the UK can teach US cities" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nThe British have long looked to US cities for inspiration. Now Americans are starting to seek UK solutions to their urban problems, says Dermot Finch of the Centre for Cities.\r\n', '<p>\r\nGleaming skyscrapers, the land of opportunity, pursuit of the American Dream - many admire major cities in the United States and their dash of extra polish. In 2006 alone, more than 30,000 Brits left to try their luck Stateside.  \r\n</p><p>\r\nLeading Labour and Conservative figures regularly look to the likes of New York and Chicago to fix urban problems back home. The Tories'' new welfare to work proposals were modelled on existing schemes in New York and Wisconsin. And John Prescott and David Miliband both made ministerial study tours of the US a top priority. \r\n</p><p>\r\nBut the reality behind the shining urban bastions of the American dream isn''t always so rosy. When it comes to preventing urban sprawl and tackling congestion, UK cities are actually further ahead.  \r\n</p><p>\r\nSo what can UK cities - which have benefited from a decade of strong economic growth - teach their Atlantic neighbours?\r\n</p><p>\r\n	</p><b>TACKLE GRIDLOCK</b>\r\n<p>\r\nSince Ken Livingstone, the previous mayor of London, brought in the congestion charge in 2003 (amidst a barrage of criticism and only reluctant support from the government), the volume of traffic entering the congestion charge zone has fallen by over a fifth - with bus use increasing by 15%. Meanwhile the £125m extra cash generated by the charge (after its upkeep costs) goes straight back into public transport.</p>\r\n<p>\r\nThis week the Department for Transport announced its support of Manchester''s own charge proposals - although until more of its critics are won over, the future of the charge continues to hang in the balance. \r\n</p><p>\r\nMiami, Minneapolis, Seattle and San Francisco are also currently looking to London''s congestion charge to solve their traffic problems. The charge in London has its critics, particularly concerning the charge amount and the western extension, and there are still problems with congestion caused by road works in parts of the capital. But the fact that the charge survived the change in mayoralty is testimony to its success - and the likes of Seattle and San Francisco could learn from the scheme''s successes and limitations. \r\n</p><p>\r\n    \r\n	</p><b>KEEP TOWN AND CITY CENTRES ALIVE</b>\r\n<p>\r\nIn 1996, the Conservative government took action to stop UK city and town centres and their High Streets turning into ghost towns. </p>\r\n<p>\r\nWhilst not everyone supports recent city centre redevelopments, by putting town centres first in the planning rules, successive governments have reduced the number of car-dependent shopping centres being built - and encouraged more shops and offices into city centres. \r\n</p><p>\r\nAs a result, total retail floor space in UK town and city centres increased from 25% in the mid 1990s to 34% in 2003/2004.\r\n</p><p>    \r\n	</p><b>HOW TO BEAT SUBURBAN SPRAWL</b>\r\n<p>\r\nThe Labour Government went on to take further steps to stop UK cities and towns sprawling like their American equivalents. Atlanta and Los Angeles have become known for the segregated neighbourhoods, lengthy commutes and gridlock that resulted from suburban sprawl. </p>\r\n<p>\r\nReusing urban land where possible, rather than building on Greenfield sites, has helped cities like Leeds and Bristol to avoid far-flung car-dependent suburbs proliferating. In 2000 the Government introduced a housing density target for new housing developments of 30-50 homes a hectare - where it''s appropriate to do so. By 2006, new homes were being built at an average density of 40 a hectare. \r\n</p><p>\r\nThe British experience suggests that American cities would benefit from a strong steer from the federal government to make neighbourhoods denser and less dependent on private transport.  \r\n</p>\r\n<p>\r\nThe decline of British industry after World War II saw UK cities and towns riddled with social and economic deprivation, and largely neglected by central government.   </p>\r\n<p>\r\nIn recent years - starting with Michael Heseltine''s city development initiatives under the Conservative government of the 1980s, UK cities have basked in the attention of senior ministers. Tony Blair''s Social Exclusion Unit, Gordon Brown''s target to reduce child poverty and John Prescott''s expert Urban Task Force attest to a concentrated effort to help cities improve after a lengthy period of economic and industrial decline. \r\n</p><p>\r\nEx-industrial cities like Leeds and Sheffield have seen jobs growth of 15% and 25% respectively in a single decade. Who would have thought 10 years ago that Liverpool, the European Capital of Culture, would be welcoming its two millionth visitor so far this year? That Gateshead would be hosting the Conservative Party''s 2008 spring conference?  \r\n</p><p>\r\nThere has been no equivalent high-profile championing of urban development and regeneration by the US government in recent years - American cities have been missing out.</p>\r\n<p>\r\nOf course, we can and should continue to learn from US cities. For one, US city mayors have more control over their own finances - meaning that they can innovate more and grow their economies as a result. Only 5% of all tax revenues are raised by local councils in England, compared to 41% in the US. \r\n</p><p>\r\nPolicy learning can go both ways. A recent visit to London''s new mayor by Michael Bloomberg, the mayor of New York, and the promise to exchange expertise and personnel on London transport and crime reduction in the Bronx could signal an end to this one-way traffic.  \r\n</p><p>\r\nBritish ministers have for too long gone cap in hand to the US for ideas on how to improve our cities. With cities and towns on both sides of the Atlantic now facing tougher economic times, isn''t it time for our two nations'' cities to share the best of both? As the US political parties gear up for the Democratic Convention in Denver and the Republican Convention in St Paul, Minnesota, the question is more relevant than ever.\r\n</p><p>\r\n<b>Dermot Finch is the director of the think-tank Centre for Cities.</b>\r\n</p>\r\n<p>\r\n<b>Send us your comments using the form below.</b>\r\n</p><p>\r\nBeing a native Bostonian I have witnessed first hand the before and after of the "Big Dig,"  a 10-plus year construction project on the entire city. On the whole its greener and cleaner, which reminds me of the UK and the rest of Europe. But still there are problems with traffic due to the spread of suburbs and lack of efficient public transportation. In that area, Europe has it all over us. But the comment on how mayors have more control of their economies is a little too rosy. The tax money is not allocated efficiently to make our towns and cities better places because funds are strained as it is. In most towns the money is put into "more needed" areas of the budget.<br /><b>Lia , Boston Ma US</b>\r\n</p><p>\r\nTackling gridlock in a sprawling city such as Los Angeles requires greater ambitions than simply charging for entry to a city center. LA has no city centre and is already so infected with sprawl that any treatment to this disease will have to be very dramatic. For those of us who live here, change such as those mentioned in the article needs to be made by courageous public officials, willing populace, and supportive corporate interests.  I''m not holding my breath.<br /><b>Hoot, Los Angeles, CA</b>\r\n</p><p>\r\nIs this for real? I used to live in Seattle. I-5 is a main interstate that runs right though the city. We have nothing like that in the UK. It seems the only think the US is taking from us are the scam-the-motorist policies. As for housing density, all forms of violent crime (per capita) increase with housing density. A detached house with a bit of grass round it is far nicer and stops people getting in each others face all the time. Like many of the world''s problem, it is overpopulation that is the real root cause.\r\n<br /><b>Simon Ward, Watford, UK</b>\r\n</p><p>\r\nThe majority of your comment seems to relate to cars and pricing cars out of affordability and cramming more people into ever smaller boxes. I''ll bet none of the decision makers want to live in them.<br /><b>Jim, Herts</b>\r\n</p><p>\r\nWhile several British cities have made innovative changes to improve life, London''s congestion charge, the majority are examples of how not to carry out urban development. Housing density is higher in the UK because of land prices, developers have to get as many properties onto a site to make building commercially viable. Many US cities have better public transport systems than UK ones, subsidy, integration, cleanliness and reliability. Granted, US city traffic is still generally bad. I am sure other readers can think of many other instances of why US cities should not apply British ideas. Personally, I think they would be better off looking at German, Dutch, French or Spanish cities for inspiration.<br /><b>Kenny Boy, Edinburgh, Scotland</b>\r\n</p><p>\r\nHorses for courses. Each city is a unique combination of geography, communications and cultures which may not work elsewhere. London''s first congestion zone had an almost-natural boundary in the Ring Road AND a unitary authority covering highways and transport. Shouldn''t stop people trying as long as they don''t just copy...<br /><b>Joel Kosminsky, London</b>\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/magazine/7452723.stm" title="What the UK can teach US cities">Source: BBC</a></p>', 1, 4, 0, 13, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:16:43', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 2, '', '', 0, 2, ''),
(131, 'Washington diary: Only in Britain', 'washington-diary-only-in-britain', '', '<img src="images/stories/world/n-america/5.jpg" alt="Washington diary: Only in Britain" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nA leader so unpopular that no candidate from his party wants to have his scent on the campaign trail. \r\n<p>Rumours of regicide. \r\n</p>', '<p>The sound of daggers being sharpened. \r\n</p>\r\n<p>Demands for change rumbling the political foundations. \r\n</p><p>Sounds familiar? \r\n</p><p>Of course it does. \r\n</p><p>But I am not talking about the dying days of George W Bush, one of whose erstwhile and most loyal retainers - former press spokesman Scott McClellan - has now dished the dirt on his former boss, adding to an already impressive catalogue of woes. \r\n</p><p>No. I am talking about Britain, where I have just spent a week being ushered from literary festival to bookshop promoting my book on the US, Only in America. \r\n</p><p>But during last week''s odyssey round the United Kingdom, the phrase "Only in Britain" kept coming to mind. \r\n</p><p><b>Knifed in the back</b>\r\n</p><p>What a week it was! \r\n</p><p>The by-election in Crewe handed the opposition Tories a stunning victory and prised open the floodgates against Prime Minister Gordon Brown. \r\n</p>\r\n<p>Will this be remembered as the key milestone on the road to defeat after more than a decade of Labour power? \r\n</p><p>The question aired in varying degrees of bold print in the newspapers is not whether Gordon will go - but when. \r\n</p><p>The cabinet has rallied to his defence with the conviction of rodents on a sinking ship. \r\n</p><p>With every shrill protestation of loyalty you hear the mumbled murmurs of deceit. \r\n</p><p>No-one should be surprised - we have been here before. \r\n</p><p>Regicide is, after all, our speciality - just ask Lady Thatcher, John Major and, yes, even Tony Blair. \r\n</p><p>They were all knifed in the back or weakened by whispers. \r\n</p><p>However charismatic or "presidential" a prime minister has become, he or she is still chosen by the MPs of the ruling party rather than the electorate. \r\n</p><p>Tony Blair jumped before he was pushed; Lady Thatcher failed to heed the ides of March; and John Major told his fractious party to "put up or shut up ", only to be silenced by the voters. \r\n</p><p>Members of parliament are of course perfectly entitled to ditch their choice. \r\n</p><p>But if they ignore the mood of the public they do so at their peril. \r\n</p><p><b>Popular mandate</b>\r\n</p><p>Adding insult to injury for the prime minister is the fact that the whole of Britain seems to be infatuated with another Gordon. \r\n</p>\r\n<p>That is, the tousle-haired, expletive-loving celebrity chef Gordon Ramsay. \r\n</p><p>His pitted face stares out with the menace of carving knives from posters all over the country. \r\n</p><p>Love him or loathe him, at least this Gordon enjoys the popular mandate of TV ratings and book sales. \r\n</p><p>The other Gordon has no such comfort. \r\n</p><p>What the prime minister really lacks and now so desperately needs - and will probably never get - is a good, old-fashioned popular mandate delivered through the ballot box. \r\n</p><p>He almost swallowed his legendary fear of risks and lunged for one last October. \r\n</p><p>The fact that he did not has come to haunt him. He may well have missed his chance for good. \r\n</p><p>The contrast with America could not be greater. \r\n</p><p>Here three - or is it now two? - candidates are still fighting, grovelling and charming for every vote in every conceivable corner of this vast and fragmented political landscape. \r\n</p><p>You have to hand it to Hillary, John and Barack: they have been campaigning for over a year, spent umpteen millions, slept in hundreds of hotel beds, shaken tens of thousands of hands, remembered hundreds of names, jumped through rings of fire and aged visibly. \r\n</p><p>And they are still nowhere near the finishing line. \r\n</p><p>Their epic battle, leading to the general election in November, has captured the imagination of the world. \r\n</p><p><b>Searching questions</b>\r\n</p><p>My plumber in Putney, south-west London, wanted to talk super-delegates rather than bathroom leaks. \r\n</p>\r\n<p>London taxi-drivers want to know whether America is ready to elect a black president and at every literary event or book shop huddle I was met with undiluted enthusiasm for, interest in and knowledge of America''s electoral process - the Brits are gripped. \r\n</p><p>The interest in the US election is not just explained by the historic firsts: a woman, an African-American and a former prisoner-of-war septuagenarian vying to lead the most powerful nation on earth. \r\n</p><p>The rest of the world also understands that the US in 2008 is tackling some soul-searching questions. \r\n</p><p>What kind of nation does it want to be? \r\n</p><p>What is the right balance between security and liberty in a world threatened by extremism and suicide bombers? \r\n</p><p>Is America an imperial democracy, a democratic empire or neither? \r\n</p><p>Does this country want to be respected, feared or adored? \r\n</p><p>These are the underlying questions of the campaign, which the rest of the world wants answered as much as Americans themselves. \r\n</p><p><b>Big impact</b>\r\n</p><p>They explain why thousands of bookish Brits flocked to the literary festival at Hay-on-Wye on one of the wettest days in living memory. \r\n</p><p>They donned their wellies, sedated their children with hot chocolate and waded through muddy fields worthy of a re-enactment of the Battle of the Somme to listen to Gore Vidal, former President Jimmy Carter and a gaggle of journalists chew the fat over Uncle Sam. \r\n</p><p>Not so long ago, talk of America induced groans of despair more than quivers of excitement. \r\n</p><p>That has now changed. \r\n</p><p>The world seems once again prepared to give this country the benefit of the doubt. \r\n</p><p>The result will be minted in the cornfields of Iowa, the swamps of Louisiana or the mountains of Colorado. \r\n</p><p>But it will, let us face it, have some impact on all our lives. \r\n</p><p>\r\n</p><p>\r\n</p><p><i>Matt Frei is the presenter of </i><a href="http://www.bbcamerica.com/content/169/worldhome.jsp"><b>BBC World News America</b></a><i>which airs every weekday at 0030 BST on BBC News and at 0000 BST (1900 ET / 1600 PT) on BBC World News and BBC America (for viewers outside the UK only).</i>\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/americas/7424577.stm" title="Washington diary: Only in Britain">Source: BBC</a></p>', 1, 4, 0, 13, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:16:51', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 2, ''),
(132, 'S Korea-US deal on beef exports', 's-korea-us-deal-on-beef-exports', '', '<img src="images/stories/world/asia/1c.jpg" alt="S Korea-US deal on beef exports" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<p><b>The US has agreed not to export beef to South Korea from cattle older than 30 months in an effort to allay South Korean concerns over meat safety.</b>\r\n</p><p>Both sides say the deal was reached during talks in Washington between top South Korean and US trade officials. \r\n</p>\r\nSouth Korea used to be a major market for US beef, but suspended imports in 2003 after a case of "mad cow disease" was identified there. \r\n\r\n<div style="height: 14px; display: block;"></div>Seoul''s decision in April to end the suspension...', 'sparked a wave of protests. \r\n<p>Speaking in Seoul on Saturday, Agriculture Minister Chung Woon-chun said the two sides had agreed "that beef from US cattle more than 30 months old should not be exported to South Korea until consumer confidence is restored". \r\n</p><p>The deal was later confirmed by US Trade Representative Susan Schwab, who held talks with South Korean Trade Minister Kim Jong-hoon this week. \r\n</p><p>The two countries will now introduce an age verification system. \r\n</p><p>On Friday, President Lee Myung-bak replaced several top aides following weeks of demonstrations over April''s beef import deal - which was part of a landmark trade agreement. \r\n</p><p>The outcry has contributed to a sharp drop in popularity for the president, who won a landslide election victory last December. </p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/7467035.stm" title="S Korea-US deal on beef exports">Source: BBC</a></p>', 1, 4, 0, 16, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:32:08', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 5, '', '', 0, 3, ''),
(133, 'Deadly typhoon hits Philippines', 'deadly-typhoon-hits-philippines', '', '<img src="images/stories/world/asia/2.jpg" alt="Deadly typhoon hits Philippines" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n            \r\n\r\nAt least 17 people have died and many more are missing after Typhoon Fengshen hit the southern Philippines.\r\n \r\nThis caused flash floods and landslides.\r\n', '<p>Thousands of people have been evacuated from the path of the typhoon. \r\n</p><p>Gusts of up to 170kph (106mph) have caused much damage in southern and central areas. Many roads are blocked and there are widespread power cuts. \r\n</p><p>Domestic flights to central regions have been cancelled and inter-island ferry services halted, officials said. \r\n</p><p>Ten people drowned after a river burst its banks and swept away houses in southern Maguindanao province. Several other people were reported missing by the local authorities. \r\n</p><p>A landslide has also buried several houses in Cotabato city, also in the south, killing at least two people, officials said. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/7466978.stm" title="Deadly typhoon hits Philippines">Source: BBC</a></p>', 1, 4, 0, 16, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:14:44', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 4, '', '', 0, 1, ''),
(138, 'Castro condemns EU''s ''hypocrisy''', 'castro-condemns-eus-hypocrisy', '', '<img src="images/stories/world/europe/2c.jpg" alt="Castro condemns EU''s ''hypocrisy''" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n	\r\nFormer Cuban President Fidel Castro has lashed out at the EU''s decision to lift sanctions against his country, calling it "an enormous hypocrisy".\r\n<p>\r\nHe said the move was "disparaging" because it was conditioned on human rights progress in Cuba. \r\n</p><p>\r\nThe ailing 81-year-old said the measure came just days after the EU passed a "brutal" law that could jail illegal immigrants up to 18 months. \r\n</p><p>\r\nThe EU lifted the sanctions against Cuba in principle on Thursday.\r\n</p>\r\n', '<p>\r\nThe decision is expected to come into formal effect on Monday. The EU said its move was aimed at encouraging change in Cuba, following Fidel Castro''s replacement by his brother Raul in February.\r\n</p><p>\r\nThe decades-old US trade embargo against Cuba remains in place. \r\n</p><p>\r\n<b>EU warning</b>\r\n</p><p>\r\nIn an article published on Cuba''s official website, Fidel Castro said he wanted "to put in writing my contempt for the enormous hypocrisy that surrounds the [EU] decision".\r\n</p>\r\n<p>\r\nWhile saying that Cuba must improve its human rights record and free political prisoners, the EU mistreats illegal immigrants from Latin America by using the new law to jail and expel them, Mr Castro wrote. \r\n</p><p>\r\n"From Cuba, in the name of human rights, they demand impunity for those [dissidents] that try to deliver... the homeland and the people to imperialism," he said, referring to the US. \r\n</p><p>\r\nThe EU sanctions were imposed in 2003 in protest at the Cuban government''s imprisonment of more than 70 dissidents.\r\n</p>\r\n<p>\r\nThey included a limit on high-level government visits and the participation of EU diplomats in cultural events in Cuba. \r\n</p><p>\r\nBut EU External Relations Commissioner Benita Ferrero-Waldner said on Thursday the EU would continue to monitor human rights conditions in Cuba.\r\n</p><p>\r\n"There will be very clear language also on what the Cubans still have to do... releasing prisoners, really working on human rights questions," she told reporters at an EU summit in Brussels.\r\n</p><p>\r\nThe sanctions'' removal is largely symbolic but still a success for Raul Castro''s new government, analysts say. \r\n</p><p>\r\nSeveral leading Cuban dissidents have criticised the decision.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/americas/7466943.stm" title="Castro condemns EU''s ''hypocrisy''">Source: BBC</a></p>\r\n', 1, 4, 0, 17, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:15:59', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 4, '', '', 0, 2, ''),
(139, 'Major new rail lines considered', 'major-new-rail-lines-considered', '', '<img src="images/stories/world/europe/3.jpg" alt="Major new rail lines considered" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n	\r\n\r\nFive new high-speed main lines crossing the length and breadth of the UK may be built, Network Rail says.\r\n\r\nThe network operator will announce on Monday it...', 'is to commission a study looking into what could be the largest track build since the 19th century.\r\n<p>\r\nThe study will consider laying new lines alongside five of the UK''s busiest routes by 2025.\r\n</p><p>\r\nThey include the East Coast main line and West Coast main line.\r\n</p><p>\r\n<b>Record numbers</b>\r\n</p><p>\r\nThe review will also assess the need for high speed trains similar to the French TGV to cope with Britain''s growing number of rail users.\r\n</p><p>\r\nIn the last decade, passenger numbers have risen by about 40% with more people travelling by rail than at any time since 1946.\r\n</p>\r\n<p>\r\nIn addition, numbers are expected to swell by a further 30% in the next 10 years.\r\n</p><p>\r\nThe study being commissioned by Network Rail will look at the service in the post-2014 period, with all options "on the table".\r\n</p><p>\r\nIf given the go-ahead, the new lines are likely to run alongside some of the UK''s busiest existing routes.\r\n</p><p>\r\n</p><p>They include the West Coast line to Birmingham, Manchester and Glasgow, the East Coast main line to Edinburgh, the Great Western main line to Cardiff and Penzance, the Midland main line to Sheffield and the Chiltern route to Birmingham.\r\n</p><p>\r\nA spokesman for Network Rail said: "We are looking at these five strategic routes. We are possibly looking at new lines.\r\n</p>\r\n<p>\r\n"There is a huge case to be made for an expansion of the rail network. All options are on the table looking at how we address capacity issues."\r\n</p><p>\r\nRichard Dyer, transport campaigner at Friends of the Earth, said: "Expanding Britain''s railways by building new high speed lines is potentially very exciting - and could play an important role in weaning Britain off fossil fuels and developing a low carbon economy.\r\n</p><p>\r\n"But the overall impact that this would have on local people and the environment must be carefully considered.\r\n</p><p>\r\n "The UK needs a modern, comprehensive and affordable rail network to provide a real alternative to cars, lorries and short haul flights, and help cut Britain''s contribution to global climate change.\r\n</p><p>\r\n"Our creaking railway system desperately requires huge investment to bring it into the 21st century."\r\n</p><p>\r\nAshwin Kumar, passenger director of independent watchdog for rail users Passenger Focus, said: "We welcome the study. It is extremely important the rail industry anticipates future growth."</p>\r\n\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/uk/7467203.stm" title="Major new rail lines considered">Source: BBC</a></p>', 1, 4, 0, 17, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:15:19', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 6, 0, 3, '', '', 0, 2, ''),
(140, 'EU maps out future amid setbacks', 'eu-maps-out-future-amid-setbacks', '', '<img src="images/stories/world/europe/4.jpg" alt="EU maps out future amid setbacks" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n            \r\n\r\nTry as they might to talk about other pressing issues, EU leaders kept bumping into the elephant in the room - the Lisbon Treaty.\r\n\r\nLast year''s German...', 'in clinching the reform treaty after some eight years of institutional wrangling now looks like a pyrrhic victory. \r\n<p>The Irish No vote on Lisbon dominated the Brussels summit, with new cracks appearing just when EU leaders thought they had papered them over.\r\n</p><p>In a surprise announcement after the talks, UK Prime Minister Gordon Brown said full British ratification would have to wait until a court ruling on a Euro-sceptic millionaire''s demand for a referendum on Lisbon.\r\n</p><p>The summit conclusions meanwhile noted - in a footnote - that ratification in the Czech Republic would not be complete until the country''s constitutional court made a ruling on the treaty.\r\n</p><p>The 27-nation EU will return to the Lisbon stumbling block in October - by which time Irish leaders will need to have mapped out a way forward, based on detailed analysis of Irish anxieties about the treaty.\r\n</p><p><b>Does no mean no?</b>\r\n</p><p>Lisbon is designed to reshape EU institutions to ease decision-making in the enlarged bloc. \r\n</p><p>German Chancellor Angela Merkel said she agreed with French President Nicolas Sarkozy that without Lisbon, further enlargement could not proceed. And Commission President Jose Manuel Barroso said the 27 countries were legally obliged to ratify the treaty - the governments had not signed up to it "just for fun".\r\n</p><p>But the leaders avoided answering the question: would the Irish be asked to vote again?\r\n</p><p>The Nice Treaty - the current mechanism for EU business - did get through in Ireland on a referendum re-run. But when asked whether this time "no means no", Mr Sarkozy replied cryptically that "no means no, but we are trying to make this an opportunity - it''s what you call English pragmatism". \r\n</p><p>France will now team up with the Czechs and Swedes - holders of the EU presidency next year - to "manage" the treaty ratification, Mr Sarkozy said.\r\n</p><p>Danish politician Jens-Peter Bonde, a leading campaigner for a more transparent EU, told the BBC that the leaders had failed to discuss how to bring the EU''s institutions closer to the people.\r\n</p><p>He expects the EU to draft a "package" in the coming months to address Irish concerns. But he says the EU ought to have a slimmed-down treaty, comprehensible to all, and put it to the popular vote in all 27 states.\r\n</p><p><b>Leaders seeking unity</b>\r\n</p><p>The EU cannot afford another protracted round of institutional wrangling - not only because that is bad for its image, but also because of the European Parliament elections in a year''s time.\r\n</p><p>Kirsty Hughes, an EU affairs expert, says "the Commission has a problem trying to pretend it''s business as usual".  \r\n</p><p>Yet that most definitely was Mr Barroso''s message, reminding everyone that EU citizens are really concerned about the surge in food and fuel prices - and expect EU leaders to deliver. Citizens need an EU "bridge over troubled water", he said.\r\n</p><p>The 27 delegations agreed that France - the incoming EU president - would examine with the Commission various ways of easing the impact of the high fuel prices and present recommendations at the next summit. \r\n</p><p>Mr Sarkozy presented that as an "innovation" in the EU, describing it as a deal he had made with Chancellor Merkel. His call for an EU-wide cap on the VAT on fuel has had a mixed reception - and Germany takes a different view on oil prices.\r\n</p><p>As if to emphasise that the Lisbon wrangling would not block EU enlargement, the summit conclusions had plenty of comforting words for the Western Balkans states aspiring to join the bloc.\r\n</p><p>The leaders'' statement deplored the violence in the run-up to Zimbabwe''s second round of presidential elections on 27 June, saying they were "deeply concerned" and ready to take further measures against the perpetrators of violence. The UK government had pushed hard for a tough message on the abuses in Zimbabwe.\r\n</p><p>In contrast, the EU lifted sanctions on Cuba - a move the EU''s Slovenian presidency described as "an encouraging message". \r\n</p><p>Bruised by the Irish No vote they may be, but EU leaders are striving to show more unity on the international stage.</p> \r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/europe/7466694.stm" title="EU maps out future amid setbacks">Source: BBC</a></p>', 1, 4, 0, 17, '2008-06-21 10:29:45', 63, '', '2008-06-22 16:35:05', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 1, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(141, 'Marine science park key to future', 'marine-science-park-key-to-future', '', '<img src="images/stories/world/europe/5.jpg" alt="Marine science park key to future" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nPlymouth, blessed with a deep-water harbour and easy access to the western approaches, has long been recognised as a great place to build boats.', '<p>\r\nSir Walter Raleigh first suggested the navy set up there and in 1689 the Admiralty started drawing up plans.\r\n</p><p>\r\nAt its peak in the 1950s the yard employed about 40,000 people. Defence cuts mean it now employs about 4,000, and 600 more jobs are going over the next year.\r\n</p><p>\r\nBut there are hopes of a bright new future for the city''s maritime industry, using the same land that the navy does not need any more.\r\n</p><p>\r\nThe key to this vision is 100 acres of disused naval land called the South Yard.\r\n</p><p>\r\nSupporters, including local MPs and the university,  estimate it could become a marine science park, supporting up to 3,000 highly-skilled jobs.\r\n</p>\r\n<p>\r\n"It is becoming increasingly obvious that Plymouth is a global centre of excellence in coastal marine science," says Plymouth MP Linda Gilroy.\r\n</p><p>\r\n"We are on the front foot."\r\n</p><p>\r\nPart of her confidence stems from the strength of the city''s existing marine science teaching and research institutions, with 450 marine scientists and 1,200 undergraduates.\r\n</p><p>\r\n<p>\r\nThe university''s Marine Institute is a key player in the science park vision.\r\n</p><p>\r\nPlymouth is also home to the Plymouth Marine Laboratory, the Marine Biological Association, the National Marine Aquarium, the Diving Diseases Research Centre and the Sir Alister Hardy Foundation for Ocean Science.\r\n</p><p>\r\n"This is not a pipe dream, it has been done elsewhere in Europe and we believe it is possible here at South Yard," says Professor Laurence Mee, director of the university''s Marine Institute.\r\n</p><p>\r\n"There''s a recognition that we need to give fresh impetus to our maritime economy."\r\n</p><p>\r\nSupporters are also hoping the site will also be home to the proposed UK Marine Management Organisation (MMO), which will be responsible for the development and protection of the marine and coastal environment.\r\n</p><p>\r\nMs Gilroy says that if the government names Plymouth as the base for the MMO, it will kick-start the development of the science park.\r\n</p><p>\r\nHowever, first the navy has to release the land at South Yard and the financing of the park is relying on funds from the government from the sale of other surplus land at the naval base.\r\n</p><p>\r\n"The science park is worth exploring, but whether it will be successful I don''t know," says Professor Peter Gripaios of Plymouth Business School.\r\n</p><p>\r\nIf the science park is not successful the prospects for the marine industry in Plymouth do not look as positive.\r\n</p><p>\r\nThere have been encouraging signs at luxury boat firm Princess Yachts, which is looking forward to significant expansion under a new owner.\r\n</p>\r\n<p>\r\nBut the winding down of the dockyard, which still employs the vast majority of people in the city''s marine industry, would be devastating for the city if there is nothing to take its place.\r\n</p><p>\r\n"The prospects for Plymouth are not looking fantastic," says Professor Gripaios.\r\n</p><p>\r\n"It will be very difficult to replace the navy and the dockyard because Plymouth is so far west."\r\n</p><p>\r\nCity MP Gary Streeter agrees.\r\n</p><p>\r\n"I am not a betting man but if I were I would stake my mortgage on submarines and frigates going from the naval base," he says.\r\n</p><p>\r\n"The issue us what we will do with the real estate.\r\n</p><p>\r\n"Unlike the South East, there is not the same kind of substitute activity.\r\n</p><p>\r\n"We are 230 miles from London and we shall need substantial government help."\r\n</p><p>\r\nAdam Corney, executive director of Marine South West, which trains people in the marine industries, says that overall the industry is in good health.\r\n</p><p>\r\n"We are on the cusp of something quite huge over the next year or 18 months," he says..\r\n</p><p>\r\n"We have every reason to be optimistic."\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/england/devon/7440585.stm" title="Marine science park key to future">Source: BBC</a></p>', 1, 4, 0, 17, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:15:18', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 1, '', '', 0, 1, ''),
(137, 'Czech threat looms for EU treaty', 'czech-threat-looms-for-eu-treaty', '', '<img src="images/stories/world/europe/1.jpg" alt="Czech threat looms for EU treaty" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\nEU leaders have admitted that the Czech Republic may not be able to ratify the Lisbon Treaty, which has already been rejected by the Irish.', '<p>The declaration from their summit in Brussels notes that the Czech process is on hold due to legal difficulties. \r\n</p><p>But they said ratification would continue elsewhere, and ruled out renegotiation of the treaty. \r\n</p><p>But British PM Gordon Brown said the UK could not definitively ratify it until a court ruled on a legal challenge. \r\n</p><p>It followed a warning from a judge in the case that ratification should be delayed until the ruling was in. \r\n</p><p>The treaty passed through British parliament this week, but has still to complete formal ratification. \r\n</p><p>Mr Brown said the judge''s intervention would not affect the process, which would not have been completed until after the court judgement anyway. \r\n</p><p><b>Bets off</b>\r\n</p><p>The Brussels summit has been overshadowed by the Irish result, despite efforts to concentrate on food and fuel prices, and now the Czech threat hangs over the treaty. \r\n</p>\r\n<p>The EU declaration noted that: "The Czech Republic cannot complete their ratification process until the constitutional court delivers its positive opinion on the accordance of the Lisbon Treaty with the Czech constitutional order". \r\n</p><p>The Czech parliament''s ratification was suspended after the Senate demanded that the court rule on its constitutionality. \r\n</p><p>The Czech Prime Minister Mirek Topolanek said at the summit that he was not going to try to halt the ratification process in his country. \r\n</p><p>But he added: "I am not going to force MPs to back Lisbon and I wouldn''t bet 100 crowns (£3, $6) on a Czech ''Yes''." \r\n</p>\r\n<p>The Czech President, Vaclav Klaus, said after the Irish vote that it had killed off the treaty. \r\n</p><p>With growing opposition from Euro-sceptics, and key elections due in October, the future of the treaty in the Czech Republic looks uncertain, says the BBC''s Oana Lungescu at the summit in Brussels. \r\n</p><p><b>''Not just for fun''</b>\r\n</p><p>The issue has obstructed attempts to get a common position in Brussels - that ratification should continue, while the Irish government takes time to consider its next step. \r\n</p><p>But President Sarkozy said EU leaders had decided that: "The treaty ratification process should continue in all member states, that''s the position now of the council." \r\n</p>\r\n<h4>LISBON TREATY PROGRESS</h4>			                     \r\n<p><b>Approved by parliament: Austria, Bulgaria, Denmark, Estonia, Finland, France, Germany, Greece, Hungary, Latvia, Lithuania, Luxembourg, Malta, Poland, Portugal, Romania, Slovakia, Slovenia, UK</b>\r\n</p>\r\n<p><b>Defeated by referendum: Irish Republic</b></p>\r\n\r\n<p><b>Challenges: Legal objections in Czech Republic, UK</b></p>\r\n\r\n<p><b>No firm date: Belgium, Cyprus, Netherlands (held up by referendum proposal), Italy (new government), Spain (new government), Sweden</b></p>\r\n\r\n\r\n<p>"Ireland is a problem, but if we have a second or third problem then it''s really going to get difficult," he added. \r\n</p><p>The treaty must be ratified by all 27 member states to take effect. Nineteen have approved it so far. \r\n</p><p>European Commission President Jose Manuel Barroso ruled out renegotiating the reform treaty. \r\n</p><p>"When a treaty is signed by 27 governments it''s not just for fun," he said. "It''s inconceivable that a government signs a treaty without the intention of ratifying it. It''s a principle of international law." \r\n</p><p>Mr Sarkozy and German Chancellor Angela Merkel said the European Union would not be able to expand further without ratification of the Lisbon Treaty, in what correspondents said appeared to be an attempt to lean on the Czechs, as well as Poland, who are keen on eastward expansion. \r\n</p><p>Polish Prime Minister Donald Tusk rejected that stance as "unacceptable". \r\n</p><p>Friday''s declaration made reference to several other matters, not least the soaring fuel and food prices that have hit consumers and sparked protests across Europe. \r\n</p><p>EU leaders: \r\n</p><p>\r\n</p><ul>\r\n<li>said the EU Commission should by October "examine the feasibility of taxation measures to smooth the impact of sudden oil price increases"  </li>\r\n<li>threatened tougher sanctions against Zimbabwe amid pre-election violence  </li>\r\n<li>threatened tougher sanctions against Sudan over its refusal to hand over officials wanted for war crimes in Darfur  </li>\r\n<li>delayed a decision on a date for Macedonia to start accession talks with the EU  </li>\r\n<li>agreed to scrap diplomatic sanctions against Cuba imposed in 2003  </li>\r\n</ul>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/europe/7465448.stm" title="Czech threat looms for EU treaty">Source: BBC</a></p>', 1, 4, 0, 17, '2008-06-21 10:29:45', 63, '', '2008-06-23 14:14:56', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 3, 0, 5, '', '', 0, 1, ''),
(134, 'Protesters march in Thai capital', 'protesters-march-in-thai-capital', '', '<img src="images/stories/world/asia/3.jpg" alt="Protesters march in Thai capital" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nSeveral thousand protesters have converged on government offices in the Thai capital Bangkok. \r\n\r\nThey demanded that the government step down.\r\n', '<p>\r\nPolice lined the streets as crowds led by the People''s Alliance for Democracy (PAD) marched in Bangkok. \r\n</p><p>\r\nThe PAD, mostly made up of middle-class Bangkok residents, say the government is a proxy for Thaksin Shinawatra, who the military ousted in a 2006 coup. \r\n</p><p>\r\nThe group has been protesting in Bangkok since late May.\r\n<!-- E SF -->\r\n</p><p>\r\nIt led the massive anti-Thaksin street protests that preceded the 2006 coup, but the demonstrations this time have so far remained small. \r\n</p><p>\r\n<b>Deep divisions</b>\r\n</p><p>\r\nAhead of the protests, police closed down the area around Government House. \r\n</p><p>\r\nSchools and offices nearby were ordered to shut. Thousands of police were deployed and barriers set up.</p>\r\n<p>\r\nThe protest leaders had promised 100,000 people would join their movement to oust the government. \r\n</p><p>\r\nIn the end, only a fraction of that number showed up, according to the BBC''s correspondent in Bangkok, Jonathan Head. \r\n</p><p>\r\nBut their lack of mass support belies the serious threat they still pose to the four-month-old government of Prime Minister Samak Sundaravej, our correspondent adds. \r\n</p><p>\r\nHis People Power Party - made up of Mr Thaksin''s allies - won the elections in December 2007 that returned Thailand to democracy. \r\n</p><p>\r\nBut the deep divisions that contributed to the military coup remain. \r\n</p><p>\r\nMr Thaksin, a telecommunications billionaire, is banned from politics, but he still enjoys strong support in rural areas. \r\n</p><p>\r\nHe is, however, deeply disliked by Bangkok''s traditional elite, who do not want him to make a political comeback. \r\n</p><p>\r\nHis opponents are also angry at the new government''s recent move to amend the military-backed constitution - a move they say will give obvious benefits to the People Power Party and give Mr Thaksin added protection. \r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/7464941.stm" title="Protesters march in Thai capital">Source: BBC</a></p>', 1, 4, 0, 16, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:16:43', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 3, '', '', 0, 2, ''),
(135, 'Most Tibet protester freed', 'most-tibet-protester-freed', '', '<img src="images/stories/world/asia/4.jpg" alt="Most Tibet protesters ''now freed''" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n	\r\n\r\nMore than 1,000 people detained after protests in Tibet earlier this year have now been freed.\r\n \r\nChinese media reported today...\r\n', '<p>\r\nThe state-run Xinhua news agency quoted a senior official saying 116 people remained in custody awaiting trial over the unrest.\r\n</p><p>\r\nThe announcement came a day before the Olympic torch relay was due to reach  Tibet''s main city, Lhasa.\r\n</p><p>\r\nIn March, Buddhist monks led anti- Beijing rallies in Lhasa which grew into widespread unrest among Tibetans.\r\n</p><p>\r\nChina says rioters killed at least 19 people in the unrest, but Tibetan exiles say security forces killed dozens of people. \r\n</p><p>\r\nThe announcement on the detainees came a day after human rights group Amnesty International called on Beijing to account for those who were still in jail after the unrest. \r\n</p><p>\r\nXinhua quoted Palma Trily, vice-governor of the Beijing-backed Tibetan government, as saying 1,157 people had now been freed after being charged with minor offences connected with the unrest. \r\n</p><p>\r\nTibet police detained and arrested 953 people after the riot, while 362 others surrendered to police, according to the vice-governor.\r\n</p><p>\r\nHe said 12 people had been sentenced for crimes related to the unrest, bring to 42 the total number of people who have been punished.\r\n</p><p>\r\nThe Xinhua report said the 42 were convicted of offences including arson, robbery and "gathering to assault state organs".\r\n</p><p>\r\n<b>Torch protests</b>\r\n</p><p>\r\nUnrest in Tibetan communities began in Lhasa on 10 March before snowballing into the most widespread protests in 20 years. \r\n</p><p>\r\nAfter several days of unrest and rioting, Chinese security forces wrested back control of the area.\r\n</p><p>\r\nBut pro-Tibetan protesters threw China''s global Olympic torch relay into disarray as it passed through several cities, including London, Paris and San Francisco. \r\n</p><p>\r\nThe Olympic torch reaches Lhasa on Saturday on the latest leg of its tour around China. \r\n</p><p>\r\nChinese security forces have been patrolling in the main square of Lhasa in the run-up to the torch''s arrival.</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/7466313.stm" title="Most Tibet protesters ''now freed''">Source: BBC</a></p>\r\n\r\n', 1, 4, 0, 16, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:19:24', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 2, '', '', 0, 1, ''),
(136, 'China ''arrests'' fake terrorists', 'china-arrests-fake-terrorists', '', '<img src="images/stories/world/asia/5.jpg" alt="China ''arrests'' fake terrorists" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n	\r\n\r\nThree men have reportedly posed as terrorists and tried to extort more than $300,000 (£150,000). \r\n\r\nThey have been arrested in the Chinese city of Qingdao.\r\n', '<p>A company in the city is said to have received a phone call last week from a man who claimed he was a member of an "East Turkestan independence group".\r\n</p><p>The man said he would bomb the firm''s offices if the money was not wired into his account, the Beijing News reported.\r\n</p><p>The police were quickly alerted and arrests were made two days later.\r\n<!-- E SF --></p><p>According to the Beijing News, the suspects were traced through their bank account details.\r\n</p><p>The paper identified the suspected leader of the extortion attempt as Sun Yongzheng, a man who devised the scheme after he lost all his money gambling.\r\n</p><p>The Chinese government has maintained that terrorism is the biggest threat to the Olympic Games, which take place in August in Beijing. \r\n</p><p>They have attributed potential attacks to a separatist group in the western, Muslim majority province of Xinjiang, who are fighting for an independent state called East Turkestan. \r\n</p><p>In April the authorities stated that they had foiled plots which involved suicide attacks and the kidnapping of athletes.\r\n</p><p>Qingdao will host the sailing competitions in the forthcoming games.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/7465828.stm" title="China ''arrests'' fake terrorists">Source: BBC</a></p>', 1, 4, 0, 16, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:22:41', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 1, ''),
(142, 'Aborigines open Canberra session', 'aborigines-open-canberra-session', '', '<img src="images/stories/world/australia/1c.jpg" alt="Aborigines open Canberra session" width="250" height="200" align="left" style="margin-right: 8px;" />\r\n\r\n<p><b>Australia''s parliament has opened with an Aboriginal welcome, ahead of an apology for past wrongs inflicted on the country''s indigenous community.</b></p>\r\n<p>\r\nIn a special ceremony, an Aboriginal elder handed a symbolic message stick to Prime Minister Kevin Rudd. \r\n</p><p>\r\nOn Wednesday Mr Rudd is due to deliver a historic apology to Aborigines for past assimilation policies.\r\n</p><p>\r\nUnder these policies, in place until the 1960s, thousands of children were forcibly taken from their families.\r\n</p>', '<p>\r\n<b>Break with tradition</b>\r\n</p><p>\r\nNever before has the Australian parliament opened with this kind of ritual.  \r\n</p><p>\r\nDidgeridoo-playing Aborigines overturned hundreds of years of British tradition by marking the official opening of the session in their own way.\r\n</p><p>\r\nAccording to the BBC correspondent Nick Bryant, this is perhaps a sign of the new spirit of  reconciliation which the country''s new prime minister is trying to nurture and nourish.  \r\n</p>\r\n</p><p>\r\nAboriginal elder Matilda House, wearing a coat of animal skins, delivered a traditional message stick to Mr Rudd, and spoke of "the hope of a united nation through reconciliation".\r\n</p><p>\r\n"Today we begin with one small step to set right the wrongs of the past," Mr Rudd said. \r\n</p><p>\r\nThe first act of parliament will be to apologise to the Stolen Generations - young Aboriginal children taken from their parents in a policy of assimilation which lasted from the 19th Century to the late 1960s.  \r\n</p><p>\r\nPrime Minister Kevin Rudd proposed a motion to acknowledge the "profound grief, suffering and loss" as well as the "indignity and degradation" caused to the Aboriginal community by previous policies. \r\n</p><p>\r\n"For the pain, suffering and hurt of these Stolen Generations, their descendants and for their families left behind, we say sorry," the text of the motion says.\r\n</p><p>\r\nThe motion is due to be put to a vote on Wednesday, and is certain to pass because it has the support of both the government and the main opposition parties.\r\n</p><p>\r\n<b>New agenda</b>\r\n</p><p>\r\nThe previous prime minister, John Howard, refused to apologise to members of the Stolen Generations, a position which chimes with about 30% of the population, according to the polls. \r\n</p>\r\n\r\n<p>\r\nBut the Liberal Party he led until last November''s election has now decided to alter its stance, so all sides will take part in the apology.\r\n</p><p>\r\nMr Rudd''s agenda, also outlined in parliament on Tuesday, included a commitment to close the 17-year life expectancy gap between Aborigines and other Australians within a generation, was well as halving Aboriginal infant mortality rates within a decade.\r\n</p><p>\r\nAustralia''s 460,000 Aborigines make up 2% of the population and are the most disadvantaged group.\r\n</p><p>\r\nThey have higher rates of infant mortality, drug abuse, alcoholism and unemployment than the rest of the population.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/7240382.stm" title="Aborigines open Canberra session">Source: BBC</a></p>', 1, 4, 0, 19, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:58:04', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 5, '', '', 0, 5, ''),
(143, 'Metropolis strives to meet its thirst', 'metropolis-strives-to-meet-its-thirst', '', '<img src="images/stories/world/australia/2.jpg" alt="Metropolis strives to meet its thirst" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nThe Australian of the year 2007, environmentalist Tim Flannery, once predicted that Perth in Western Australia. \r\n\r\nHe could become the world''s first ghost metropolis... ', 'its population forced to abandon the city due to lack of water.\r\n\r\n<p>\r\nWhile some critics scoffed at this idea, there is no doubt that it has forced the city to wake up to the fact its water is running out and that it can no longer rely on its natural supply. \r\n</p><p>\r\nAustralians are some of the world''s greatest energy consumers, and people in Perth use more water than any other city in Australia. \r\n</p><p>\r\nYet theirs is also the driest climate in the world, and Perth sits right on the edge of a vast desert, an island of greenery in the form of European style parks and gardens. \r\n</p><p>\r\n<b>Consumption paradox</b>\r\n</p><p>\r\nThe city''s case is a fascinating paradox of over consumption matched by a dawning awareness of climate change that is resulting in an urgent response to safeguard the city''s water supplies for the future.  \r\n</p><p>\r\nPerth sits above a vast ancient aquifer of 40,000-year-old water that has traditionally been the main source of drinking water.  But in the mid 1970s there was a dramatic shift in climate that resulted in a decline of between 15% and 20% in winter rainfall.  \r\n</p><p>\r\nThe combination of rising temperatures and a lack of wet winters has meant a steady decline in water levels in the aquifer and they are not being recharged. \r\n</p><p>\r\nBy the mid 1990s, scientists realised they were facing more than a prolonged drought, that this was in fact climate change.\r\n</p><p>\r\nDon McFarlane, of the Commonwealth Scientific Industrial Research Organisation (CSIRO), says: "Climatologists tell us that it is the most profoundly affected city in the world.  People have accepted that it is climate change.  \r\n</p><p>\r\n"In other parts of the world people are thinking it''s something that''s going to happen to them in the next 10 or 30 years and that they''ve got time to adjust.  We''ve found we''ve been living with it for 30 years now and we''re having to adjust very quickly."\r\n</p><p>\r\n<b>City of industry</b>\r\n</p><p>\r\nAlthough perhaps the residents of the city have been slow to respond to the threat of climate change, there has been intense pressure on water experts to find new sources of water for the city.  \r\n</p><p>\r\nPerth is growing rapidly thanks to its thriving mining industry and the population will soon top two million people, attracted there by a high standard of living.  \r\n</p><p>\r\nThe city is made up of suburbs that stretch for more than 70km along the coast of the Indian Ocean.  \r\n</p><p>\r\nPeople consume a lot of energy. It is a car-dependent city with little public transport. Many of the luxury houses overlooking the ocean (known locally as "starter mansions") boast currently fashionable black roofs that soak up the heat in temperatures of up to 42 degrees in summer, and produce a greater need for air conditioning inside.  \r\n</p><p>\r\nAnd, ironically, although it''s a desert climate, Perth prides itself on being a garden city, boasting vast expanses of beautifully kept lawns and parks complete with water hungry plants and flowers.  \r\n</p><p>\r\nAnd many residents can extract water for these gardens directly from the aquifer. There are over 150,000 unlicensed boreholes in Perth''s back gardens that allow householders unlimited access to groundwater for watering.  \r\n</p><p>\r\nYet the Water Corporation is reluctant to clamp down on private water usage even though before current restrictions people were often watering their gardens in the middle of the day when the water was most likely to evaporate and be wasted. \r\n</p><p>\r\n<b>''Mining water''</b>\r\n</p><p>\r\nOne gardener we spoke to for Costing the Earth told us that 90% of his water usage is for his garden and that it would break his heart if he ever had to stop watering and give up his beloved green lawns. \r\n</p><p>\r\nBut Pierre Horwitz, associate professor of ecosystems at Edith Cowan University,  Perth, questions why drinking water is being used for gardens to such an extent and says people have got to start using less water. \r\n</p><p>\r\n"If you compare our individual consumption rates, they''re almost a third higher again than those in Sydney, Melbourne and Brisbane.  You just can''t continue to sustain that." \r\n</p><p>\r\nHorwitz says people have been too complacent about the availability of water because of the vast ground water resource.  \r\n</p><p>\r\n"We''re actually mining water. This is a non-renewable resource and we have to constrain our behaviours so that we use what''s replenishable rather than eat into our reserves."\r\n</p><p>\r\nFollowing this early wake up call to the onset of climate change, Perth''s water experts are now leading the way in exploring new ways of providing water for this thirsty city.  One of them involves recharging the aquifer with treated waste water - left over from people''s washing machines and dish washers.  \r\n</p><p>\r\nThere is plenty of it available because of the increasing population. Until now, most of it has been going straight out of the kitchen into the ocean. That is 111 billion litres of "wasted" waste water. \r\n</p><p>\r\n<b>Environmental concerns</b>\r\n</p><p>\r\nThat water is now being put into some of Perth''s lakes to be treated naturally in the soil before topping up the groundwater in the aquifer.\r\n</p><p>\r\nAt the moment, it is not going to be used for drinking water but for irrigation and in the lakes for the benefit of wildlife; but there are concerns about potentially harmful effects on the environment, which scientists are monitoring very closely. \r\n</p><p>\r\nResearch scientist Simon Toze says: "The biggest impact for the environment are nutrients which could cause algal blooms.  Also, trace chemicals like hormones, things we excrete.  We know most nutrients are taken out naturally by processes. We don''t know so much about the trace organics."\r\n</p><p>\r\nThere are well documented concerns about the so called "gender bending" hormones in water causing fish to change sex, but Toze says that so far results seem to show that things like oestrogen are stripped out during the bio processes taking place in the aquifer.\r\n</p><p>\r\nSometime soon though, the citizens of Perth could be looking at drinking recycled water, and currently Toze and his colleagues are doing a lot of work to try to persuade people to get over what they call "the yuk factor".  \r\n</p><p>\r\n<b>Current prices</b>\r\n</p><p>\r\nHe says that the recycled water would remain even longer in the aquifer to allow nature to remove any harmful nutrients, possibly for up to 50 years, before being used for drinking water.  \r\n</p><p>\r\nToze claims by then it would be pure to drink, better than what comes out of our taps at the moment. This is one solution to Perth''s water crisis, although it may not be the most popular one. \r\n</p><p>\r\nThere is a joke doing the rounds that goes: the good news is we''ll all soon be drinking recycled sewage. The bad news is there will not be enough to go round. These may be desperate times for Perth''s water supply, but the city is in the fortunate position of being fairly wealthy with a government that is prepared to invest in expensive water projects. \r\n</p><p>\r\nThe latest is a state of the art desalination plant that came online last November and will supply 17% of the city''s drinking water.  \r\n</p><p>\r\nIt is partly powered by a wind farm further up the coast and the city''s Water Corporation claims it is the most efficient and environmentally friendly of its kind anywhere in the world. \r\n</p><p>\r\nGary Crisp, the corporation''s desalination engineer, is proud of their achievements: "What we''ve done [in Perth] is truly pioneering stuff. \r\n</p><p>\r\n"There''s no one else really to help us so we have to bite the bullet and do the job ourselves." \r\n</p><p>\r\nHowever, he does concede that, ultimately, Perth is going to have to pay more for its water.\r\n</p><p>\r\n"At the current prices in Australia, there''s not enough water to go around and there''s not enough incentive for people to use less." \r\n</p><p>\r\nAnd that is the only true solution to Perth''s water crisis - learning to live with less water and maybe even giving up some of those beautiful green lawns.  \r\n</p><p>\r\nOtherwise that prediction that it could become a ghost town may yet come true. \r\n</p><p>\r\n<i>Costing the Earth is on BBC Radio 4 on Thursday 3 May at 2100, and on Friday afternoon at 1500. You can also hear the programme after it is broadcast on the Listen Again service on the Radio 4 website</i>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/sci/tech/6620919.stm" title="Metropolis strives to meet its thirst">Source: BBC</a></p>', 1, 4, 0, 19, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:58:29', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 4, '', '', 0, 1, ''),
(144, 'Australia making Asian friends', 'australia-making-asian-friends', '', '<img src="images/stories/world/australia/3.jpg" alt="Australia making Asian friends" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n\r\n\r\nAustralia''s diplomatic march into Asia is continuing, with its latest achievement being a historic security pact with Japan.\r\n\r\nThe agreement is seen ...', 'as a good result for both countries.\r\n<p>\r\n"It''s a very significant accord," explained Professor Alan Dupont from the University of Sydney. \r\n</p><p>\r\n"It reflects the fact that Japan is moving to develop a more assertive defence and foreign policy."\r\n</p><p>\r\n<!-- E SF -->\r\nThe bilateral arrangement is also a boost to Canberra''s long-term efforts to make more friends in Asia. It will lead to increased co-operation in the fight against terrorism, and more joint disaster relief operations.\r\n</p><p>\r\n"It is generally accepted that in the region Australia is part of Asia," said Prof Dupont.\r\n</p><p>\r\n"That is a historic shift.  Australia was always seen as a bit of an outpost of empire, and its people transplanted Europeans.  I don''t think that is the perception now," he added.\r\n</p><p>\r\n<b>Chinese fears</b>\r\n</p><p>\r\nAustralia wants to engage more with its neighbours in Asia for two main reasons: to pursue economic opportunity and to enhance security.  \r\n</p><p>\r\nThese efforts are not new, but they have now reached unprecedented heights.  \r\n</p>\r\nFor the past two decades, Australian leaders have seen the strategic importance of alliances with Asia''s biggest players.\r\n</p><p>\r\nTrade with its regional partners has helped Australia''s economy boom.  Japan is its biggest export market, while commercial ties with China continue to blossom.\r\n</p><p>\r\nAustralia has been working towards a free trade deal with the Chinese for the past couple of years, and similar talks with the Japanese are expected to begin within weeks.\r\n</p><p>\r\nThis all requires some nifty diplomatic footwork on the part of Australia''s veteran Prime Minister John Howard, who is also one of Washington''s most loyal allies.\r\n</p><p>\r\nTokyo and Beijing are not the best of friends. The danger for Mr Howard is that he could be caught in the middle of any dispute between these Asian giants.\r\n</p><p>\r\nAustralia''s security accord with Japan has not been received well in China, according to Dr Jian Zhang, a China specialist at the Australian Defence Force Academy in Canberra.\r\n</p><p>\r\n"I think China will not be happy about the new agreement," said Dr Zhang. "It will see it as an effort to counter-balance China''s growing influence in the region."\r\n</p><p>\r\n"It will reinforce China''s suspicions that an anti-China group is forming among US allies in the region.  As a result China will accelerate its military modernisation programme," he predicted.\r\n</p><p>\r\nMr Howard has tried to play down Beijing''s concerns by repeating his assertion that it has nothing to worry about.\r\n</p><p>\r\nThe defence agreement with Japan "should not be seen as being antagonistic to anybody in the region," the Australian leader said.\r\n</p><p>\r\n<b>Volatile relationship</b>\r\n</p><p>\r\nMr Howard has often found it tough going in his efforts to make friends in Asia, and not everyone has welcomed Australia''s entry into the Asian club.\r\n</p>\r\nHis declaration after the Bali bombings in 2002 that his government was prepared to launch military strikes against terrorists in neighbouring Asian countries did not go down well.\r\n</p><p>\r\nFormer Malaysian leader Dr Mahathir Mohamad famously denounced Australians as a country "that stands out like a sore thumb trying to impose its European values in Asia".\r\n</p><p>\r\n"The volatility in the relationship between Australia and its Asian neighbours usually refers to ties with Indonesia or Malaysia," said Prof Alan Dupont.\r\n</p><p>\r\nTragedy has brought Canberra and Jakarta closer together in recent years, most notably after atrocities in Bali and the huge tsunami in December 2004.\r\n</p><p>\r\nBut Malaysia''s former Deputy Prime Minister Anwar Ibrahim recently insisted that Australia was still regarded as an outsider in parts of Asia.\r\n</p><p>\r\n"The perception remains that Australia has not changed considerably from their old racist white supremacy, or racist policies," Mr Anwar told Australian radio.\r\n</p><p>\r\n"But we must recognise there have been major changes, and I think people do recognise this, but they don''t think that the change is radical enough."\r\n</p><p>\r\nWhile Australia is gradually strengthening its economic and political ties across Asia, there is still one Australian alliance that stands head and shoulders above all the others.\r\n</p><p>\r\nMr Howard has made it abundantly clear that his country''s long-term future depends on its close relationship with the United States.\r\n</p>\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/6449387.stm" title="Australia making Asian friends">Source: BBC</a></p>', 1, 4, 0, 19, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:58:24', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 4, 0, 3, '', '', 0, 1, ''),
(145, 'Long-term tensions behind Sydney riots', 'long-term-tensions-behind-sydney-riots', '', '<img src="images/stories/world/australia/4.jpg" alt="Long-term tensions behind Sydney riots" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n	\r\n\r\nA week to the day after two surf life savers had been assaulted in what was believed to be an unprovoked attack.\r\n \r\nSuspicions lie with a... \r\n', 'large group of men of Middle Eastern appearance.\r\n<p>\r\nThe following week, texts started circulating around Sydney calling for a revenge fight. \r\n</p><p>\r\nBy Sunday, the media and a crowd of about 5,000 had gathered in anticipation in Cronulla. Right wing pamphlets were seen circulating in the crowd.\r\n</p><p>\r\nSeventeen-year-old Wade Kereopa and his friend Kurt Sholes were at the beach.\r\n</p><p>\r\n"At about 12 o''clock everyone started gathering at Cronulla and then some guy yelled out ''There''s Lebs on the next train!" so thousands of people went up to the station, but there was only about two on the train and about 50 people ran on and bashed them," said Kurt.\r\n</p><p>\r\nHis friend Wade, who admits to have been drinking all afternoon, found himself on the train as well.\r\n</p><p>\r\n"I saw a crowd of people running to the train station. I went to have a look and ended up getting pushed onto the train by all the Aussies behind me. All these Aussies were smashing these Middle Eastern people. Then another guy of Middle Eastern origin got chased and beaten by the crowd. Everyone was drunk and anyone of Middle Eastern appearance got bashed. It went on all day into the night," he said.\r\n</p><p>\r\nApparently in retaliation, a Caucasian man was stabbed after an altercation outside a golf club with "a group of males of Middle Eastern or Mediterranean appearance", according to police reports. Fifty car-loads of youths - again of Middle Eastern or Mediterranean appearance - later smashed 100 vehicles with baseball bats and other weapons. Police received reports of firearms being "flashed" but not discharged.\r\n</p><p>\r\nThe hostility escalated and spread across eight suburbs in Sydney''s south and west. Sixteen people were arrested and charged with 41 offences.\r\n</p><p>\r\nOn Monday, tensions remained high. More retaliatory attacks were carried out and police later made 11 more arrests during a second night of violence.\r\n</p><p>\r\nCar-loads of people were stopped and searched, there was violence at a mosque in the western suburb of Lakemba, assaults were carried out and a group of men armed with iron bars and guns were dispersed by police outside a convenience store in Cronulla.\r\n</p><p>\r\n<b>''Attritional''</b>\r\n</p><p>\r\nDespite the fact that right-wing pamphlets have been circulated, the violence does not appear to have been co-ordinated from the wings by extremist groups, but to be the result of large groups of youths fuelled by mass hysteria.\r\n</p><p>\r\nIt does, however, come against the backdrop of long-term racial tensions in Cronulla - a predominantly white community with a beach easily accessible on the train from Sydney''s western suburbs, which are home to a large Muslim population.\r\n</p><p>\r\nJason Lalor lives minutes from the beach and is pessimistic that there is a quick fix to the deeply rooted antagonism on both sides. \r\n</p><p>\r\nHe says he has been harassed by groups of Lebanese youths on more than one occasion and says he is tired of being hassled in his own neighbourhood. \r\n</p><p>\r\n"It''s not going to stop one day. It''s going to keep going, which is what it''s been doing since my father''s time."\r\n</p><p>\r\nThe Australian Arabic Council (AAC) agrees that tensions have been building.\r\n</p><p>\r\n"These events typify an ugly and fringe element of Australian society," said AAC chairman Roland Jabbour.\r\n</p><p>\r\n"Arab Australians have had to cope with vilification, racism, abuse and fear of a racial backlash for a number of years, but these riots will take that fear to a new level," he said.\r\n</p><p>\r\nOn Tuesday morning the New South Wales premier announced he was recalling parliament to push through tough new police powers to allow them to tackle the unrest.\r\n</p><p>\r\nIn addition to having new powers of arrest, police will also be allowed to close down pubs and off licenses to prevent inebriated crowds accessing more alcohol.\r\n</p><p>\r\nThere are new fears that the violence could spread nationally, with a high volume of mobile phone text messages inciting racial hatred.\r\n</p><p>\r\nOne reads: " We''ll show them! It''s on again sunday... send this to everyone in your phone book... this is a straight up WAR! We must continue to come together to help the innocet an family''s so every one can enjoy our beach''s!"\r\n</p><p>\r\nThe country is watching and waiting to see what happens next.\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/4525352.stm" title="Long-term tensions behind Sydney riots">Source: BBC</a></p>\r\n\r\n', 1, 4, 0, 19, '2008-06-21 10:29:45', 63, '', '2008-06-22 16:03:34', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 2, '', '', 0, 2, ''),
(146, 'Australian blokes face up to change', 'australian-blokes-face-up-to-change', '', '<img src="images/stories/world/australia/5.jpg" alt="Australian blokes face up to change" width="100" height="100" align="left" style="margin-right: 8px;" />\r\n	\r\n\r\nIn Australia right now, it is tough to be a bloke. "I turned on my television expecting to see the Haka,".\r\n \r\nWas a recent night in Melbourne when...\r\n', ' the All Blacks faced off against the Wallabies. \r\n\r\n<p>\r\n"Instead, I got I am Sixteen Going on Seventeen," he said.\r\n\r\n</p><p>\r\n\r\nThe man in question, a sports-loving Aussie, was bemoaning the decision from one of the country''s leading television networks.\r\n\r\n</p><p>\r\nInstead of showing the Bledisloe Cup - the South Pacific''s most eagerly anticipated international rugby fixture of the year - it broadcast a re-run of The Sound of Music.\r\n\r\n</p>\r\n<p>\r\n\r\nThat decision came as Australians tried to come to terms with the loss of two great male icons.\r\n\r\n</p><p>\r\n\r\nCrocodile Hunter Steve Irwin - that great larrikin of larrikins - and the more quietly-spoken Peter Brock, a peerless racing driver known as the King of the Mountain, who was to Australian motor sport what Lance Armstrong was to international cycling. \r\n\r\n</p><p>\r\n\r\nThough less well known than the Croc Hunter outside of Australia, "Peter Perfect" - as he was also known - was arguably held in higher esteem within it. \r\n\r\n</p><p>\r\n\r\nLike Irwin, he was killed doing what he was famous for, in his case driving his race car. \r\n\r\n</p><p>\r\n<b>''Nervous wrecks''</b>\r\n</p><p>\r\n\r\nMateship, bravery, a towering self-confidence and a fearsome determination to succeed - both men personified the spirit of Australian masculinity.\r\n\r\n</p><p>\r\n\r\nBut Brock and Irwin were part of an endangered species, according to Mark Latham, the former leader of the Labor Party, whose latest musings on the "crisis in male identity" have sparked a rare moment of blokeish introspection.\r\n</p><p>\r\n\r\n</p><p>\r\n"One of the saddest things I have seen in my lifetime has been the decline in Australian male culture," Latham writes in a  new book. \r\n\r\n</p><p>\r\n\r\n"Australian mates and good blokes have been replaced by nervous wrecks, metrosexual knobs and toss-bags."\r\n\r\n</p><p>\r\n\r\nLatham cited a number of factors: The rise of feminism (remember it was Germaine Greer, the Australian-born author of the Female Eunuch who launched a vicious assault on Steve Irwin in the immediate aftermath of his death); changes to the family and in the workplace; and what he considers the namby pamby neo-conservatism of the John Howard government.  \r\n</p><p>\r\nThe government''s treasurer Peter Costello shot back immediately. \r\n</p><p>\r\nOnly days after proving his own macho credentials by taking a supersonic ride in a Royal Australian Air Force fighter jet, Costello assailed those of Latham. \r\n</p><p>\r\nSince stepping down from frontline politics, he asked pointedly, had not the former Labour leader been a stay-at-home dad? \r\n\r\n</p><p>\r\n<b>''Real change''</b>\r\n</p><p>\r\n\r\nOf course, Costello could have levelled similar accusations against macho heroes Steve Irwin and Peter Brock. \r\n</p><p>\r\nBrock was a vegan, who had an intense interest in New Age-style spirituality. \r\n</p><p>\r\nAnd away from the cameras, Steve Irwin was a sensitive and profoundly emotional family man, who regularly told his father, Bob, that he loved him and how he cherished their time together.\r\n\r\n</p>\r\n\r\nPrime Minister John Howard would appear to be a staunch defender of a less complicated version of Australia masculinity. \r\n</p><p>\r\nWhen video tapes from Iraq surfaced recently, showing an Australian soldier pointing a pistol at the head of a man wearing Arab clothing [thought to be another Australian soldier], the prime minister played down the incident.\r\n\r\n</p><p>\r\n\r\n"Through the ages soldiers have let off a bit of steam, haven''t they," he said. "The difference is that we now have videos and internets, we didn''t 50 or 100 years ago." \r\n\r\n</p><p>\r\n\r\nTaking the temperature this morning at Bondi beach, that great bastion of Australian masculinity, there was a surprising degree of support for the transformation of Australian man. \r\n\r\n</p><p>\r\n\r\n"The death of the larrikin and bad manners is bloody wonderful," said retired stockbroker John Ray, as he stepped from the surf. \r\n</p><p>\r\n"It''s good to see the demise of those attitudes which said women are expendable, and that you''re no good unless you go down the pub every night and get smashed. Over the past 20 years or so, there''s been a real change in blokes'' attitudes."\r\n\r\n</p><p>\r\nBut the female perspective was a little different. \r\n</p><p>\r\n"There''s no demise of the macho male in my household," said Sue Shaw, the mother of a 19-year-old boy. "My boy loves rugby and cars. That said, he waxes his body, so he does display metrosexual tendencies." \r\n\r\n</p><p>\r\n\r\nMetrosexuality vying with retrosexuality. No wonder men are so confused, as they strive to achieve the thinking man''s manhood.\r\n\r\n<p><a href="http://news.bbc.co.uk/1/hi/world/asia-pacific/5403004.stm" title="Australian blokes face up to change">Source: BBC</a></p>', 1, 4, 0, 19, '2008-06-21 10:29:45', 63, '', '2008-06-22 15:58:34', 63, 0, '0000-00-00 00:00:00', '2008-06-21 10:27:46', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 5, 0, 1, '', '', 0, 1, ''),
(165, 'Ad', 'ad', '', '<div align="center" style="margin-top:5px"><a href="#"><img src="images/ads/ad5.jpg" alt="Ad" /></a></div>', '', 1, 3, 0, 7, '2008-03-26 16:25:56', 62, '', '2008-06-28 12:19:12', 62, 0, '0000-00-00 00:00:00', '2008-03-26 16:24:52', '0000-00-00 00:00:00', '', '', 'show_title=0\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 10, 0, 3, '', '', 0, 0, 'robots=\nauthor='),
(148, 'TerranTribune Home', 'home', 'home', '{loadposition news}', '', 1, 0, 0, 0, '2008-06-23 12:54:03', 62, '', '2008-06-23 13:07:15', 62, 0, '0000-00-00 00:00:00', '2008-06-23 12:53:22', '0000-00-00 00:00:00', '', '', 'menu_image=-1\nitem_title=1\npageclass_sfx=\nback_button=\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=', 1, 0, 15, '', '', 0, 11, '');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(150, 'Features', 'features', '', '<p><b>TerranTribune</b> continues the chain of impressive, revolutionary, yet functional RocketTheme templates. It combines incredible styling with refined and powerful code to help your website achieve its maximum potential.</p>\r\n\r\n<ul class="bullet-1">\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=153&amp;Itemid=67">Color Array</a></b><br />\r\n<b>TerranTribune</b> includes an array of colors that you can select from and are integrated with the menu system for a stylish, color-changing effect.\r\n</li>\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=159&amp;Itemid=79#rokmininews">RokMiniNews</a></b><br />\r\nRokMiniNews is a powerful module to display your articles, perfect for news and media sites. It is highly configurable and is javascript enabled to allow for user interaction. A truly versatile extension</li>\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=159&amp;Itemid=79#roknewsrotator">RokNewsRotator</a></b><br />\r\nRokNewsRotator is a module that rotates your news item using the powerful of the mootools javascript library. You simply assign a category/section and watch your articles transition\r\n</li>\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=160&amp;Itemid=81#">IE6 Warning Message</a></b><br />\r\n<img src="images/stories/ie6.jpg" width="195" height="145" alt="image" align="right" class="demo-border" style="margin-right:10px;margin-left:10px;" />\r\nFor the <b>TerranTribune</b> template we included a script that will display a message to IE6 users advising them to upgrade to a more secure browser version.  <br /><br /> This is not enabled by default, but can easily be turned on or off with a toggle in the template index.php. When enabled, users visiting your site with IE6 only, will be able to view the message.  By enabling this, you can help fight the good fight that rids the internet of the evil incarnation that is IE6!    \r\n</li>\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60">Stylish Typography</a></b><br />\r\n<b>TerranTribune</b> includes a vast selection of professionally styled typography to bring that extra element to your content. Choose from several typography options including various bullet and number styles as well as much much more.\r\n</li>\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=155&amp;Itemid=69">32 Module Positions</a></b><br />\r\nWith a Module Position count of 32, as well as support for many more using the new tabbed module functionality, you will be able create a wide variety of layout options and methods for presenting your site''s content.\r\n</li>\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=154&amp;Itemid=68">Menu Extravaganza</a></b><br />\r\nSplitMenu is a dynamic colour changing menu system with 3rd level dropdowns to maximise navigation. The new <b>RokMooMenu</b> is now accompanied by its predecessor, <b>Suckerfish</b> in a toggle option so you can easier interchange for maximum compatibility.\r\n</li>\r\n\r\n<li><b><a href="index.php?option=com_content&amp;task=view&amp;id=151&amp;Itemid=65">Rocketlauncher Available</a></b><br />\r\nThe TerranTribune RocketLauncher package consists of a full 1.5.3 Joomla install, complete with all of the demo images, content, modules, and extensions. By running the installer, your Joomla site will be set up with all everything needed to create an exact implementation of the demo site automatically.\r\n</li>\r\n\r\n</ul>', '', 1, 0, 0, 0, '2008-06-24 09:15:44', 63, '', '2008-06-28 10:48:16', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:07:18', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 2, 0, 14, '', '', 0, 95, 'robots=\nauthor='),
(151, 'RocketLauncher', 'rocketlauncher', '', '<p>RocketTheme templates features some amazing advanced features and layout possibilities that open up a wide world of options for your sites. Unfortunately, the default Joomla content in a new Joomla install is very limited and does little to take advantage of the abilities of a modern Joomla template.</p>\r\n<p>Each of our demo sites has been highly customized to show off the abilities of each template and give that "professional touch" to the look and feel of the content. This professional look could not be achieved without hands on manual customization, that is, until now.</p>\r\n\r\n<p><b>TerranTribune</b> now features the exciting new RocketLauncher custom Joomla install option. With the RocketLauncher <b>TerranTribune</b> Joomla installer, you can instantly create a Joomla site complete with custom content that is a perfect replica of our <b>TerranTribune</b> demo site that has been professionally tuned to look its best, all with just a few clicks.</p>\r\n\r\n<p>The <b>TerranTribune</b> RocketLauncher package consists of a full 1.5.3 Joomla install, complete with all of the demo images, content, modules, and extensions. By running the installer, your Joomla site will be set up with all everything needed to create an exact implementation of the demo site automatically.</p>\r\n\r\n<span class="alert">RocketLauncher includes a FULL Joomla install, in addition to the template and demo contents. The Joomla installation process is necessary in creating the demo content, therefore RocketLauncher will only work properly as a new Joomla installation. It can not be used on an existing Joomla installation.</span><br />\r\n\r\n<h4>Instructions</h4>\r\n\r\n<b>Upload the files</b><br />\r\nDownload the separate TerranTribune RocketLauncher package (Joomla_RT_TerranTribune_j15.zip) from the TerranTribune template downloads section.\r\n\r\nUnzip the RocketLauncher package, after which you will have a folder named "Joomla_RT_TerranTribune_j15". Using your FTP client, upload all of the files inside of the "Joomla_RT_TerranTribune_j15" folder (not the folder itself) to your server as you would a standard Joomla installation package. You upload the files with a FTP client such as <a href="http://filezilla.sourceforge.net/" title="filezilla">Filezilla</a>. <a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,20046.0/">Want to learn more...?</a>\r\n<br /><br />\r\n<b>Run the Installer</b><br />\r\nPoint your browser to the location where you uploaded your RocketLauncher files (whichever domain/folder you uploaded to, generally the root of your web server). You will then see the Joomla 1.5 installation screen. Follow the Joomla installation on screen instructions. IMPORTANT: Be sure to click the LOAD SAMPLE DATA button in step 6 of the installation in order to load all of the demo content into your installation.\r\n\r\n<h4>Further Guides</h4>\r\n\r\n<b>RocketLauncher Installation Video Tutorial</b><p>Learn the steps to uploading the RocketLauncher package files to your server and installing the RocketLauncher template packages by following along with the steps in this detailed video tutorial. It''s now easier than ever before to deploy a replica of the RocketTheme template demo sites. <a href="http://demo.rockettheme.com/jul07/media/video_tutorial/rt_launcher_full.v1.2.html" title="RocketTutorials :: Installing RocketLauncher">Launch Video...</a></p>\r\n\r\n<b>Uploading RocketLauncher to your Root</b><p>An in depth guide that details the steps necessary to properly upload the files from the RocketLauncher template package directly to the root of your site. This will ensure your RocketLauncher installation installs to the root of your site, and not in a subfolder.  <a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,20046.0/" target="_new">Learn more...</a></p>', '', 1, 0, 0, 0, '2008-06-24 09:17:37', 63, '', '2008-06-28 10:56:48', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:16:25', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 6, 0, 13, '', '', 0, 25, 'robots=\nauthor='),
(152, 'RokBox', 'rokbox', '', '<span class="alert">Please note that RokBox is not part of the template but is an independent download from <a href="http://www.rocketwerx.com/products/rokbox/overview">http://www.rocketwerx.com/products/rokbox/overview</a>.</span>\r\n\r\n<p><b>RokBox</b>, the successor of our popular RokZoom plugin, is a <a target="_new" href="http://mootools.net">mootools</a> powered JavaScript slideshow that allows you to quickly and easily display multiple media formats including images, videos (video sharing services also) and music. RokBox provides a theme system that allows you to create your own custom ones to fit your websites design. It includes two predefined themes, a Light theme and a Dark theme that will fit seamlessly into your site design. RokBox is as easy as pie to install and customize, providing an easy way to create your own custom themes for it.</p>\r\n\r\n<p>RokBox comes in 3 formats. A standalone HTML/JavaScript solution for inclusion in any website or page; A Joomla 1.0 plugin, and a Joomla 1.5 plugin. Each Joomla! plugins come with a <b>system</b> and a <b>content</b> plugin.</p>\r\n<p>We highly recommend using <b>RokBox</b> in Joomla 1.5 for optimal performance and ease of use.</p>\r\n\r\n<h2>Screenshots</h2>\r\n<a title="RokBox Light Theme :: A screenshot of an image shown with RokBox in the default light style" rel="rokbox[640 594](rokbox)" href="http://rocketwerx.com/images/rokbox/sshot1.jpg"><img alt="RokBox Light Theme :: A screenshot of an image shown with RokBox in the default light style" src="http://rocketwerx.com/images/rokbox/sshot1_thumb.jpg" class="album" style="margin: 3px; padding: 3px; border: 3px solid #eee; width: 130px;" /></a>\r\n\r\n<a title="RokBox Dark Theme :: A screenshot of an image shown with RokBox in the optional dark style" rel="rokbox[640 594](rokbox)" href="http://rocketwerx.com/images/rokbox/sshot2.jpg"><img alt="RokBox Dark Theme :: A screenshot of an image shown with RokBox in the optional dark style" src="http://rocketwerx.com/images/rokbox/sshot2_thumb.jpg" class="album" style="margin: 3px; padding: 3px; border: 3px solid #eee; width: 130px;" /></a>\r\n\r\n<a title="RokBox System Plugin Prefernces :: The plugin is fully configurable via the system plugin prefences parameters" rel="rokbox[640 549](rokbox)" href="http://rocketwerx.com/images/rokbox/sshot3.jpg"><img alt="RokBox System Plugin Prefernces :: The plugin is fully configurable via the system plugin prefences parameters" src="http://rocketwerx.com/images/rokbox/sshot3_thumb.jpg" class="album" style="margin: 3px; padding: 3px; border: 3px solid #eee; width: 130px;" /></a>\r\n\r\n<h2>Features</h2>\r\n\r\n<ul>\r\n<li>Mootools v1.11 compatible</li>\r\n<li>4 Customizable Transition Type: <b>Fade, QuickSilver, Growl, Explode.</b></li>\r\n<li>Support for <b>Images</b>, <b>QuickTime</b> (.mov), <b>Windows Media Video</b> (.wmv), <b>Flash</b> (.swf), <b>YouTube</b>, <b>DailyMotion</b>, <b>MetaCafe</b>, <b>Google Video</b>, <b>Vimeo</b>, <b>Audio</b> (.mp3, .wav), <b>local</b> and <b>remote</b> sites.</li>\r\n<li>Support for albums/categories.</li>\r\n<li>Support for <b>Captions</b> including support for titles and descriptions.</li>\r\n<li>2 Predefined Themes provided: <b>Light Theme</b>, <b>Dark Theme</b>.</li>\r\n<li>Support for custom themes with ability to customize styles and RokBox configuration per theme.</li>\r\n<li>Ability to auto-generate thumbnails when RokBox-ing local images.</li>\r\n<li>Support for generate <b>thumbnail</b> or <b>inline</b> links from your Joomla! Content.</li>\r\n</ul>\r\n\r\n\r\n<h2>History</h2>\r\n\r\n<p><b>RokBox</b> is a Joomla! plugin inspired by the now famous LightBox, but with a large support for multimedia content and not only images. RokBox is written by Djamil Legato.</p>\r\n\r\n<h2>Demo</h2>\r\n\r\nBelow are examples of just some of the formats that you use with RokBox, an image, a video and even an iframe/wrapper!\r\n\r\n<span class="note">To see a more extensive demo of RokBox with descriptions and syntax, please visit <a href="http://www.rocketwerx.com/products/rokbox/demo">http://www.rocketwerx.com/products/rokbox/demo</a></span>\r\n\r\n<div style="float: left; width: 25%; margin-right: 10px">\r\n\r\n\r\n\r\n<h3 style="text-align: center;">Image</h3>\r\n<a title="RokBox Light Theme :: A screenshot of an image shown with RokBox in the default light style" rel="rokbox[640 594](rokbox)" href="http://rocketwerx.com/images/rokbox/sshot1.jpg"><img alt="RokBox Light Theme :: A screenshot of an image shown with RokBox in the default light style" src="http://rocketwerx.com/images/rokbox/sshot1_thumb.jpg" class="album" style="margin: 3px; padding: 3px; border: 3px solid #eee; width: 130px" /></a>\r\n</div>\r\n\r\n<div style="float: left; width: 25%; margin-right: 10px; ">\r\n<h3 style="text-align: center;">Video</h3>\r\n<a title="Torino 2006 :: Opening Ceremony Olympic Games Torino 2006 - Ski Jumper" rel="rokbox[425 373](demo)" href="http://www.youtube.com/watch?v=4BY40QvWQKE"><img alt="Torino 2006 :: Opening Ceremony Olympic Games Torino 2006 - Ski Jumper" src="http://rocketwerx.com/images/rokbox/demo/youtube.jpg" class="album" style="margin: 3px; padding: 3px; border: 3px solid #eee; height: 130px !important; width: 130px;" /></a>\r\n</div>\r\n\r\n<div style="float: left; width: 25%;">\r\n<h3 style="text-align: center;">Wrapper</h3>\r\n<div class="center"><a title="Did you mean... :: ...Google?" rel="rokbox[700 450]" href="http://www.google.com"><img alt="Did you mean... :: ...Google?" src="images/stories/google.jpg" class="album" style="margin: 3px; padding: 3px; border: 3px solid #eee; height: 130px;" /></a></div>\r\n</div>\r\n\r\n<div class="clr"></div><br /><br />\r\n', '', 1, 0, 0, 0, '2008-06-24 09:18:44', 63, '', '2008-06-24 14:08:10', 63, 0, '0000-00-00 00:00:00', '2008-06-24 09:17:51', '0000-00-00 00:00:00', '', '', 'menu_image=-1\nitem_title=1\npageclass_sfx=\nback_button=\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=', 1, 0, 12, '', '', 0, 31, ''),
(153, 'Color Styles', 'color-styles', '', '<b>TerranTribune</b> is a stylish professional design with lots of versatility. You can choose one of the included menu assignable color styles by specifying it in the template''s configuration options in the Joomla admin. \r\n\r\n<br /><br />\r\n\r\n<div align="center">\r\n<img src="images/stories/styles/ss_style1.jpg" alt="Style1" style="margin-bottom:10px" /><br />\r\n<img src="images/stories/styles/ss_style2.jpg" alt="Style2" style="margin-bottom:10px" /><br />\r\n<img src="images/stories/styles/ss_style3.jpg" alt="Style3" style="margin-bottom:10px" /><br />\r\n<img src="images/stories/styles/ss_style4.jpg" alt="Style4" style="margin-bottom:10px" /><br />\r\n<img src="images/stories/styles/ss_style5.jpg" alt="Style5" style="margin-bottom:10px" /><br />\r\n<img src="images/stories/styles/ss_style6.jpg" alt="Style6" style="margin-bottom:10px" /><br />\r\n<img src="images/stories/styles/ss_style7.jpg" alt="Style7" />\r\n</div>', '', 1, 0, 0, 0, '2008-06-24 09:18:51', 63, '', '2008-06-29 07:26:14', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:17:51', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 3, 0, 11, '', '', 0, 41, 'robots=\nauthor='),
(154, 'Menu Options', 'menu-options', '', '<p><b>TerranTribune</b> features the exciting and exclusive RokMooMenu system for the ultimate in menu functionality and style, as well as the popular and reliable RTSplitMenu. An option for Suckerfish is also included. Here you can read an overview of the <b>TerranTribune</b> menu configuration options.</p>\r\n\r\n<span class="note">\r\n<b>Video Tutorial Currently Available!</b><br/>\r\n\r\n<a title="RocketTutorials :: Menu Configuration" rel="rokbox[820 520]" href="http://tutorials.rockettheme.com/video/menu_configuration/menu_config.v1.2.html">Launch the Joomla Menu Setup Video Tutorial now!</a><i>(Requires Flash)</i></span>\r\n\r\n\r\n<h2>Selecting your Menu Style</h2>\r\n\r\n<p><b>TerranTribune</b> allows you to choose from 3 menu options:</p>\r\n\r\n<ul class="bullet-1">\r\n	<li style="margin-bottom:0px;"><b><a href="index.php?option=com_content&amp;task=view&amp;id=154&amp;Itemid=68&amp;mtype=moomenu">RokMooMenu</a></b> - The exciting new menu system based on the ever popular Suckerfish menu style, featuring mootools powered transitions and effects.</li>\r\n	<li style="margin-bottom:0px;"><b><a href="index.php?option=com_content&amp;task=view&amp;id=154&amp;Itemid=68&amp;mtype=suckerfish">Suckerfish</a></b> - The versatile dropdown menu is now an option in combination with RokMooMenu to minimize library conflicts.</li>\r\n	<li style="margin-bottom:0px;"><b><a href="index.php?option=com_content&amp;task=view&amp;id=154&amp;Itemid=68&amp;mtype=splitmenu">SplitMenu</a></b> - Then venerable SplitMenu is a solid choice for navigation.  It works by rendering the top-level menu options horizontally, and the submenu/child items are rendered in a module on the side. Now with advanced 3rd level features.</li>\r\n</ul>\r\n\r\n<p>You can designate which menu type you want to use on your site with a single control in the Template Manager (located in the Joomla Administrator).</p>\r\n\r\n\r\n<h3><a name="moomenu1" href="#moomenu1">The Powerful &amp; Popular RokMooMenu</a></h3>\r\nMaking its return this month is the immensely popular RokMooMenu. This menu has been developed from scratch using the latest and greatest MooTools JavaScript framework. The RokMooMenu is a highly advanced and fully customizable menu system. Some of the great features include:\r\n<ul>\r\n<li>Hover support for IE6 using the sfHover javascript class just like in Suckerfish.</li>\r\n<li>Fully degradable to standard SuckerFish menu if javascript is not supported.</li>\r\n<li>Configurable mouse-out delay to allow for accidental mousing out of the menu.</li>\r\n<li>Completely customizable animation effects using MooTools transitions. Can be configured in X and/or Y directions.</li>\r\n<li>Support for fade-in transparency</li>\r\n<li>Experimental support for IE6 z-index bug using the iFrame hack.</li>\r\n</ul>\r\nAn example configuration as used in the demo:\r\n<pre>\r\n&lt;script type=&quot;text/javascript&quot;&gt;\r\nwindow.addEvent(&#x27;domready&#x27;, function() {\r\nnew Rokmoomenu($E(&#x27;ul.menutop &#x27;), {\r\nbgiframe: false,\r\ndelay: 500,\r\nanimate: {\r\nprops: [&#x27;width&#x27;, &#x27;opacity&#x27;],\r\nopts: {\r\nduration: 600,\r\ntransition: Fx.Transitions.Sine.easeOut\r\n}\r\n}\r\n});\r\n});\r\n&lt;/script&gt;</pre>\r\n\r\n<h3>Menu Settings</h3>\r\n<ul>\r\n<li><b>Bgiframe</b> - Can be <b>true</b> or <b>false</b>. Only turn on if you are having problems with IE and z-index. This feature is experimental.</li>\r\n\r\n<li><b>Delay</b> - Defaults to 500ms. This is the how <b>long</b> you can mouse off the menu before it vanishes.</li>\r\n\r\n<li><b>Props</b> - These are the <b>properties</b> that will be applied to the menu. Can be any combination of opacity, width, height. The two properties, width and height are affected by the transition defined in opts.</li>\r\n\r\n<li><b>Duration</b> - the <b>time</b> in ms the animation will run for.</li>\r\n\r\n<li><b>Transitions</b> - any of the available <a href="http://mootools.net"><b>MooTools</b></a> transitions. See below for more details.<br />For example, &quot;<b>Bounce.easeIn</b> or <b>Bounce.easeOut</b> or <b>Bounce.easeInOut</b>&quot; produce a bouncing effect.</li>\r\n</ul>\r\n\r\n<span class="info">For more details with diagrams, visit the <a href="http://docs.mootools.net/Effects/Fx-Transitions.js">Mootools documentation site</a></span>\r\n\r\n<h3><a name="guide" href="#guide">Creating dropdown menus for RokMooMenu and Suckerfish</a></h3>\r\nTo have specific menu items appear as sub items, you must assign them to the specific navigation item in which they will originate from. The following tutorial will show you how simple it is to create your ideal menu system.<br /><br />\r\n\r\n<h3><a name="step1" href="#step1">Step 1 - Navigation</a></h3>\r\nOnce you have logged into the Joomla! Administration Area, you must navigate to the Menu area. Hover over the Menu item in the taskbar to show the dropdown menu. For this example, we are going into the mainmenu but the technique is exactly the same for all menus in the Administrative area.\r\n\r\n<h3><a href="#step2" name="step2">Step 2 - The Menu Manager</a></h3>\r\nYou will then be transported to the Menu Manager for mainmenu. At this point, you can do 2 things. The first is to edit an existing menu item, which we will be doing in this tutorial or create a New menu item to be subordinate to an existing item. Click on the item you want to be part of the dropdown menu.\r\n\r\n<h3><a href="#step3" name="step3">Step 3 - Assigning a Parent Item</a></h3>\r\nYou can now assign the content item to the mainmenu item in which you want to be in the dropdown menu. Identify the "Parent Item" section of the manager. You will select the item in which you wish to be the parent and the source of the dropdown menu. In this example, we have selected "Home".', '', 1, 0, 0, 0, '2008-06-24 09:21:50', 63, '', '2008-06-28 21:36:33', 63, 0, '0000-00-00 00:00:00', '2008-06-24 09:20:58', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 4, 0, 10, '', '', 0, 64, 'robots=\nauthor='),
(155, 'Module Positions', 'module-positions', '', '<p><strong>TerranTribune</strong> has been constructed with an assortment of 32 module positions allowing for one of the most versatile designs ever. Most module positions are fully collapsible meaning that if there are no modules published in  particular area, that module area will not be shown. This provides you with the maximum amount of flexibility possible.</p>\r\n\r\n<br />\r\n\r\n<center><img src="images/module-positions.jpg" alt="Module Positions" style="border:4px solid #f1f1f1" /></center>', '', 1, 0, 0, 0, '2008-06-24 09:22:35', 63, '', '2008-06-29 07:26:49', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:22:10', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 4, 0, 9, '', '', 0, 33, 'robots=\nauthor='),
(156, 'Module Variations', 'module-variations', '', '<strong>TerranTribune</strong> has 3 module class suffixes which are structural in their purposes. They allow you to change the layout of the module itself. These are <em>-title</em> (this loads the title bar on the module) or <em>-notitle</em> (this removes the title bar on the module) or -<em>ad</em> (provides a layout suitable for sidebar ads). \r\n<br /><br />\r\n\r\nTo use these, just add the hilite names in the <b>module class suffix</b> parameter of the module in the <b>Module Manager</b> located in your Joomla administrator.<br /><br />\r\n\r\n<img alt="Module Suffix Setting" src="images/stories/mod_suffix.jpg" />\r\n<div style="position: absolute; margin-left: 170px; margin-top: -37px;">-notitle</div>\r\n<br /> <br />', '', 1, 0, 0, 0, '2008-06-24 09:23:00', 63, '', '2008-06-28 11:03:32', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:22:46', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 3, 0, 8, '', '', 0, 95, 'robots=\nauthor='),
(157, 'Tutorials', 'tutorials', '', '<br />\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=158&amp;Itemid=78"><img src="images/tutorial/icon1.png" align="left" border="0" alt="Install TerranTribune" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">Installing TerranTribune</div>\r\n\r\n<p>An overview of template files and instructions for installing and activating the template. <a href="index.php?option=com_content&amp;task=view&amp;id=158&amp;Itemid=78">Read More...</a></p>\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n\r\n\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=159&amp;Itemid=79"><img src="images/tutorial/icon2.png" align="left" border="0" alt="Custom Modules" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">Custom Modules</div>\r\n\r\n<p>Learn all about the included <strong>TerranTribune</strong> custom modules and how to configure them for your site. <a href="index.php?option=com_content&amp;task=view&amp;id=159&amp;Itemid=79">Read More...</a></p>\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n\r\n\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=154&amp;Itemid=68"><img src="images/tutorial/icon3.png" align="left" border="0" alt="Menu Options" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">Menu Options</div>\r\n\r\n<p>An overview of the <strong>TerranTribune</strong> menu options including the top menu icon configuration. <a href="index.php?option=com_content&amp;task=view&amp;id=158&amp;Itemid=68">Read More...</a></p>\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n\r\n\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=160&amp;Itemid=81"><img src="images/tutorial/icon4.png" align="left" border="0" alt="Customization" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">Customisation</div>\r\n\r\n<p>A guide to the <strong>TerranTribune</strong> customisation options that can be configured within the template''s <b>index.php</b>. <a href="index.php?option=com_content&amp;task=view&amp;id=160&amp;Itemid=81">Read More...</a></p>\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n\r\n\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=161&amp;Itemid=82"><img src="images/tutorial/icon5.png" align="left" border="0" alt="Typography" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">Using Typography</div>\r\n\r\n<p>A guide to using the included the <strong>TerranTribune</strong> typography styles in your site. <a href="index.php?option=com_content&amp;task=view&amp;id=161&amp;Itemid=82">Read More...</a></p>\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n\r\n\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=162&amp;Itemid=83"><img src="images/tutorial/icon6.png" align="left" border="0" alt="Demo Content" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">Demo Content</div>\r\n\r\n<p>A look at some of the modules and techniques used in the demo content on the frontpage of the <strong>TerranTribune</strong> demo. <a href="index.php?option=com_content&amp;task=view&amp;id=162&amp;Itemid=83">Read More...</a></p>\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n\r\n\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=163&amp;Itemid=84"><img src="images/tutorial/icon7.png" align="left" border="0" alt="Logo Editing" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">Logo Editing</div>\r\n\r\n<p>An overview for customizing your logo and replacing the logo text with your organization or company name and logo. <a href="index.php?option=com_content&amp;task=view&amp;id=163&amp;Itemid=84">Read More...</a></p>\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n\r\n\r\n<a href="http://tutorials.rockettheme.com/joomla-templates/terrantribune-tutorials/pngfix.html"><img src="images/tutorial/icon8.png" align="left" border="0" alt="PNGfix" class="nounder" style="margin-right:10px;" /></a><div style="font-size:130%;font-weight:bold;margin-bottom:15px;padding-top:3px;">PNGfix</div>\r\n\r\n<p>An overview of how to customize your <strong>TerranTribune</strong> in respects to the Internet Explorer PNGfix. <a href="http://tutorials.rockettheme.com/joomla-templates/terrantribune-tutorials/pngfix.html">Read More...</a></p>\r\n\r\n<div class="clr" style="border-bottom: 3px solid #eee; padding: 3px; margin-bottom: 17px;"></div>\r\n<br /><br />\r\n\r\n<div class="contentheading">More TerranTribune Template Tutorials</div>\r\n\r\n<p>Continue learning how to configure and customize the TerranTribune template with the following guides and tutorials available in the RocketTheme  members forum board.</p>\r\n\r\n\r\n<ul>\r\n	<li><a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,37087.0/"><b>Integrate Flash Clock</b></a></li>\r\n	<li><a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,37030.0/"><b>Integrate RokBlog</b></a></li>\r\n	<li><a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,37029.0/"><b>Integrate IE6 Warning</b></a></li>\r\n	<li><a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,37028.0/"><b>Integrate RokMiniNews</b></a></li>\r\n</ul>\r\n\r\n\r\n<ul>\r\n	<li><a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,37027.0/"><b>RocketTheme Logo / Copyright</b></a></li>\r\n	<li><a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,37026.0/"><b>Logo Changes</b></a></li>\r\n	<li><a href="http://www.rockettheme.com/option,com_smf/Itemid,190/topic,37025.0/"><b>Disable the Template''s scripts</b></a></li>\r\n</ul>\r\n\r\n', '', 1, 0, 0, 0, '2008-06-24 09:24:14', 63, '', '2008-06-26 10:50:05', 63, 0, '0000-00-00 00:00:00', '2008-06-24 09:23:50', '0000-00-00 00:00:00', '', '', 'menu_image=-1\nitem_title=1\npageclass_sfx=\nback_button=\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=', 1, 0, 7, '', '', 0, 97, ''),
(158, 'Installation', 'installation', '', '<p>The following is a guide that covers how to set up your new <strong>TerranTribune</strong> template on your Joomla site. Here you can find an overview of the files included in the <b>TerranTribune</b> release and instructions on installing and activating the template in your Joomla install.</p>\r\n\r\n<h3>Downloading the TerranTribune Files</h3>\r\n\r\nThe first step is to download all of the files that will be needed to install your template, custom modules, as well as make modifications. Here is a quick explanation of each of the available files in the <strong>TerranTribune</strong> release.\r\n\r\n<ul class="bullet-1">\r\n	\r\n	<li><b>TerranTribune Template</b> <i>(rt_terrantribune_j15.tgz)</i> This file is the template package you will use to install your template into Joomla.</li>\r\n\r\n	<li><b>TerranTribune Custom Extensions</b> <i>(terrantribune-extensions-j15.zip)</i> This package contains each of the individual custom extensions included in the terrantribune template release.</li>\r\n\r\n	<li><b>TerranTribune Source PNG''s</b> <i>(terrantribune-sources.zip)</i> This zip contains the source PNGs for making modifications and customizations to the images in the template as well as the logo font. There are additional sources for the transparent background, buttons, typography and headers. You will need an image editing software (preferably Adobe/Macromedia Fireworks) to utilize the Source PNG files. </li>\r\n\r\n	<li><b>TerranTribune RocketLauncher</b> <i>(Joomla_RT_TerranTribune_j15.zip)</i> This is the RocketLauncher pack for TerranTribune which is a complete and separate Joomla install which has the template preinstalled, configured as well as the demo content already implemented.</li>\r\n\r\n</ul>\r\n\r\n<div style="float: left; width: 47%; margin-right: 7%;">\r\n<h3 style="font-size: 120%; margin-top: 0px; margin-bottom: 0px;">Step 1 - Using the Joomla installer</h3>\r\n\r\nGo to your Admin control panel for your site. In the Menu at the top, go to <b><u>Extensions</u></b> > <b><u>Install/Uninstall</u></b>. Next browse for your <b>rt_terrantribune_j15.tgz</b> file you downloaded and then click <b>Upload File &amp; Install</b>. Now <strong>TerranTribune</strong>  is installed and in your template list. You should observe an introductory page in which you select <b>Continue</b>.\r\n<br />\r\n</div>\r\n\r\n\r\n<div style="float: left; width: 45%;">\r\n<h3 style="font-size: 120%; margin-top: 0px; margin-bottom: 0px;">Step 2 - Making TerranTribune Default</h3>\r\n\r\nNext, from your admin control panel, go to <b><u>Extensions</u></b> > <b><u>Template Manager</u></b>. This will pull up the list of your installed templates. Find TerranTribune on the list and select the radio button to the left and then click <b>Default</b> up in the top right corner. TerranTribune will now be the default template on your Joomla! website.\r\n</div>', '', 1, 0, 0, 0, '2008-06-24 09:25:53', 63, '', '2008-06-28 11:11:21', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:24:51', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 3, 0, 6, '', '', 0, 25, 'robots=\nauthor='),
(159, 'Custom Modules', 'custom-modules', '', '<p>Learn all about the exciting new RocketTheme exclusive modules that are included in the <b>TerranTribune</b> template release. Here you can find instructions for installation and configuration for each of the custom modules.</p>\r\n\r\n<div style="width: 48%; float: left; margin-right: 3%; margin-bottom: 0;">\r\n<h3>Step One: Installing the Module</h3>\r\n<ul class="bullet-5">\r\n<li>Download the <b>terrantribune-extensions-j15.zip</b> archive from the <strong>TerranTribune</strong>  download section of the RocketTheme Joomla! Club.  Unzip the archive, inside you will find individual zip files for each of the modules.</li> \r\n<li>Login in to your administrator console on your Joomla! website and navigate to the <b>Extensions</b> menu item, and select <b>Install/Uninstall</b> from the dropdown menu.\r\n</li>\r\n<li>In the <b>Upload Package File</b> section, click the <b>Choose File</b> button and select one of the <b>mod_modulename.zip</b> that was inside of the zip file you downloaded earlier.  Next click the <b>Upload File &amp; Install</b> button to install the module.</li></ul>\r\n</div>\r\n\r\n\r\n<div style="width: 48%; float: left; margin-bottom: 0;">\r\n<h3>Step Two: Publishing the Module</h3>\r\n<ul class="bullet-5">\r\n<li>Now the module is installed it must be published in the appropriate module position and configured to suit our needs.  From the top menu, select <b>Extensions</b> then <b>Module Manager</b>.</li>\r\n<li>This will take you to the <b>Module Manager</b> which allows you to configure the placement and configuration of all modules in your Joomla! website.</li>\r\n<li>Locate the module from the list. Remember there could be a few pages. Once you have found it, you can publish in 2 ways: The first is selecting the cross next to the tile or clicking the title then set <b>Publish</b> to <b>Yes</b> followed by a Save.</li></ul>\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n<h3><a name="rokmininews" href="#rokmininews">RokMiniNews</a></h3>\r\nRokMiniNews is a powerful module to display your articles, perfect for news and media sites. It is highly configurable and is javascript enabled to allow for user interaction. A truly versatile extension.\r\n<br /><br />\r\nWe will take a quick look at the parameters you will find when you install this module.\r\n\r\n<ol>\r\n	\r\n	<li>Title: Hide</li>\r\n	<li>Position: We recommend the newsflash position.</li>\r\n	<li>Access level: Public</li>\r\n	<li>Published: Yes</li>\r\n	<li>Ordering: Determines which appears first, controlled by the creation or modification date of the article</li>\r\n	<li>Preview Length: This is the number of characters loaded in the module.</li>\r\n	<li>Frontpage items: Show or Hide</li>\r\n	<li>Default # of Articles: Select either 0, 5, 10 and 15 as the default option on load.</li>\r\n	<li>Section: Choose which Section to pull your stories from.</li>\r\n	<li>Module Class Suffix and Cache: Most will leave empty by default.</li>\r\n	<li>Extra Module CSS Class: Adds a class to the module to allow for custom styling, such as colour.</li>\r\n	<li>Use Custom CSS: The Module can be set to not load the template''s styling if you wanted to custom appearance/theme.</li>\r\n\r\n</ol>\r\n\r\n<h4>Demo Setup</h4>\r\n\r\nOn the demo, you will see we have 6 blocks of content. These are all individual installs of RokMiniNews. To copy and setup this module, follow the steps below:-\r\n\r\n<ol>\r\n	<li>Login into the Administrator</li>\r\n	<li>Navigate to the Module Manager</li>\r\n	<li>Find your install of RokMiniNews in the list</li>\r\n	<li>Tick the box to the left of the Module''s title in the list</li>\r\n	<li>Click the Copy button in the top right of the Module Manager</li>\r\n	<li>Now setup the new copied RokMiniNews</li>\r\n	<li>Ensure the module is assigned to the same position as its clone to have the javascript move effect (we use <b>newsflash</b> on the demo)</li>\r\n</ol>\r\n\r\n<h3><a name="roknewsrotator" href="#roknewsrotator">RokNewsRotator</a></h3>\r\nRokNewsRotator is a module that rotates your news item using the powerful of the mootools javascript library. You simply assign a category/section and watch your articles transition<br /><br />\r\nWe will take a quick look at the parameters you will find when you install this module.\r\n<ol>\r\n	\r\n	<li>Title: Hide</li>\r\n	<li>Position: We recommend the header position.</li>\r\n	<li>Access level: Public</li>\r\n	<li>Published: Yes</li>\r\n	<li>Module Class Suffix and Cache: Most will leave empty by default.</li>\r\n	<li>Module Mode: You have a choice of what type of content to choose from.</li>\r\n	<li>Link Titles: Enable this option if you wish the titles to link to your main article.</li>\r\n	<li>Link Image: Similar to the above but adds a link to your content image.</li>\r\n	<li>Frontpage items: Show or Hide</li>\r\n	<li>Count: Enter how many items you would like to show in the module.</li>\r\n	<li>Category: Choose which Category to pull your stories from.</li>\r\n	<li>Section: Choose which Section to pull your stories from.</li>\r\n	<li>Read More Label: Enter any text such as Read On, or Learn More.</li>\r\n	<li>Show Controls: This option will enable/disable the controls that appear when you hover over the rotator.</li>\r\n	<li>AutoHide Control: This option controls where the controls are permanently active or just appear on hover.</li>\r\n	<li>Preview Length: This is the time your article will display for.</li>\r\n\r\n</ol>\r\n\r\n<p>All you need to do now is to create some content items which are assigned to the category/section you chose in the module settings. In the content item, you will need to use the following syntax to load the image with the correct styling. The code is content editor HTML mode friendly. </p>\r\n\r\n<pre>&lt;!--IMAGE image_path IMAGE--&gt;</pre>\r\n\r\n<p>An example is as follows</p>\r\n\r\n<pre>&lt;!--IMAGE images/stories/lego/rotator-3.jpg IMAGE--&gt;</pre>\r\n\r\n<p>Place the image code at the top of your content item and write your content after it.</p>\r\n\r\n<span class="alert">Ensure that you are either, using HTML mode in your content editor or disabling your content editor entirely. If you wish to disable your WYSIWYG editor, then go to <u><em><strong>Admin > Site > User Manager > *You*</strong></em></u> and select <strong>No Editor</strong> then save.</span>\r\n\r\n<h4>Demo Setup</h4>\r\n\r\nIf you wish to mimic the setup of the demo, then it is a simple procedure.\r\n\r\n<ol>\r\n	<li>Login into the Joomla administrator</li>\r\n	<li>Create your content item in your particular category/section</li>\r\n	<li>Assign this content item to appear on the frontpage</li>\r\n	<li>Navigate to <strong><u>Admin > Extensions > Module Manager > RokNewsRotator</u></strong></li>\r\n	<li>Set the <strong>Frontpage items</strong> setting to <strong>Show</strong></li>\r\n	<li>Navigate to <u><strong>Admin > Menu > mainmenu > Home</strong></u></li>\r\n	<li>Set the <em>(leading, intro, columns &amp; links)</em> options to 0</li>\r\n	<li>Save</li>\r\n</ol>\r\n\r\n<span class="note">Note that setting no articles to display will result in a XHTML validation error due to an error in the Joomla core coding. Therefore, you may wish to add a placeholder article. To avoid this appearing in the RokNewsRotator module, unsure that you change the creation and modification date to much earlier than the set articles loading in the Module. On the demo, we have 6 articles assigned to the frontpage, the RokNewsRotator loads 5 due to its setting for Count being 5. Therefore, the 6th article doesn''t appear in the module.<br /><br />\r\nTo ensure that this artificially dated article is the one that appears in the Mainbody area, ensure that in <b>Home > Menu > mainmenu > Home</b>, Order is set to oldest first.</span>\r\n\r\n<p>For your content items, use something similar to the following code (this has been extracted from the demo content):-</p>\r\n\r\n<pre style="overflow: auto; width: 530px;">&lt;!--IMAGE images/stories/rotator/5.jpg IMAGE--&gt;&lt;img src=&quot;images/stories/world/s-america/1.jpg&quot; alt=&quot;Alonso Unsure&quot; width=&quot;100&quot; height=&quot;100&quot; align=&quot;left&quot; style=&quot;margin-right: 8px;&quot; /&gt;\r\n\r\nS&Atilde;O PAULO, Brazil (AP) -- Three heavily armed robbers stole two Pablo Picasso prints from an art museum in downtown S&atilde;o Paulo on Thursday, the city&#x27;s second high profile art theft...</pre>\r\n\r\n<p>Observe that we have the RokNewsRotator code, image HTML code as well as the content item. The RokNewsRotator code will only appear in the module itself and as its using commenting HTML code to parse the image, it will not appear in your article. Similarly, RokNewsRotator doesn''t process HTML code so the image from the content item will not appear in the module. This ensures that you do not have to create a new category/section just for RokNewsRotator as you can easily assign whatever content items you wish with this method and maintain the integrity of the article in both mediums</p>', '', 1, 0, 0, 0, '2008-06-24 09:26:49', 63, '', '2008-06-28 11:21:54', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:25:59', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 3, 0, 5, '', '', 0, 40, 'robots=\nauthor='),
(160, 'Basic Customisation', 'basic-customisation', '', '<p>A guide to the basic <b>TerranTribune</b> customisation options that can be configured in the template manager </p>\r\n\r\n<img src="images/tutorial/customisation.jpg" alt="Customisation" />\r\n\r\n<h3><a href="#ie-warn" name="ie-warn">IE6 Warning</a></h3>\r\nWarn your visitors using Internet Explorer 6 to upgrade to a more secure version with this toggle.<br /> <br />\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;margin-right:15px;padding:5px;">\r\n<h3><a href="#d-color" name="d-color">Default Color</a></h3>\r\n<strong>TerranTribune</strong> has 8 selectable colour options for the horizontal menu bar. Simply change the settings in the template manager.\r\n</div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;">\r\n<h3><a href="#m-colors" name="m-colors">Menu Colors</a></h3>\r\nWarn your visitors using Internet Explorer 6 to upgrade to a more secure version with this toggle.<br /> <br />\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;margin-right:15px;padding:5px;">\r\n<h3><a name="fontfamily" href="#fontfamily">Font Family</a></h3>\r\nYou can choose which font you would like to use for your titles.\r\n</div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;">\r\n<h3><a href="#s-logo" name="s-logo">Show Logo</a></h3>\r\nWith the manager setting enabled, you can have the logo as a module position (<strong>icon</strong>).\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;margin-right:15px;padding:5px;">\r\n<h3><a name="f-buttons" href="#f-buttons">Font Buttons</a></h3>\r\nYou can enable or disable the font sizer buttons that will display at the top of the template.<br /><br /> \r\n</div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;">\r\n<h3><a name="t-width" href="#t-width">Template Width</a></h3>\r\nYou have the ability to select the width of the template. The template setting is what you edit to either reduce or increase templates width.\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;margin-right:15px">\r\n<h3><a name="lc-width" href="#lc-width">LeftColumn Width</a></h3>\r\nWith the manager setting, you can choose the width of the left column.\r\n</div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px">\r\n<h3><a name="rc-width" href="#rc-width">RightColumn Width</a></h3>\r\nWith the manager setting, you can choose the width of the right column.\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;margin-right:15px">\r\n<h3><a name="s-date" href="#s-date">Show Date</a></h3>\r\nThe template has a styled date module which will display the current date (day, date and month). The manager setting controls whether it is active.\r\n</div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px">\r\n<h3><a name="splitmenu-side" href="#splitmenu-side">Splitmenu Location</a></h3>\r\nWith this setting, choose to have the sidebar placed on the left or right of the mainbody. The name of the module positions changes to reflect left or right.\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;margin-right:15px">\r\n<h3><a href="#m-name" name="m-name">Menu Name</a></h3>\r\nThe following parameter controls which Joomla! menu is loaded for the horizontal navigation bar.<br/>\r\n</div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;">\r\n<h3><a href="#m-type" name="m-type">Menu Type</a></h3>\r\nYou can either, select moomenu,  suckerfish, splitmenu, or as a separate module position.\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px;margin-right:15px;">\r\n<h3><a name="d-font" href="#d-font">Default Font</a></h3>\r\nBased on your own personal preference, you can set the default font size with this template setting.\r\n</div>\r\n\r\n<div style="margin-bottom:0;float:left;width:45%;padding:5px">\r\n<h3><a name="pathway" href="#pathway">Show Pathway</a></h3>\r\nThis setting controls whether the pathway appears on your site.<br />\r\n</div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div>\r\n<h3><a name="s-copyright" href="#s-copyrighy">Show Copyright</a></h3>\r\nThis setting allows you to change the copyright text and RocketTheme logo at the bottom of the template to the module position: <strong>footer</strong>.\r\n</div>', '', 1, 0, 0, 0, '2008-06-24 09:27:17', 63, '', '2008-06-29 16:46:59', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:26:56', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 4, 0, 4, '', '', 0, 22, 'robots=\nauthor=');
INSERT INTO `#__content` (`id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`) VALUES
(161, 'Logo Editing', 'logo-editing', '', '<p>The following is a step by step guide to customising your TerranTribune logo image by replacing the logo text  with your own organization or company''s name and logo.</p>\r\n\r\n<span class="info">In order to utilise the Fireworks Source PNG included with the terrantribune template release, you will need Adobe Fireworks. The 30-day free trial of this software as well as more information is available <a href="http://www.adobe.com/products/fireworks/" target="_new"><strong>here at the Adobe website</strong></a>.</span><div class="clr"></div><br />\r\n\r\n<a rel="rokbox[504 336]" title="TerranTribune Logo Customization" href="http://tutorials.rockettheme.com/video/jul08/logo-editing.mov"><img src="images/stories/logo-editing-video.jpg" alt="Logo Editing" align="left" style="margin-right: 15px" /></a><h3>Logo Editing Video Tutorial</h3>\r\nLearn how to customize your TerranTribune logo using Adobe Fireworks with this detailed video tutorial. <a rel="rokbox[504 336]" title="TerranTribune Logo Customization" href="http://tutorials.rockettheme.com/video/jul08/logo-editing.mov">Watch Now!</a>\r\n\r\n<div class="clr"></div>\r\n\r\n<h2>Customising Your Logo</h2>\r\n\r\n<p>One of the first steps of customising your new <strong>TerranTribune</strong> template will undoubtedly be altering the logo text to reflect the name of your company / organization. RocketTheme makes this process a simple one by including both the Source PNG for the template, as well as font(s) used.</p>\r\n\r\n<p>The most effective way to customise the logo is to use the included Source PNG file. When opened in Adobe Fireworks, this file contains all of the Layers in the design allowing you to tweak and change any of the image elements of the template design. The following steps will help you quickly get your new logo ready to go:</p>\r\n\r\n<div>\r\n<h3><a name="step1" href="#step1">Step 1</a></h3>\r\n\r\nFirst, open the header Source PNG file in Adobe Fireworks. On the right side, you will notice a taskbar named <strong>Layers</strong>. Inside this column, a list of elements within the source will appear, divided into folders. The first is Web Layers which controls the green slices on the page that are used to export the images. Click the eye which is immediately left to the folder name <strong>Web Layers</strong> to make it invisible. This allows use to edit the logo.<br /><br />\r\n<img  src="images/tutorial/logo/logo0.jpg" alt="Logo"/>\r\n</div>\r\n\r\n<div>\r\n<h3><a name="step2" href="#step2">Step 2</a></h3>\r\nNext, double click on the logo which should be position in top-left. This will activate the text tool so you can edit the element. Highlight the entire text box with your cursor and type your text instead(such as your company name.)<br /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo1.jpg" style="margin-bottom:15px;" /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo2.jpg" style="margin-bottom:15px;" /><br />\r\nNext, double click on the slogan which is beneath the logo. This will activate the text tool so you can edit the element. Highlight the entire text box with your cursor and type your text instead(such as your company slogan). You may need to drag and move the second text block<br /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo3.jpg" style="margin-bottom:15px;" /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo4.jpg" /><br />\r\nNow, double click on the icon letters left of the logo. This will activate the text tool so you can edit the element. Highlight the entire text box with your cursor and type your text instead(such as your company initials).<br /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo5.jpg" style="margin-bottom:15px;" /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo6.jpg" /><br />\r\n</div>\r\n\r\n<div>\r\n<h3><a name="step3" href="#step3">Step 3</a></h3>\r\nOn the right column where the Web layers area is, we need to reactivate it. As you did in the initial step, select the eye icon to make it visible and subsequently making the slices visible on the canvas. Select the logo slice, either on the canvas itself or in the Web Layers folder. If you find the slice is too small, hover your cursor the blue points around the slice and drag it to a new size<br /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo7.jpg" style="margin-bottom:15px;" /><br />\r\n</div>\r\n<div>\r\n<h3><a name="step4" href="#step4">Step 4</a></h3>\r\nTo export your logo, right click on the green slice that is situated above your new logo. A popup menu should appear with numerous options. The value we want to deal with is &quot;Export Selected Slice...&quot;. As the name suggests, this option will export/save this slice only out of the entire source window.\r\n<br /><br />\r\n<img alt="Logo" src="images/tutorial/logo/logo7a.jpg" /><br />\r\n</div>\r\n\r\n\r\n<div>\r\n<h3><a name="step5" href="#step5">Step 5</a></h3>\r\n<p>If you are new to Fireworks, you may be wondering why it appears that there is only one style variation in the source. This is not the case as we take advantage of the Frame features of Fireworks. You need to simply switch frames to see all the other style variation sources.<br /><br />\r\nThere are a few ways to change frames and we will show 2 methods that you can use.</p>\r\n\r\n\r\n<p>In the right column where you find the Layers toolbar including the Web Layers area, you should see another tab/toolbar named Frames. Just left click on the title <b>Frames</b> to enter the frames area. Then you can click on either of the frames which are named to show which style variant is on that particular frame.</p>\r\n<img alt="Logo" src="images/tutorial/logo/logo8.jpg" style="margin-bottom:15px;" /><br />\r\n\r\n<p>The second method is the most easiest and simplistic. At the bottom of the Fireworks canvas is a row of buttons, arrows just as previous and next. Select the arrows to switch between frames.</p>\r\n<img alt="Logo" src="images/tutorial/logo/logo9.jpg" /><br />\r\n</div>\r\n\r\n<h3><a name="step6" href="#step6">Step 6</a></h3>\r\n<p>Once you have successfully edited then exported your new logo, you will need to upload it to your server. This process is best done via a FTP client such as <a href="http://filezilla.sourceforge.net/">Filezilla</a></p>\r\n<ol>\r\n<li>Open your FTP client on your local computer.</li>\r\n<li>Login to your web server where <strong>TerranTribune</strong> is installed.</li>\r\n<li>Navigate to the /templates/rt_terrantribune_j15/images/#color directory.</li>\r\n<li>Upload <strong>logo.png</strong> to this directory (You may need to browse on the local panel in the FTP client to find where you have exported your logo).</li>\r\n<li>Clear your browser cache before viewing such as using the keyboard commands on Windows, <strong>Ctrl+F5</strong>.</li>\r\n</ol>\r\n\r\n<span class="note">\r\nEnsure that you are uploading the correct logo to avoid confusion if it does not change.\r\nAlso take into account hosting permissions. Sometimes, hosts which are not designed for \r\nJoomla may have permissions not suited for the setup, thus, the upload will not be complete.\r\nIn this case, contact your hosting provider.\r\n</span>', '', 1, 0, 0, 0, '2008-06-24 09:28:02', 63, '', '2008-06-29 16:47:46', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:27:30', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 3, 0, 3, '', '', 0, 18, 'robots=\nauthor='),
(162, 'Using Typography', 'using-typography', '', '<p>A guide to implementing the included <b>TerranTribune</b> typography styles and elements into your site as well as instructions for inserting typography using the HTML editor option of your WYSIWYG editor.</p>\r\n\r\n<p>Every RocketTheme template has its own set of content styles, these styles are known as Typography. Typography can come in a number of varying and diverse formats, ranging from simple text modifications to image insertions to improve the look, layout of your website and give it life. This tutorial will take you through the necessary steps to adding typography to your Joomla! content.</p>\r\n\r\n<h2>Inserting Typography with the HTML Editor</h2>\r\n\r\n<p>To insert the Typography into your content, you must use the HTML feature of all Joomla! content editors. The following tutorial will outline the steps in which to does this with the default Joomla! content edit, TinyMCE. Please be aware, even though there are other content editors available, all are basically the same and the steps with be just as effective if you are using another Content editor.</p>\r\n\r\n<span class="note">Please note that the following tutorial will show you how to insert HTML (typography) into Article, the same procedure is apparent for Content Items and Custom modules. You may skip steps 4 and 5 if you are using <b>No WYSIWYG</b> editor.</span>\r\n\r\n<div style="float: left; width: 48%; margin-right: 15px; margin-bottom: 15px;"><div><div><div>\r\n<h3><a name="step1" href="#step1">Step 1 - Login</a></h3>\r\nLogin to the Joomla! Administration Control Panel. Go to <a href="javascript:void(0);">www.yoursite.com/administrator</a>. Enter the Administrator''s Username and password.\r\n</div></div></div></div>\r\n\r\n<div style="float: left; width: 48%; margin-bottom: 15px;"><div><div><div>\r\n<h3><a name="step2" href="#step2">Step 2 - Navigation</a></h3>\r\nNavigate to the Article Manager. Hover over the Content link on the top taskbar, scroll down to Article Manager.\r\n</div></div></div></div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div style="float: left; width: 48%; margin-right: 15px; margin-bottom: 15px;"><div><div><div>\r\n<h3><a name="step3" href="#step3">Step 3 - Article Manager</a></h3>\r\nWhen you have selected the Article Manager link, you will be sent to the Article Manager control panel. Select either Edit (after selecting a particular content item) or New, depending on whether you want to add typography to an existing or new item.\r\n</div></div></div></div>\r\n\r\n<div style="float: left; width: 48%; margin-bottom: 15px;"><div><div><div>\r\n<h3><a name="step4" href="#step4">Step 4 - HTML Icon</a></h3>\r\nTo add typography to your content, you must enter the HTML mode of your Content editor. In the TinyMCE editor, this an icon called "HTML", in some other content editors, it is a tab. Press the icon to enter HTML mode. This step is not necessary if you are using <b>No WYSIWYG</b> editor.\r\n</div></div></div></div>\r\n\r\n<div class="clr"></div>\r\n\r\n<div style="float: left; width: 48%; margin-right: 15px; margin-bottom: 15px;"><div><div><div>\r\n<h3><a name="step5" href="#step5">Step 5 - HTML Mode</a></h3>\r\nA popup shall appear with your content in HTML format, only if you are using TinyMCE, with other editors, a new tab may become selected. You shall do all your editing here for typography.\r\n</div></div></div></div>\r\n\r\n<div style="float: left; width: 48%; margin-bottom: 15px;"><div><div><div>\r\n<h3><a name="step6" href="#step6">Step 6 - Inserting HTML</a></h3>\r\nYou then proceed to add your HTML coding into the tab/textbox that appears in front of you. This can be any HTML such as span class typography or styled lists.\r\n</div></div></div></div>\r\n\r\n<div class="clr"></div>\r\n\r\n<center>\r\n<span class="note">You will not see the effects in the content editor, all style affects are only visible on the Frontend of your Joomla! website.\r\n</span>\r\n</center>', '', 1, 0, 0, 0, '2008-06-24 09:29:12', 63, '', '2008-06-28 11:46:31', 62, 0, '0000-00-00 00:00:00', '2008-06-24 09:28:29', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 3, 0, 2, '', '', 0, 11, 'robots=\nauthor='),
(163, 'Demo Content', 'demo-content', '', '<p>The demo for <b>TerranTribune</b> utilises a large stock of custom code and styling to make the most of every content item and show what TerranTribune can do. This basically \r\nmeans that the HTML used in the custom modules and content have customisations\r\nwhich employ the characteristics of the template to make the &quot;perfect&quot; content.</p>\r\n\r\n<p>This demo content section will take you through some of the content areas and general techniques used to further your understanding and help you realise the true potential of <b>TerranTribune</b>. If you would like to quickly deploy a replica of our TerranTribune demo for a new Joomla site, be sure to check out our <a href="index.php?option=com_content&amp;task=view&amp;id=44&amp;Itemid=60">RocketLauncher package</a>.</p>\r\n\r\n<h3><a name="readmore" href="#readmore">Read More Buttons</a></h3>\r\nRead more buttons are automatically generated for content items that use the intro and main text option. However, you can easily insert them manually as witnessed on this demo. Use the following code:\r\n<pre>\r\n&lt;a href=&quot;your_link&quot; class="readon"&gt;Read More...&lt;/a&gt;\r\n</pre>', '', 1, 0, 0, 0, '2008-06-24 09:29:52', 63, '', '2008-06-28 21:42:47', 63, 0, '0000-00-00 00:00:00', '2008-06-24 09:29:16', '0000-00-00 00:00:00', '', '', 'show_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_vote=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nlanguage=\nkeyref=\nreadmore=', 2, 0, 1, '', '', 0, 22, 'robots=\nauthor='),
(164, 'Joomla! Core Stuff', 'joomla-core-stuff', '', '<h4>Joomla! in Action</h4>   	\r\n	<p>Joomla! is used all over the world to power everything from simple, personal homepages to complex corporate web applications. Here are just some of the ways people use our software:</p>  		\r\n		\r\n			<ul> 	\r\n				<li>Corporate websites or portals</li> 		\r\n				<li>Online commerce</li> 		\r\n				<li>Small business websites</li> 		\r\n				<li>Non-profit and organizational websites</li> 		\r\n				<li>Government applications</li>  		\r\n				<li>Corporate intranets and extranets</li> 		\r\n				<li>School and church websites</li> 		\r\n				<li>Personal or family homepages</li> 		\r\n				<li>Community-based portals</li> 		\r\n				<li>Magazines and newspapers</li> 		\r\n				<li>the possibilities are limitless</li>  	\r\n			</ul>   	\r\n	\r\n	<p>Joomla! can be used to easily manage every aspect of your website, from adding content and images to updating a product catalog or taking online reservations.</p>', '', 1, 1, 0, 1, '2007-06-24 09:34:28', 63, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2008-06-24 09:34:28', '0000-00-00 00:00:00', '', '', 'pageclass_sfx=\nback_button=\nitem_title=1\nlink_titles=\nintrotext=1\nsection=0\nsection_link=0\ncategory=0\ncategory_link=0\nrating=\nauthor=\ncreatedate=\nmodifydate=\npdf=\nprint=\nemail=\nkeyref=\ndocbook_type=', 1, 0, 1, '', '', 0, 54, '');

-- --------------------------------------------------------

--
-- Table structure for table `#__content_frontpage`
--

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE IF NOT EXISTS `#__content_frontpage` (
  `content_id` int(11) NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  PRIMARY KEY  (`content_id`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__content_frontpage`
--

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(22, 4),
(70, 5),
(43, 6),
(37, 3),
(165, 1),
(63, 2);

-- --------------------------------------------------------

--
-- Table structure for table `#__content_rating`
--

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE IF NOT EXISTS `#__content_rating` (
  `content_id` int(11) NOT NULL default '0',
  `rating_sum` int(11) unsigned NOT NULL default '0',
  `rating_count` int(11) unsigned NOT NULL default '0',
  `lastip` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`content_id`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__content_rating`
--

--
-- Table structure for table `#__groups`
--

DROP TABLE IF EXISTS `#__groups`;
CREATE TABLE IF NOT EXISTS `#__groups` (
  `id` tinyint(3) unsigned NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__groups`
--

INSERT INTO `#__groups` (`id`, `name`) VALUES
(0, 'Public'),
(1, 'Registered'),
(2, 'Special');

-- --------------------------------------------------------

--
-- Table structure for table `#__menu`
--

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE IF NOT EXISTS `#__menu` (
  `id` int(11) NOT NULL auto_increment,
  `menutype` varchar(75) default NULL,
  `name` varchar(255) default NULL,
  `alias` varchar(255) NOT NULL default '',
  `link` text,
  `type` varchar(50) NOT NULL default '',
  `published` tinyint(1) NOT NULL default '0',
  `parent` int(11) unsigned NOT NULL default '0',
  `componentid` int(11) unsigned NOT NULL default '0',
  `sublevel` int(11) default '0',
  `ordering` int(11) default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `pollid` int(11) NOT NULL default '0',
  `browserNav` tinyint(4) default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `utaccess` tinyint(3) unsigned NOT NULL default '0',
  `params` text NOT NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `home` int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `componentid` (`componentid`,`menutype`,`published`,`access`),
  KEY `menutype` (`menutype`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__menu`
--

INSERT INTO `#__menu` (`id`, `menutype`, `name`, `alias`, `link`, `type`, `published`, `parent`, `componentid`, `sublevel`, `ordering`, `checked_out`, `checked_out_time`, `pollid`, `browserNav`, `access`, `utaccess`, `params`, `lft`, `rgt`, `home`) VALUES
(1, 'mainmenu', 'Home', 'home-mainmenu-1', 'index.php?option=com_content&view=frontpage', 'component', 1, 0, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 3, 'num_leading_articles=1\nnum_intro_articles=0\nnum_columns=0\nnum_links=0\norderby_pri=\norderby_sec=date\nshow_pagination=0\nshow_pagination_results=0\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=0\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=0\nshow_print_icon=0\nshow_email_icon=0\nshow_hits=\nfeed_summary=\npage_title=TerranTribune\nshow_page_title=0\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 1),
(10, 'othermenu', 'Joomla! Home', 'joomla-home-othermenu-10', 'http://www.joomla.org', 'url', 1, 0, 0, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 3, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(11, 'othermenu', 'Joomla! Forums', 'joomla-forums-othermenu-11', 'http://forum.joomla.org', 'url', 1, 0, 0, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 3, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(12, 'othermenu', 'OSM Home', 'osm-home-othermenu-12', 'http://www.opensourcematters.org', 'url', 1, 0, 0, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 3, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(24, 'othermenu', 'Administrator', 'administrator-othermenu-24', 'administrator/', 'url', 1, 0, 0, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 3, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(21, 'usermenu', 'Your Details', 'your-details-usermenu-21', 'index.php?option=com_user&task=edit', 'url', 1, 0, 0, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 1, 3, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(13, 'usermenu', 'Submit News', 'submit-news-usermenu-13', 'index.php?option=com_content&task=new&sectionid=1', 'url', 1, 0, 0, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 1, 2, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(14, 'usermenu', 'Submit WebLink', 'submit-weblink-usermenu-14', 'index.php?option=com_weblinks&view=weblink&layout=form', 'url', 1, 0, 0, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 1, 2, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(15, 'usermenu', 'Check-In My Items', 'check-in-my-items-usermenu-15', 'index.php?option=com_user&task=checkin', 'url', 1, 0, 0, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 1, 2, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(16, 'usermenu', 'Logout', 'logout-usermenu-16', 'index.php?option=com_user&view=login', 'component', 1, 0, 14, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 1, 3, '\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(26, 'mainmenu', 'World', 'world-mainmenu-26', 'index.php?option=com_content&view=section&layout=blog&id=4', 'component', 1, 0, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=0\norderby_pri=\norderby_sec=\nshow_pagination=0\nshow_pagination_results=0\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(27, 'mainmenu', 'Africa', 'africa-mainmenu-27', 'index.php?option=com_content&view=category&layout=blog&id=18', 'component', 1, 26, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=18\nshow_title=1\n', 0, 0, 0),
(28, 'mainmenu', 'Sport', 'sport-mainmenu-28', 'index.php?option=com_content&view=section&layout=blog&id=5', 'component', 1, 0, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=0\norderby_pri=\norderby_sec=\nshow_pagination=0\nshow_pagination_results=0\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(29, 'mainmenu', 'Business', 'business-mainmenu-29', 'index.php?option=com_content&view=section&layout=blog&id=6', 'component', 1, 0, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=0\norderby_pri=\norderby_sec=\nshow_pagination=0\nshow_pagination_results=0\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(30, 'mainmenu', 'Tech', 'tech-mainmenu-30', 'index.php?option=com_content&view=section&layout=blog&id=7', 'component', 1, 0, 20, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=0\norderby_pri=\norderby_sec=\nshow_pagination=0\nshow_pagination_results=0\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(31, 'mainmenu', 'Life and Style', 'life-and-style-mainmenu-31', 'index.php?option=com_content&view=section&layout=blog&id=8', 'component', 1, 0, 20, 0, 6, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=0\norderby_pri=\norderby_sec=\nshow_pagination=0\nshow_pagination_results=0\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(32, 'mainmenu', 'Travel', 'travel-mainmenu-32', 'index.php?option=com_content&view=section&layout=blog&id=9', 'component', 1, 0, 20, 0, 7, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=0\norderby_pri=\norderby_sec=\nshow_pagination=0\nshow_pagination_results=0\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(33, 'mainmenu', 'Asia', 'asia-mainmenu-33', 'index.php?option=com_content&view=category&layout=blog&id=16', 'component', 1, 26, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=16\nshow_title=1\n', 0, 0, 0),
(34, 'mainmenu', 'Australia', 'australia-mainmenu-34', 'index.php?option=com_content&view=category&layout=blog&id=19', 'component', 1, 26, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=19\nshow_title=1\n', 0, 0, 0),
(35, 'mainmenu', 'Europe', 'europe-mainmenu-35', 'index.php?option=com_content&view=category&layout=blog&id=17', 'component', 1, 26, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=17\nshow_title=1\n', 0, 0, 0),
(36, 'mainmenu', 'North America', 'north-america-mainmenu-36', 'index.php?option=com_content&view=category&layout=blog&id=13', 'component', 1, 26, 20, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=13\nshow_title=1\n', 0, 0, 0),
(37, 'mainmenu', 'South America', 'south-america-mainmenu-37', 'index.php?option=com_content&view=category&layout=blog&id=14', 'component', 1, 26, 20, 0, 6, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=14\nshow_title=1\n', 0, 0, 0),
(38, 'mainmenu', 'Football', 'football-mainmenu-38', 'index.php?option=com_content&view=category&layout=blog&id=23', 'component', 1, 28, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=23\nshow_title=1\n', 0, 0, 0),
(39, 'mainmenu', 'Golf', 'golf-mainmenu-39', 'index.php?option=com_content&view=category&layout=blog&id=24', 'component', 1, 28, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=24\nshow_title=1\n', 0, 0, 0),
(40, 'mainmenu', 'Motor Sport', 'motor-sport-mainmenu-40', 'index.php?option=com_content&view=category&layout=blog&id=22', 'component', 1, 28, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=22\nshow_title=1\n', 0, 0, 0),
(41, 'mainmenu', 'Olympics', 'olympics-mainmenu-41', 'index.php?option=com_content&view=category&layout=blog&id=21', 'component', 1, 28, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=21\nshow_title=1\n', 0, 0, 0),
(42, 'mainmenu', 'Soccer', 'soccer-mainmenu-42', 'index.php?option=com_content&view=category&layout=blog&id=20', 'component', 1, 28, 20, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=20\nshow_title=1\n', 0, 0, 0),
(43, 'mainmenu', 'Commentary', 'commentary-mainmenu-43', 'index.php?option=com_content&view=category&layout=blog&id=28', 'component', 1, 29, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=28\nshow_title=1\n', 0, 0, 0),
(44, 'mainmenu', 'Economics', 'economics-mainmenu-44', 'index.php?option=com_content&view=category&layout=blog&id=26', 'component', 1, 29, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=26\nshow_title=1\n', 0, 0, 0),
(45, 'mainmenu', 'Markets', 'markets-mainmenu-45', 'index.php?option=com_content&view=category&layout=blog&id=25', 'component', 1, 29, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=25\nshow_title=1\n', 0, 0, 0),
(46, 'mainmenu', 'Sectors', 'sectors-mainmenu-46', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', 1, 29, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=27\nshow_title=1\n', 0, 0, 0),
(47, 'mainmenu', 'Computers', 'computers-mainmenu-47', 'index.php?option=com_content&view=category&layout=blog&id=30', 'component', 1, 30, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=30\nshow_title=1\n', 0, 0, 0),
(48, 'mainmenu', 'Gadgets', 'gadgets-mainmenu-48', 'index.php?option=com_content&view=category&layout=blog&id=32', 'component', 1, 30, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=32\nshow_title=1\n', 0, 0, 0),
(49, 'mainmenu', 'Science', 'science-mainmenu-49', 'index.php?option=com_content&view=category&layout=blog&id=31', 'component', 1, 30, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=order\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=0\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(50, 'mainmenu', 'Space', 'space-mainmenu-50', 'index.php?option=com_content&view=category&layout=blog&id=29', 'component', 1, 30, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=29\nshow_title=1\n', 0, 0, 0),
(51, 'mainmenu', 'Fashion and Beauty', 'fashion-and-beauty-mainmenu-51', 'index.php?option=com_content&view=category&layout=blog&id=33', 'component', 1, 31, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=33\nshow_title=1\n', 0, 0, 0),
(52, 'mainmenu', 'Food and Drink', 'food-and-drink-mainmenu-52', 'index.php?option=com_content&view=category&layout=blog&id=34', 'component', 1, 31, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=34\nshow_title=1\n', 0, 0, 0),
(53, 'mainmenu', 'Health', 'health-mainmenu-53', 'index.php?option=com_content&view=category&layout=blog&id=36', 'component', 1, 31, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=36\nshow_title=1\n', 0, 0, 0),
(54, 'mainmenu', 'Home and Gardens', 'home-and-gardens-mainmenu-54', 'index.php?option=com_content&view=category&layout=blog&id=35', 'component', 1, 31, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=35\nshow_title=1\n', 0, 0, 0),
(55, 'mainmenu', 'Blogs', 'blogs-mainmenu-55', 'index.php?option=com_content&view=category&layout=blog&id=40', 'component', 1, 32, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=40\nshow_title=1\n', 0, 0, 0),
(56, 'mainmenu', 'Hotels', 'hotels-mainmenu-56', 'index.php?option=com_content&view=category&layout=blog&id=37', 'component', 1, 32, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=37\nshow_title=1\n', 0, 0, 0),
(57, 'mainmenu', 'Restaurants', 'restaurants-mainmenu-57', 'index.php?option=com_content&view=category&layout=blog&id=38', 'component', 1, 32, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=38\nshow_title=1\n', 0, 0, 0),
(58, 'mainmenu', 'Trip Deals', 'trip-deals-mainmenu-58', 'index.php?option=com_content&view=category&layout=blog&id=39', 'component', 1, 32, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\npage_title=\nshow_page_title=1\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nimage=1\nshow_description=0\nshow_description_image=0\nshow_category=0\ncategory_num_links=0\nshow_title=1\nlink_titles=\nshow_readmore=\nshow_vote=\nshow_author=\nshow_create_show_date=\nshow_modify_show_date=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nunpublished=0\ncategoryid=39\nshow_title=1\n', 0, 0, 0),
(59, 'mainmenu', 'Home', 'home-mainmenu-59', 'index.php?option=com_content&view=article&id=148', 'component', 0, 0, 20, 0, 8, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(60, 'mainmenu', 'Typography', 'typography-mainmenu-60', 'index.php?option=com_content&view=article&id=149', 'component', 1, 1, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(61, 'mainmenu', 'Features', 'features-mainmenu-61', 'index.php?option=com_content&view=article&id=150', 'component', 1, 1, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(62, 'mainmenu', 'Tutorials', 'tutorials-mainmenu-62', 'index.php?option=com_content&view=article&id=157', 'component', 1, 1, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(63, 'mainmenu', 'Wrapper', 'wrapper-mainmenu-63', 'index.php?option=com_wrapper&view=wrapper', 'component', 1, 1, 17, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\npageclass_sfx=\nback_button=\nshow_page_title=0\npage_title=\nscrolling=auto\nwidth=100%\nheight=500\nheight_auto=1\nadd=1\nurl=http://www.google.com\nshow_title=1\n', 0, 0, 0),
(65, 'mainmenu', 'RocketLauncher', 'rocketlauncher-mainmenu-65', 'index.php?option=com_content&view=article&id=151', 'component', 1, 61, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(66, 'mainmenu', 'RokBox', 'rokbox-mainmenu-66', 'index.php?option=com_content&view=article&id=152', 'component', 1, 61, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(67, 'mainmenu', 'Color Styles', 'color-styles', 'index.php?option=com_content&view=article&id=153', 'component', 1, 61, 20, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_noauth=\nshow_title=1\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(68, 'mainmenu', 'Menu Options', 'menu-options-mainmenu-68', 'index.php?option=com_content&view=article&id=154', 'component', 1, 61, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(69, 'mainmenu', 'Module Positions', 'module-positions-mainmenu-69', 'index.php?option=com_content&view=article&id=155', 'component', 1, 61, 20, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(70, 'mainmenu', 'Module Variations', 'module-variations-mainmenu-70', 'index.php?option=com_content&view=article&id=156', 'component', 1, 61, 20, 0, 6, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(71, 'mainmenu', 'Dummy Menu Item', 'dummy-menu-item-mainmenu-71', 'javascript:void(0);', 'url', 1, 68, 0, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(72, 'mainmenu', 'Dummy Menu Item', 'dummy-menu-item-mainmenu-72', 'javascript:void(0);', 'url', 1, 68, 0, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(73, 'mainmenu', 'Dummy Menu Item', 'dummy-menu-item-mainmenu-73', 'javascript:void(0);', 'url', 1, 68, 0, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(74, 'mainmenu', 'Dummy Menu Item', 'dummy-menu-item-mainmenu-74', 'javascript:void(0);', 'url', 1, 73, 0, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(75, 'mainmenu', 'Dummy Menu Item', 'dummy-menu-item-mainmenu-75', 'javascript:void(0);', 'url', 1, 68, 0, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(76, 'mainmenu', 'Dummy Menu Item', 'dummy-menu-item-mainmenu-76', 'javascript:void(0);', 'url', 1, 73, 0, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(77, 'mainmenu', 'Dummy Menu Item', 'dummy-menu-item-mainmenu-77', 'javascript:void(0);', 'url', 1, 73, 0, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(78, 'mainmenu', 'Installation', 'installation-mainmenu-78', 'index.php?option=com_content&view=article&id=158', 'component', 1, 62, 20, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(79, 'mainmenu', 'Custom Modules', 'custom-modules-mainmenu-79', 'index.php?option=com_content&view=article&id=159', 'component', 1, 62, 20, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(80, 'mainmenu', 'Menu Options', 'menu-options-mainmenu-80', 'index.php?option=com_content&view=article&id=154&Itemid=68', 'url', 1, 62, 0, 0, 3, 63, '2008-06-28 21:42:13', 0, 0, 0, 0, 'menu_image=-1\n\n', 0, 0, 0),
(81, 'mainmenu', 'Basic Customisation', 'basic-customisation-mainmenu-81', 'index.php?option=com_content&view=article&id=160', 'component', 1, 62, 20, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(82, 'mainmenu', 'Logo Editing', 'logo-editing-mainmenu-82', 'index.php?option=com_content&view=article&id=161', 'component', 1, 62, 20, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(83, 'mainmenu', 'Using Typography', 'using-typography-mainmenu-83', 'index.php?option=com_content&view=article&id=162', 'component', 1, 62, 20, 0, 6, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(84, 'mainmenu', 'Demo Content', 'demo-content-mainmenu-84', 'index.php?option=com_content&view=article&id=163', 'component', 1, 62, 20, 0, 7, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nunique_itemid=0\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(95, 'topmenu', 'Joomla!', 'joomla-topmenu-95', 'http://www.joomla.org', 'url', 1, 0, 0, 0, 7, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(96, 'topmenu', 'RocketTheme', 'rockettheme-topmenu-96', 'http://www.rockettheme.com', 'url', 1, 0, 0, 0, 8, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(97, 'topmenu', 'RocketTutorials', 'rockettutorials-topmenu-97', 'http://tutorials.rockettheme.com', 'url', 1, 0, 0, 0, 9, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(98, 'topmenu', 'RocketWerx', 'rocketwerx-topmenu-98', 'http://www.rocketwerx.com', 'url', 1, 0, 0, 0, 10, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(99, 'topmenu', 'RocketLabs', 'rocketlabs-topmenu-99', 'http://labs.rockettheme.com', 'url', 1, 0, 0, 0, 11, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'menu_image=-1\nshow_title=1\nshow_page_title=1\n', 0, 0, 0),
(101, 'mainmenu', 'J! Stuff', 'jomla-core-stuff', 'index.php?option=com_content&view=article&id=164', 'component', 1, 1, 20, 1, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(102, 'mainmenu', 'Contact Us', 'contatct', 'index.php?option=com_contact&view=category&catid=12', 'component', 1, 101, 7, 2, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'image=-1\nimage_align=right\nshow_limit=0\nshow_feed_link=1\ncontact_icons=\nicon_address=\nicon_email=\nicon_telephone=\nicon_mobile=\nicon_fax=\nicon_misc=\nshow_headings=\nshow_position=\nshow_email=\nshow_telephone=\nshow_mobile=\nshow_fax=\nallow_vcard=\nbanned_email=\nbanned_subject=\nbanned_text=\nvalidate_session=\ncustom_reply=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(103, 'mainmenu', 'News', 'news', 'index.php?option=com_content&view=section&id=1', 'component', 1, 101, 20, 2, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nshow_categories=1\nshow_empty_categories=0\nshow_cat_num_articles=1\nshow_category_description=1\norderby=\norderby_sec=\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(104, 'mainmenu', 'Blog', 'blog', 'index.php?option=com_content&view=category&layout=blog&id=1', 'component', 1, 103, 20, 3, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_description=0\nshow_description_image=0\nnum_leading_articles=1\nnum_intro_articles=4\nnum_columns=2\nnum_links=4\norderby_pri=\norderby_sec=\nshow_pagination=2\nshow_pagination_results=1\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(105, 'mainmenu', 'News Feeds', 'news-feeds', 'index.php?option=com_newsfeeds&view=category&id=4', 'component', 1, 103, 11, 3, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_limit=1\nshow_headings=\nshow_name=\nshow_articles=\nshow_link=\nshow_cat_description=\nshow_cat_items=\nshow_feed_image=\nshow_feed_description=\nshow_item_description=\nfeed_word_count=0\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(106, 'mainmenu', 'Links', 'links', 'index.php?option=com_weblinks&view=category&id=2', 'component', 1, 101, 4, 2, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_feed_link=1\nshow_comp_description=\ncomp_description=\nshow_link_hits=\nshow_link_description=\nshow_other_cats=\nshow_headings=\ntarget=\nlink_icons=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(107, 'mainmenu', 'FAQs', 'faqs', 'index.php?option=com_content&view=category&id=7', 'component', 1, 101, 20, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'show_headings=1\nshow_date=0\ndate_format=\nfilter=1\nfilter_type=title\norderby_sec=\nshow_pagination=1\nshow_pagination_limit=1\nshow_feed_link=1\nshow_noauth=\nshow_title=\nlink_titles=\nshow_intro=\nshow_section=\nlink_section=\nshow_category=\nlink_category=\nshow_author=\nshow_create_date=\nshow_modify_date=\nshow_item_navigation=\nshow_readmore=\nshow_vote=\nshow_icons=\nshow_pdf_icon=\nshow_print_icon=\nshow_email_icon=\nshow_hits=\nfeed_summary=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
(108, 'mainmenu', 'Search', 'search', 'index.php?option=com_search&view=search', 'component', 1, 101, 15, 2, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'search_areas=1\nshow_date=\nenabled=\npage_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__menu_types`
--

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE IF NOT EXISTS `#__menu_types` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `menutype` varchar(75) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `menutype` (`menutype`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__menu_types`
--

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(1, 'mainmenu', 'mainmenu', ''),
(2, 'othermenu', 'othermenu', ''),
(3, 'topmenu', 'topmenu', ''),
(4, 'usermenu', 'usermenu', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__messages`
--

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE IF NOT EXISTS `#__messages` (
  `message_id` int(10) unsigned NOT NULL auto_increment,
  `user_id_from` int(10) unsigned NOT NULL default '0',
  `user_id_to` int(10) unsigned NOT NULL default '0',
  `folder_id` int(10) unsigned NOT NULL default '0',
  `date_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `state` int(11) NOT NULL default '0',
  `priority` int(1) unsigned NOT NULL default '0',
  `subject` text NOT NULL,
  `message` text NOT NULL,
  PRIMARY KEY  (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__messages`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__messages_cfg`
--

DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE IF NOT EXISTS `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL default '0',
  `cfg_name` varchar(100) NOT NULL default '',
  `cfg_value` varchar(255) NOT NULL default '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__messages_cfg`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__migration_backlinks`
--

DROP TABLE IF EXISTS `#__migration_backlinks`;
CREATE TABLE IF NOT EXISTS `#__migration_backlinks` (
  `itemid` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `url` text NOT NULL,
  `sefurl` text NOT NULL,
  `newurl` text NOT NULL,
  PRIMARY KEY  (`itemid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__migration_backlinks`
--

INSERT INTO `#__migration_backlinks` (`itemid`, `name`, `url`, `sefurl`, `newurl`) VALUES
(1, 'Home', 'index.php?option=com_frontpage&Itemid=1', 'index.php?option=com_frontpage&Itemid=1', ''),
(2, 'News', 'index.php?option=com_content&task=section&id=1&Itemid=2', 'index.php?option=com_content&task=section&id=1&Itemid=2', ''),
(3, 'Contact Us', 'index.php?option=com_contact&Itemid=3', 'index.php?option=com_contact&Itemid=3', ''),
(23, 'Links', 'index.php?option=com_weblinks&Itemid=23', 'index.php?option=com_weblinks&Itemid=23', ''),
(5, 'Search', 'index.php?option=com_search&Itemid=5', 'index.php?option=com_search&Itemid=5', ''),
(6, 'Joomla! License', 'index.php?option=com_content&task=view&id=5&Itemid=6', 'index.php?option=com_content&task=view&id=5&Itemid=6', ''),
(7, 'News Feeds', 'index.php?option=com_newsfeeds&Itemid=7', 'index.php?option=com_newsfeeds&Itemid=7', ''),
(8, 'Wrapper', 'index.php?option=com_wrapper&Itemid=8', 'index.php?option=com_wrapper&Itemid=8', ''),
(9, 'Blog', 'index.php?option=com_content&task=blogsection&id=0&Itemid=9', 'index.php?option=com_content&task=blogsection&id=0&Itemid=9', ''),
(10, 'Joomla! Home', 'http://www.joomla.org', 'http://www.joomla.org', ''),
(11, 'Joomla! Forums', 'http://forum.joomla.org', 'http://forum.joomla.org', ''),
(12, 'OSM Home', 'http://www.opensourcematters.org', 'http://www.opensourcematters.org', ''),
(24, 'Administrator', 'administrator/', 'administrator/', ''),
(21, 'Your Details', 'index.php?option=com_user&task=UserDetails&Itemid=21', 'index.php?option=com_user&task=UserDetails&Itemid=21', ''),
(13, 'Submit News', 'index.php?option=com_content&task=new&sectionid=1&Itemid=0', 'index.php?option=com_content&task=new&sectionid=1&Itemid=0', ''),
(14, 'Submit WebLink', 'index.php?option=com_weblinks&task=new&Itemid=14', 'index.php?option=com_weblinks&task=new&Itemid=14', ''),
(15, 'Check-In My Items', 'index.php?option=com_user&task=CheckIn&Itemid=15', 'index.php?option=com_user&task=CheckIn&Itemid=15', ''),
(16, 'Logout', 'index.php?option=com_login&Itemid=16', 'index.php?option=com_login&Itemid=16', ''),
(17, 'Home', 'index.php', 'index.php', ''),
(18, 'Features', 'index.php?option=com_content&task=view&id=150&Itemid=61', 'index.php?option=com_content&task=view&id=150&Itemid=61', ''),
(19, 'Typography', 'index.php?option=com_content&task=view&id=149&Itemid=60', 'index.php?option=com_content&task=view&id=149&Itemid=60', ''),
(20, 'Tutorials', 'index.php?option=com_content&task=view&id=157&Itemid=62', 'index.php?option=com_content&task=view&id=157&Itemid=62', ''),
(25, 'FAQs', 'index.php?option=com_content&task=category&sectionid=3&id=7&Itemid=25', 'index.php?option=com_content&task=category&sectionid=3&id=7&Itemid=25', ''),
(26, 'World', 'index.php?option=com_content&task=blogsection&id=4&Itemid=26', 'index.php?option=com_content&task=blogsection&id=4&Itemid=26', ''),
(27, 'Africa', 'index.php?option=com_content&task=blogcategory&id=18&Itemid=27', 'index.php?option=com_content&task=blogcategory&id=18&Itemid=27', ''),
(28, 'Sport', 'index.php?option=com_content&task=blogsection&id=5&Itemid=28', 'index.php?option=com_content&task=blogsection&id=5&Itemid=28', ''),
(29, 'Business', 'index.php?option=com_content&task=blogsection&id=6&Itemid=29', 'index.php?option=com_content&task=blogsection&id=6&Itemid=29', ''),
(30, 'Tech', 'index.php?option=com_content&task=blogsection&id=7&Itemid=30', 'index.php?option=com_content&task=blogsection&id=7&Itemid=30', ''),
(31, 'Life and Style', 'index.php?option=com_content&task=blogsection&id=8&Itemid=31', 'index.php?option=com_content&task=blogsection&id=8&Itemid=31', ''),
(32, 'Travel', 'index.php?option=com_content&task=blogsection&id=9&Itemid=32', 'index.php?option=com_content&task=blogsection&id=9&Itemid=32', ''),
(33, 'Asia', 'index.php?option=com_content&task=blogcategory&id=16&Itemid=33', 'index.php?option=com_content&task=blogcategory&id=16&Itemid=33', ''),
(34, 'Australia', 'index.php?option=com_content&task=blogcategory&id=19&Itemid=34', 'index.php?option=com_content&task=blogcategory&id=19&Itemid=34', ''),
(35, 'Europe', 'index.php?option=com_content&task=blogcategory&id=17&Itemid=35', 'index.php?option=com_content&task=blogcategory&id=17&Itemid=35', ''),
(36, 'North America', 'index.php?option=com_content&task=blogcategory&id=13&Itemid=36', 'index.php?option=com_content&task=blogcategory&id=13&Itemid=36', ''),
(37, 'South America', 'index.php?option=com_content&task=blogcategory&id=14&Itemid=37', 'index.php?option=com_content&task=blogcategory&id=14&Itemid=37', ''),
(38, 'Football', 'index.php?option=com_content&task=blogcategory&id=23&Itemid=38', 'index.php?option=com_content&task=blogcategory&id=23&Itemid=38', ''),
(39, 'Golf', 'index.php?option=com_content&task=blogcategory&id=24&Itemid=39', 'index.php?option=com_content&task=blogcategory&id=24&Itemid=39', ''),
(40, 'Motor Sport', 'index.php?option=com_content&task=blogcategory&id=22&Itemid=40', 'index.php?option=com_content&task=blogcategory&id=22&Itemid=40', ''),
(41, 'Olympics', 'index.php?option=com_content&task=blogcategory&id=21&Itemid=41', 'index.php?option=com_content&task=blogcategory&id=21&Itemid=41', ''),
(42, 'Soccer', 'index.php?option=com_content&task=blogcategory&id=20&Itemid=42', 'index.php?option=com_content&task=blogcategory&id=20&Itemid=42', ''),
(43, 'Commentary', 'index.php?option=com_content&task=blogcategory&id=28&Itemid=43', 'index.php?option=com_content&task=blogcategory&id=28&Itemid=43', ''),
(44, 'Economics', 'index.php?option=com_content&task=blogcategory&id=26&Itemid=44', 'index.php?option=com_content&task=blogcategory&id=26&Itemid=44', ''),
(45, 'Markets', 'index.php?option=com_content&task=blogcategory&id=25&Itemid=45', 'index.php?option=com_content&task=blogcategory&id=25&Itemid=45', ''),
(46, 'Sectors', 'index.php?option=com_content&task=blogcategory&id=27&Itemid=46', 'index.php?option=com_content&task=blogcategory&id=27&Itemid=46', ''),
(47, 'Computers', 'index.php?option=com_content&task=blogcategory&id=30&Itemid=47', 'index.php?option=com_content&task=blogcategory&id=30&Itemid=47', ''),
(48, 'Gadgets', 'index.php?option=com_content&task=blogcategory&id=32&Itemid=48', 'index.php?option=com_content&task=blogcategory&id=32&Itemid=48', ''),
(49, 'Science', 'index.php?option=com_content&task=blogcategory&id=31&Itemid=49', 'index.php?option=com_content&task=blogcategory&id=31&Itemid=49', ''),
(50, 'Space', 'index.php?option=com_content&task=blogcategory&id=29&Itemid=50', 'index.php?option=com_content&task=blogcategory&id=29&Itemid=50', ''),
(51, 'Fashion and Beauty', 'index.php?option=com_content&task=blogcategory&id=33&Itemid=51', 'index.php?option=com_content&task=blogcategory&id=33&Itemid=51', ''),
(52, 'Food and Drink', 'index.php?option=com_content&task=blogcategory&id=34&Itemid=52', 'index.php?option=com_content&task=blogcategory&id=34&Itemid=52', ''),
(53, 'Health', 'index.php?option=com_content&task=blogcategory&id=36&Itemid=53', 'index.php?option=com_content&task=blogcategory&id=36&Itemid=53', ''),
(54, 'Home and Gardens', 'index.php?option=com_content&task=blogcategory&id=35&Itemid=54', 'index.php?option=com_content&task=blogcategory&id=35&Itemid=54', ''),
(55, 'Blogs', 'index.php?option=com_content&task=blogcategory&id=40&Itemid=55', 'index.php?option=com_content&task=blogcategory&id=40&Itemid=55', ''),
(56, 'Hotels', 'index.php?option=com_content&task=blogcategory&id=37&Itemid=56', 'index.php?option=com_content&task=blogcategory&id=37&Itemid=56', ''),
(57, 'Restaurants', 'index.php?option=com_content&task=blogcategory&id=38&Itemid=57', 'index.php?option=com_content&task=blogcategory&id=38&Itemid=57', ''),
(58, 'Trip Deals', 'index.php?option=com_content&task=blogcategory&id=39&Itemid=58', 'index.php?option=com_content&task=blogcategory&id=39&Itemid=58', ''),
(59, 'Home', 'index.php?option=com_content&task=view&id=148&Itemid=59', 'index.php?option=com_content&task=view&id=148&Itemid=59', ''),
(60, 'Typography', 'index.php?option=com_content&task=view&id=149&Itemid=60', 'index.php?option=com_content&task=view&id=149&Itemid=60', ''),
(61, 'Features', 'index.php?option=com_content&task=view&id=150&Itemid=61', 'index.php?option=com_content&task=view&id=150&Itemid=61', ''),
(62, 'Tutorials', 'index.php?option=com_content&task=view&id=157&Itemid=62', 'index.php?option=com_content&task=view&id=157&Itemid=62', ''),
(63, 'Wrapper', 'index.php?option=com_wrapper&Itemid=63', 'index.php?option=com_wrapper&Itemid=63', ''),
(64, 'J! Stuff', 'index.php?option=com_content&task=view&id=164&Itemid=64', 'index.php?option=com_content&task=view&id=164&Itemid=64', ''),
(65, 'RocketLauncher', 'index.php?option=com_content&task=view&id=151&Itemid=65', 'index.php?option=com_content&task=view&id=151&Itemid=65', ''),
(66, 'RokBox', 'index.php?option=com_content&task=view&id=152&Itemid=66', 'index.php?option=com_content&task=view&id=152&Itemid=66', ''),
(67, 'Preset Styles', 'index.php?option=com_content&task=view&id=153&Itemid=67', 'index.php?option=com_content&task=view&id=153&Itemid=67', ''),
(68, 'Menu Options', 'index.php?option=com_content&task=view&id=154&Itemid=68', 'index.php?option=com_content&task=view&id=154&Itemid=68', ''),
(69, 'Module Positions', 'index.php?option=com_content&task=view&id=155&Itemid=69', 'index.php?option=com_content&task=view&id=155&Itemid=69', ''),
(70, 'Module Variations', 'index.php?option=com_content&task=view&id=156&Itemid=70', 'index.php?option=com_content&task=view&id=156&Itemid=70', ''),
(71, 'Dummy Menu Item', 'javascript:void(0);', 'javascript:void(0);', ''),
(72, 'Dummy Menu Item', 'javascript:void(0);', 'javascript:void(0);', ''),
(73, 'Dummy Menu Item', 'javascript:void(0);', 'javascript:void(0);', ''),
(74, 'Dummy Menu Item', 'javascript:void(0);', 'javascript:void(0);', ''),
(75, 'Dummy Menu Item', 'javascript:void(0);', 'javascript:void(0);', ''),
(76, 'Dummy Menu Item', 'javascript:void(0);', 'javascript:void(0);', ''),
(77, 'Dummy Menu Item', 'javascript:void(0);', 'javascript:void(0);', ''),
(78, 'Installation', 'index.php?option=com_content&task=view&id=158&Itemid=78', 'index.php?option=com_content&task=view&id=158&Itemid=78', ''),
(79, 'Custom Modules', 'index.php?option=com_content&task=view&id=159&Itemid=79', 'index.php?option=com_content&task=view&id=159&Itemid=79', ''),
(80, 'Menu Options', 'index.php?option=com_content&task=view&id=154&Itemid=68', 'index.php?option=com_content&task=view&id=154&Itemid=68', ''),
(81, 'Basic Customisation', 'index.php?option=com_content&task=view&id=160&Itemid=81', 'index.php?option=com_content&task=view&id=160&Itemid=81', ''),
(82, 'Logo Editing', 'index.php?option=com_content&task=view&id=161&Itemid=82', 'index.php?option=com_content&task=view&id=161&Itemid=82', ''),
(83, 'Using Typography', 'index.php?option=com_content&task=view&id=162&Itemid=83', 'index.php?option=com_content&task=view&id=162&Itemid=83', ''),
(84, 'Demo Content', 'index.php?option=com_content&task=view&id=163&Itemid=84', 'index.php?option=com_content&task=view&id=163&Itemid=84', ''),
(85, 'Contact Us', 'index.php?option=com_contact&task=view&contact_id=1&Itemid=85', 'index.php?option=com_contact&task=view&contact_id=1&Itemid=85', ''),
(86, 'News', 'index.php?option=com_content&task=category&sectionid=1&id=1&Itemid=86', 'index.php?option=com_content&task=category&sectionid=1&id=1&Itemid=86', ''),
(87, 'Joomla! License', 'index.php?option=com_content&task=view&id=5&Itemid=87', 'index.php?option=com_content&task=view&id=5&Itemid=87', ''),
(88, 'Blog', 'index.php?option=com_content&task=blogcategory&id=1&Itemid=88', 'index.php?option=com_content&task=blogcategory&id=1&Itemid=88', ''),
(89, 'News Feeds', 'index.php?option=com_newsfeeds&catid=4&Itemid=89', 'index.php?option=com_newsfeeds&catid=4&Itemid=89', ''),
(90, 'Links', 'index.php?option=com_weblinks&catid=2&Itemid=90', 'index.php?option=com_weblinks&catid=2&Itemid=90', ''),
(91, 'Search', 'index.php?option=com_search&Itemid=91', 'index.php?option=com_search&Itemid=91', ''),
(92, 'FAQs', 'index.php?option=com_content&task=category&sectionid=3&id=7&Itemid=92', 'index.php?option=com_content&task=category&sectionid=3&id=7&Itemid=92', ''),
(93, 'J! Stuff', 'index.php?option=com_content&task=view&id=164&Itemid=64', 'index.php?option=com_content&task=view&id=164&Itemid=64', ''),
(94, 'Wrapper', 'http://demo.rockettheme.com/jul08/index.php?option=com_wrapper&Itemid=63', 'http://demo.rockettheme.com/jul08/index.php?option=com_wrapper&Itemid=63', ''),
(95, 'Joomla!', 'http://www.joomla.org', 'http://www.joomla.org', ''),
(96, 'RocketTheme', 'http://www.rockettheme.com', 'http://www.rockettheme.com', ''),
(97, 'RocketTutorials', 'http://tutorials.rockettheme.com', 'http://tutorials.rockettheme.com', ''),
(98, 'RocketWerx', 'http://www.rocketwerx.com', 'http://www.rocketwerx.com', ''),
(99, 'RocketLabs', 'http://labs.rockettheme.com', 'http://labs.rockettheme.com', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__migration_configuration`
--

DROP TABLE IF EXISTS `#__migration_configuration`;
CREATE TABLE IF NOT EXISTS `#__migration_configuration` (
  `cid` int(12) NOT NULL auto_increment,
  `key` varchar(255) NOT NULL,
  `value` text,
  PRIMARY KEY  (`cid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__migration_configuration`
--

INSERT INTO `#__migration_configuration` (`cid`, `key`, `value`) VALUES
(1, 'offline_message', 'This site is down for maintenance.<br /> Please check back again soon.'),
(2, 'sitename', 'TerranTribune'),
(3, 'debug', '0'),
(4, 'MetaDesc', 'Joomla - the dynamic portal engine and content management system'),
(5, 'MetaKeys', 'Joomla, joomla'),
(6, 'MetaTitle', '1'),
(7, 'MetaAuthor', '1'),
(8, 'gzip', '1'),
(9, 'editor', 'none'),
(10, 'smtpauth', '0'),
(11, 'smtpuser', ''),
(12, 'smtppass', ''),
(13, 'smtphost', 'localhost'),
(14, 'sendmail', '/usr/sbin/sendmail'),
(15, 'fromname', 'TerranTribune'),
(16, 'mailfrom', 'test@test.com'),
(17, 'mailer', 'mail'),
(18, 'caching', '1'),
(19, 'error_reporting', '-1'),
(20, 'list_limit', '50');

-- --------------------------------------------------------

--
-- Table structure for table `#__modules`
--

DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE IF NOT EXISTS `#__modules` (
  `id` int(11) NOT NULL auto_increment,
  `title` text NOT NULL,
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL default '0',
  `position` varchar(50) default NULL,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL default '0',
  `module` varchar(50) default NULL,
  `numnews` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `showtitle` tinyint(3) unsigned NOT NULL default '1',
  `params` text NOT NULL,
  `iscore` tinyint(4) NOT NULL default '0',
  `client_id` tinyint(4) NOT NULL default '0',
  `control` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__modules`
--

INSERT INTO `#__modules` (`id`, `title`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `published`, `module`, `numnews`, `access`, `showtitle`, `params`, `iscore`, `client_id`, `control`) VALUES
(1, 'Main Menu', '', 1, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_mainmenu', 0, 0, 1, 'menutype=mainmenu\nmoduleclass_sfx=_menu\n', 1, 0, ''),
(2, 'Login', '', 1, 'login', 0, '0000-00-00 00:00:00', 1, 'mod_login', 0, 0, 1, '', 1, 1, ''),
(3, 'Popular', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', 1, 'mod_popular', 0, 2, 1, '', 0, 1, ''),
(4, 'Recent added Articles', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', 1, 'mod_latest', 0, 2, 1, 'ordering=c_dsc\nuser_id=0\ncache=0\n\n', 0, 1, ''),
(5, 'Menu Stats', '', 5, 'cpanel', 0, '0000-00-00 00:00:00', 1, 'mod_stats', 0, 2, 1, '', 0, 1, ''),
(6, 'Unread Messages', '', 1, 'header', 0, '0000-00-00 00:00:00', 1, 'mod_unread', 0, 2, 1, '', 1, 1, ''),
(7, 'Online Users', '', 2, 'header', 0, '0000-00-00 00:00:00', 1, 'mod_online', 0, 2, 1, '', 1, 1, ''),
(8, 'Toolbar', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', 1, 'mod_toolbar', 0, 2, 1, '', 1, 1, ''),
(9, 'Quick Icons', '', 1, 'icon', 0, '0000-00-00 00:00:00', 1, 'mod_quickicon', 0, 2, 1, '', 1, 1, ''),
(10, 'Logged in Users', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', 1, 'mod_logged', 0, 2, 1, '', 0, 1, ''),
(11, 'Footer', '', 0, 'footer', 0, '0000-00-00 00:00:00', 1, 'mod_footer', 0, 0, 1, '', 1, 1, ''),
(12, 'Admin Menu', '', 1, 'menu', 0, '0000-00-00 00:00:00', 1, 'mod_menu', 0, 2, 1, '', 0, 1, ''),
(13, 'Admin SubMenu', '', 1, 'submenu', 0, '0000-00-00 00:00:00', 1, 'mod_submenu', 0, 2, 1, '', 0, 1, ''),
(14, 'User Status', '', 1, 'status', 0, '0000-00-00 00:00:00', 1, 'mod_status', 0, 2, 1, '', 0, 1, ''),
(15, 'Title', '', 1, 'title', 0, '0000-00-00 00:00:00', 1, 'mod_title', 0, 2, 1, '', 0, 1, ''),
(16, 'Take a Poll', '', 0, 'user5', 0, '0000-00-00 00:00:00', 1, 'mod_poll', 0, 0, 1, 'id=14\nmoduleclass_sfx=\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(17, 'User Menu', '', 4, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_mainmenu', 0, 1, 1, 'menutype=usermenu', 1, 0, ''),
(18, 'Main Menu', '', 2, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_mainmenu', 0, 0, 1, 'menutype=mainmenu', 1, 0, ''),
(19, 'Login Form', '', 5, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_login', 0, 0, 1, '', 1, 0, ''),
(20, 'Top Headlines', '', 1, 'header2', 0, '0000-00-00 00:00:00', 1, 'mod_latestnews', 0, 0, 1, 'moduleclass_sfx=\ncache=1\ntype=1\nshow_front=1\ncount=6\ncatid=\nsecid=', 1, 0, ''),
(21, 'Statistics', '', 6, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_stats', 0, 0, 1, 'serverinfo=1\nsiteinfo=1\ncounter=1\nincrease=0\nmoduleclass_sfx=', 0, 0, ''),
(22, 'Who''s Online', '', 13, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_whosonline', 0, 0, 1, 'cache=0\nshowmode=0\nmoduleclass_sfx=\n\n', 0, 0, ''),
(23, 'Popular', '', 2, 'user2', 0, '0000-00-00 00:00:00', 0, 'mod_mostread', 0, 0, 1, '', 0, 0, ''),
(24, 'Archive', '', 9, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_archive', 0, 0, 1, '', 1, 0, ''),
(25, 'Sections', '', 10, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_sections', 0, 0, 1, '', 1, 0, ''),
(26, 'Newsflash', '', 1, 'top', 0, '0000-00-00 00:00:00', 1, 'mod_newsflash', 0, 0, 0, 'catid=3\nstyle=random\nimage=0\nlink_titles=\nreadmore=0\nitem_title=0\nitems=\ncache=1\nmoduleclass_sfx=', 0, 0, ''),
(27, 'Related Items', '', 11, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_related_items', 0, 0, 1, '', 0, 0, ''),
(90, 'Search', '', 0, 'search', 0, '0000-00-00 00:00:00', 1, 'mod_search', 0, 0, 0, 'moduleclass_sfx=\nwidth=20\ntext=\nbutton=\nbutton_pos=right\nimagebutton=\nbutton_text=\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(29, 'Random Image', '', 14, 'right', 0, '0000-00-00 00:00:00', 0, 'mod_random_image', 0, 0, 1, '', 0, 0, ''),
(30, 'Bottom Menu', '', 1, 'bottom', 0, '0000-00-00 00:00:00', 1, 'mod_mainmenu', 0, 0, 0, 'class_sfx=-bottom\nmoduleclass_sfx=\nmenutype=topmenu\nmenu_style=list_flat\nfull_active_id=1\ncache=1\nmenu_images=0\nmenu_images_align=0\nexpand_menu=0\nactivate_parent=0\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=\nspacer=\nend_spacer=', 1, 0, ''),
(31, 'Banners', '', 1, 'banner', 0, '0000-00-00 00:00:00', 0, 'mod_banners', 0, 0, 0, 'banner_cids=\nmoduleclass_sfx=\n', 1, 0, ''),
(32, 'Other Menu', '', 3, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_mainmenu', 0, 0, 0, 'menutype=othermenu\nmenu_style=vert_indent\ncache=0\nmenu_images=0\nmenu_images_align=0\nexpand_menu=0\nclass_sfx=\nmoduleclass_sfx=\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=', 0, 0, ''),
(33, 'Wrapper', '', 12, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_wrapper', 0, 0, 1, '', 0, 0, ''),
(34, 'Travel Deals', '<img src="images/stories/travel/deals/4_thumb.jpg" alt="image" align="left" style="margin-right:8px" />Hendon Hall is a 16th Century mansion in North London and perfect for a relaxing break. Whilst secluded enough...', 0, 'user1', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\n\n', 0, 0, ''),
(35, 'Enviro-Watch', '<img src="images/stories/world/s-america/4_thumb.jpg" alt="image" align="left" style="margin-right:8px" />Food and Drug inspectors headed for farms in Florida and Mexico on Friday as new clues...', 0, 'user2', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\n\n', 0, 0, ''),
(36, 'Tech Update', '<img src="images/stories/tech/space/2_thumb.jpg" alt="image" align="left" style="margin-right:8px" />Plans to use a state of the art camera onboard a satellite to monitor the deforestation levels in parts of Africa...', 0, 'user3', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\n\n', 0, 0, ''),
(37, 'Advertisement', '<img src="images/ads/ad1.jpg" alt="advertisement" />', 11, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-ad\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(38, 'World Headlines', '', 5, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_latestnews', 0, 0, 1, 'moduleclass_sfx=\ncache=1\ntype=1\nshow_front=1\ncount=6\ncatid=\nsecid=4', 0, 0, ''),
(39, 'Sports Headlines', '', 7, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_latestnews', 0, 0, 1, 'moduleclass_sfx=\ncache=1\ntype=1\nshow_front=1\ncount=6\ncatid=\nsecid=5', 0, 0, ''),
(40, 'Blogs', '<ul class="bullet-6" style="padding-left:0;margin-left:0;margin-bottom:0">\r\n<li><a href="#">Business 360</a></li>\r\n<li><a href="#">In the Field</a></li>\r\n<li><a href="#">The Marquee</a></li>\r\n<li><a href="#">SciTech Blog</a></li>\r\n</ul>', 1, 'right5', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(41, 'Module Right2', 'This is the <b>right2</b> module position, it can load all suffixes. but is not using one.', 0, 'right2', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\n\n', 0, 0, ''),
(42, 'Podcasts', '<ul class="bullet-8" style="padding-left:0;margin-left:0;margin-bottom:0">\r\n<li><a href="#">NewsUpdate</a></li>\r\n<li><a href="#">Screening Room</a></li>\r\n<li><a href="#">ShowBiz Tonight</a></li>\r\n<li><a href="#">Show and Tell</a></li>\r\n</ul>', 2, 'right4', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(43, 'Module Right3', 'This is the <b>right3</b> module position, it can load all suffixes. but is not using one.', 0, 'right3', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\n\n', 0, 0, ''),
(44, 'Module Right4', 'This is the <b>right4</b> module position, it can load all suffixes. but is using <b>-title</b>.', 0, 'right4', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-title\n\n', 0, 0, ''),
(88, 'Module User3', 'This is the <b>user3</b> module position, which is currently using no module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.', 2, 'user3', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\n\n', 0, 0, ''),
(45, 'Module Right5', 'This is the <b>right5</b> module position, it can load all suffixes. but is using <b>-title</b>.', 2, 'right5', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-title\n\n', 0, 0, ''),
(46, 'Module Right', '<img src="images/ads/ad1.png" alt="advertisement" />', 12, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-ad\n\n', 0, 0, ''),
(47, 'Module Left', 'This is the <b>right</b> module position, which is currently using the <b>-title</b> module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.\r\n\r\n					', 1, 'left', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-title\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(48, 'Module Left2', 'This is the <b>left2</b> module position, which is currently using no module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.\r\n\r\n', 1, 'left2', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(49, 'Module Left3', '<div class="module-notitle">\r\n			<div>\r\n				<div>\r\n					<div>\r\n						<h3>Module Left3</h3>This is the <b>left3</b> module position, which is currently using the <b>-title</b> module class suffix but can load either <em>-notitle</em> or <em>-notitle</em> or -<em>ad</em>.\r\n\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n\r\n<div class="module-title">\r\n			<div>\r\n				<div>\r\n					<div>\r\n						<h3>Module Left3</h3>This is the <b>left3</b> module position, which is currently using the <b>-title</b> module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.\r\n\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>', 1, 'left4', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 0, 'moduleclass_sfx=-\ncache=0\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(50, 'Module User1', 'This is the <b>user1</b> module position, which is currently using the <b>-notitle</b> module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.', 2, 'user1', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-notitle\n\n', 0, 0, ''),
(51, 'Module User3', 'This is the <b>user3</b> module position, which is currently using the <b>-notitle</b> module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.', 0, 'user3', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-notitle\n\n', 0, 0, ''),
(52, 'Module User1', 'This is the <b>user1</b> module position, which is currently using no module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.', 3, 'user1', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\n\n', 0, 0, ''),
(54, 'Module Newflash', 'This is the <b>newsflash</b> module position, which does not have module class suffix capability.\r\n', 7, 'newsflash', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(55, 'Module User4', 'This is the <b>user4</b> module position, which is currently using the <b>-title</b> module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.\r\n\r\n', 1, 'user4', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-title\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(56, 'Module User5', 'This is the <b>user5</b> module position, which is currently using the <b>-notitle</b> module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.\r\n\r\n', 2, 'user5', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=-notitle\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(57, 'Module User6', 'This is the <b>user6</b> module position, which is currently using the no module class suffix but can load either <em>-title</em> or <em>-notitle</em> or -<em>ad</em>.\r\n\r\n', 1, 'user6', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(58, 'Module Advert1', 'This is the <b>advert1</b> module position, which doesn''t have module class suffix capability.\r\n\r\n\r\n', 1, 'advert1', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(59, 'Module Advert2', 'This is the <b>advert2</b> module position, which doesn''t have module class suffix capability.\r\n\r\n', 1, 'advert2', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(60, 'Module Advert3', 'This is the <b>advert3</b> module position, which doesn''t have module class suffix capability.\r\n', 1, 'advert3', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(61, 'Module User9', 'This is the <b>user9</b> module position, which doesn''t have module class suffix capability.\r\n\r\n', 1, 'user9', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(62, 'Module Header2', 'This is the <b>header2</b> module position, which doesn''t have module class suffix capability.\r\n\r\n', 3, 'header2', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(63, 'Module User8', 'This is the <b>user8</b> module position, which doesn''t have module class suffix capability.\r\n', 1, 'user8', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(64, 'Module User7', 'This is the <b>user7</b> module position, which doesn''t have module class suffix capability.\r\n\r\n\r\n', 1, 'user7', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=0\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(65, 'Module Header', '<div class="module">\r\n	\r\n	<div>\r\n	\r\n		<div>\r\n	\r\n			<div style="padding: 10px;">\r\n		\r\n				<h3>Module Header</h3>\r\n				\r\nThis is the <b>header</b> module position, which doesn''t have module class suffix capability. On the frontpage, this is the location of the <strong>RokNewsRotator</strong> module which rotates articles. This is the prime position for the <strong>RokNewsRotator</strong> module as the styling of the header area is designed to compliment it. That being the semi-transparent image with gradient overlay. <br />\r\n\r\n					<img height="20" alt="spacer" src="images/blank.png"/>\r\n\r\n			</div>\r\n		\r\n		</div>\r\n	\r\n	</div>\r\n\r\n</div>', 2, 'header', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 0, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(66, 'SiteMap', '<div style="width:90px;height:135px;float:left;margin-right:15px;border-right:1px dotted #ccc;padding-right:5px">\r\n<a href="index.php?option=com_frontpage&amp;Itemid=1"><b>Home</b></a><br /><br />\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=150&amp;Itemid=61">Features</a><br />\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=149&amp;Itemid=60">Typography</a><br />\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=157&amp;Itemid=62">Tutorials</a><br />\r\n<a href="index.php?option=com_content&amp;task=view&amp;id=164&amp;Itemid=64">J! Stuff</a><br />\r\n<a href="index.php?option=com_wrapper&amp;Itemid=63">Wrapper</a>\r\n</div>\r\n<div style="width:90px;height:135px;float:left;margin-right:15px;border-right:1px dotted #ccc;padding-right:5px">\r\n<a href="index.php?option=com_content&amp;task=blogsection&amp;id=4&amp;Itemid=26"><b>World</b></a><br /><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=18&amp;Itemid=27">Africa</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=16&amp;Itemid=33">Asia</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=19&amp;Itemid=34">Australia</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=17&amp;Itemid=35">Europe</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=13&amp;Itemid=36">North America</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=14&amp;Itemid=37">South America</a>\r\n</div>\r\n<div style="width:90px;height:135px;float:left;margin-right:15px;border-right:1px dotted #ccc;padding-right:5px">\r\n<a href="index.php?option=com_content&amp;task=blogsection&amp;id=5&amp;Itemid=28"><b>Sport</b></a><br /><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=23&amp;Itemid=38">Football</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=24&amp;Itemid=39">Golf</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=22&amp;Itemid=40">Motor Sport</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=21&amp;Itemid=41">Olympics</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=20&amp;Itemid=42">Soccer</a>\r\n</div>\r\n<div style="width:90px;height:135px;float:left;margin-right:15px;border-right:1px dotted #ccc;padding-right:5px;">\r\n<a href="index.php?option=com_content&amp;task=blogsection&amp;id=6&amp;Itemid=29"><b>Business</b></a><br /><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=28&amp;Itemid=43">Commentary</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=26&amp;Itemid=44">Economics</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=25&amp;Itemid=45">Markets</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=27&amp;Itemid=46">Sectors</a>\r\n</div>\r\n<div style="width:90px;height:135px;float:left;margin-right:15px;border-right:1px dotted #ccc;padding-right:5px">\r\n<a href="index.php?option=com_content&amp;task=blogsection&amp;id=7&amp;Itemid=30"><b>Tech</b></a><br /><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=30&amp;Itemid=47">Computers</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=32&amp;Itemid=48">Gadgets</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=31&amp;Itemid=49">Science</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=29&amp;Itemid=50">Space</a>\r\n</div>\r\n<div style="width:120px;height:135px;float:left;margin-right:15px;border-right:1px dotted #ccc;padding-right:5px">\r\n<a href="index.php?option=com_content&amp;task=blogsection&amp;id=8&amp;Itemid=31"><b>Life and Style</b></a><br /><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=33&amp;Itemid=51">Fashion and Beauty</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=34&amp;Itemid=52">Food and Drink</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=36&amp;Itemid=53">Health</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=35&amp;Itemid=54">Home and Gardens</a>\r\n</div>\r\n<div style="width:90px;height:135px;float:left;margin-right:15px;padding-right:5px">\r\n<a href="index.php?option=com_content&amp;task=blogsection&amp;id=9&amp;Itemid=32"><b>Travel</b></a><br /><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=40&amp;Itemid=55">Blogs</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=37&amp;Itemid=56">Hotels</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=38&amp;Itemid=57">Restaurants</a><br />\r\n<a href="index.php?option=com_content&amp;task=blogcategory&amp;id=39&amp;Itemid=58">Trip Deals</a>\r\n</div>', 2, 'user7', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 0, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(67, 'Stock Listings', '<b>Market Data: Monday 30 June 2008</b><br /><br />\r\n\r\n<table style="margin-bottom: 20px;">\r\n		<tr>\r\n			<td width="95"><a href="#"><span class="highlight-green">FTSE 100</span></a></td>\r\n			<td width="60"><span class="highlight-green">5529.9</span></td>\r\n			<td width="30"><span class="highlight-green"><img src="images/green_arrow.gif" alt="Increase" /></span></td>\r\n			<td><span class="highlight-green">11.7</span></td>\r\n		</tr>\r\n		<tr>\r\n			<td><span class="highlight-red"><a href="#"><span class="highlight-red">Dax</span></a></span></td>\r\n			<td><span class="highlight-red">6421.91</span></td>\r\n			<td><span class="highlight-red"><img src="images/red_arrow.gif" alt="Decrease" /></span></td>\r\n			<td><span class="highlight-red">-37.69</span></td>\r\n		</tr>\r\n		<tr>\r\n			<td><span class="highlight-red"><a href="#"><span class="highlight-red">Cac 40</span></a></span></td>\r\n			<td><span class="highlight-red">4397.32</span></td>\r\n			<td><span class="highlight-red"><img src="images/red_arrow.gif" alt="Decrease" /></span></td>\r\n			<td><span class="highlight-red">-28.87</span></td>\r\n		</tr>\r\n		<tr>\r\n			<td><span class="highlight-red"><a href="#"><span class="highlight-red">Dow Jones</span></a></span></td>\r\n			<td><span class="highlight-red">11346.51</span></td>\r\n			<td><span class="highlight-red"><img src="images/red_arrow.gif" alt="Decrease" /></span></td>\r\n			<td><span class="highlight-red">-106.91</span></td>\r\n		</tr>\r\n		<tr>\r\n			<td><span class="highlight-red"><a href="#"><span class="highlight-red">Nasdaq</span></a></span></td>\r\n			<td><span class="highlight-red">2315.63</span></td>\r\n			<td><span class="highlight-red"><img src="images/red_arrow.gif" alt="Decrease" /></span></td>\r\n			<td><span class="highlight-red">-5.74</span></td>\r\n		</tr>\r\n		<tr>\r\n			<td><span class="highlight-red"><a href="#"><span class="highlight-red">BBC Global 30</span></a></span></td>\r\n			<td><span class="highlight-red">5230.64</span></td>\r\n			<td><span class="highlight-red"><img src="images/red_arrow.gif" alt="Decrease" /></span></td>\r\n			<td><span class="highlight-red">-56.13</span></td>\r\n		</tr>\r\n</table>\r\n\r\n', 2, 'user4', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(68, 'Videos', '<b>Most Recent Videos</b>\r\n<ul class="bullet-7">\r\n<li><a href="#">25-foot Squid Found off the Coast</a></li>\r\n<li><a href="#">Diver soars past their own Record</a></li>\r\n</ul>\r\n<b>Previous Videos</b>\r\n<ul class="bullet-7">\r\n<li><a href="#">700 Puppies Rescued</a></li>\r\n<li><a href="#">Red Carpet Report: Dark Knight</a></li>\r\n</ul>', 2, 'user6', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(69, 'From Our Partners', '<img src="images/stories/partners1.png" alt="partners" /><br />\r\n<ul class="bullet-1">\r\n<li><a href="#">How to Succeed? Make Employees Happy</a></li>\r\n<li><a href="#">Euro 2008: The Final Countdown</a></li>\r\n</ul>\r\n<img src="images/stories/partners2.png" alt="partners" /><br />\r\n<ul class="bullet-1">\r\n<li><a href="#">£150 Bribes to Quit Smoking</a></li>\r\n<li><a href="#">Brown &amp; Out</a></li>\r\n</ul>', 2, 'advert1', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(70, 'From Our Partners2', '<img src="images/stories/partners3.png" alt="partners" /><br />\r\n<ul class="bullet-1">\r\n<li><a href="#">NFL: Rookie contracts are ridiculous</a></li>\r\n<li><a href="#">Second Round of the U.S. Women''s Open</a></li>\r\n</ul>\r\n<img src="images/stories/partners4.png" alt="partners" /><br />\r\n<ul class="bullet-1">\r\n<li><a href="#">Oil hits a record near $143</a></li>\r\n<li><a href="#">Wall Street pessimists cash in</a></li>\r\n</ul>', 2, 'advert2', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 0, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(71, 'From Our Partners3', '<img src="images/stories/partners1.png" alt="partners" /><br />\r\n<ul class="bullet-1">\r\n<li><a href="#">Chicago Under Attack  by Blackbirds</a></li>\r\n<li><a href="#">Earning Our Pride</a></li>\r\n</ul>\r\n<img src="images/stories/partners2.png" alt="partners" /><br />\r\n<ul class="bullet-1">\r\n<li><a href="#">TV Dragon in £310M Giveaway</a></li>\r\n<li><a href="#">Gloucester Principal Stands by Story</a></li>\r\n</ul>', 2, 'advert3', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 0, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(72, 'Video', '<embed src="http://www.vimeo.com/moogaloop.swf?clip_id=1249340&server=www.vimeo.com&show_title=0&show_byline=0&show_portrait=0&color=0D507A&fullscreen=1" type="application/x-shockwave-flash" allowfullscreen="true" allowscriptaccess="always" width="300" height="200"></embed>', 8, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 0, 'moduleclass_sfx=-ad\n\n', 0, 0, ''),
(73, 'Videos', '<b>Most Recent Videos</b>\r\n<ul class="bullet-7">\r\n<li><a href="#">25-foot Squid Found off the Coast</a></li>\r\n<li><a href="#">Diver soars past their own Record</a></li>\r\n</ul>\r\n<b>Previous Videos</b>\r\n<ul class="bullet-7">\r\n<li><a href="#">700 Puppies Rescued</a></li>\r\n<li><a href="#">Red Carpet Report: Dark Knight</a></li>\r\n</ul>', 10, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(74, 'Local Weather', '<div align="center"><img src="images/stories/weather.jpg" alt="weather" /></div>', 9, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 1, 'moduleclass_sfx=\ncache=1\nfirebots=1\nrssurl=\nrsstitle=1\nrssdesc=1\nrssimage=1\nrssitems=3\nrssitemdesc=1\nword_count=0\nrsscache=3600', 0, 0, ''),
(75, 'RocketTutorials', '<b>Video Tutorials</b>\r\n<ul class="bullet-7">\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/installing-rocketlauncher-joomla15.mov">How to install RocketLauncher</a></li>\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/article-access-levels-joomla15.mov">Article Access Levels</a></li>\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/custom-modules-joomla15.mov">Custom Modules</a></li>\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/extensions-manager-joomla15.mov">Extensions Manager</a></li>\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/menu-configuration-joomla15.mov">Menu Configuration</a></li>\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/template-installation-joomla15.mov">Template Installation</a></li>\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/user-manager-joomla15.mov">User Manager</a></li>\r\n <li><a rel="rokbox[515 365]" href="http://tutorials.rockettheme.com/video/joomla15/using-typography-joomla15.mov">Using Typography</a></li>\r\n</ul>', 0, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_custom', 0, 0, 0, 'moduleclass_sfx=-notitle\n\n', 0, 0, ''),
(76, 'Business Headlines', '', 6, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_latestnews', 0, 0, 1, 'moduleclass_sfx=\ncache=1\ntype=1\nshow_front=1\ncount=6\ncatid=\nsecid=6', 0, 0, ''),
(77, 'Tech Headlines', '', 4, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_latestnews', 0, 0, 1, 'moduleclass_sfx=\ncache=1\ntype=1\nshow_front=1\ncount=6\ncatid=\nsecid=7', 0, 0, ''),
(78, 'Life and Style Headlines', '', 3, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_latestnews', 0, 0, 1, 'moduleclass_sfx=\ncache=1\ntype=1\nshow_front=1\ncount=6\ncatid=\nsecid=8', 0, 0, ''),
(79, 'Travel Headlines', '', 2, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_latestnews', 0, 0, 1, 'moduleclass_sfx=\ncache=1\ntype=1\nshow_front=1\ncount=6\ncatid=\nsecid=9', 0, 0, ''),
(80, 'Breadcrumbs', '', 1, 'breadcrumb', 0, '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 0, 0, 1, 'moduleclass_sfx=\ncache=0\nshowHome=1\nhomeText=Home\nshowComponent=1\nseparator=\n\n', 1, 0, ''),
(81, 'World', '', 0, 'newsflash', 0, '0000-00-00 00:00:00', 1, 'mod_rokmininews', 0, 0, 0, 'ordering=c_dsc\npreview_count=80\nimage=1\nuser_id=0\nshow_front=1\ndefault_articles=5\nsecid=4\nmoduleclass_sfx=\ncssclass=green\nuse_custom_css=0\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(82, 'Business', '', 3, 'newsflash', 0, '0000-00-00 00:00:00', 1, 'mod_rokmininews', 0, 0, 0, 'ordering=c_dsc\npreview_count=80\nimage=1\nuser_id=0\nshow_front=1\ndefault_articles=0\nsecid=6\nmoduleclass_sfx=\ncssclass=grey\nuse_custom_css=0\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(83, 'Sport', '', 2, 'newsflash', 0, '0000-00-00 00:00:00', 1, 'mod_rokmininews', 0, 0, 0, 'ordering=c_dsc\npreview_count=80\nimage=1\nuser_id=0\nshow_front=1\ndefault_articles=5\nsecid=5\nmoduleclass_sfx=\ncssclass=red\nuse_custom_css=0\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(84, 'Life and Style', '', 5, 'newsflash', 0, '0000-00-00 00:00:00', 1, 'mod_rokmininews', 0, 0, 0, 'ordering=c_dsc\npreview_count=80\nimage=1\nuser_id=0\nshow_front=1\ndefault_articles=0\nsecid=8\nmoduleclass_sfx=\ncssclass=purple\nuse_custom_css=0\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(85, 'Travel', '', 6, 'newsflash', 0, '0000-00-00 00:00:00', 1, 'mod_rokmininews', 0, 0, 0, 'ordering=c_dsc\npreview_count=80\nimage=1\nuser_id=0\nshow_front=1\ndefault_articles=0\nsecid=9\nmoduleclass_sfx=\ncssclass=brown\nuse_custom_css=0\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(86, 'Tech', '', 4, 'newsflash', 0, '0000-00-00 00:00:00', 1, 'mod_rokmininews', 0, 0, 0, 'ordering=c_dsc\npreview_count=80\nimage=1\nuser_id=0\nshow_front=1\ndefault_articles=0\nsecid=7\nmoduleclass_sfx=\ncssclass=orange\nuse_custom_css=0\ncache=1\ncache_time=900\n\n', 0, 0, ''),
(89, 'RokNewsRotator News', '', 0, 'header', 0, '0000-00-00 00:00:00', 1, 'mod_roknewsrotator', 0, 0, 0, 'linktitle=1\nlinkimage=1\nshow_front=2\ncount=4\ncatid=0\nsecid=0\njslib=0\nreadmore=Read More\nduration=800\ndelay=7000\ncorners=0\nautoplay=1\npreview_count=300\ncontrols=1\nautohide=1\ncache=1\ncache_time=900\n\n', 0, 0, '');

-- --------------------------------------------------------

--
-- Table structure for table `#__modules_menu`
--

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE IF NOT EXISTS `#__modules_menu` (
  `moduleid` int(11) NOT NULL default '0',
  `menuid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`moduleid`,`menuid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__modules_menu`
--

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(1, 0),
(16, 1),
(17, 0),
(18, 0),
(19, 1),
(20, 1),
(22, 1),
(23, 1),
(23, 2),
(23, 4),
(23, 27),
(23, 36),
(26, 0),
(30, 0),
(31, 0),
(32, 0),
(34, 1),
(35, 1),
(36, 1),
(37, 1),
(37, 26),
(37, 27),
(37, 28),
(37, 29),
(37, 30),
(37, 31),
(37, 32),
(37, 33),
(37, 34),
(37, 35),
(37, 36),
(37, 37),
(37, 38),
(37, 39),
(37, 40),
(37, 41),
(37, 42),
(37, 43),
(37, 44),
(37, 45),
(37, 46),
(37, 47),
(37, 48),
(37, 49),
(37, 50),
(37, 51),
(37, 52),
(37, 53),
(37, 54),
(37, 55),
(37, 56),
(37, 57),
(37, 58),
(37, 61),
(37, 62),
(37, 65),
(37, 66),
(37, 67),
(37, 68),
(37, 69),
(37, 78),
(37, 79),
(37, 81),
(37, 82),
(37, 83),
(37, 84),
(38, 26),
(38, 27),
(38, 33),
(38, 34),
(38, 35),
(38, 36),
(38, 37),
(39, 28),
(39, 38),
(39, 39),
(39, 40),
(39, 41),
(39, 42),
(40, 1),
(40, 26),
(40, 27),
(40, 28),
(40, 29),
(40, 30),
(40, 31),
(40, 32),
(40, 33),
(40, 34),
(40, 35),
(40, 36),
(40, 37),
(40, 38),
(40, 39),
(40, 40),
(40, 41),
(40, 42),
(40, 43),
(40, 44),
(40, 45),
(40, 46),
(40, 47),
(40, 48),
(40, 49),
(40, 50),
(40, 51),
(40, 52),
(40, 53),
(40, 54),
(40, 55),
(40, 56),
(40, 57),
(40, 58),
(41, 70),
(42, 1),
(42, 26),
(42, 27),
(42, 28),
(42, 29),
(42, 30),
(42, 31),
(42, 32),
(42, 33),
(42, 34),
(42, 35),
(42, 36),
(42, 37),
(42, 38),
(42, 39),
(42, 40),
(42, 41),
(42, 42),
(42, 43),
(42, 44),
(42, 45),
(42, 46),
(42, 47),
(42, 48),
(42, 49),
(42, 50),
(42, 51),
(42, 52),
(42, 53),
(42, 54),
(42, 55),
(42, 56),
(42, 57),
(42, 58),
(43, 70),
(44, 70),
(45, 70),
(46, 70),
(47, 70),
(48, 70),
(49, 70),
(50, 70),
(51, 70),
(52, 70),
(54, 70),
(55, 70),
(56, 70),
(57, 70),
(58, 70),
(59, 70),
(60, 70),
(61, 70),
(62, 70),
(63, 70),
(64, 70),
(65, 70),
(66, 1),
(67, 1),
(68, 1),
(69, 1),
(70, 1),
(71, 1),
(72, 1),
(73, 26),
(73, 27),
(73, 28),
(73, 29),
(73, 30),
(73, 31),
(73, 32),
(73, 33),
(73, 34),
(73, 35),
(73, 36),
(73, 37),
(73, 38),
(73, 39),
(73, 40),
(73, 41),
(73, 42),
(73, 43),
(73, 44),
(73, 45),
(73, 46),
(73, 47),
(73, 48),
(73, 49),
(73, 50),
(73, 51),
(73, 52),
(73, 53),
(73, 54),
(73, 55),
(73, 56),
(73, 57),
(73, 58),
(74, 1),
(75, 61),
(75, 62),
(75, 65),
(75, 66),
(75, 67),
(75, 68),
(75, 69),
(75, 71),
(75, 72),
(75, 73),
(75, 74),
(75, 75),
(75, 76),
(75, 77),
(75, 78),
(75, 79),
(75, 81),
(75, 82),
(75, 83),
(75, 84),
(76, 29),
(76, 43),
(76, 44),
(76, 45),
(76, 46),
(77, 30),
(77, 47),
(77, 48),
(77, 49),
(77, 50),
(78, 31),
(78, 51),
(78, 52),
(78, 53),
(78, 54),
(79, 32),
(79, 55),
(79, 56),
(79, 57),
(79, 58),
(81, 1),
(82, 1),
(83, 1),
(84, 1),
(85, 1),
(86, 1),
(88, 70),
(89, 1),
(90, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__newsfeeds`
--

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE IF NOT EXISTS `#__newsfeeds` (
  `catid` int(11) NOT NULL default '0',
  `id` int(11) NOT NULL auto_increment,
  `name` text NOT NULL,
  `alias` varchar(255) NOT NULL default '',
  `link` text NOT NULL,
  `filename` varchar(200) default NULL,
  `published` tinyint(1) NOT NULL default '0',
  `numarticles` int(11) unsigned NOT NULL default '1',
  `cache_time` int(11) unsigned NOT NULL default '3600',
  `checked_out` tinyint(3) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL default '0',
  `rtl` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `published` (`published`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__newsfeeds`
--

INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `filename`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`) VALUES
(4, 1, 'Joomla! - Official News', 'joomla-official-news', 'http://www.joomla.org/index.php?option=com_rss_xtd&feed=RSS2.0&type=com_frontpage&Itemid=1', '', 1, 5, 3600, 0, '0000-00-00 00:00:00', 8, 0),
(4, 2, 'Joomla! - Community News', 'joomla-community-news', 'http://www.joomla.org/index.php?option=com_rss_xtd&feed=RSS2.0&type=com_content&task=blogcategory&id=0&Itemid=33', '', 1, 5, 3600, 0, '0000-00-00 00:00:00', 9, 0),
(10, 4, 'Linux Today', 'linux-today', 'http://linuxtoday.com/backend/my-netscape.rdf', '', 1, 3, 3600, 0, '0000-00-00 00:00:00', 1, 0),
(5, 5, 'Business News', 'business-news', 'http://headlines.internet.com/internetnews/bus-news/news.rss', '', 1, 3, 3600, 0, '0000-00-00 00:00:00', 2, 0),
(11, 6, 'Web Developer News', 'web-developer-news', 'http://headlines.internet.com/internetnews/wd-news/news.rss', '', 1, 3, 3600, 0, '0000-00-00 00:00:00', 3, 0),
(10, 7, 'Linux Central:New Products', 'linux-centralnew-products', 'http://linuxcentral.com/backend/lcnew.rdf', '', 1, 3, 3600, 0, '0000-00-00 00:00:00', 4, 0),
(10, 8, 'Linux Central:Best Selling', 'linux-centralbest-selling', 'http://linuxcentral.com/backend/lcbestns.rdf', '', 1, 3, 3600, 0, '0000-00-00 00:00:00', 5, 0),
(10, 9, 'Linux Central:Daily Specials', 'linux-centraldaily-specials', 'http://linuxcentral.com/backend/lcspecialns.rdf', '', 1, 3, 3600, 0, '0000-00-00 00:00:00', 6, 0),
(9, 10, 'Internet:Finance News', 'internetfinance-news', 'http://headlines.internet.com/internetnews/fina-news/news.rss', '', 1, 3, 3600, 0, '0000-00-00 00:00:00', 7, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__plugins`
--

DROP TABLE IF EXISTS `#__plugins`;
CREATE TABLE IF NOT EXISTS `#__plugins` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `element` varchar(100) NOT NULL default '',
  `folder` varchar(100) NOT NULL default '',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `published` tinyint(3) NOT NULL default '0',
  `iscore` tinyint(3) NOT NULL default '0',
  `client_id` tinyint(3) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_folder` (`published`,`client_id`,`access`,`folder`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__plugins`
--

INSERT INTO `#__plugins` (`id`, `name`, `element`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`) VALUES
(1, 'Authentication - Joomla', 'joomla', 'authentication', 0, 1, 1, 1, 0, 0, '0000-00-00 00:00:00', ''),
(2, 'Authentication - LDAP', 'ldap', 'authentication', 0, 2, 0, 1, 0, 0, '0000-00-00 00:00:00', 'host=\nport=389\nuse_ldapV3=0\nnegotiate_tls=0\nno_referrals=0\nauth_method=bind\nbase_dn=\nsearch_string=\nusers_dn=\nusername=\npassword=\nldap_fullname=fullName\nldap_email=mail\nldap_uid=uid\n\n'),
(3, 'Authentication - GMail', 'gmail', 'authentication', 0, 4, 0, 0, 0, 0, '0000-00-00 00:00:00', ''),
(4, 'Authentication - OpenID', 'openid', 'authentication', 0, 3, 0, 0, 0, 0, '0000-00-00 00:00:00', ''),
(5, 'User - Joomla!', 'joomla', 'user', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', 'autoregister=1\n\n'),
(6, 'Search - Content', 'content', 'search', 0, 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 'search_limit=50\nsearch_content=1\nsearch_uncategorised=1\nsearch_archived=1\n\n'),
(7, 'Search - Contacts', 'contacts', 'search', 0, 3, 1, 1, 0, 0, '0000-00-00 00:00:00', 'search_limit=50\n\n'),
(8, 'Search - Categories', 'categories', 'search', 0, 4, 1, 0, 0, 0, '0000-00-00 00:00:00', 'search_limit=50\n\n'),
(9, 'Search - Sections', 'sections', 'search', 0, 5, 1, 0, 0, 0, '0000-00-00 00:00:00', 'search_limit=50\n\n'),
(10, 'Search - Newsfeeds', 'newsfeeds', 'search', 0, 6, 1, 0, 0, 0, '0000-00-00 00:00:00', 'search_limit=50\n\n'),
(11, 'Search - Weblinks', 'weblinks', 'search', 0, 2, 1, 1, 0, 0, '0000-00-00 00:00:00', 'search_limit=50\n\n'),
(12, 'Content - Pagebreak', 'pagebreak', 'content', 0, 10000, 1, 1, 0, 0, '0000-00-00 00:00:00', 'enabled=1\ntitle=1\nmultipage_toc=1\nshowall=1\n\n'),
(13, 'Content - Rating', 'vote', 'content', 0, 4, 1, 1, 0, 0, '0000-00-00 00:00:00', ''),
(14, 'Content - Email Cloaking', 'emailcloak', 'content', 0, 5, 1, 0, 0, 0, '0000-00-00 00:00:00', 'mode=1\n\n'),
(15, 'Content - Code Hightlighter (GeSHi)', 'geshi', 'content', 0, 5, 0, 0, 0, 0, '0000-00-00 00:00:00', ''),
(16, 'Content - Load Module', 'loadmodule', 'content', 0, 6, 1, 0, 0, 0, '0000-00-00 00:00:00', 'enabled=1\nstyle=0\n\n'),
(17, 'Content - Page Navigation', 'pagenavigation', 'content', 0, 2, 1, 1, 0, 0, '0000-00-00 00:00:00', 'position=1\n\n'),
(18, 'Editor - No Editor', 'none', 'editors', 0, 0, 1, 1, 0, 0, '0000-00-00 00:00:00', ''),
(19, 'Editor - TinyMCE 2.0', 'tinymce', 'editors', 0, 0, 1, 1, 0, 0, '0000-00-00 00:00:00', 'theme=advanced\ncleanup=1\ncleanup_startup=0\nautosave=0\ncompressed=0\nrelative_urls=1\ntext_direction=ltr\nlang_mode=0\nlang_code=en\ninvalid_elements=applet\ncontent_css=1\ncontent_css_custom=\nnewlines=0\ntoolbar=top\nhr=1\nsmilies=1\ntable=1\nstyle=1\nlayer=1\nxhtmlxtras=0\ntemplate=0\ndirectionality=1\nfullscreen=1\nhtml_height=550\nhtml_width=750\npreview=1\ninsertdate=1\nformat_date=%Y-%m-%d\ninserttime=1\nformat_time=%H:%M:%S\n\n'),
(20, 'Editor - XStandard Lite 2.0', 'xstandard', 'editors', 0, 0, 0, 1, 0, 0, '0000-00-00 00:00:00', ''),
(21, 'Editor Button - Image', 'image', 'editors-xtd', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', ''),
(22, 'Editor Button - Pagebreak', 'pagebreak', 'editors-xtd', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', ''),
(23, 'Editor Button - Readmore', 'readmore', 'editors-xtd', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', ''),
(24, 'XML-RPC - Joomla', 'joomla', 'xmlrpc', 0, 7, 0, 1, 0, 0, '0000-00-00 00:00:00', ''),
(25, 'XML-RPC - Blogger API', 'blogger', 'xmlrpc', 0, 7, 0, 1, 0, 0, '0000-00-00 00:00:00', 'catid=1\nsectionid=0\n\n'),
(27, 'System - SEF', 'sef', 'system', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', ''),
(28, 'System - Debug', 'debug', 'system', 0, 2, 1, 0, 0, 0, '0000-00-00 00:00:00', 'queries=1\nmemory=1\nlangauge=1\n\n'),
(29, 'System - Legacy', 'legacy', 'system', 0, 3, 0, 1, 0, 0, '0000-00-00 00:00:00', 'route=0\n\n'),
(30, 'System - Cache', 'cache', 'system', 0, 4, 0, 1, 0, 0, '0000-00-00 00:00:00', 'browsercache=1\ncachetime=60\n\n'),
(31, 'System - Log', 'log', 'system', 0, 5, 0, 1, 0, 0, '0000-00-00 00:00:00', ''),
(32, 'System - Remember Me', 'remember', 'system', 0, 6, 1, 1, 0, 0, '0000-00-00 00:00:00', ''),
(33, 'System - Backlink', 'backlink', 'system', 0, 7, 0, 1, 0, 0, '0000-00-00 00:00:00', ''),
(34, 'Content - RokBox', 'rokbox', 'content', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', 'thumb_ext=_thumb\nthumb_class=album\nthumb_custom=0\nthumb_dir=cache\nthumb_width=150\nthumb_height=100\nthumb_quality=90\n\n'),
(35, 'System - RokBox', 'rokbox', 'system', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', 'theme=dark\ncustom-theme=sample\ncustom-legacy=0\nwidth=640\nheight=460\ntransition=Quad.easeOut\nduration=200\nchase=40\neffect=quicksilver\nframe-border=20\ncontent-padding=0\narrows-height=35\ncaptions=1\ncaptionsDelay=800\nscrolling=0\nkeyEvents=1\noverlay_background=#000000\noverlay_opacity=0.85\noverlay_duration=200\noverlay_transition=Quad.easeInOut\nytautoplay=0\ncontroller=false\nbgcolor=#f3f3f3\nvimeoColor=00adef\nvimeoPortrait=0\nvimeoTitle=0\nvimeoFullScreen=1\nvimeoByline=0\n\n');

-- --------------------------------------------------------

--
-- Table structure for table `#__polls`
--

DROP TABLE IF EXISTS `#__polls`;
CREATE TABLE IF NOT EXISTS `#__polls` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `voters` int(9) NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL default '0',
  `access` int(11) NOT NULL default '0',
  `lag` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__polls`
--

INSERT INTO `#__polls` (`id`, `title`, `alias`, `voters`, `checked_out`, `checked_out_time`, `published`, `access`, `lag`) VALUES
(14, 'This news was very informative...', 'this-news-was-very-informative', 3, 0, '0000-00-00 00:00:00', 1, 0, 86400);

-- --------------------------------------------------------

--
-- Table structure for table `#__poll_data`
--

DROP TABLE IF EXISTS `#__poll_data`;
CREATE TABLE IF NOT EXISTS `#__poll_data` (
  `id` int(11) NOT NULL auto_increment,
  `pollid` int(11) NOT NULL default '0',
  `text` text NOT NULL,
  `hits` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `pollid` (`pollid`,`text`(1))
) ENGINE=MyISAM;

--
-- Dumping data for table `#__poll_data`
--

INSERT INTO `#__poll_data` (`id`, `pollid`, `text`, `hits`) VALUES
(1, 14, 'Yes, the news was very informative', 2),
(2, 14, 'For the most part, yes it was', 0),
(3, 14, 'Not so much, not all that informative', 1),
(4, 14, 'Absolutely not, not informative at all', 0),
(5, 14, 'I Have No Opinion on the Matter', 0),
(6, 14, '', 0),
(7, 14, '', 0),
(8, 14, '', 0),
(9, 14, '', 0),
(10, 14, '', 0),
(11, 14, '', 0),
(12, 14, '', 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__poll_date`
--

DROP TABLE IF EXISTS `#__poll_date`;
CREATE TABLE IF NOT EXISTS `#__poll_date` (
  `id` bigint(20) NOT NULL auto_increment,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `vote_id` int(11) NOT NULL default '0',
  `poll_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `poll_id` (`poll_id`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__poll_date`
--

INSERT INTO `#__poll_date` (`id`, `date`, `vote_id`, `poll_id`) VALUES
(1, '2008-06-27 18:54:00', 3, 14),
(2, '2008-06-28 15:19:21', 1, 14);

-- --------------------------------------------------------

--
-- Table structure for table `#__poll_menu`
--

DROP TABLE IF EXISTS `#__poll_menu`;
CREATE TABLE IF NOT EXISTS `#__poll_menu` (
  `pollid` int(11) NOT NULL default '0',
  `menuid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pollid`,`menuid`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__poll_menu`
--

INSERT INTO `#__poll_menu` (`pollid`, `menuid`) VALUES
(14, 1),
(14, 26);

-- --------------------------------------------------------

--
-- Table structure for table `#__sections`
--

DROP TABLE IF EXISTS `#__sections`;
CREATE TABLE IF NOT EXISTS `#__sections` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `image` text NOT NULL,
  `scope` varchar(50) NOT NULL default '',
  `image_position` varchar(30) NOT NULL default '',
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `count` int(11) NOT NULL default '0',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_scope` (`scope`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__sections`
--

INSERT INTO `#__sections` (`id`, `title`, `name`, `alias`, `image`, `scope`, `image_position`, `description`, `published`, `checked_out`, `checked_out_time`, `ordering`, `access`, `count`, `params`) VALUES
(1, 'News', 'The News', 'news', 'articles.jpg', 'content', 'right', 'Select a news topic from the list below, then select a news article to read.', 1, 0, '0000-00-00 00:00:00', 8, 0, 1, ''),
(2, 'Newsflashes', 'Newsflashes', 'newsflashes', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 9, 0, 1, ''),
(3, 'FAQs', 'Frequently Asked Questions', 'faqs', 'pastarchives.jpg', 'content', 'left', 'From the list below choose one of our FAQs topics, then select an FAQ to read. If you have a question which is not in this section, please contact us.', 1, 0, '0000-00-00 00:00:00', 10, 0, 1, ''),
(4, 'World', 'World', 'world', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 7, 0, 7, 'imagefolders=*1*'),
(5, 'Sport', 'Sport', 'sport', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 6, 0, 4, 'imagefolders=*1*'),
(6, 'Business', 'Business', 'business', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 5, 0, 4, 'imagefolders=*1*'),
(7, 'Tech', 'Tech', 'tech', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 4, 0, 4, 'imagefolders=*1*'),
(8, 'Life and Style', 'Life and Style', 'life-and-style', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 3, 0, 8, 'imagefolders=*1*'),
(9, 'Travel', 'Travel', 'travel', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 2, 0, 7, 'imagefolders=*1*'),
(10, 'Rotator', 'Rotator', 'rotator', '', 'content', 'left', '', 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 'imagefolders=*1*');

-- --------------------------------------------------------

--
-- Table structure for table `#__session`
--

DROP TABLE IF EXISTS `#__session`;
CREATE TABLE IF NOT EXISTS `#__session` (
  `username` varchar(150) default '',
  `time` varchar(14) default '',
  `session_id` varchar(200) NOT NULL default '0',
  `guest` tinyint(4) default '1',
  `userid` int(11) default '0',
  `usertype` varchar(50) default '',
  `gid` tinyint(3) unsigned NOT NULL default '0',
  `client_id` tinyint(3) unsigned NOT NULL default '0',
  `data` longtext,
  PRIMARY KEY  (`session_id`(64)),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM;

--
-- Table structure for table `#__stats_agents`
--

DROP TABLE IF EXISTS `#__stats_agents`;
CREATE TABLE IF NOT EXISTS `#__stats_agents` (
  `agent` varchar(255) NOT NULL default '',
  `type` tinyint(1) unsigned NOT NULL default '0',
  `hits` int(11) unsigned NOT NULL default '1'
) ENGINE=MyISAM;

--
-- Dumping data for table `#__stats_agents`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__templates_menu`
--

DROP TABLE IF EXISTS `#__templates_menu`;
CREATE TABLE IF NOT EXISTS `#__templates_menu` (
  `template` varchar(255) NOT NULL default '',
  `menuid` int(11) NOT NULL default '0',
  `client_id` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`menuid`,`client_id`,`template`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__templates_menu`
--

INSERT INTO `#__templates_menu` (`template`, `menuid`, `client_id`) VALUES
('rt_terrantribune_j15', 0, 0),
('joomla_admin', 0, 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__users`
--

DROP TABLE IF EXISTS `#__users`;
CREATE TABLE IF NOT EXISTS `#__users` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `username` varchar(150) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `password` varchar(100) NOT NULL default '',
  `usertype` varchar(25) NOT NULL default '',
  `block` tinyint(4) NOT NULL default '0',
  `sendEmail` tinyint(4) default '0',
  `gid` tinyint(3) unsigned NOT NULL default '1',
  `registerDate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL default '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL default '',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `usertype` (`usertype`),
  KEY `idx_name` (`name`),
  KEY `gid_block` (`gid`,`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM;

--
-- Table structure for table `#__weblinks`
--

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE IF NOT EXISTS `#__weblinks` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `catid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(250) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `url` varchar(250) NOT NULL default '',
  `description` text NOT NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL default '0',
  `archived` tinyint(1) NOT NULL default '0',
  `approved` tinyint(1) NOT NULL default '1',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `catid` (`catid`,`published`,`archived`)
) ENGINE=MyISAM;

--
-- Dumping data for table `#__weblinks`
--

INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `published`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `params`) VALUES
(1, 2, 0, 'Joomla!', 'joomla', 'http://www.joomla.org', 'Home of Joomla!', '2005-02-14 15:19:02', 2, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 'target=0'),
(2, 2, 0, 'php.net', 'phpnet', 'http://www.php.net', 'The language that Joomla! is developed in', '2004-07-07 11:33:24', 0, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, ''),
(3, 2, 0, 'MySQL', 'mysql', 'http://www.mysql.com', 'The database that Joomla! uses', '2004-07-07 10:18:31', 0, 1, 0, '0000-00-00 00:00:00', 5, 0, 1, ''),
(4, 2, 0, 'OpenSourceMatters', 'opensourcematters', 'http://www.opensourcematters.org', 'Home of OSM', '2005-02-14 15:19:02', 2, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 'target=0'),
(5, 2, 0, 'Joomla! - Forums', 'joomla-forums', 'http://forum.joomla.org', 'Joomla! Forums', '2005-02-14 15:19:02', 2, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 'target=0');
